#!/usr/bin/python
# -*- coding: utf-8 -*-
import os
import gi
import SimpleHTTPServer
import SocketServer
import threading
import sqlite3
import hashlib
import subprocess
import uuid
import requests
import zipfile
import hmac
import binascii
import StringIO
import shutil
import base64
import sys
import time
import json
import datetime

gi.require_version('Gtk', '3.0')
#gi.require_version('WebKit2', '4.0')

acceptable_versions = ["4.0", "3.0"]
for namespace_version in acceptable_versions:
    try:
        gi.require_version('WebKit2', namespace_version)
    except ValueError:
        continue
    break

from gi.repository import Gtk, WebKit2 as WebKit, Soup, Gdk, GLib, GdkPixbuf, Pango, GObject
from gi.repository.GdkPixbuf import InterpType
from threading import Thread
from lxml import objectify

#from pkcs7 import PKCS7Encoder

#egg_path='./res/crp.egg'
#sys.path.append(egg_path)

from CryptoPlus.Cipher import AES
from CryptoPlus.Cipher import python_AES

import pkg_resources

PORT = 8182

#respath = os.path.join(os.path.dirname(__file__), 'res')

#respath = '/usr/share/cga/res'
#self.librospath = '/usr/share/cga/libros'

#respath = pkg_resources.resource_filename(__name__, 'res')
#self.librospath = pkg_resources.resource_filename(__name__, 'libros')

#respath = os.path.expanduser('~/cga/res')
#self.librospath = os.path.expanduser('~/cga/libros')

#self.librospath = '/var/lib/cga/libros'
#DATABASE_PATH = respath+'/cga.db'

class App:

    def __init__(self):

        self.apppath = os.path.dirname(os.path.realpath(__file__))

        self.respath = '/var/lib/cga/res'

        if not os.path.exists(self.respath):
            self.respath = "./res"

        us = os.environ["USER"]
        self.dirusuario = "/home/" + us + "/.cgavisor/libros/"
        if not os.path.exists(self.dirusuario):
            os.makedirs(self.dirusuario)

        if not os.path.exists(self.dirusuario+"/cga.db"):
            shutil.copyfile(self.respath + '/cga.db', self.dirusuario+"/cga.db")
        if not os.path.exists(self.dirusuario+"/info.html"):
            shutil.copyfile(self.respath + '/info.html', self.dirusuario+"/info.html")
        if not os.path.exists(self.dirusuario+"/refresh.png"):
            shutil.copyfile(self.respath + '/refresh.png', self.dirusuario+"/refresh.png")

        self.DATABASE_PATH = self.dirusuario+'/cga.db'
        self.librospath = self.dirusuario

        # Inicializar urls
        self.urltrazabilidad = "https://trazabilidad.grupoanaya.es"
        self.trazaObtenida = False

        # Inicializar cola de descarga
        self.descargando = False
        self.coladescarga = []
        self.unidadesperando = []

        # Inicializar Base de datos
        self.db_init()

        # Asociar el archivo glade
        self.glade_file = self.respath + "/cga.glade"
        self.glade = Gtk.Builder()
        self.glade.add_from_file(self.glade_file)

        # Asociar el archivo css
        cssProvider = Gtk.CssProvider()
        cssProvider.load_from_path(self.respath+"/cga.css")
        screen = Gdk.Screen.get_default()
        styleContext = Gtk.StyleContext()
        styleContext.add_provider_for_screen(screen, cssProvider, Gtk.STYLE_PROVIDER_PRIORITY_USER)

        # Ventanas y elementos
        self.ventanaprincipal = self.glade.get_object("principal")
        self.ventanaconfig = self.glade.get_object("ventanaconfig")
        self.info = self.glade.get_object('info')
        self.btnconfig = self.glade.get_object('btnconfig')
        self.btninfo = self.glade.get_object('btninfo')
        self.btndescargar = self.glade.get_object('btndescargar')
        self.txtlicencia = self.glade.get_object('txtlicencia')
        self.logo = self.glade.get_object('logoanaya')
        self.logocga = self.glade.get_object("lbllogo")
        self.visorunidades = self.glade.get_object("visorunidades")

        # Eventos Ventana principal
        self.ventanaprincipal.connect("destroy", self.on_ventanaprincipal_destroy)
        self.btnconfig.set_has_window(True)
        self.btnconfig.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.btnconfig.connect('button-press-event', self.on_btnconfig_clicked)
        self.btninfo.set_has_window(True)
        self.btninfo.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.btninfo.connect('button-press-event', self.on_btninfo_clicked)
        self.btndescargar.set_has_window(True)
        self.btndescargar.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.btndescargar.connect('button-press-event', self.on_btndescargar_clicked)
        self.ventanaconfig.connect("delete-event", self.on_ventanaconfig_destroy)
        self.info.connect("delete-event", self.on_ventanainfo_destroy)
        self.visorunidades.connect("delete-event", self.on_visorunidades_destroy)

        # Fuente
        self.font = Pango.FontDescription("FontAwesome 19")
        self.btnconfig.modify_font(self.font)

        # Logo inferior
        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath+"/logogrupo.png")
        pixbuf = pixbuf.scale_simple(156, 21, InterpType.TILES)
        self.logo.set_margin_right(10)
        self.logo.set_from_pixbuf(pixbuf)

        # Grid libros
        self.nombrelibros = []
        self.progresolibros = []

        self.grid = Gtk.Grid()
        self.grid.set_column_spacing(20)
        self.boxGridWrapper = self.glade.get_object('boxGridWrapper')
        self.boxGridWrapper.set_shadow_type(0)
        self.boxGridWrapper.add(self.grid)

        # Redimensión de la ventana para calcular filas y columnas del grid
        self.primeracarga = True
        self.ventanaprincipal.connect('check-resize', self.resize)
        self.ventanawidth = self.ventanaprincipal.get_size()[0]
        self.ventanaheight = self.ventanaprincipal.get_size()[1]
        self.config1vez = True
        self.info1vez = True
        self.visorunidades1vez = True

        # Abrir Ventana principal
        self.ventanaprincipal.show_all()

        # Establecer servidor HTTP para libros
        self.start_server()

        # Inicializar compatibilidades
        self.blcompatevents = False

        try:
            sys.setrecursionlimit(5000)
            self.visor = self.glade.get_object('navegador')
            self.scrolledwindow1 = self.glade.get_object('scrolledwindow1')
            self.visor.connect("delete-event", self.on_navegador_destroy)
            self.visor.connect('check-resize', self.resizevisor)
            self.primeracargavisor = True
            self.visorwidth = self.ventanaprincipal.get_size()[0]
            self.visorheight = self.ventanaprincipal.get_size()[1]
            self.webview = WebKit.WebView()

            self.webview.get_settings().set_enable_webaudio(True)
            self.webview.get_settings().set_enable_developer_extras(True)
            self.webview.get_settings().set_enable_accelerated_2d_canvas(True)
            self.webview.get_settings().set_enable_page_cache(True)

            self.webview.connect("resource-load-started", self.load_started)
            self.webview.connect("decide-policy", self.decide_policy)
            self.webview.connect("script-dialog", self.script_dialog)
            self.webview.connect("load-changed", self.load_changed)
            self.scrolledwindow1.add(self.webview)
        except:
            print("EX 0x002")

        #settings = WebKit.WebSettings()
        #settings.set_property('user-agent', 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0 iPad')
        #self.webview.set_settings(settings)
        #self.webview.get_settings().set_user_agent('Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:58.0) Gecko/20100101 Firefox/58.0 iPad')

        # Libros retos
        self.barra_retos = self.glade.get_object('barraretos')
        self.barraRetos()

    ############################################################################
    # BASE DE DATOS

    def db_init(self):
        conn = sqlite3.connect(self.DATABASE_PATH)
        c = conn.cursor()

        c.execute("CREATE TABLE IF NOT EXISTS CGADB (id INTEGER DEFAULT 1 PRIMARY KEY, version INTEGER)")
        c.execute("SELECT version FROM CGADB WHERE id=1")
        version = c.fetchone()
        if version is None:
            c.execute("INSERT INTO CGADB VALUES(1, 1)")

        c.execute("CREATE TABLE IF NOT EXISTS ALUMNOTRAZABILIDAD (usuario VARCHAR(100), isbn VARCHAR(50), traza TEXT, fecha TEXT, codigocentro VARCHAR(50), idclase VARCHAR(50), modificado BOOLEAN, scorm_data TEXT NULL, PRIMARY KEY (usuario, isbn, codigocentro, idclase))")
        c.execute("CREATE TABLE IF NOT EXISTS LIBROS (ruta VARCHAR(256),isbn VARCHAR(13) PRIMARY KEY,titulo VARCHAR(250),licencia VARCHAR(250),descripcion TEXT NULL,fechexp VARCHAR(10),estado INTEGER DEFAULT 0, url TEXT NULL, size TEXT NULL, autor TEXT NULL, categoria INTEGER DEFAULT 0, tipo TEXT NULL)")
        c.execute("CREATE TABLE IF NOT EXISTS UNITS (unit_id VARCHAR(20),isbn VARCHAR(50),order_unit VARCHAR(50),size VARCHAR(50),title VARCHAR(250),type VARCHAR(50),estado VARCHAR(50),PRIMARY KEY (unit_id, isbn))")

        for row in c.execute("SELECT * FROM CGADB"):
            self.db_update(row[1])

        conn.commit()
        conn.close()

    def db_update(self, check_version):
        conn1 = sqlite3.connect(self.DATABASE_PATH)
        c1 = conn1.cursor()

        if check_version < 2:
            c1.execute("CREATE TABLE IF NOT EXISTS TRAZAANAYA (licencia VARCHAR(50), timestampa VARCHAR(30), marsupial_data TEXT, scorm_data TEXT, PRIMARY KEY (licencia))")
            c1.execute("UPDATE CGADB SET version = 2 WHERE id = 1")

        #if check_version < 3:
        #    print("hola version 3")
        #    c1.execute("UPDATE CGADB SET version = 3 WHERE id = 1")

        #if check_version < 4:
        #    print("hola version 4")
        #    c1.execute("UPDATE CGADB SET version = 4 WHERE id = 1")

        conn1.commit()
        conn1.close()

    # BASE DE DATOS
    ############################################################################

    ############################################################################
    # GRID LIBROS

    def resize(self, *args):

        ventanaw = self.ventanaprincipal.get_size()[0]
        ventanah = self.ventanaprincipal.get_size()[1]
        self.librosfila = ventanaw / 170

        if ventanaw != self.ventanawidth or ventanah != self.ventanaheight or self.primeracarga:
            self.primeracarga = False
            self.ventanawidth = ventanaw
            self.ventanaheight = ventanah
            GLib.idle_add(self.gridLibros, self.librosfila)

    def resizevisor(self, *args):
        ventanaw = self.visor.get_size()[0]
        ventanah = self.visor.get_size()[1]

        if ventanaw != self.visorwidth or ventanah != self.visorheight or self.primeracargavisor:
            self.primeracargavisor = False
            self.visorwidth = ventanaw
            self.visorheight = ventanah
            self.br_boxcolores = self.glade.get_object('boxcolores')

            self.br_boxcolores.set_visible(False)
            self.panelfijo = self.glade.get_object('panelfijo')
            self.panelfijo.child_set_property(self.br_boxcolores, "x", self.visor.get_size()[0] - 470)
            self.panelfijo.child_set_property(self.br_boxcolores, "y", 50)
            self.br_boxcolores.set_visible(True)
            self.br_boxcolores.set_opacity(0)
            GLib.idle_add(self.br_boxcolores.set_visible, False)

            self.br_boxgrosores = self.glade.get_object('boxgrosores')

            self.br_boxgrosores.set_visible(False)
            self.panelfijo.child_set_property(self.br_boxgrosores, "x", self.visor.get_size()[1] - 210)
            self.panelfijo.child_set_property(self.br_boxgrosores, "y", 50)
            self.br_boxgrosores.set_visible(True)
            self.br_boxgrosores.set_opacity(0)
            GLib.idle_add(self.br_boxgrosores.set_visible, False)

        self.boxvisor = self.glade.get_object('boxvisor')
        self.boxvisor.set_size_request(0,0)
        self.boxvisor.set_size_request(ventanaw,ventanah)

    def gridLibros(self, LIBROS_FILA):

        # Primero limpiar grid eliminando todas sus columnas (100 por ejemplo)
        j = 100
        while j > 0:
            self.grid.remove_column(j-1)
            j-=1

        # Abrir conexion con la base de datos y establecer contadores
        conn = sqlite3.connect(self.DATABASE_PATH)
        c = conn.cursor()
        columna = 0
        fila = 0;
        x = 0
        for row in c.execute("SELECT * FROM LIBROS"):
            # Pasar a la siguiente fila
            if float(x) % float(LIBROS_FILA) == 0.0:
                fila += 1
                columna = 0

            # Portada del libro
            img = Gtk.Image()
            if os.path.exists(self.librospath+"/" + row[1] + "/p_portada.jpg"):
                try:
                    pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.librospath+"/" + row[1] + "/p_portada.jpg")
                except Exception as e:
                    if os.path.exists(self.librospath+"/" + row[1] + "/p_portada.jpg"):
                        try:
                            pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.librospath+"/" + row[1] + "/portada.jpg")
                        except Exception as e:
                            os.chdir(self.apppath)
                            pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath+"/sinportada.png")
                            os.chdir(self.librospath)
            else:
                os.chdir(self.apppath)
                pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath+"/sinportada.png")
                os.chdir(self.librospath)

            pixbuf = pixbuf.scale_simple(140, 140, InterpType.TILES)
            img.set_from_pixbuf(pixbuf)
            pixbuf = None

            # Barra de progreso
            pblibro = Gtk.ProgressBar()
            self.progresolibros.append(pblibro)

            # Estado del libro
            lblnombre = Gtk.Label("")
            self.nombrelibros.append(lblnombre)

            # Click de la imagen con menu contextual
            img.set_has_window(True)
            img.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
            menu = Gtk.Menu()
            menu_item = Gtk.MenuItem("Información")
            menu_item.connect("activate", self.menu_info, row[1])
            menu.append(menu_item)
            menu_item.show()
            menu_item = Gtk.MenuItem("Eliminar")
            menu_item.connect("activate", self.menu_eliminar, row[1], row[3])
            menu.append(menu_item)
            menu_item.show()
            img.connect_object("button-press-event", self.celllibro_click, menu, row[1])
            img.set_margin_left(10)
            img.set_margin_right(10)

            # Colocar elementos para crear la †Zelda
            self.cell = Gtk.Box(orientation=Gtk.Orientation.VERTICAL)

            eb = Gtk.EventBox()
            eb.add(img)
            eb.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
            eb.connect_object("button-press-event", self.celllibro_click, menu, row[1])
            eb.show()
            eb.set_visible_window(False)

            self.cell.pack_start(eb, True, True, 0) #eb -> img
            pblibro.set_size_request(150,10) # El mínimo de la barra es 150
            self.cell.pack_start(pblibro, True, True, 0)
            self.cell.pack_start(lblnombre, True, True, 0)
            pblibro.set_opacity(0) #.set_no_show_all(True)

            #self.grid.add(self.cell)
            self.grid.attach(self.cell, columna, fila, 1, 1)
            x+=1
            columna += 1

        conn.close()
        self.grid.show_all()

    def menu_info(self, widget, isbn):
        conn = sqlite3.connect(self.DATABASE_PATH)
        c = conn.cursor()
        info = ""
        for row in c.execute("SELECT * FROM LIBROS WHERE isbn LIKE '" +str(isbn)+ "' "):
            info = "<b>ISBN: </b>" + str(row[1].encode('utf-8')) + "\n<b>Título: </b>" + str(row[2].encode('utf-8')) + "\n<b>Autor: </b>" + str(row[9].encode('utf-8')) + "\n<b>Tamaño: </b>" + str(row[8].encode('utf-8')) + "MB\n<b>Licencia: </b>" + str(row[3].encode('utf-8')) +"\n<b>Fecha expiración: </b>" + str(row[5].encode('utf-8'))
        conn.close()

        dialog = Gtk.Dialog(title="Información", parent=self.ventanaprincipal)
        dialog.get_content_area().set_margin_top(20)
        dialog.get_content_area().set_margin_bottom(20)
        dialog.get_content_area().set_margin_left(10)
        dialog.get_content_area().set_margin_right(10)
        lblinfo = Gtk.Label()
        lblinfo.set_markup(info)
        dialog.get_content_area().add(lblinfo)
        dialog.get_content_area().set_size_request(350,100)
        dialog.set_resizable(False)
        dialog.show_all()
        dialog.run()
        dialog.hide()

    def menu_eliminar(self, widget, isbn, licencia):
        conn = sqlite3.connect(self.DATABASE_PATH)
        c = conn.cursor()
        info = ""
        for row in c.execute("SELECT * FROM LIBROS WHERE isbn LIKE '" +str(isbn)+ "' "):
            info = str(row[2].encode('utf-8'))
        conn.close()

        dialog = Gtk.Dialog(title="Eliminar", parent=self.ventanaprincipal)
        dialog.get_content_area().set_margin_top(20)
        dialog.get_content_area().set_margin_bottom(4)
        dialog.get_content_area().set_margin_left(10)
        dialog.get_content_area().set_margin_right(10)
        dialog.get_content_area().add(Gtk.Label("¿Eliminar "+str(info)+"?"))
        dialog.get_content_area().set_size_request(300,80)
        dialog.set_resizable(False)
        dialog.show_all()
        cancel_button = dialog.add_button(Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL)
        ok_button = dialog.add_button(Gtk.STOCK_OK, Gtk.ResponseType.OK)
        ok_button.grab_default()
        response = dialog.run()

        if response == Gtk.ResponseType.OK:
            dialog.hide()
            if self.ejecutarServicio(licencia, "eliminar") :
                conn = sqlite3.connect(self.DATABASE_PATH)
                c = conn.cursor()
                c.execute("DELETE FROM LIBROS WHERE isbn LIKE '" + str(isbn) + "'")
                c.execute("DELETE FROM UNITS WHERE isbn LIKE '" + str(isbn) + "'")
                conn.commit()
                conn.close()
                GLib.idle_add(self.gridLibros, self.librosfila)

                def eliminar(isbn):
                    shutil.rmtree(self.librospath + "/" + str(isbn))
                t = threading.Thread(target=eliminar,args=(isbn,))
                t.start()

        else:
            dialog.hide()

    def celllibro_click(self, widget, event, isbn):
        if event.button == 1: # Botón izquierdo del ratón para entrar al libro
            self.isbnactual = isbn
            self.descifrar = True

            try:
                conn = sqlite3.connect(self.DATABASE_PATH)
                c = conn.cursor()
                c.execute("SELECT tipo FROM LIBROS WHERE isbn LIKE '"+self.isbnactual+"'")
                self.tipolibro = ''.join(c.fetchone())
                conn.close()

                self.__navegacion("http://127.0.0.1:" + str(PORT) + "/" + str(isbn))
                self.visor.maximize()

                if self.tipolibro.find("HTML5Infantil") != -1:
                    self.barra_retos.show()

                    self.on_quitar_herramientas()

                    os.chdir(self.apppath)
                    self.archivocanvas = self.dirusuario+"/"+self.isbnactual+"/canvashermes.js"
                    if not os.path.exists(self.archivocanvas):
                        shutil.copyfile(self.respath + '/br/canvashermes.js', self.archivocanvas)

                    self.archivojquery = self.dirusuario+"/"+self.isbnactual+"/jquery-3.2.0.min.js"
                    if not os.path.exists(self.archivojquery):
                        shutil.copyfile(self.respath + '/br/jquery-3.2.0.min.js', self.archivojquery)
                    os.chdir(self.librospath)
                else:

                    if self.tipolibro.find("HTML5_NAVEGABLE") == -1:
                        os.chdir(self.apppath)

                        self.archivocanvas = self.dirusuario+"/"+self.isbnactual+"/apiscormanaya.js"
                        if not os.path.exists(self.archivocanvas):
                            shutil.copyfile(self.respath + '/sp/apiscormanaya.js', self.archivocanvas)

                        self.archivojquery = self.dirusuario+"/"+self.isbnactual+"/scormAPI_12.js"
                        if not os.path.exists(self.archivojquery):
                            shutil.copyfile(self.respath + '/sp/scormAPI_12.js', self.archivojquery)

                        self.archivojquery = self.dirusuario+"/"+self.isbnactual+"/apib.min.js"
                        if not os.path.exists(self.archivojquery):
                            shutil.copyfile(self.respath + '/sp/apib.min.js', self.archivojquery)

                        self.archivojquery = self.dirusuario+"/"+self.isbnactual+"/slides.min.js"
                        if not os.path.exists(self.archivojquery):
                            shutil.copyfile(self.respath + '/sp/slides.min.js', self.archivojquery)

                        self.archivojquery = self.dirusuario+"/"+self.isbnactual+"/interactios.js"
                        if not os.path.exists(self.archivojquery):
                            shutil.copyfile(self.respath + '/sp/interactios.js', self.archivojquery)

                        os.chdir(self.librospath)
                    else:
                        os.chdir(self.apppath)

                        self.archivocanvas = self.dirusuario+"/"+self.isbnactual+"/coursePlayer/apiscormanaya.js"
                        if not os.path.exists(self.archivocanvas):
                            shutil.copyfile(self.respath + '/sp/apiscormanaya.js', self.archivocanvas)

                        self.archivojquery = self.dirusuario+"/"+self.isbnactual+"/coursePlayer/apiscormlibro.js"
                        if not os.path.exists(self.archivojquery):
                            shutil.copyfile(self.respath + '/sp/scormAPI_12.js', self.archivojquery)

                        os.chdir(self.librospath)

                    self.barra_retos.hide()

                self.visor.show_all()

            except:
                print("EX 0x003")

        elif event.button == 3: # Botón derecho del ratón para abrir el menú
            widget.popup(None, None, None, event.button, event.time, event.time)

    def actualizarCelda(self, texto, percent):
        ilibro = len(self.nombrelibros)
        if ilibro > 0:
            self.nombrelibros[ilibro-1].set_markup(str(texto))
            if percent > 0:
                self.progresolibros[ilibro-1].set_opacity(1)
                self.progresolibros[ilibro-1].set_fraction(percent / float(100))
            elif percent == 0:
                self.progresolibros[ilibro-1].set_opacity(0)

    # GRID LIBROS
    ############################################################################

    ############################################################################
    # WEBVIEW LIBROS

    def start_server(self):
        global t

        t = 0

        #Handler = SimpleHTTPServer.SimpleHTTPRequestHandler
        #Handler.extensions_map.update({
        #    '.webapp': 'application/x-web-app-manifest+json',
        #});

        class visorHandler(SimpleHTTPServer.SimpleHTTPRequestHandler):
            #def end_headers(self):
            #    self.send_my_headers()
            #    SimpleHTTPServer.SimpleHTTPRequestHandler.end_headers(self)
            #def send_my_headers(self):
            #    self.send_header("HTTP/1.1 206 Partial Content")

            def do_GET(self):
                SimpleHTTPServer.SimpleHTTPRequestHandler.do_GET(self)

            def do_POST(self):
                try:
                #    self.send_response(200)
                #    self.send_header('Content-type', 'text/html')
                #    self.end_headers()
                #    return
                    self.do_GET()
                except Exception as e:
                    raise

        visorHandler.extensions_map['.mp4'] = 'video/mpeg'
        visorHandler.extensions_map['.mp3'] = 'audio/mpeg'
        visorHandler.extensions_map['.ogg'] = 'audio/ogg'

        os.chdir(self.librospath)
        SocketServer.TCPServer.allow_reuse_address = True
        self.httpd = SocketServer.TCPServer(("", PORT), visorHandler)

        def server():
            #print("Server at " + str(PORT))
            self.httpd.serve_forever()

        t = threading.Thread(target=server)
        t.start()

    def load_started(self, web_view, resource, request):

        def force_update():
            try:
	        r = requests.get("http://moodle.espaciodigitalgreta.es/local/wsbookstructure/client/client.php?isbn=" + self.isbnactual + "&force_update=1", params=None, verify=False)
	        r.encoding = 'utf8'
            except:
	        print("No se pudo forzar la actualización de la estructura del libro.")

        if self.descifrar:
            self.descifrar = False

            # Llamar a force_update
            t = threading.Thread(target=force_update)
            t.start()
            #res = r.text

            with open(self.librospath + "/"+str(self.isbnactual)+"/index.html") as f:
                data = f.read()
            f.close()

            self.key = "@4CKaOW|_.3CF"
            keybytes = str.encode(self.key)
            keyfinal = hashlib.sha256(self.key)
            keyf = keyfinal.digest()
            keyf = keyf[:16]

            #https://github.com/doegox/python-cryptoplus/blob/master/src/CryptoPlus/
            #cipher = python_AES.new(keyf)
            #crypt = cipher.encrypt('a')
            #crypt += cipher.final()
            #crypt = base64.b64encode(crypt)
            #print(crypt)

            IV = ('00000000000000000000000000000000').decode('hex')
            decipher = python_AES.new(keyf,python_AES.MODE_CBC,IV)
            data = base64.b64decode(data)
            plaintext = decipher.decrypt(data)
            (plaintext).encode('hex')
            findex = open(self.librospath + "/"+str(self.isbnactual)+"/descifrada.html", "w")
            findex.write(plaintext)
            findex.close

            if self.tipolibro.find("HTML5Infantil") != -1:
                self.query = "SELECT * FROM UNITS WHERE isbn LIKE '"+self.isbnactual+"' ORDER BY CAST(order_unit AS INTEGER)"

                conn = sqlite3.connect(self.DATABASE_PATH)
                c = conn.cursor()

                for row in c.execute(self.query):
                    c.execute("UPDATE UNITS SET estado = 'Descarga disponible' WHERE estado <> 'Descarga disponible' AND estado <> 'Descargada' ")
                    conn.commit()

                conn.close()

            self.__navegacion("http://127.0.0.1:" + str(PORT) + "/" + self.isbnactual + "/descifrada.html")

        if self.tipolibro.find("HTML5Infantil") != -1:
            self.mostrandocontroles = False
            self.br_buttonboxcanvas.hide()
            self.on_quitar_herramientas()
            self.escribirVariables()

            uri = web_view.get_uri()

            pathunidad = "/"+str(self.isbnactual)+"/contentvisor/"

            if uri.find(pathunidad) != -1:
                pathunidad = uri.replace("http://127.0.0.1:" + str(PORT), "")
                pathunidad = self.librospath + "/" + pathunidad.replace("/index.html", "")

                uriunidad = pathunidad.replace(self.librospath + "/", "")
                uriunidad = uriunidad.replace(str(self.isbnactual) + "/", "")

                if not os.path.exists(pathunidad + "/descifrada.html"):
                    self.descifrarUnidad(pathunidad)

                self.__navegacion("http://127.0.0.1:" + str(PORT) + "/" + self.isbnactual + "/" + uriunidad + "/descifrada.html")

	###############################################
	# Mejorar el rendimiento de los libros quitando
	# los transform translate del swiper.min.css
	###############################################
	pathunidadcss = self.webview.get_uri().replace("http://127.0.0.1:" + str(PORT) + "/", "")
	barra = int(pathunidadcss.rindex("/"))
	pathcss = self.librospath + pathunidadcss[0:barra] + "/css/swiper.min.css"
        with open(pathcss) as f:
        	data = f.read()
        f.close()
	if data is not None:
		if ".velocidad14" not in data:
			findex = open(pathcss, "w")
        		findex.write(data+".velocidad14,.swiper-wrapper{-webkit-transform: none;-moz-transform: none;-o-transform: none;-ms-transform: none;transform: none;}")
        		findex.close
	###############################################

        if self.tipolibro.find("DigitalUD") != -1:
            self.webview.run_javascript("var iframe = document.getElementById('iframecontenido'); var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'var scormPlayer = {}; scormPlayer.descargarUnidadLibrogeno = function(i, s, r){alert(\"cgavisor://descargarUnidadLibrogeno(\"+i+\", \"+s+\", \"+r+\")\");}; scormPlayer.eliminarUnidad = function(i, s, r){alert(\"cgavisor://eliminarUnidadLibrogeno(\"+i+\", \"+s+\", \"+r+\")\");}; scormPlayer.createTraza = function(){alert(\"cgavisor://createTraza()\");}; scormPlayer.createMarsupial = function(){alert(\"cgavisor://createMarsupial()\");}; scormPlayer.saveMarsupial = function(objDatosTraza, objMarsupial){alert(\"cgavisor://saveMarsupial(\"+objDatosTraza+\" |#|#| \"+objMarsupial+\")\");}; scormPlayer.setidclase = function(idclase){alert(\"cgavisor://setidclase(\"+idclase+\")\");}; scormPlayer.setidscorm = function(idscorm){alert(\"cgavisor://setidscorm(\"+idscorm+\")\");};    '; iframe.contentWindow.document.getElementsByTagName(\"head\")[0].appendChild(script_tag);")

            self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'var scormPlayer = {}; scormPlayer.descargarUnidadLibrogeno = function(i, s, r){alert(\"cgavisor://descargarUnidadLibrogeno(\"+i+\", \"+s+\", \"+r+\")\");}; scormPlayer.eliminarUnidad = function(i, s, r){alert(\"cgavisor://eliminarUnidadLibrogeno(\"+i+\", \"+s+\", \"+r+\")\");}; scormPlayer.createTraza = function(){alert(\"cgavisor://createTraza()\");}; scormPlayer.createMarsupial = function(){alert(\"cgavisor://createMarsupial()\");}; scormPlayer.saveMarsupial = function(objDatosTraza, objMarsupial){alert(\"cgavisor://saveMarsupial(\"+objDatosTraza+\" |#|#| \"+objMarsupial+\")\");}; scormPlayer.setidclase = function(idclase){alert(\"cgavisor://setidclase(\"+idclase+\")\");}; scormPlayer.setidscorm = function(idscorm){alert(\"cgavisor://setidscorm(\"+idscorm+\")\");};    '; document.getElementsByTagName(\"head\")[0].appendChild(script_tag);")

            self.webview.run_javascript("var urlLibrogenoLigera = function(i, s, r){alert(\"cgavisor://urlLibrogenoLigera(\"+i+\", \"+s+\", \"+r+\")\");};")

        #self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'var strAnotaciones = anotaciones.toString().replace('if (is_iPad)', 'if (true)'); eval(strAnotaciones); if (typeof scormPlayerLibrogeno === \"undefined\") { if (window.parent.objDatosTraza !== undefined) { anotaciones(jQuery, getStorage(\"TOTAL\")); } else { anotaciones(jQuery, getStorage(\"TOTAL\")); } } else { var inte = setInterval(function () { if (typeof objDatosTraza !== \"undefined\") { clearInterval(inte); console.log('getSotrage TOTAL = ' + idclase); anotaciones(jQuery, getStorage(\"TOTAL\")) } }, 100); }'; document.head.appendChild(script_tag);")

        #if self.tipolibro.find("HTML5_NAVEGABLE") != -1:

            #######

            #os.chdir(self.apppath)
            #pathapi = self.librospath + '/' + self.isbnactual + '/coursePlayer/apigretavisor.js'
            #if not os.path.exists(pathapi):
            #    shutil.copyfile(self.respath + '/apigretavisor.js', pathapi)
            #os.chdir(self.librospath)

            #self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.src = 'apigretavisor.js'; document.getElementsByTagName(\"head\")[0].appendChild(script_tag);")

            #######

            #self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.src = 'http://code.jquery.com/mobile/1.4.5/jquery.mobile-1.4.5.min.js'; document.getElementsByTagName(\"head\")[0].appendChild(script_tag);")

            #with open(self.librospath + "/"+str(self.isbnactual)+"/download.html") as f:
            #    data = f.read()
            #f.close()
            #data = data.replace("scormPlayer.descargarUnidadLibrogeno(i, s, r);", "location.href='cgavisor://descargarUnidadLibrogeno('+i+', '+s+', '+r+')';")
            #findex = open(self.librospath + "/"+str(self.isbnactual)+"/download.html", "w")
            #findex.write(data)
            #findex.close
            #self.__navegacion("http://127.0.0.1:" + str(PORT) + "/" + self.isbnactual + "/descifrada.html")

    def script_dialog(self, web_view, dialog):
        req = dialog.get_message()

        prot = "cgavisor://"
        if prot in req:

            req = req.replace(prot, "").replace("%20", "")

            fun = "filtrarUnidadRetos"
            if fun in req:
                indice = req.replace(fun, "").replace("(", "").replace(")", "")
                self.on_br_descargarunidades_clicked(None, None, indice)

            fun = "descargarUnidadRetos"
            if fun in req:
                indice = req.replace(fun, "").replace("(", "").replace(")", "")
                self.descargarUnidadRetos(indice)

            fun = "eliminarUnidadRetos"
            if fun in req:
                indice = req.replace(fun, "").replace("(", "").replace(")", "")
                self.eliminarUnidadRetos(indice)

            fun = "descargarUnidadLibrogeno"
            if fun in req:
                params = req.replace(fun, "").replace("(", "").replace(")", "")
                orden, tipo, ruta = params.split(",")
                self.descargarUnidadLibrogeno(orden, tipo, ruta)

            fun = "eliminarUnidadLibrogeno"
            if fun in req:
                params = req.replace(fun, "").replace("(", "").replace(")", "")
                orden, tipo, ruta = params.split(",")
                ruta = ruta.strip()
                self.eliminarUnidadLibrogeno(orden, tipo, ruta)
                self.webview.run_javascript("comprobar(" + orden + ", '" + tipo + "');")

            fun = "urlLibrogenoLigera"
            if fun in req:
                params = req.replace(fun, "").replace("(", "").replace(")", "")
                url, opcionalnomostrar, tipo = params.split(",")

                conn = sqlite3.connect(self.DATABASE_PATH)
                c = conn.cursor()
                c.execute("SELECT licencia FROM LIBROS WHERE isbn LIKE '"+self.isbnactual+"'")
                licencia = ''.join(c.fetchone())
                conn.close()

                url = "https://www.espaciodigitalgreta.es/index.php?module=greta&section=services&action=sincronizar&option=librogenourlligera&" + url + "&libro=" + self.isbnactual + "&user=" + licencia;

                try:
                    r = requests.get(url, params=None, verify=False)
                    r.encoding = 'utf8'
                    res = r.text
                    res = res.replace("<div id=\"mm_content\">", "").replace("</div>", "")

                    self.respopup = res
                    self.opcionalnomostrarpopup = opcionalnomostrar
                    self.tipopopup = tipo
                    self.webview.run_javascript("openpopup('"+res+"', "+opcionalnomostrar+", "+tipo+")")
                except requests.exceptions.RequestException as e:
                    print e

            fun = "createTraza"
            if (fun in req):
                conn = sqlite3.connect(self.DATABASE_PATH)
                c = conn.cursor()

                c.execute("SELECT licencia FROM LIBROS WHERE isbn LIKE '"+self.isbnactual+"'")
                licencia = ''.join(c.fetchone())

                rows_count = c.execute("SELECT scorm_data FROM TRAZAANAYA WHERE licencia LIKE '"+str(licencia)+"'")

                #if not c.fetchone() is None:
                try:
                    if rows_count > 0:
                        traza = c.fetchone()[0] #[:-2]#.replace("(u'", "")
                        #else:
                        #    traza = ''

                        if (traza == ''):
                            traza = '{}'

                        traza = traza.replace("\\", "\\\\\\\\")
                        traza = traza.replace("\"", '\\\\\"')

                    self.webview.run_javascript("if (typeof asignarEventos !== 'undefined') {asignarEventos();};")
                    self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'objDatosTraza = JSON.parse(\""+traza+"\")'; document.body.appendChild(script_tag);")

                except Exception as e:
                    print e

                conn.close()

            fun = "createMarsupial"
            if (fun in req):
                conn = sqlite3.connect(self.DATABASE_PATH)
                c = conn.cursor()
                c.execute("SELECT marsupial_data FROM TRAZAANAYA WHERE licencia LIKE '"+self.isbnactual+"'")
                traza = ''.join(c.fetchone())
                conn.close()

                if (traza == ''):
                    traza = '{}'

                self.webview.run_javascript("if (typeof asignarEventos !== 'undefined') {asignarEventos();};")
                self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'objMarsupial = \'"+traza+"\''; document.body.appendChild(script_tag);")

            fun = "saveMarsupial"
            if (fun in req):
                params = req.replace(fun, "").replace("(", "")
                pos = params.rfind(")")
                params = params[:pos]
                objDatosTraza, objMarsupial = params.split(" |#|#| ")
                fecha = time.strftime("%Y-%m-%d %H:%M:%S")

                objdt = json.loads(objDatosTraza)
                if 'length' in objdt:
                    objdt.pop('length')

                objDatosTraza = json.dumps(objdt)

                #print("####################################")
                #print(objDatosTraza)

                conn = sqlite3.connect(self.DATABASE_PATH)
                c = conn.cursor()

                c.execute("SELECT licencia FROM LIBROS WHERE isbn LIKE '"+self.isbnactual+"'")
                licencia = ''.join(c.fetchone())

                c.execute("INSERT OR REPLACE INTO TRAZAANAYA (licencia, timestampa, marsupial_data, scorm_data) VALUES ('" + str(licencia) + "', '" + str(fecha) + "', '" + str(objMarsupial) + "', '" + str(objDatosTraza) + "')")
                conn.commit()
                conn.close()

                self.enviarTraza(licencia, fecha, objMarsupial, objDatosTraza)

            fun = "setidclase"
            if (fun in req):
                params = req.replace(fun, "").replace("(", "").replace(")", "")
                #url, opcionalnomostrar, tipo = params.split(",")
                idclase =  params;
                self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'idclase="+idclase+"'; document.head.appendChild(script_tag);")

            fun = "setidscorm"
            if (fun in req):
                params = req.replace(fun, "").replace("(", "").replace(")", "")
                idscorm =  params;
                self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'idscorm="+idscorm+"'; document.head.appendChild(script_tag);")

            return True

    def decide_policy(self, web_view, decision, decision_type):

        tipo = -1

        req = decision.get_request().get_uri()

        if self.tipolibro.find("HTML5_NAVEGABLE") != -1:
            if req.find(".pdf") != -1:
                import webbrowser
                webbrowser.open(req)

        try:
            tipo = decision.get_navigation_type()
        except Exception as e:
            return False

        if tipo == WebKit.NavigationType.OTHER:
            #req = decision.get_request().get_uri()

            # Redireccion correcta a descifrada.html
            if self.tipolibro.find("DigitalUD") != -1 or self.tipolibro.find("HTML5Infantil") != -1:
                if req.find(self.isbnactual + "/index.html") != -1 or (req.find("contentvisor") != -1 and req.find("/index.html") != -1):
                    self.__navegacion(req.replace("index.html", "descifrada.html"))
                    return False

    def load_changed(self, web_view, load_event):

        if load_event == WebKit.LoadEvent.FINISHED:

            self.webview.run_javascript('$(".js-tema").on("click",function(n){var t=$(this),i=t.data("target"),e=$(".js-unit-content").not(".hidden"),a=$(\'.js-unit-content[data-id="\'+i+\'"]\'),d=e.index()>a.index()?"down":"up";if(t.closest("li").hasClass("disabled"))return!1;e.index()===a.index()||a.is(":animated")||(changeUnit(t,e,a,d,"150px"),setCookie("unitOpen-456379",i),innerWidth<580||$("html, body").animate({scrollTop:0},500))});')
            self.webview.run_javascript('function changeUnit(o,n,e,t,a){if(innerWidth<580){e.removeClass("hidden").addClass("active").find(".content").show().end().siblings().removeClass("active").addClass("hidden").find(".content").hide();var i=e.offset().top;$("html:not(:animated), body:not(:animated)").animate({scrollTop:i-100},500)}else e.hasClass("hidden")||e.addClass("hidden"),"up"==t?animationLesson({current:{selector:n,animation:"hideFromTopToBottom"},target:{selector:e,animation:"showFromBottomToTop"}},o):animationLesson({current:{selector:n,animation:"hideFromTopToUp"},target:{selector:e,animation:"showFromUpToTop"}},o)}')

            if self.unidadesperando:
                self.tipounidad = 'l'
                if self.unidadesperando[1] is "COMPLETA":
                    self.tipounidad = 'p'
                self.webview.run_javascript("comprobar(" + self.unidadesperando[0] + ", '" + self.tipounidad + "');")

            if self.coladescarga:
                i = 0
                while i < len(self.coladescarga):
                    if self.coladescarga[i][1]:
                        self.tipounidad = 'l'
                        if self.coladescarga[i][2] is "COMPLETA":
                            self.tipounidad = 'p'
                        self.webview.run_javascript("comprobar(" + self.coladescarga[i][4] + ", '" + self.tipounidad + "');")
                    i += 1

            if self.tipolibro.find("HTML5Infantil") != -1 or self.tipolibro.find("DigitalMas") != -1:
                self.webview.run_javascript("var els = document.getElementsByTagName('a'); for (var i = 0; i < els.length; i++) {if(els[i].getAttribute(\"target\") === \"_blank\") { if (els[i].getAttribute('href').indexOf('?') != -1){els[i].setAttribute('href', els[i].getAttribute('href') + '&gretanw=1');} else { els[i].setAttribute('href', els[i].getAttribute('href') + '?gretanw=1');}}}")
                self.webview.run_javascript("function crearDiv(){var body = document.getElementsByTagName('body')[0]; var div1 = document.createElement('div'); div1.innerHTML = \"<div id='canvasSimpleToolsDiv'></div>\";body.appendChild(div1); }")
                self.webview.run_javascript("function loadScript(url){ var body = document.getElementsByTagName('body')[0]; var script = document.createElement('script'); script.type = 'text/javascript'; script.src = url; body.appendChild(script); }")
                self.webview.run_javascript("crearDiv();")
                self.webview.run_javascript("if(typeof jQuery == 'undefined'){loadScript('http://127.0.0.1:" + str(PORT) + "/"+self.isbnactual+"/jquery-3.2.0.min.js');}")
                self.webview.run_javascript("loadScript('http://127.0.0.1:" + str(PORT) + "/"+self.isbnactual+"/canvashermes.js');")
                self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'var raizlibro = \"http://127.0.0.1:" + str(PORT) + "/"+self.isbnactual+"/\"'; document.body.appendChild(script_tag);")
                self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'var descargarUnidad = function(indice){alert(\"cgavisor://filtrarUnidadRetos(\"+indice+\")\");}'; document.body.appendChild(script_tag);")
                self.webview.run_javascript("$('body').bind('DOMSubtreeModified', function(){ var canvas = document.getElementById('canvasSimpleTools'); var context = canvas.getContext('2d'); context.clearRect(0, 0, canvas.width, canvas.height); });")

            #Fuente con espacios
            self.webview.run_javascript("$('body').css('font-variant-ligatures', 'discretionary-ligatures')")

            if self.tipolibro.find("HTML5_NAVEGABLE") != -1:

                if self.blcompatevents == False:
                    self.blcompatevents = True
                    self.blfile = self.librospath + self.isbnactual + "/themes/responsive/assets/styles/anaya_indice_2016/style.js"
                    self.replaceTapEvent(None, self.blfile, False)
                    self.blfile = self.librospath + self.isbnactual + "/themes/responsive/assets/styles/anaya/style.js"
                    self.replaceTapEvent(None, self.blfile, False)

                self.blfile = self.webview.get_uri().replace("http://127.0.0.1:" + str(PORT) + "/", "")
                self.uriblfile = self.blfile
                self.blfile = self.librospath + self.blfile
                self.replaceTapEvent(self.uriblfile, self.blfile, True)

                self.webview.run_javascript('blink.rest.openUrl = function(view, url, ent){location.href=url;};')

                # ScormPlayer Blink
                self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'var scormPlayer = {}; scormPlayer.createTraza = function(){alert(\"cgavisor://createTraza()\");}; scormPlayer.createMarsupial = function(){alert(\"cgavisor://createMarsupial()\");}; scormPlayer.saveMarsupial = function(objDatosTraza, objMarsupial){alert(\"cgavisor://saveMarsupial(\"+objDatosTraza+\" |#|#| \"+objMarsupial+\")\");}; scormPlayer.setidclase = function(idclase){alert(\"cgavisor://setidclase(\"+idclase+\")\");}; scormPlayer.setidscorm = function(idscorm){alert(\"cgavisor://setidscorm(\"+idscorm+\")\");};  '; document.head.appendChild(script_tag); var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.src = 'apiscormanaya.js'; document.head.appendChild(script_tag); var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.src = 'apiscormlibro.js'; document.head.appendChild(script_tag);")
                self.webview.run_javascript("window.datosTraza; window.scormPlayerLibrogeno = window;")
                self.webview.run_javascript("blink.rest.openUrl = function(view, url, ent){location.href=url;};")

            else:
                # ScormPlayer cualquier libro menos Blink
                URL_LOCAL = "http://127.0.0.1:" + str(PORT)
                self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'var urlLibrogenoLigera = function(i, s, r){alert(\"cgavisor://urlLibrogenoLigera(\"+i+\", \"+s+\", \"+r+\")\");}; '; document.body.appendChild(script_tag);")
                self.webview.run_javascript("var datosTraza; var scormPlayerLibrogeno = window; var scormPlayer = window; var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.src = '"+URL_LOCAL+"/"+self.isbnactual+"/apib.min.js'; document.head.appendChild(script_tag); var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.src = '"+URL_LOCAL+"/"+self.isbnactual+"/apiscormanaya.js'; document.head.appendChild(script_tag); var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.src = '"+URL_LOCAL+"/"+self.isbnactual+"/interactios.js'; document.head.appendChild(script_tag); var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.src = '"+URL_LOCAL+"/"+self.isbnactual+"/scormAPI_12.js'; document.head.appendChild(script_tag); var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.src = '"+URL_LOCAL+"/"+self.isbnactual+"/slides.min.js'; document.head.appendChild(script_tag); var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'var scormPlayer = {}; scormPlayer.createTraza = function(){alert(\"cgavisor://createTraza()\");}; scormPlayer.createMarsupial = function(){alert(\"cgavisor://createMarsupial()\");}; scormPlayer.saveMarsupial = function(objDatosTraza, objMarsupial){alert(\"cgavisor://saveMarsupial(\"+objDatosTraza+\" |#|#| \"+objMarsupial+\")\");}; scormPlayer.setidclase = function(idclase){alert(\"cgavisor://setidclase(\"+idclase+\")\");}; scormPlayer.setidscorm = function(idscorm){alert(\"cgavisor://setidscorm(\"+idscorm+\")\");};    '; document.head.appendChild(script_tag);")

                self.webview.run_javascript("var i = 0; var interv = setInterval(function(){ if (typeof cargarCanvas != 'undefined') { try { cargarCanvas(); if($('canvas').first().width() > 0 && $('canvas').first().css('webkitUserSelect') === 'none' ){ clearInterval(interv); console.log('canvas cargado: ' + $('canvas').first().width()) } } catch(e){} } i++; if (i > 50000) { clearInterval(interv); } }, 100);")

                # Botones de recursos web
                conn = sqlite3.connect(self.DATABASE_PATH)
                c = conn.cursor()
                c.execute("SELECT licencia FROM LIBROS WHERE isbn LIKE '"+self.isbnactual+"'")
                licencia = ''.join(c.fetchone())
                conn.commit()
                conn.close()

                ts = time.time() + 900 # + 15 minutos
                self.minutos15 = datetime.datetime.fromtimestamp(int(ts)).strftime('%M')
                ts = ts - 900
                self.segundos = datetime.datetime.fromtimestamp(int(ts)).strftime('%S')
                self.fecharecursos = datetime.datetime.fromtimestamp(int(ts)).strftime('%Y%m%d%H') + self.minutos15 + self.segundos
                pvkey = "*==/&HERMES&/==*"
                firmarecursos = licencia

                i = 0
                while i < 10:
                    firmarecursos = hashlib.sha256(pvkey + firmarecursos + self.fecharecursos).hexdigest()
                    i+=1
                    pass


                if "descifrada_inicio.html" not in self.webview.get_uri():

                    self.jsgrc = "var scriptgrc = jQuery(\"body\").html().substring(jQuery(\"body\").html().indexOf(\"$(\\'#recursosweb\\')\"), jQuery(\"body\").html().indexOf(\"$(\\\".descargas_uni\\\").each\"));"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/grc.anaya/g, \"srvrecursos.anaya\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/\\'\\,false\\,/g, \"&credencial=" + licencia + "&fecha=" + self.fecharecursos + "&firma=" + firmarecursos + "\\',false,\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/\\'\\,true\\,/g, \"&credencial=" + licencia + "&fecha=" + self.fecharecursos + "&firma=" + firmarecursos + "\\',false,\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(\"//popup(\\\"./pdf/ayuda.pdf\\\", false);\", \"\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/\\n/g, \"\");"
                    self.jsgrc += "var newscriptgrc = document.createElement(\"script\");"
                    self.jsgrc += "newscriptgrc.type=\"text/javascript\";"
                    self.jsgrc += "newscriptgrc.text = scriptgrc;"
                    self.jsgrc += "document.body.appendChild(newscriptgrc);"
                    self.webview.run_javascript(self.jsgrc)

                    self.jsgrc = "var scriptgrc = jQuery(\"body\").html().substring(jQuery(\"body\").html().indexOf(\"$(\\'#banrec\\')\"), jQuery(\"body\").html().indexOf(\"$(\\\".ayuda\\\")\"));"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/grc.anaya/g, \"srvrecursos.anaya\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/\\'\\,false\\,\\'ejecutable\\'/g, \"&credencial=" + licencia + "&fecha=" + self.fecharecursos + "&firma=" + firmarecursos + "\\',false,\\\'ejecutable\\\',0,0,false,false\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/\\'\\,true\\,\\'ejecutable\\'/g, \"&credencial=" + licencia + "&fecha=" + self.fecharecursos + "&firma=" + firmarecursos + "\\',false,\\\'ejecutable\\\',0,0,false,false\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(\"//popup(\\\"./pdf/ayuda.pdf\\\", false);\", \"\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/\\n/g, \"\");"
                    self.jsgrc += "var newscriptgrc = document.createElement(\"script\");"
                    self.jsgrc += "newscriptgrc.type=\"text/javascript\";"
                    self.jsgrc += "newscriptgrc.text = scriptgrc;"
                    self.jsgrc += "document.body.appendChild(newscriptgrc);"
                    self.webview.run_javascript(self.jsgrc)

                else:

                    self.jsgrc = "var scriptgrc = jQuery(\"body\").html().substring(jQuery(\"body\").html().indexOf(\"$(\\'#bancorec\\')\"), jQuery(\"body\").html().indexOf(\"});\\n</script>\") - 4);"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/grc.anaya/g, \"srvrecursos.anaya\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/\\'\\,false\\,\\'ejecutable\\'/g, \"&credencial=" + licencia + "&fecha=" + self.fecharecursos + "&firma=" + firmarecursos + "\\',false,\\\'ejecutable\\\',0,0,false,false\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/\\'\\,true\\,\\'ejecutable\\'/g, \"&credencial=" + licencia + "&fecha=" + self.fecharecursos + "&firma=" + firmarecursos + "\\',false,\\\'ejecutable\\\',0,0,false,false\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(\"//popup(\\\"./pdf/ayuda.pdf\\\", false);\", \"\");"
                    self.jsgrc += "scriptgrc = scriptgrc.replace(/\\n/g, \"\");"
                    self.jsgrc += "var newscriptgrc = document.createElement(\"script\");"
                    self.jsgrc += "newscriptgrc.type=\"text/javascript\";"
                    self.jsgrc += "newscriptgrc.text = scriptgrc;"
                    self.jsgrc += "document.body.appendChild(newscriptgrc);"
                    self.webview.run_javascript(self.jsgrc)

            # Obtener traza del servidor
            if not self.trazaObtenida:
                self.trazaObtenida = True
                straza = self.obtenerTraza()
                if len(straza) > 0:
                    jstraza = json.loads(straza)

                    if len(jstraza["resultOut"]) > 2:
                        licencia = jstraza["resultOut"]["key"]
                        fecha = jstraza["resultOut"]["updated"]
                        objMarsupial = jstraza["resultOut"]["marsupial_data"]
                        objDatosTraza = jstraza["resultOut"]["scorm_data"]

                        eobjDatosTraza = objDatosTraza #.encode('ascii', 'ignore').decode('ascii')

                        conn = sqlite3.connect(self.DATABASE_PATH)
                        c = conn.cursor()
                        c.execute("INSERT OR REPLACE INTO TRAZAANAYA (licencia, timestampa, marsupial_data, scorm_data) VALUES ('" + str(licencia) + "', '" + str(fecha) + "', '" + str(objMarsupial) + "', '" + eobjDatosTraza + "')")
                        conn.commit()
                        conn.close()

            self.webview.run_javascript("var script_tag = document.createElement('script'); script_tag.type = 'text/javascript'; script_tag.text = 'var oua = navigator.userAgent; if (oua.indexOf(\\\'iPad\\\') == -1) { Object.defineProperty(window.navigator, \\\'userAgent\\\', { value: oua + \\\' iPad\\\', configurable: true }); } anotaciones(jQuery, getStorage(\\\'TOTAL\\\')); '; document.head.appendChild(script_tag);")

    def replaceTapEvent(self,uriblfile,blfile,redir):
        os.chdir(self.apppath)
        try:
            with open(blfile) as f:
                data = f.read()
            f.close()

            if data.find('on("tap') != -1 or data.find("on('tap") != -1:

                data = data.replace('on("tap', 'on("click').replace("on('tap", "on('click")

                findex = open(blfile, "w")
                findex.write(data)
                findex.close

                if redir:
                    self.__navegacion("http://127.0.0.1:" + str(PORT) + "/" + uriblfile)
        except Exception as e:
            pass
        os.chdir(self.librospath)

    def __navegacion(self,url):
        self.webview.load_uri(url)
        #self.webview.open(url)
        #cookiejar = Soup.CookieJarText.new("./cookies.txt", False);
        #cookiejar.set_accept_policy(Soup.CookieJarAcceptPolicy.ALWAYS);
        #session = WebKit.get_default_session()

    def on_navegador_destroy(self,*args):
        #self.httpd.shutdown()
        #self.httpd.server_close()
        #self.visor.destroy()
        os.remove(self.librospath + "/"+self.isbnactual+"/descifrada.html")
        self.trazaObtenida = False
        self.visor.hide()
        return True
        #Se cierra la aplicación
        #Gtk.main_quit()
        #httpd.server_close()

    def enviarTraza(self, licencia, fecha, objMarsupial, objDatosTraza):
        # Guardar traza en servidor
        try:
            body = json.dumps({u"key": u""+licencia+"", u"timestamp": u""+str(fecha)+"", u"marsupial_data": u""+str(objMarsupial)+"", u"scorm_data": u""+str(objDatosTraza)+""})
            url = u""+self.urltrazabilidad+"/save"
            r = requests.post(url=url, data=body, headers={'x-api-key': 'aabbCDferfasd'}, verify=False)
        except Exception as e:
            print e

    def obtenerTraza(self):
        try:
            conn = sqlite3.connect(self.DATABASE_PATH)
            c = conn.cursor()
            c.execute("SELECT licencia FROM LIBROS WHERE isbn LIKE '"+self.isbnactual+"'")
            licencia = ''.join(c.fetchone())
            conn.commit()
            conn.close()

            url = u""+self.urltrazabilidad+"/get/"+licencia
            r = requests.get(url=url, headers={'x-api-key': 'aabbCDferfasd'}, verify=False)

            return r.content
        except Exception as e:
            print e

        return ""

    # WEBVIEW LIBROS
    ############################################################################

    ############################################################################
    # DESCARGAR LIBROS

    def descargarLibro(self, licencia):
        # Crear thread para descargarLibro
        t = threading.Thread(target=self.descargarPackLicencia, args=(licencia,))
        t.start()

    def ejecutarServicio(self, licencia, tipo, unidad_id = 0):

        ntipo = 0

        if tipo == "descargar":
            ntipo = 1
        if tipo == "descargado":
            ntipo = 3
        if tipo == "eliminar":
            ntipo = 4
        if tipo == "pack":
            ntipo = 8

        if ntipo > 0:
            urlservicio = "http://ebook.edistribucion.es/services.php"
            pvkey = "*gt-n_)6%6(_n-gt*"
            deviceid = str(uuid.getnode());

            signature = licencia + deviceid

            i = 0
            while i < 10:
                signature = hashlib.sha256(pvkey + signature).hexdigest()
                i+=1
                pass

            if ntipo == 1:
                self.txtlicencia.set_text("Comprobando licencia...")
                self.txtlicencia.set_editable(False)

            urlserviciop = urlservicio + "?service="+str(ntipo)+"&origin=1004&license_code="+licencia+"&device_id="+deviceid+"&signature="+signature+"&os_type=Linux"

            if (unidad_id > 0):
                urlserviciop = urlserviciop + "&unit_id=" + unidad_id

            r = requests.get(urlserviciop, params=None, verify=False)
            r.encoding = 'utf8'
            res = r.text

            #res = '<pack><status>OK</status><credentials><credential>M2F3-JYR9-BZY4-ZRZV</credential><credential>4UEB-3SP4-ZK4T-V9SH</credential><credential>5P67-W6Y7-4JY9-KZ9C</credential><credential>GCP5-W8QT-JH2U-D77C</credential></credentials></pack>';

            objLibro = objectify.fromstring(res.encode('utf8'))

            if ntipo == 1:
                self.txtlicencia.set_text("")
                self.txtlicencia.set_editable(True)

            if len(objLibro.findall("error")):
                #if unidad_id > 0:
                mensaje = objLibro.error.text
                GLib.idle_add(self.mensaje, mensaje)
                return False
            else:
                return objLibro

    def descargarPackLicencia(self, licencia):
        objPack = self.ejecutarServicio(licencia, "pack")
        if objPack:
            if objPack.status == "ERROR":
                t = threading.Thread(target=self.descargarLibroLicencia, args=(licencia,))
                t.start()
            else:
                for credential in objPack.credentials.credential:
                    print credential
                    GLib.idle_add(self.guardarEnColaDescarga, credential)
                GLib.idle_add(self.procesarColaDescarga)

    def descargarLibroLicencia(self, licencia):
        if (self.descargando):
            GLib.idle_add(self.guardarEnColaDescarga, licencia)
        else:
            objLibro = self.ejecutarServicio(licencia, "descargar")
            if objLibro:
                # Guardar isbn
                isbn = objLibro.isbn.text

                conn = sqlite3.connect(self.DATABASE_PATH)
                c = conn.cursor()
                c.execute("SELECT titulo FROM LIBROS WHERE isbn=" + str(isbn))
                libro = c.fetchone()
                if libro is None:
                    # Descargar portada
                    try:
                        urlportada = objLibro.thumbnail.text
                        self.descargar_libro_archivo(urlportada, isbn, licencia)
                    except:
                        print "Error al descargar portada"

                    #self.registrarLibro(objLibro, licencia)
                    GLib.idle_add(self.registrarLibro, objLibro, licencia)

                    #Descargar libro
                    urldescarga = objLibro.URL.text
                    self.descargar_libro_archivo(urldescarga, isbn, licencia)

                else:
                    libro = libro[0].encode('utf-8').strip()
                    GLib.idle_add(self.mensaje, "Este libro ya existe ("+str(libro)+")")

                conn.close()

    def descargarUnidadLibrogeno(self, orden, tipo, ruta):
        unidad_tipo = "COMPLETA"
        if tipo.find("l") != -1:
            unidad_tipo = "PARCIAL"

        conn = sqlite3.connect(self.DATABASE_PATH)
        c = conn.cursor()
        c.execute("SELECT unit_id FROM UNITS WHERE order_unit LIKE '"+orden+"' AND isbn LIKE '"+self.isbnactual+"' AND type LIKE '"+unidad_tipo+"'")
        unidad_id = ''.join(c.fetchone())

        c.execute("SELECT licencia FROM LIBROS WHERE isbn LIKE '"+self.isbnactual+"'")
        licencia = ''.join(c.fetchone())

        conn.close()

        ruta = ""

        t = threading.Thread(target=self.descargarUnidadLicencia, args=(licencia, unidad_id, unidad_tipo, ruta, orden))
        t.start()

    def descargarUnidadRetos(self, unidad_id):
        conn = sqlite3.connect(self.DATABASE_PATH)
        c = conn.cursor()

        c.execute("SELECT order_unit FROM UNITS WHERE unit_id LIKE '"+unidad_id+"' AND isbn LIKE '"+self.isbnactual+"'")
        orden = ''.join(c.fetchone())

        c.execute("SELECT licencia FROM LIBROS WHERE isbn LIKE '"+self.isbnactual+"'")
        licencia = ''.join(c.fetchone())

        c.execute("UPDATE UNITS SET estado = 'Descargando...' WHERE unit_id = " + unidad_id + " AND isbn LIKE '" + self.isbnactual + "'")
        conn.commit()
        self.mostrarUnidadesRetos(-1)

        conn.close()

        unidad_tipo = None
        ruta = "contentvisor/" + orden

        t = threading.Thread(target=self.descargarUnidadLicencia, args=(licencia, unidad_id, unidad_tipo, ruta, orden))
        t.start()

    def eliminarUnidadLibrogeno(self, orden, tipo, ruta):
        isbn = self.isbnactual
        def eliminarunidad(isbn, ruta, orden, tipo):
            shutil.rmtree(self.librospath + "/" + str(isbn) + "/" + ruta)
            GLib.idle_add(self.recargarDownload)
        t = threading.Thread(target=eliminarunidad,args=(self.isbnactual,ruta,orden,tipo,))
        t.start()

    def eliminarUnidadRetos(self, unidad_id):
        isbn = self.isbnactual

        conn1 = sqlite3.connect(self.DATABASE_PATH)
        c1 = conn1.cursor()

        c1.execute("SELECT order_unit FROM UNITS WHERE unit_id LIKE '"+unidad_id+"' AND isbn LIKE '"+self.isbnactual+"'")
        orden = ''.join(c1.fetchone())

        def eliminarunidadr(isbn, orden):
            shutil.rmtree(self.librospath + "/" + str(isbn) + "/contentvisor/" + orden)
            self.escribirVariables()
            self.mostrarUnidadesRetos(-1)
        t = threading.Thread(target=eliminarunidadr,args=(self.isbnactual,orden,))
        t.start()

        c1.execute("UPDATE UNITS SET estado = 'Descarga disponible' WHERE unit_id = " + unidad_id + " AND isbn LIKE '" + self.isbnactual + "'")
        conn1.commit()
        conn1.close()

    def descargarUnidadLicencia(self, licencia, unidad_id, unidad_tipo, ruta, orden):
        if (self.descargando):
            GLib.idle_add(self.guardarEnColaDescarga, licencia, unidad_id, unidad_tipo, ruta, orden)
        else:
            objUnidad = self.ejecutarServicio(licencia, "descargar", unidad_id)
            if objUnidad:
                rutaunidad = self.isbnactual + "/" + ruta
                urldescarga = objUnidad.URL.text
                self.descargar_libro_archivo(urldescarga, rutaunidad, licencia, unidad_id, ruta)

    def guardarEnColaDescarga(self, licencia, unidad_id = None, unidad_tipo = None, ruta = None, orden = None):
        self.nuevoelementocola = [licencia, unidad_id, unidad_tipo, ruta, orden]
        self.coladescarga.append(self.nuevoelementocola)

    def procesarColaDescarga(self):
        if self.coladescarga:
            licencia = self.coladescarga[0][0]
            unidad_id = self.coladescarga[0][1]
            unidad_tipo = self.coladescarga[0][2]
            ruta = self.coladescarga[0][3]
            orden = self.coladescarga[0][4]

            self.unidadesperando = [orden, unidad_tipo]

            self.coladescarga.pop(0)

            if unidad_id is None:
                t = threading.Thread(target=self.descargarLibroLicencia, args=(licencia,))
                t.start()
            else:
                t = threading.Thread(target=self.descargarUnidadLicencia, args=(licencia, unidad_id, unidad_tipo, ruta, orden,))
                t.start()
        else:
            self.unidadesperando = []

    def descargar_libro_archivo(self, url, isbn, licencia, unidad_id = 0, rutaunidad = ""):

        self.descargando = True

        rutaunidad = rutaunidad.strip()

        portada = False
        local_filename = url.split('/')[-1]
        if ".jpg" in url:
            portada = True
            local_filename = "p_portada.jpg"
        if ".png" in url:
            portada = True
            local_filename = "p_portada.png"

        dlibros = self.librospath + isbn + "/"
        if not os.path.exists(dlibros):
            os.makedirs(dlibros)

        r = requests.get(url, stream=True, verify=False)
        total_length = r.headers.get('content-length')

        if total_length is None:
            f.write(r.content)
        else:
            per = 0
            dl = 0
            total_length = int(total_length)

            #if os.path.exists(local_filename):

            with open(dlibros + local_filename, 'wb') as f:
                for chunk in r.iter_content(chunk_size=4096):
                    if chunk:
                        dl += (len(chunk) * 100)
                        f.write(chunk)
                        done = int(dl / total_length)

                        if not portada:
                            if done != per:
                                per = done
                                if per % 1 == 0:
                                    GLib.idle_add(self.actualizarCelda, "Descargando... (" + str(done) + " %)", done)
                                    if unidad_id > 0:
                                        GLib.idle_add(self.visor.set_title, "CGAvisor | Descargando Unidad ... " + str(done) + "%")

                f.close()

                if not portada:
                    GLib.idle_add(self.actualizarCelda, "Descomprimiendo...", -1)
                    if unidad_id > 0:
                        GLib.idle_add(self.visor.set_title, "CGAvisor | Descomprimiendo Unidad ... ")
                    try:
                        os.rename(dlibros + local_filename, dlibros + "libro.tar")
                        zipf = dlibros + "libro.tar"
                        zip_ref = zipfile.ZipFile(str(zipf))
                        zip_ref.extractall(str(dlibros))
                        self.ejecutarServicio(licencia, "descargado", unidad_id)

                        if unidad_id > 0:
                            GLib.idle_add(self.recargarDownload)
                            conn1 = sqlite3.connect(self.DATABASE_PATH)
                            c1 = conn1.cursor()
                            c1.execute("UPDATE UNITS SET estado = 'Descargada' WHERE unit_id = " + unidad_id + " AND isbn LIKE '" + self.isbnactual + "'")
                            conn1.commit()
                            conn1.close()
                            if self.tipolibro.find("HTML5Infantil") != -1:
                                self.escribirVariables()
                                self.mostrarUnidadesRetos(-1)

                    except zipfile.BadZipfile:
                        GLib.idle_add(self.mensaje, "Error al descomprimir 0x001")

                    os.remove(zipf)
                    GLib.idle_add(self.actualizarCelda, "", 0)
                    if unidad_id > 0:
                        GLib.idle_add(self.visor.set_title, "CGAvisor")

                #if rutaunidad is not "":
                #    self.pathdownload = dlibros+rutaunidad+"/js/scriptsNEW.js"
                #    if os.path.exists(self.pathdownload):
                #        with open(self.pathdownload) as f:
                #            data = f.read()
                #        f.close()
                #        data = data.replace("urlLibrogenoLigera(url, opcionalnomostrar, undefined);", "location.href='cgavisor://urlLibrogenoLigera('+url+', '+opcionalnomostrar+', '+undefined+')';")
                #        findex = open(self.pathdownload, "w")
                #        findex.write(data)
                #        findex.close

                self.descargando = False
                GLib.idle_add(self.procesarColaDescarga)

            return local_filename

    def recargarDownload(self):
        self.webview.run_javascript("if (document.getElementById('iframecontenido').contentWindow.location.href.indexOf('download.html') !== -1) { document.getElementById('iframecontenido').contentWindow.location.reload(); } else { window.location.reload(true); };")

    def registrarLibro(self, objLibro, licencia):
        #from pprint import pprint
        #pprint(vars(objLibro))

        conn = sqlite3.connect(self.DATABASE_PATH)
        c = conn.cursor()
        #c.execute("DELETE FROM LIBROS")

        title = unicode(objLibro.title)
        title = title.replace("\'", "\'\'")
        c.execute("INSERT INTO LIBROS VALUES ('.', '" + str(objLibro.isbn) + "', '" + title + "', '" + licencia + "', '', '" + objLibro.expiration_date + "', 0, '" + objLibro.URL + "', '" + str(objLibro.size) + "', '" + objLibro.author + "', 0, '" + objLibro.book_type + "')")

        # Guardar unidades si las tuviera
        if objLibro.units.find("unit") is not None:
            for unit in objLibro.units.unit:
                self.titulounidad = unicode(unit.title)
                self.titulounidad = self.titulounidad.replace("'", "''")
                c.execute("INSERT INTO UNITS VALUES('"+str(unit.unit_id)+"', '"+str(objLibro.isbn)+"', '"+str(unit.order)+"', '"+str(unit.size)+"', '"+self.titulounidad+"', '"+str(unit.type)+"', 'Descarga disponible')")

        conn.commit()
        conn.close()
        GLib.idle_add(self.gridLibros, self.librosfila)

    # DESCARGAR LIBROS
    ############################################################################

    ############################################################################
    # INTERFAZ

    def on_btndescargar_clicked(self, *args):
        licencia = self.txtlicencia.get_text().strip()
        if (licencia):
            self.descargarLibro(licencia)
            self.txtlicencia.set_text("")

    def on_btninfo_clicked(self, *args):
        if self.info1vez:
            self.info1vez = False
            self.scrolledwindow2 = self.glade.get_object('scrolledwindow2')
            self.webviewinfo = WebKit.WebView()
            self.scrolledwindow2.add(self.webviewinfo)
            self.webviewinfo.load_uri("http://127.0.0.1:" + str(PORT) + "/info.html")
        self.info.show_all()

    def on_btnconfig_clicked(self, *args):
        if self.config1vez:
            self.config1vez = False
            self.btncatalogo = self.glade.get_object('btncatalogo')
            self.btncatalogo.set_has_window(True)
            self.btncatalogo.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
            self.btncatalogo.connect('button-press-event', self.on_btncatalogo_clicked)
        self.ventanaconfig.show_all()

    def on_btncatalogo_clicked(self, *args):
        import webbrowser
        webbrowser.open("http://www.cga.es/tiendaonline/")

    def on_ventanaconfig_destroy(self, *args):
        self.ventanaconfig.hide()
        return True

    def on_ventanainfo_destroy(self, *args):
        self.info.hide()
        return True

    def on_visorunidades_destroy(self, *args):
        self.visorunidades.hide()
        return True

    # Retos ####################################################################
    def barraRetos(self):

        self.mostrandocontroles = False
        self.mostrandocolores = False
        self.mostrandogrosores = False
        self.pintando = True

        self.br_logo = self.glade.get_object('logoanayaretos')

        self.br_btnretosatras = self.glade.get_object('btnretosatras1')
        self.br_btnretosatras.set_has_window(True)
        self.br_btnretosatras.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btnretosatras.connect('button-press-event', self.on_br_btnretosatras_clicked)

        self.br_btnretoscerrar = self.glade.get_object('btnretoscerrar')
        self.br_btnretoscerrar.set_has_window(True)
        self.br_btnretoscerrar.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btnretoscerrar.connect('button-press-event', self.on_br_btnretoscerrar_clicked)

        self.br_btndescargarunidadesretos = self.glade.get_object('btndescargarunidadesretos')
        self.br_btndescargarunidadesretos.set_has_window(True)
        self.br_btndescargarunidadesretos.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btndescargarunidadesretos.connect('button-press-event', self.on_br_descargarunidades_clicked, -1)

        self.br_btncontrolesretos = self.glade.get_object('btncontrolesretos')
        self.br_eventcontrolesretos = self.glade.get_object('eventcontrolesretos')

        self.br_btncoloresretos = self.glade.get_object('btncoloresretos')
        self.br_btncolor1 = self.glade.get_object('btncolor1')
        self.br_btncolor1.set_has_window(True)
        self.br_btncolor1.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btncolor1.connect('button-press-event', self.on_br_btncolor_clicked, 1)
        self.br_btncolor2 = self.glade.get_object('btncolor2')
        self.br_btncolor2.set_has_window(True)
        self.br_btncolor2.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btncolor2.connect('button-press-event', self.on_br_btncolor_clicked, 2)
        self.br_btncolor3 = self.glade.get_object('btncolor3')
        self.br_btncolor3.set_has_window(True)
        self.br_btncolor3.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btncolor3.connect('button-press-event', self.on_br_btncolor_clicked, 3)
        self.br_btncolor4 = self.glade.get_object('btncolor4')
        self.br_btncolor4.set_has_window(True)
        self.br_btncolor4.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btncolor4.connect('button-press-event', self.on_br_btncolor_clicked, 4)
        self.br_btncolor5 = self.glade.get_object('btncolor5')
        self.br_btncolor5.set_has_window(True)
        self.br_btncolor5.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btncolor5.connect('button-press-event', self.on_br_btncolor_clicked, 5)
        self.br_btncolor6 = self.glade.get_object('btncolor6')
        self.br_btncolor6.set_has_window(True)
        self.br_btncolor6.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btncolor6.connect('button-press-event', self.on_br_btncolor_clicked, 6)

        self.br_eventcoloresretos = self.glade.get_object('eventcoloresretos')
        self.br_btnlapizretos = self.glade.get_object('btnlapizretos')
        self.br_eventlapizretos = self.glade.get_object('eventlapizretos')
        self.br_btngomaretos = self.glade.get_object('btngomaretos')
        self.br_eventgomaretos = self.glade.get_object('eventgomaretos')
        self.br_buttonboxcanvas = self.glade.get_object('buttonboxcanvas')

        os.chdir(self.apppath)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/logo_anaya_130.png")
        pixbuf = pixbuf.scale_simple(110, 25, InterpType.TILES)
        self.br_logo.set_from_pixbuf(pixbuf)
        self.br_logo.set_margin_right(10)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/descarga.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btndescargarunidadesretos.set_from_pixbuf(pixbuf)

        self.on_quitar_herramientas()
        os.chdir(self.apppath)
        self.br_eventcontrolesretos.set_has_window(True)
        self.br_eventcontrolesretos.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_eventcontrolesretos.connect('button-press-event', self.on_br_eventcontrolesretos_clicked)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/boton_colores.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btncoloresretos.set_from_pixbuf(pixbuf)
        self.br_btncoloresretos.set_margin_right(10)
        self.br_eventcoloresretos.set_has_window(True)
        self.br_eventcoloresretos.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_eventcoloresretos.connect('button-press-event', self.on_br_eventcoloresretos_clicked)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/btn_color_amarillo.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btncolor1.set_from_pixbuf(pixbuf)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/btn_color_rojo.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btncolor2.set_from_pixbuf(pixbuf)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/btn_color_naranja.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btncolor3.set_from_pixbuf(pixbuf)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/btn_color_verde.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btncolor4.set_from_pixbuf(pixbuf)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/btn_color_rosa.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btncolor5.set_from_pixbuf(pixbuf)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/btn_color_azul.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btncolor6.set_from_pixbuf(pixbuf)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/boton_lapiz.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btnlapizretos.set_from_pixbuf(pixbuf)
        self.br_btnlapizretos.set_margin_right(10)
        self.br_btnlapizretos.set_has_window(True)
        self.br_btnlapizretos.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btnlapizretos.connect('button-press-event', self.on_br_eventgrosoresretos_clicked)

        self.br_btngrosor1 = self.glade.get_object('btngrosor1')
        self.br_btngrosor1.set_has_window(True)
        self.br_btngrosor1.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btngrosor1.connect('button-press-event', self.on_br_btngrosor_clicked, 4)
        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/grosor_4.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btngrosor1.set_from_pixbuf(pixbuf)

        self.br_btngrosor2 = self.glade.get_object('btngrosor2')
        self.br_btngrosor2.set_has_window(True)
        self.br_btngrosor2.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btngrosor2.connect('button-press-event', self.on_br_btngrosor_clicked, 3)
        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/grosor_3.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btngrosor2.set_from_pixbuf(pixbuf)

        self.br_btngrosor3 = self.glade.get_object('btngrosor3')
        self.br_btngrosor3.set_has_window(True)
        self.br_btngrosor3.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btngrosor3.connect('button-press-event', self.on_br_btngrosor_clicked, 2)
        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/grosor_2.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btngrosor3.set_from_pixbuf(pixbuf)

        self.br_btngrosor4 = self.glade.get_object('btngrosor4')
        self.br_btngrosor4.set_has_window(True)
        self.br_btngrosor4.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_btngrosor4.connect('button-press-event', self.on_br_btngrosor_clicked, 1)
        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/grosor_1.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btngrosor4.set_from_pixbuf(pixbuf)

        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/boton_goma.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btngomaretos.set_from_pixbuf(pixbuf)
        self.br_btngomaretos.set_margin_right(10)
        self.br_eventgomaretos.set_has_window(True)
        self.br_eventgomaretos.set_events(Gdk.EventMask.BUTTON_PRESS_MASK)
        self.br_eventgomaretos.connect('button-press-event', self.on_br_eventgomaretos_clicked)

        os.chdir(self.librospath)

    def on_br_btnretosatras_clicked(self, a, b):
        if self.webview.can_go_back():
            self.webview.go_back()
        else:
            self.visor.hide()

    def on_br_btnretoscerrar_clicked(self, a, b):
        self.visor.hide()

    def on_br_eventcontrolesretos_clicked(self, a, b):

        if not self.mostrandocontroles:
            self.mostrandocontroles = True
            self.br_buttonboxcanvas.show()

            os.chdir(self.apppath)
            pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/boton_herramientas_press.png")
            pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
            self.br_btncontrolesretos.set_from_pixbuf(pixbuf)
            os.chdir(self.librospath)

            self.webview.run_javascript("activarCanvas()")

        else:
            self.mostrandocontroles = False
            self.br_buttonboxcanvas.hide()

            os.chdir(self.apppath)
            pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/boton_herramientas.png")
            pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
            self.br_btncontrolesretos.set_from_pixbuf(pixbuf)
            os.chdir(self.librospath)

            self.webview.run_javascript("desactivarCanvas()")

    def on_br_eventcoloresretos_clicked(self, a, b):

        self.panelfijo = self.glade.get_object('panelfijo')
        self.boxpanel = self.glade.get_object('boxpanel')

        if not self.mostrandocolores:
            self.mostrandocolores = True
            self.br_boxcolores.set_opacity(1)
            self.br_boxcolores.show()
        else:
            self.br_boxcolores.hide()
            self.mostrandocolores = False

    def on_br_btncolor_clicked(self, a, b, color):

        if not self.pintando:
            self.pintando = True
            self.webview.run_javascript("grosorCanvas(2)")
            self.webview.run_javascript("tipoCanvas('marker')")
            self.on_quitar_goma()

        if color == 1:
            self.webview.run_javascript("colorCanvas('#fecc00')")
        if color == 2:
            self.webview.run_javascript("colorCanvas('#e2001a')")
        if color == 3:
            self.webview.run_javascript("colorCanvas('#ee7f01')")
        if color == 4:
            self.webview.run_javascript("colorCanvas('#b1c903')")
        if color == 5:
            self.webview.run_javascript("colorCanvas('#e75094')")
        if color == 6:
            self.webview.run_javascript("colorCanvas('#009ee0')")

        self.br_boxcolores.hide()
        self.mostrandocolores = False

        self.br_boxgrosores.hide()
        self.mostrandogrosores = False

        #self.webview.run_javascript("desactivarCanvas()")
        #self.webview.run_javascript("document.getElementByTagName('canvas').remove()")
        #self.webview.run_javascript("canvas_simpleTools.setAttribute('style', 'left:0;top:0;bottom:0;right:0;position:absolute;z-index:9999999;pointer-events:auto;background:#000');")

    def on_br_eventgrosoresretos_clicked(self, a, b):
        if not self.mostrandogrosores:
            self.mostrandogrosores = True
            self.br_boxgrosores.set_opacity(1)
            self.br_boxgrosores.show()
        else:
            self.br_boxgrosores.hide()
            self.mostrandogrosores = False

    def on_br_btngrosor_clicked(self, a, b, color):
        self.webview.run_javascript("grosorCanvas("+str(color)+")")

        self.br_boxcolores.hide()
        self.mostrandocolores = False

        self.br_boxgrosores.hide()
        self.mostrandogrosores = False

        if not self.pintando:
            self.pintando = True
            self.webview.run_javascript("tipoCanvas('marker')")
            self.on_quitar_goma()

    def on_br_eventgomaretos_clicked(self, a, b):
        if self.pintando:
            self.pintando = False
            self.webview.run_javascript("grosorCanvas(4)")
            self.webview.run_javascript("tipoCanvas('eraser')")

            os.chdir(self.apppath)
            pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/boton_goma_press.png")
            pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
            self.br_btngomaretos.set_from_pixbuf(pixbuf)
            os.chdir(self.librospath)
        else:
            self.pintando = True
            self.webview.run_javascript("grosorCanvas(2)")
            self.webview.run_javascript("tipoCanvas('marker')")

            self.on_quitar_goma()

    def on_quitar_goma(self):
        os.chdir(self.apppath)
        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/boton_goma.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btngomaretos.set_from_pixbuf(pixbuf)
        os.chdir(self.librospath)

    def on_quitar_herramientas(self):
        self.br_btncontrolesretos = self.glade.get_object('btncontrolesretos')
        os.chdir(self.apppath)
        pixbuf = GdkPixbuf.Pixbuf.new_from_file(self.respath + "/br/boton_herramientas.png")
        pixbuf = pixbuf.scale_simple(32, 32, InterpType.TILES)
        self.br_btncontrolesretos.set_from_pixbuf(pixbuf)
        os.chdir(self.librospath)

        self.br_boxcolores = self.glade.get_object('boxcolores')
        self.br_boxcolores.set_visible(False)

        self.br_boxgrosores = self.glade.get_object('boxgrosores')
        self.br_boxgrosores.set_visible(False)

        self.br_boxcolores.hide()
        self.mostrandocolores = False

        self.br_boxgrosores.hide()
        self.mostrandogrosores = False

    def on_br_descargarunidades_clicked(self, a, b, indice):

        if self.visorunidades1vez:
            self.visorunidades1vez = False
            self.scrolledwindow3 = self.glade.get_object('scrolledwindow3')
            self.webviewunidades = WebKit.WebView()
            self.webviewunidades.connect("script-dialog", self.script_dialog)
            self.scrolledwindow3.add(self.webviewunidades)
            GLib.idle_add(self.visorunidades.set_title, "CGAvisor")

        self.mostrarUnidadesRetos(indice)

        self.visorunidades.show_all()

    def mostrarUnidadesRetos(self, indice):
        os.chdir(self.apppath)
        with open(self.respath + "/br/unidadesretos.html") as f:
            data = f.read()
        f.close()

        conn = sqlite3.connect(self.DATABASE_PATH)

        data_unidades = ""

        c = conn.cursor()
        if (indice == -1):
            self.query = "SELECT * FROM UNITS WHERE isbn LIKE '"+self.isbnactual+"' ORDER BY CAST(order_unit AS INTEGER)"
        else:
            self.query = "SELECT * FROM UNITS WHERE isbn LIKE '"+self.isbnactual+"' AND order_unit LIKE '"+indice+"' ORDER BY CAST(order_unit AS INTEGER)"

        for row in c.execute(self.query):
            btnunidad = '<div class="btnunidad" onclick="alert(\'cgavisor://descargarUnidadRetos('+str(row[0])+')\');">Descargar</div>'

            if row[6].find("Descargada") != -1:
                btnunidad = '<div class="btnunidad descargada" onclick="alert(\'cgavisor://eliminarUnidadRetos('+str(row[0])+')\');">Eliminar</div>'

            if row[6].find("Descargando...") != -1:
                btnunidad = ''

            data_unidades = data_unidades + '<li><div class="filaunidad"><div class="infounidad"><div class="titulounidad">'+row[4]+'</div><div class="datosunidad"><div class="tipounidad">' + str('').decode('utf-8') + ' '+str(row[5])+'</div><div class="sizeunidad">' + str('').decode('utf-8') + ' '+str(row[3])+'</div><div class="estadounidad">' + str('').decode('utf-8') + ' '+str(row[6])+'</div></div></div>'+btnunidad+'</div></li>'

        conn.close()

        data = data.replace("<!--UNIDADESRETOS-->", data_unidades)
        self.webviewunidades.load_html(data, "/")
        os.chdir(self.librospath)

    def escribirVariables(self):
        self.query = "SELECT * FROM UNITS WHERE isbn LIKE '"+self.isbnactual+"' ORDER BY CAST(order_unit AS INTEGER)"

        conn = sqlite3.connect(self.DATABASE_PATH)
        c = conn.cursor()

        for row in c.execute(self.query):
            orden = row[2]
            tipo = row[5]
            GLib.idle_add(self.webview.run_javascript, "unidad" + orden + "estado = undefined; unidad" + orden + "ruta = \"http://127.0.0.1:" + str(PORT) + "/" + self.isbnactual + "/contentvisor/" + orden + "/index.html\" ");

        for row in c.execute(self.query):
            orden = row[2]
            tipo = row[5]
            estado = row[6]
            if estado.find("Descargada") != -1:
                if tipo.find("COMPLETA") != -1:
                    estado = "2"
                else:
                    estado = "1"
                jsvariables = "unidad" + orden + "estado = " + estado + "; unidad" + orden + "ruta = \"http://127.0.0.1:" + str(PORT) + "/" + self.isbnactual + "/contentvisor/" + orden + "/index.html\" "
                GLib.idle_add(self.webview.run_javascript, jsvariables);

            self.estadoRetos()

        conn.close()

    def descifrarUnidad(self, pathunidad):
        with open(pathunidad+"/index.html") as f:
            data = f.read()
        f.close()

        self.key = "@4CKaOW|_.3CF"
        keybytes = str.encode(self.key)
        keyfinal = hashlib.sha256(self.key)
        keyf = keyfinal.digest()
        keyf = keyf[:16]

        IV = ('00000000000000000000000000000000').decode('hex')
        decipher = python_AES.new(keyf,python_AES.MODE_CBC,IV)
        data = base64.b64decode(data)
        plaintext = decipher.decrypt(data)
        (plaintext).encode('hex')
        findex = open(pathunidad+"/descifrada.html", "w")
        findex.write(plaintext)
        findex.close

    def estadoRetos(self):
        GLib.idle_add(self.webview.run_javascript, "if (typeof estadoretos !== 'undefined') {estadoretos();}");

    # Fin Retos ################################################################

    # INTERFAZ
    ############################################################################

    ############################################################################
    # AUXILIARES

    def mensaje(self, mensaje):
        dialog = Gtk.MessageDialog(None, 0, Gtk.MessageType.INFO, Gtk.ButtonsType.OK, "Error")
        dialog.format_secondary_text(mensaje)
        dialog.run()
        dialog.destroy()

    # AUXILIARES
    ############################################################################

    def on_ventanaprincipal_destroy(self,*args):
        self.httpd.shutdown()
        self.httpd.server_close()

        Gtk.main_quit()

    def main(args=None):
        #Inicia la aplicación
        Gtk.main()

def main(args=None):
    app = App()
    app.main()

if __name__ == '__main__':
    main()
