var matched, browser;

jQuery.uaMatch = function(ua) {
    ua = ua.toLowerCase();

    var match = /(chrome)[ \/]([\w.]+)/.exec(ua) ||
        /(webkit)[ \/]([\w.]+)/.exec(ua) ||
        /(opera)(?:.*version|)[ \/]([\w.]+)/.exec(ua) ||
        /(msie) ([\w.]+)/.exec(ua) ||
        ua.indexOf("compatible") < 0 && /(mozilla)(?:.*? rv:([\w.]+)|)/.exec(ua) || [];

    return {
        browser: match[1] || "",
        version: match[2] || "0"
    };
};

matched = jQuery.uaMatch(navigator.userAgent);
browser = {};

if (matched.browser) {
    browser[matched.browser] = true;
    browser.version = matched.version;
}

// Chrome is Webkit, but Webkit is also Safari.
if (browser.chrome) {
    browser.webkit = true;
} else if (browser.webkit) {
    browser.safari = true;
}

jQuery.browser = browser;

var blink = {};
var msgBoxWidth = 550;
var sonido_ultimo_id_abierto = 0;
var loadpagewithajax = false;
var allowedSpecialCodes = new Array(37, 39, 46, 8, 9);
var imgsizearray = [];

function mostrarAvisoOffline() {
    _showAlert(text_web.aviso_offline)
}

function getWindowObjectByString(f) {
    var d = window;
    var c = f.split(".");
    for (var b = 0; b < c.length; b++) {
        d = d[c[b]]
    }
    return d
}

function callOfflinePCParent(b, c) {
    if (!blink.isOfflinePCApp) {
        return
    }
    if (!c) {
        c = []
    }
    if (blink.appVersion >= 3.4) {
        try {
            var d = {
                task: "js",
                funcStr: b,
                args: c
            };
            top.postMessage(d, "*")
        } catch (g) {
            blink.log.error(g)
        }
    } else {
        try {
            var f = getWindowObjectByString(b);
            f = "parent." + f;
            f.apply(null, c)
        } catch (g) {
            blink.log.error(g)
        }
    }
}

function cambiarIdioma(b) {
    url = location.href.replace("#", "");
    if (url.indexOf("blinklang=") != -1) {
        redireccionar(url.replace(/blinklang=\w\w/, "blinklang=" + b))
    } else {
        redireccionar(url + ((url.indexOf("?") == -1) ? "?" : "&") + "blinklang=" + b)
    }
    return false
}

function compararTexto(texto1, texto2, modoMates, permitirTolerancia) {
    if (modoMates) {
        texto1 = texto1.replace(new RegExp("[=.]+", "g"), "");
        texto1 = texto1.replace(/,/g, ".");
        texto1 = texto1.replace(/'/g, ".");
        texto2 = texto2.replace(new RegExp("[.=]+", "g"), "");
        texto2 = texto2.replace(/,/g, ".");
        texto2 = texto2.replace(/'/g, ".");
        if (!isFinite(texto1)) {
            return false
        }
        if (!isFinite(texto2)) {
            return false
        }
        return (ltrim(clean(texto1), "+") == ltrim(clean(texto2), "+"));
        permitirTolerancia = true;
        if (!permitirTolerancia) {
            return parseFloat(texto1) == parseFloat(texto2)
        } else {
            var valor = parseFloat(texto2);
            var i = 10,
                j = 1;
            while (Math.floor(valor * i) - (valor * i) != 0 && j < 4) {
                i *= 10;
                j++
            }
            if (Math.abs(valor * i) < 10) {
                i *= 10;
                j++
            }
            return (Math.abs(valor - eval(texto1)) <= 1 / i * 1.0001)
        }
    } else {
        return clean(texto1).toLowerCase() == clean(texto2).toLowerCase()
    }
}

function verificarVacios(b, c) {
    return blink.theme.verificarVacios(b, c)
}

function verificarTamanoMinimo(b, c) {
    return blink.theme.verificarTamanoMinimo(b, c)
}

function isValidURL(b) {
    return !!b.match(/^https?:\/\/[0-9a-z\.\-_]+\.[a-z]{2,}/)
}

function isValidEmail(c) {
    var b = /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/;
    if (!b.test(c)) {
        _showAlert(text_web.registro_email_invalido);
        return false
    }
    return true
}

function verificarEmail(b) {
    for (var c = 0; c < b.length; c++) {
        var d = document.getElementById(b[c]);
        if (!d) {
            continue
        }
        if (!isValidEmail($.trim(d.value))) {
            d.focus();
            return false
        }
    }
    return true
}

function verificarSelect(b) {
    for (var c = 0; c < b.length; c++) {
        var d = document.getElementById(b[c]);
        if (!d) {
            continue
        }
        if (!d.selectedIndex) {
            _showAlert(text_web.registro_code_campo_vacio);
            d.focus();
            return false
        }
    }
    return true
}
var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

function encode64(d) {
    d = escape(d);
    var b = "";
    var n, k, h = "";
    var l, j, g, f = "";
    var c = 0;
    do {
        n = d.charCodeAt(c++);
        k = d.charCodeAt(c++);
        h = d.charCodeAt(c++);
        l = n >> 2;
        j = ((n & 3) << 4) | (k >> 4);
        g = ((k & 15) << 2) | (h >> 6);
        f = h & 63;
        if (isNaN(k)) {
            g = f = 64
        } else {
            if (isNaN(h)) {
                f = 64
            }
        }
        b = b + keyStr.charAt(l) + keyStr.charAt(j) + keyStr.charAt(g) + keyStr.charAt(f);
        n = k = h = "";
        l = j = g = f = ""
    } while (c < d.length);
    return b
}

function decode64(f, o) {
    if (f == undefined || f == "") {
        return ""
    }
    var c = "";
    var p, l, j = "";
    var n, k, h, g = "";
    var d = 0;
    var b = /[^A-Za-z0-9\+\/\=]/g;
    if (b.exec(f)) {
        if (o != true) {
            _showAlert("There were invalid base64 characters in the input text.\nValid base64 characters are A-Z, a-z, 0-9, '+', '/',and '='\nExpect errors in decoding.")
        }
    }
    f = f.replace(/[^A-Za-z0-9\+\/\=]/g, "");
    do {
        n = keyStr.indexOf(f.charAt(d++));
        k = keyStr.indexOf(f.charAt(d++));
        h = keyStr.indexOf(f.charAt(d++));
        g = keyStr.indexOf(f.charAt(d++));
        p = (n << 2) | (k >> 4);
        l = ((k & 15) << 4) | (h >> 2);
        j = ((h & 3) << 6) | g;
        c = c + String.fromCharCode(p);
        if (h != 64) {
            c = c + String.fromCharCode(l)
        }
        if (g != 64) {
            c = c + String.fromCharCode(j)
        }
        p = l = j = "";
        n = k = h = g = ""
    } while (d < f.length);
    return decode_utf8(c)
}

function getTimeParam(b) {
    var d = 0;
    var f = b.indexOf("t=");
    if (f != -1) {
        var c = b.indexOf("&", f + 2);
        if (c == -1) {
            c = b.length
        }
        d = b.substr(f + 2, c - (f + 2))
    }
    return d
}

function calculateTimeParameter(b) {
    var d = 0;
    var l = b.split(/t=/);
    if (l.length > 1 && l[1].trim() != "") {
        var k = l[1].split(/[m]/i);
        $seconds = 0;
        if (k.length > 1) {
            var j = k[1];
            if (j.trim() != "") {
                var h = k[1].split(/[s]/i);
                var f = (!isNaN(k[0])) ? parseInt(k[0]) * 60 : 0;
                var g = (h[0].trim() != "" && !isNaN(h[0])) ? parseInt(h[0]) : 0;
                seconds = f + g
            } else {
                seconds = (k[0].trim() != "" && !isNaN(k[0])) ? parseInt(k[0]) * 60 : 0
            }
        } else {
            if (k.length == 1) {
                var c = k[0].split(/[s]/i);
                seconds = (c[0].trim() != "" && !isNaN(c[0])) ? parseInt(c[0]) : 0
            }
        }
        d = seconds
    }
    return d
}

function borrarMultimedia(b) {
    closeMsgBox();
    var c = $("#" + prefijoSeleccionMultimedia + "_img1v").val();
    if (b == "") {
        if (idCursoSeleccionMultimedia == 0) {
            $("[name=perfil_img1v]").val("-1");
            $("#perfil_img1").attr("src", "../images/i/foto_registro.gif")
        } else {
            cargarImagen("", WEB + SIN_IMAGEN_CURSO, true);
            getAJAX("/LMS/ajax.php?op=updatecourseimage&idcurso=" + idCursoSeleccionMultimedia + "&img=", standardAJAXFunc, false)
        }
        return
    } else {
        writeImgPlayer(prefijoSeleccionMultimedia, "../images/multimedia.jpg", $("#" + prefijoSeleccionMultimedia + "_imagezoom").val(), false, $("[name=" + prefijoSeleccionMultimedia + "_img1v_title]").val());
        $("[name=" + b + "_img1v]").val("");
        $("#slide_miniatura_" + secuencia[activeSlide]).attr("src", "../images/multimedia.jpg");
        $("#" + prefijoSeleccionMultimedia + "_picnik").show();
        marcarHaCambiado(getIDSlideFromPrefijo(prefijoSeleccionMultimedia))
    }
}

function setBackgroundImage(c, b) {
    blink.theme.setBackgroundImage(c, b)
}

function _oldsetBackgroundImage(c, b) {
    if (c != "") {
        $("#" + b + "contenidos_curso").prepend('<div class="backimage"><img src="' + c + '" style="z-index:-1;"></div>')
    } else {
        $("#" + b + "contenidos_curso div.backimage").remove()
    }
}

function updateLabelFile(d, b) {
    if (d != "") {
        var c = d.substring(d.lastIndexOf("/") + 1);
        $("#" + b).html(c)
    }
}

function showSlideFromID(c) {
    var b = secuencia.findIndex(c);
    if (b != -1) {
        showSlide(b)
    }
    return false
}

function generaThumbSlide(f, c, b, d) {
    return blink.theme.generaThumbSlide(f, c, b, d)
}

function votar(c, b) {
    getAJAX("/LMS/ajax.php?op=votar&idcurso=" + c + "&valor=" + b, null, false, "votacion_ajax_" + c)
}

function mostrarTooltip(b) {
    toggleLayer(b)
}

function toggleVisibility(c) {
    var b = document.getElementById(c).style.visibility;
    if (b == "visible") {
        document.getElementById(c).style.visibility = "hidden"
    } else {
        document.getElementById(c).style.visibility = "visible"
    }
}

function toggleLayer(d) {
    var b, c;
    if (document.getElementById) {
        b = document.getElementById(d)
    } else {
        if (document.all) {
            b = document.all[d]
        } else {
            if (document.layers) {
                b = document.layers[d]
            }
        }
    }
    c = b.style;
    if (c.display == "" && b.offsetWidth != undefined && b.offsetHeight != undefined) {
        c.display = (b.offsetWidth != 0 && b.offsetHeight != 0) ? "block" : "none"
    }
    c.display = (c.display == "" || c.display == "block") ? "none" : "block"
}
try {
    YAHOO.namespace("example.container")
} catch (e) {}
var usingPasswd = false;

function getWaitingHTML() {
    return blink.theme.getWaitingHTML()
}

function getErrorHTML() {
    return text_web.error_general_AJAX
}

function getMsgBoxFromURL(c, b, d) {
    if (d == null) {
        d = "responsecontainer"
    }
    if (c.startsWith("text:")) {
        setAndExecute(d, decode64(c.substring(5), true));
        return
    }
    c = addParamUrl(c, "theme_msgbox", BLINK_THEME);
    blink.ajax(c, function(f) {
        if (!f || f.startsWith("ERROR")) {
            closeMsgBox();
            blink.rest.connection(function(g) {
                if (g == 0) {
                    _showAlert(text_web.tablettxt_require_connection)
                } else {
                    _showAlert(text_web.error_general_AJAX)
                }
            })
        } else {
            if (blink.isIE7orlower) {
                $("#dlgAJAX").hide().show()
            }
        }
    }, {
        data: b
    }, {
        responseContainer: "#" + d
    })
}
var respAJAX = null;
var pingTimer = null;
var pingTimeout = 1;

function setPingTimer(b) {
    pingTimeout = b;
    initPingTimer()
}

function initPingTimer() {
    pingTimer = setTimeout("ping()", pingTimeout * 1000)
}

function resetPingTimer() {
    if (pingTimer) {
        clearTimeout(pingTimer);
        initPingTimer()
    }
}

function ping(b) {
    if (blink.user.esAnonimo()) {
        return false
    }
    getAJAX("/LMS/ajax.php?op=ping&idcurso=" + idcurso + "&idclase=" + idclase, function(c) {})
}

function changeActiveDiv(b, d, c) {
    $("#solapas > li").removeClass("on");
    $("#solapas > li:eq(" + c + ")").addClass("on");
    if (document.getElementById(d + visibleDiv)) {
        document.getElementById(d + visibleDiv).style.display = "none"
    }
    visibleDiv = c;
    if (document.getElementById(d + visibleDiv)) {
        document.getElementById(d + visibleDiv).style.display = "block"
    }
    $("#" + d + visibleDiv + " .campoonfocustab").focus();
    return false
}
var visibleDiv = 0;

function initializeVisibleDiv(b) {
    visibleDiv = b
}

function getActiveDiv() {
    return visibleDiv
}

function buttonPlayVideoPressed(d, b, c) {
    if (c) {
        blink.theme.rest.video(b, d, c)
    } else {
        blink.rest.video(b)
    }
}

function habilitarBoton(c, b) {
    if (b) {
        $("#" + c).removeClass("disabled").find("a").each(function() {
            $(this).attr("onclick", $(this).attr("onclick_old"));
            $(this).attr("onclick2", "")
        })
    } else {
        $("#" + c).addClass("disabled").find("a").each(function() {
            $(this).attr("onclick2", $(this).attr("onclick_old"));
            $(this).attr("onclick", "return false;")
        })
    }
}

function habilitarBoton2(c, b) {
    blink.theme.habilitarBoton2(c, b)
}

function conmutarEstadoBoton(c, b) {
    blink.theme.conmutarEstadoBoton(c, b)
}
var MODO_STANDALONE = false;

function dlgCreateNewEditCourse(b) {
    showMsgBox("", "/LMS/msgbox.php?op=neweditcourse" + ((b) ? "&idcurso=" + b : ""), "550")
}

function msgboxCopyOldCourseToCurrentYear(b) {
    showMsgBox("", "/LMS/msgbox.php?op=copyoldcoursetocurrentyear&idcurso=" + b, "550")
}

function executeCopyOldCourseToCurrentYear(b) {
    getAJAX("/LMS/ajax.php?op=executecopyoldcoursetocurrentyear&idcurso=" + b, standardAJAX)
}

function dlgCreateNewLibroDemo(b) {
    showMsgBox("", "/LMS/msgbox.php?op=newLibroDemo&idcentro=" + b, "550")
}

function msgboxSmoothCreateWorkingCopy(b) {
    showMsgBox("", "/LMS/msgbox.php?op=smoothcreateworkingcopy&idcurso=" + b, "550")
}

function executeSmoothCreateWorkingCopy(b) {
    getAJAX("/LMS/ajax.php?op=course.smoothCreateWorkingCopy&idcurso=" + b, standardAJAX)
}

function msgboxSmoothPublishWorkingCopy(b) {
    showMsgBox("", "/LMS/msgbox.php?op=smoothpublishworkingcopy&idcurso=" + b, "550")
}

function executeSmoothPublishWorkingCopy(b) {
    getAJAX("/LMS/ajax.php?op=course.smoothPublishWorkingCopy&idcurso=" + b, standardAJAX)
}

function actualizarNumeroMensajesNuevos(b) {
    if (b > 0) {
        $("#header_nummensajes").show().html(b)
    }
}
var numUsuariosVentanaClase = 0;
var hayCambiosVentanaClase = false;
var notIDs = "";
var autocompleteWithTeachers = false;

function definirAutocompleteEditGroup() {
    $("#nombre").blinkcomplete({
        minLength: 2,
        source: function(d, b) {
            var c = "/LMS/ajax.php?";
            c += autocompleteWithTeachers ? "op=searchteacher" : "op=searchstudent&esInfantil=" + esInfantil;
            blink.getJSON(c, b, {
                data: {
                    term: d.term,
                    notIDs: notIDs
                }
            })
        },
        getItemLine1: function(b) {
            return b.label
        },
        open: function(b, c) {
            $(".ui-autocomplete").css("z-index", 4200)
        },
        select: function(b, c) {
            $("#nombre").val(c.item.nombre);
            $("#apellidos").val(c.item.apellidos);
            $("#email").val(c.item.email);
            $("#idusuariohidden").val(c.item.id);
            notIDs += "," + c.item.id;
            definirAutocompleteEditGroup();
            onEditGroupPressEnter();
            return false
        }
    })
}

function addUsuario(b) {
    blink.theme.addUsuario(b)
}

function removeUsuarioExistente(b, g) {
    if (notIDs.length) {
        var c = notIDs;
        var f = notIDs.indexOf(b);
        if (f != -1) {
            var d = "" + b;
            c = notIDs.substr(0, f) + notIDs.substr(f + d.length + 1)
        }
        notIDs = c
    }
    definirAutocompleteEditGroup();
    removeUsuario(g)
}

function removeUsuario(b) {
    blink.theme.removeUsuario(b)
}

function editUsuario(c, b) {
    blink.theme.editUsuario(c, b)
}

function onEditGroupPressEnter() {
    if ($("#anadir:visible").size()) {
        $(".anadir").click();
        $("#nombre").focus()
    }
    if ($(".confirmar:visible").size()) {
        $(".confirmar").click();
        $("#nombre").focus();
        return
    }
}

function updateUsuario() {
    blink.theme.updateUsuario()
}

function updateHandlersVentanaClase() {
    $(".alumno").each(function(b) {
        this.id = "fila" + b
    });
    $(".tabla_alumno_ref").each(function(b) {
        $(this).click(function() {
            editUsuario(b, "nombre")
        })
    });
    $(".tabla_alumno_nombre").each(function(b) {
        $(this).click(function() {
            editUsuario(b, "nombre")
        })
    });
    $(".tabla_alumno_apellidos").each(function(b) {
        $(this).click(function() {
            editUsuario(b, "apellidos")
        })
    });
    $(".tabla_alumno_email").each(function(b) {
        $(this).click(function() {
            editUsuario(b, "email")
        })
    });
    $(".tabla_alumno_email2").each(function(b) {
        $(this).click(function() {
            editUsuario(b, "email2")
        })
    })
}

function checkCambiosVentanaClase() {
    if (hayCambiosVentanaClase) {
        return confirm(text_web.new_edit_group_17)
    }
    return true
}

function getIDsAlumnosSeleccionados() {
    return blink.theme.getIDsAlumnosSeleccionados()
}

function getIDsProfesoresSeleccionados() {
    return blink.theme.getIDsProfesoresSeleccionados()
}

function onCreateEditGroup(d, c, b) {
    if (modoUsuarios == 2 && esInfantil) {
        return
    }
    if (!modoUsuarios) {
        c = 1
    }
    if (!c) {
        c = modoUsuarios
    }
    if (b) {
        prf = "1"
    } else {
        prf = "0"
    }
    showMsgBox("", "/LMS/msgbox.php?op=neweditgroup" + ((d) ? "&idgrupo=" + d : "") + "&modoUsuarios=" + c + "&prf=" + prf, 550, null, true)
}

function onCreateEditClaustro(b) {
    showMsgBox("", "/LMS/msgbox.php?op=neweditgroup" + ((b) ? "&idgrupo=" + b : "") + "&modoUsuarios=3", 550, null, false)
}

function onCreateEditStaff(b) {
    showMsgBox("", "/LMS/msgbox.php?op=neweditgroup&modoUsuarios=4&idcentro=" + b, 550, null, false)
}

function onJoinCommunity() {
    showMsgBox("", "/LMS/msgbox.php?op=group.joincommunity", "550")
}

function onSendHomework(b, c) {
    if (modoUsuarios == 1 && (typeof modoVistaClase == "undefined" || !modoVistaClase || modoVistaClase == "clase")) {
        ids = getIDsAlumnosSeleccionados();
        showMsgBox("", "/LMS/msgbox.php?op=preparardeberes&idcurso=" + b + "&idgrupo=" + c + (window.lastColorFilterSelected ? "&ideje=" + window.lastColorFilterSelected : "") + ((ids.length == 0) ? "" : "&idalumnos=" + ids.join(",")), 550)
    }
}

function deleteHomework(c, b) {
    if (confirm(text_web.js_borrar_nota_deberes)) {
        getAJAX("/LMS/ajax.php?op=deletehomework&idhomework=" + c + "&idgrupo=" + b, standardAJAX)
    }
}

function onMiClasePasarLista() {
    ids = getIDsAlumnosSeleccionados();
    showMsgBox("", "/LMS/msgbox.php?op=pasarlista&idgrupo=" + idgrupo + "&ids=" + ids.join(","), 300)
}

function onMiClaseSendMessage() {
    idsProfs = getIDsProfesoresSeleccionados();
    if (idsProfs.length == 0) {
        ids = getIDsAlumnosSeleccionados()
    } else {
        ids = idsProfs
    }
    var b = "/LMS/msgbox.php?op=enviarmensaje&idgrupo=" + idgrupo + "&modoUsuarios=" + modoUsuarios + ((idsProfs.length > 0) ? "&tipo_dest=2" : "");
    if (ids.length != 0) {
        b += "&idusers=" + ids.join(",")
    }
    showMsgBox("", b, 550)
}

function onMensajesSendMessage(c, d) {
    var b = "/LMS/msgbox.php?op=enviarmensaje&idusers=" + c + "&idgrupo=" + d + "&modoUsuarios=" + modoUsuarios;
    showMsgBox("", b, 550)
}

function onMessagesSendMassive() {
    var b = "/LMS/msgbox.php?op=enviarmensaje&options=massive";
    showMsgBox("", b, 550)
}

function onMiClaseInfantilWriteInfoStudent(c) {
    var b = "/LMS/msgbox.php?op=writeinfostudent&idgrupo=" + idgrupo + "&idcurso=" + idcurso + "&idalumno=" + c;
    showMsgBox("", b, 550)
}

function onMiClaustroSendMessage() {
    blink.theme.onMiClaustroSendMessage()
}

function enviarMensaje(d, c, b) {
    if (!d || d == 0) {
        _showAlert(text_web.diagnostico_alumno_23);
        return
    }
    if (c != undefined) {
        idcurso = c
    }
    showMsgBox("", "/LMS/msgbox.php?op=enviarmensaje&idcurso=" + idcurso, 550, "&idusers=" + d + (b ? "&dest=" + b : ""))
}

function onDeleteGroup(b, c) {
    if (modoUsuarios == 1 || modoUsuarios == 3) {
        texto = (c && c == 6) ? text_web.js_borrar_comunidad : text_web.js_borrar_grupo;
        if (!confirm(texto)) {
            return
        }
        if (c && c == 6) {
            getAJAX("/LMS/ajax.php?op=deletegroup&idgrupo=" + b, function(d) {
                if (d.startsWith("GO")) {
                    redireccionar(d.substr(3), false)
                }
            })
        } else {
            getAJAX("/LMS/ajax.php?op=deletegroup&idgrupo=" + b, standardAJAX)
        }
    }
}

function onDeleteStudents(b) {
    if (!confirm(text_web.js_borrar_alumnos)) {
        return
    }
    ids = getIDsAlumnosSeleccionados();
    getAJAX("/LMS/ajax.php?op=deletestudentsfromgroup&idgrupo=" + b + "&idalumnos=" + ids.join(","), standardAJAX)
}

function loadColorFilter(d, c) {
    seleccionarMiClase("" + d.ids, c);
    var b = (d.m < 0.33 ? "Reforzar" : "Potenciar");
    $('<div class="color_selector"><div class="color ' + c + '"></div><div class="color_label">' + b + " <b>" + d.n + "</b></div>").click(function() {
        window.lastColorFilterSelected = d.e + 1;
        $(".un_alunmo_clickbase").removeClass("un_alunmo_click").addClass("un_alunmo_noclick");
        seleccionarMiClase("" + d.ids)
    }).appendTo("#color_filters")
}

function marcarResultadoFiltro() {
    $("#resultadoFiltro").html(text_web.mi_clase_filtro_1 + ": " + $(".un_alunmo_click").size() + " " + text_web.mi_clase_filtro_2);
    $("#resultadoFiltro").fadeIn()
}

function onMiClaseDesasignarContenido(b) {
    var c = window.event;
    c && c.stopPropagation();
    if (!confirm(text_web.js_desasignar_contenido)) {
        return
    }
    getAJAX("/LMS/ajax.php?op=removecontentfromgroup&idgrupo=" + idgrupo + "&idcurso=" + b, standardAJAX)
}

function onMiClaseAsignarContenido() {
    showMsgBox("", "/LMS/msgbox.php?op=assigncourse&idgroup=" + idgrupo, 550)
}

function seleccionarMiClase(b, c) {
    blink.theme.seleccionarMiClase(b, c)
}
var modoUsuarios = 1;
var modoClaseInicial = true;

function cambiarModoPadresAlumnos(c, b) {
    blink.theme.cambiarModoPadresAlumnos(c, b)
}

function onIngresarCodigoClase(b) {
    var c = "";
    if (b && b != "") {
        c = "&cod=" + b
    }
    showMsgBox("", "/LMS/msgbox.php?op=ingresarcodigoclase" + c, 550, null)
}

function onGrupoCambiarCerrado(b) {
    getAJAX("/LMS/ajax.php?op=cambiarcerradogrupo&idgrupo=" + b, function(c) {
        if (c.startsWith("ERROR")) {
            standardAJAX(c)
        } else {
            $("#codgrupo" + b).removeClass("tipo_acceso_grupo_0 tipo_acceso_grupo_1").addClass("tipo_acceso_grupo_" + c.substring(2))
        }
    })
}

function onCursoCambiarTipoAcceso(b) {
    blink.theme.onCursoCambiarTipoAcceso(b)
}

function onCursoCambiarTipoAccesoCurso(b) {
    getAJAX("/LMS/ajax.php?op=cambiartipoaccesocurso&idcurso=" + b, function(c) {
        if (c.startsWith("ERROR")) {
            standardAJAX(c)
        } else {
            if ($("#access_control").hasClass("tipo_acceso_amarillo_0")) {
                $("#access_control").removeClass("tipo_acceso_amarillo_0").addClass("tipo_acceso_amarillo_3")
            } else {
                $("#access_control").removeClass("tipo_acceso_amarillo_3").addClass("tipo_acceso_amarillo_0")
            }
        }
    })
}

function onCursoCambiarNovedad(b) {
    getAJAX("/LMS/ajax.php?op=cambiarnovedad&idcurso=" + b, function(h) {
        var g;
        var d = blink.theme.isAdaptative();
        g = $("#novedad" + b);
        if (h.startsWith("ERROR")) {
            standardAJAX(h);
            if (d) {
                var f = g.prop("checked");
                var c = f ? false : true;
                g.prop("checked", c)
            }
        } else {
            if (!d) {
                toggleClasses("#novedad" + b, ".cursoEnNovedad", ".cursoNoNovedad")
            }
        }
    })
}

function onCursoCambiarBloqueado(b) {
    blink.theme.onCursoCambiarBloqueado(b)
}

function onCursoCambiarOnline(b) {
    blink.theme.onCursoCambiarOnline(b)
}

function onCursoCambiarBloqueadoTema(b, d, c) {
    blink.theme.onCursoCambiarBloqueadoTema(b, d, c)
}

function onCursoCambiarOnlineTema(b, d, c) {
    blink.theme.onCursoCambiarOnlineTema(b, d, c)
}

function onCursoNotificarCambios() {
    if (confirm(text_web.js_confirmar_notificar_cambios_curso)) {
        getAJAX("/LMS/ajax.php?op=notificarcambioscurso&idcurso=" + idcurso, standardAJAX)
    }
}

function onGenerateExam(b) {
    showMsgBox("", "/LMS/msgbox.php?op=prepararexamen&idcurso=" + b)
}

function saveComentario(d, c, b) {
    blink.theme.saveComentario(d, c, b)
}

function onFinishSavingComentario(b) {
    if (b != "OK") {
        _showAlert(text_web.js_error_guardar_comentario);
        return
    }
    _showAlert(text_web.js_ok_guardar_comentario)
}

function savePositivosUsuario(d, b, c) {
    getAJAX("/LMS/ajax.php?op=savepositivos&idgrupo=" + d + "&idusuario=" + b + "&positivos=" + encodeURIComponent(c), function(f) {
        if (f != "OK") {
            _showAlert(text_web.js_error_guardar_comentario);
            return
        } else {
            path = "#positivos" + b + " ." + ((c == 1) ? "pos" : "neg");
            $(path).html(parseInt($(path).html()) + 1)
        }
    })
}

function onFinishSavingPositivos(b) {}

function esconderColumnasDiagnostico(b) {
    blink.theme.esconderColumnasDiagnostico(b)
}

function irSubtema(c, h, f, b, d, g) {
    blink.theme.irSubtema(c, h, f, b, d, g)
}
var camposTextoCalificacionesActivados = false;
var cerrarSinVerificar = false;

function onCalificacionesBeforeUnload() {
    if (!cerrarSinVerificar) {
        if ($(".input_calificaciones.changed").size() > 0) {
            return ""
        }
    }
}

function onCalificacionesEditarNotas() {
    blink.theme.onCalificacionesEditarNotas()
}

function cambiarEstadoBotonNotas() {
    blink.theme.cambiarEstadoBotonNotas()
}

function desactivarCamposTextoCalificaciones() {
    blink.theme.desactivarCamposTextoCalificaciones()
}

function activarCamposTextoCalificaciones() {
    blink.theme.activarCamposTextoCalificaciones()
}

function isScrolledIntoView(d) {
    var g = $(window).scrollTop(),
        f = g + $(window).height(),
        b = $(d).offset().top,
        c = b + $(d).height();
    return ((b + ((c - b) / 2)) >= g && ((b + ((c - b) / 2)) <= f))
}

function obtenerArrayActualizacionNotas(b) {
    return blink.theme.obtenerArrayActualizacionNotas(b)
}

function hanCambiadoNotas() {
    return $(".input_calificaciones.changed").length > 0
}

function guardarNotasCambiadas() {
    a = obtenerArrayActualizacionNotas();
    if (a == "[]") {
        desactivarCamposTextoCalificaciones();
        return
    }
    getAJAX("/LMS/ajax.php?op=updategrades&json=" + encodeURIComponent(a) + "&" + window.seleccion, function(b) {
        _showAlert(b)
    })
}

function goRegister() {
    redireccionar("/portal/contactus.php?os=1")
}

function onLoadDiagnostico() {
    blink.theme.onLoadDiagnostico()
}

function f_td_progreso_1(d) {
    var b = $(d).attr("codtabla");
    var c = $("#tabla_diagnostico th[codtabla='" + b + "']").addClass("on").attr("title");
    $("#tabla_diagnostico td[codtabla='" + b + "']").addClass("on");
    $("#titular_tabla").html(c)
}

function f_td_progreso_2(c) {
    var b = $(c).attr("codtabla");
    $("#tabla_diagnostico th[codtabla='" + b + "']").removeClass("on");
    $("#tabla_diagnostico td[codtabla='" + b + "']").removeClass("on");
    $("#titular_tabla").html("")
}

function irListaCursos() {
    parent.location.href = "/"
}

function changeStatus() {
    getAJAX("/LMS/ajax.php?op=changestatus", function(b) {
        if (b.startsWith("OK")) {
            online = b.substring(2) == "1";
            $("#status_line").html('<div class="' + (online ? "on_line" : "off_line") + '">' + (online ? text_web.header_8 : text_web.header_9) + "</div>");
            if (window.idUsuarioMiClase) {
                $("input[name='seleccionado_1'][value='" + window.idUsuarioMiClase + "']").parents(".un_alumno").each(function() {
                    if (modoUsuarios == 1) {
                        if (online) {
                            $(this).find(".ficha_alumno .offline").addClass("online").removeClass("offline")
                        } else {
                            $(this).find(".ficha_alumno .online").addClass("offline").removeClass("online")
                        }
                    } else {
                        if (online) {
                            $(this).find(".ficha_padre .offline").addClass("online").removeClass("offline")
                        } else {
                            $(this).find(".ficha_padre .online").addClass("offline").removeClass("online")
                        }
                    }
                })
            }
        }
    }, false)
}

function setSessionAttribute(b, c) {
    if (b != "PIZARRA" && b != "SONIDO") {
        getAJAX("/LMS/ajax.php?op=setSessionAttribute&SESSION_ATTRIBUTE=" + b + "&SESSION_ATTRIBUTE_VALUE=" + c, function() {})
    }
}

function searchPhoto(b, c) {
    blink.theme.searchPhoto(b, c)
}

function searchMediateca(b, c) {
    blink.theme.searchMediateca(b, c)
}

function msgIncompatibleDevice() {
    _showAlert(text_web.device_incompatible)
}

function goEditarCurso(b) {
    var c = false;
    getAJAX("/LMS/ajax.php?op=checkIncompatibleDevice&idcontent=" + b + "&content_type=Curso", function(d) {
        if (!d.startsWith("OK")) {
            msgIncompatibleDevice();
            c = true
        }
    }, false, undefined, undefined, true);
    if (c) {
        return
    }
    if (blink.isAndroid) {
        goVerCurso(b)
    } else {
        redireccionar("/coursePlayer/curso2.php?editar=1&idcurso=" + b)
    }
}

function goVerCurso(b, c) {
    var d = false;
    getAJAX("/LMS/ajax.php?op=checkIncompatibleDevice&idcontent=" + b + "&content_type=Curso", function(f) {
        if (!f.startsWith("OK")) {
            msgIncompatibleDevice();
            d = true
        }
    }, false, undefined, undefined, true);
    if (d) {
        return
    }
    if (c) {
        showMsgBox("", "/LMS/msgbox.php?op=askteachertoactivate&idcurso=" + b, msgBoxWidth)
    } else {
        redireccionar("/coursePlayer/curso2.php?idcurso=" + b)
    }
}

function goEnrollCurso(b) {
    if (blink.isApp) {
        getAJAX("/LMS/ajax.php?op=enroll&idcurso=" + b, standardAJAX)
    } else {
        redireccionar("/coursePlayer/curso2.php?idcurso=" + b + "&enroll=true")
    }
}

function goBusqueda(l, k, g, f, d, j) {
    borrarValoresDefecto();
    if (!g) {
        g = 1
    }
    if (!l) {
        l = "buscador"
    }
    var c = $("#" + l).attr("value") || "";
    var h = "";
    if (d) {
        h += "&o=" + d
    }
    if (j) {
        h += "&idc=" + j
    }
    if ($("#selfiltrogrupo1") != undefined && $("#selfiltrogrupo1").attr("value") != undefined && $("#selfiltrogrupo1").attr("value") != "undefined") {
        h += "&fg1=" + $("#selfiltrogrupo1").attr("value")
    }
    if ($("#selfiltrogrupo2") != undefined && $("#selfiltrogrupo2").attr("value") != undefined && $("#selfiltrogrupo2").attr("value") != "undefined") {
        h += "&fg2=" + $("#selfiltrogrupo2").attr("value")
    }
    if ($("#selfiltrogrupo3") != undefined && $("#selfiltrogrupo3").attr("value") != undefined && $("#selfiltrogrupo3").attr("value") != "undefined") {
        h += "&fg3=" + $("#selfiltrogrupo3").attr("value")
    }
    if ($("#selfiltrogrupo4") != undefined && $("#selfiltrogrupo4").attr("value") != undefined && $("#selfiltrogrupo4").attr("value") != "undefined") {
        h += "&fg4=" + $("#selfiltrogrupo4").attr("value")
    }
    if ($("#popup") != undefined && $("#popup").attr("value") != undefined && $("#popup").attr("value") != "undefined") {
        h += "&popup=" + $("#popup").attr("value")
    }
    if (k == "res") {
        redireccionar("/LMS/busqueda.php?busqueda=" + encodeURIComponent(c) + ("&resources=1") + (f ? "&u=" + f : "") + "&m=" + g + h)
    } else {
        redireccionar("/LMS/busqueda.php?busqueda=" + encodeURIComponent(c) + (true || k == "cat" ? "&catalog=1" : "") + (f ? "&u=" + f : "") + "&m=" + g + h)
    }
}

function goBusquedaMisCursos(f, d) {
    borrarValoresDefecto();
    if (!f) {
        f = "buscador"
    }
    var c = $("#" + f).attr("value");
    redireccionar("/LMS/teachers.php?as=mycourses&busqueda=" + encodeURIComponent(c) + "&tipo=" + d)
}

function goBusquedaMisCentros(d, f) {
    borrarValoresDefecto();
    if (!f) {
        f = "buscador"
    }
    var c = $("#" + f).attr("value");
    redireccionar("/LMS/estadisticas2.php?idcurso=" + encodeURIComponent(d) + "&busqueda=" + encodeURIComponent(c))
}

function goBusquedaMisCursosAlumno(d) {
    if (!d) {
        d = "buscador"
    }
    var c = $("#" + d).attr("value");
    redireccionar("/LMS/students.php?busqueda=" + encodeURIComponent(c))
}

function goBusquedaMisMensajes(h, f, d) {
    if (window.offline) {
        mostrarAvisoOffline();
        return
    }
    borrarValoresDefecto();
    if (!h) {
        h = "buscador_mensajes"
    }
    if (!d) {
        d = "0"
    }
    var c = $("#" + h).attr("value");
    redireccionar("/LMS/mensajes.php?busqueda=" + encodeURIComponent(c) + "&fm=" + d + "&g=" + f)
}

function goBusquedaActividadesCurso(f, d) {
    borrarValoresDefecto();
    idc = (idcurso != undefined) ? idcurso : "";
    var c = $("#" + f).attr("value");
    redireccionar("/coursePlayer/curso2.php?idcurso=" + idc + (d == "1" ? "&editar=" + d : "") + (($.trim(c) != "") ? "&q=" + encodeURIComponent(c) : ""))
}

function borrarCursoConPermiso(g, f, k, h, j) {
    blink.theme.borrarCursoConPermiso(g, f, k, h, j)
}

function desasignarCursoConPermiso(b, c) {
    blink.theme.desasignarCursoConPermiso(b, c)
}

function onMisCursosSendMessage(b) {
    showMsgBox("", "/LMS/msgbox.php?op=enviarmensaje&idcurso=" + b, 550)
}

function onMisCursosAsignarCurso(b) {
    showMsgBox("", "/LMS/msgbox.php?op=assigngroup&idcurso=" + b, 550)
}

function onMisCursosGenerarCodigo(b) {
    showMsgBox("", "/LMS/msgbox.php?op=generatecode" + ((b != undefined && b != "") ? "&idcurso=" + b : ""), 555)
}

function onMisCursosImportarCodigo(b) {
    showMsgBox("", "/LMS/msgbox.php?op=importcode&idcurso=" + b, 555)
}

function onMisCursosFiltrar(b) {
    if (b == "filtro_creados") {
        redireccionar("/LMS/teachers.php?tipo=1")
    } else {
        if (b == "filtro_todos") {
            redireccionar("/LMS/teachers.php?tipo=0")
        } else {
            redireccionar("/LMS/teachers.php?tipo=2")
        }
    }
    return
}

function onMisCursosCambiarEstadoOnline(b) {
    blink.theme.onMisCursosCambiarEstadoOnline(b)
}

function onMisCursosCambiarDestacado(b) {
    blink.theme.onMisCursosCambiarDestacado(b)
}

function onMisCursosCambiarEnCatalogo(b) {
    blink.theme.onMisCursosCambiarEnCatalogo(b)
}

function onMisCursosEditarColaboradores(b) {
    showMsgBox("", "/LMS/msgbox.php?op=neweditcolaborators&idcurso=" + b, 550)
}

function onMisCursosFileSize(b) {
    showMsgBox("", "/LMS/msgbox.php?op=filesize&idcurso=" + b, 550)
}

function duplicarCurso(b) {
    showMsgBox("", "/LMS/msgbox.php?op=showduplicatecourse&idcurso=" + b, 550)
}

function onSaveNewsletter() {
    showMsgBox("", "/LMS/msgbox.php?saveNewsletter=" + document.news.mailnewsletter.value, 550)
}

function onMisCursosCargaLicencia(b, c) {
    askCredit(b, c)
}

function askCredit(b, c) {
    var d = "";
    if (b && b != "") {
        d = "&cod=" + b
    }
    if (typeof c !== "undefined" && c != "") {
        d += "&idalumno=" + c
    }
    showMsgBox("", "/LMS/msgbox.php?typemsg=musthavecredit&typeservice=36" + d, "550")
}

function checkCodigoClaseLibro(c, f) {
    var d = "";
    var b = false;
    c = $.trim(c);
    d = (c.match(/^cl/i) && c.length == 10) ? "clase" : "libro";
    if (d == "clase" && f == "cursos") {
        if (confirm(text_web.js_confirmar_codigo_clase)) {
            closeMsgBox();
            onIngresarCodigoClase(c);
            return false
        } else {
            b = true
        }
    } else {
        if (d == "libro" && f === "clases") {
            if (confirm(text_web.js_confirmar_codigo_libro)) {
                closeMsgBox();
                onMisCursosCargaLicencia(c);
                return false
            } else {
                b = true
            }
        }
    }
    if (b) {
        closeMsgBox();
        return false
    }
    return true
}

function noHaceNada() {}

function onMensajesEnviarMensaje(c, d, b) {
    blink.theme.onMensajesEnviarMensaje(c, d, b)
}

function onMensajesEliminarMensaje(b) {
    blink.theme.onMensajesEliminarMensaje(b)
}

function onMensajesOcultarMensaje(b) {
    blink.theme.onMensajesOcultarMensaje(b)
}

function imprimirClase(d, f, c) {
    showMask();
    $('<div id="busyDIV">' + text_web.pdf_creating + "</div>").prependTo(document.body).center();
    var b = "/coursePlayer/imprimir2.php?idcurso=" + d + "&idclase=" + f;
    if (c && c != "") {
        b += "&numSec=" + c
    }
    getAJAX(b, function(g) {
        $("#busyDIV").remove();
        hideMask();
        standardAJAXFunc(g);
        formatPrintScreen()
    })
}

function printURL(c) {
    var g = "/LMS/ajax.php?op=printServer.printURL&url=" + encodeURIComponent(c);
    var f = '<h3 id="divBUSY" align="center" style="					position: absolute;					padding: 10px 30px 10px 10px;					border-radius: 20px;					z-index: 10000;					background-image: url(https://www.blinklearning.com/images/loader.gif);					background-position: 95% center;					background-repeat: no-repeat;">' + text_web.pdf_creating + "</h3>";
    var b = 'var xhr=window.XMLHttpRequest?new XMLHttpRequest:window.ActiveXObject?new ActiveXObject("Microsoft.XMLHTTP"):null;xhr&&(xhr.open("GET","' + g + '"),xhr.onreadystatechange=function(){if(4==xhr.readyState){var e=xhr.responseText;if(e&&"GO "==e.substr(0,3)){location=e.substr(3)}else /*alert("error")*/}},xhr.send());';
    var d = window.open("about:blank", "_blank");
    d.document.write(f + "<script>" + b + "<\/script>")
}

function formatPrintScreen() {}

function onCursoImprimir(c, b) {
    showMsgBox("", "/LMS/msgbox.php?" + ((b) ? "modoBook=1" : "") + "&op=printcourse&idcurso=" + c, 550)
}

function onCursoInvitar(b) {
    showMsgBox("", "/LMS/msgbox.php?op=enviarinvitacion&idcurso=" + b, 550)
}

function imprimirTemas() {
    blink.theme.imprimirTemas()
}
var oMenu = null;

function onIniciarChat(b) {
    return;
    if (oMenu != null) {
        oMenu.destroy()
    }
    oMenu = new YAHOO.widget.Menu("basicmenu", {
        zindex: 3,
        x: YAHOO.util.Dom.getX("botonChat" + b),
        y: YAHOO.util.Dom.getY("botonChat" + b) + 40
    });
    oMenu.clearContent();
    oMenu.addItems([{
        text: "Yahoo! Mail",
        url: "http://mail.yahoo.com"
    }, {
        text: "Yahoo! Address Book",
        url: "http://addressbook.yahoo.com"
    }, {
        text: "Yahoo! Calendar",
        url: "http://calendar.yahoo.com"
    }, {
        text: "Yahoo! Notepad",
        url: "http://notepad.yahoo.com"
    }]);
    oMenu.render(document.body);
    oMenu.show()
}

function showOlvidoContrasena(b) {
    $("#olvidaste").val($("#email").val());
    $("#labelolvidocontrasena").hide();
    $("#labelolvidocontrasena_init").show();
    $("#olvidaste_contrasena").toggle();
    if (b) {
        var c = $("#popup").offset();
        c.left += 320;
        c.top += 180
    } else {
        var c = $("#label_olvido").offset();
        c.left -= 382;
        c.top -= 20
    }
    $("#olvidaste_contrasena").offset(c)
}

function onOlvidoContrasena(b) {
    return blink.theme.onOlvidoContrasena(b)
}

function showAccesoClase() {
    $("#labelaccesoclase").hide();
    $("#labelaccesoclase_init").show();
    toggleLayer("acceso_clase")
}

function onAccesoClase(b) {
    $("#botonaccesoclase").css("cursor", "wait");
    $("#labelaccesoclase_init").hide();
    $("#labelaccesoclase").show();
    getAJAX("/LMS/ajax.php?op=accesoclase&codigo=" + encodeURIComponent(b), function(c) {
        if (c.startsWith("ERROR")) {
            $("#labelaccesoclase").html('<span style="color:#cc3333";>' + c.substring(5) + "</span>");
            $("#botonaccesoclase").css("cursor", "default")
        } else {
            redireccionar(c.substring(2))
        }
    });
    return false
}
var factorpixelcanvas = 1;
var _guardarPizarra = true;

function getIndiceStoreDrawing() {
    if (window.secuencia != undefined && window.secuencia.length > 0) {
        return blink.activity.getFirstSlideIndex(window.activeSlide)
    }
    return 0
}

function getCanvas() {
    var b = $("#canvas" + getIndiceStoreDrawing()).get(0);
    if (b && b.getContext) {
        return b.getContext("2d")
    }
}

function clearCanvas() {
    var b = $("#canvas" + getIndiceStoreDrawing()).get(0);
    if (b && b.getContext) {
        ctx = b.getContext("2d");
        ctx.clearRect(0, 0, $(b).width(), $(b).height())
    }
}

function drawLine(n, f, k, d, j, l, g) {
    if (!n) {
        return
    }
    var c = g;
    var b = (l == 2 ? 0.2 : 1);
    var h = 5;
    if (l == 2) {
        h = 15
    } else {
        if (l == 4) {
            h = 10
        }
    }
    h = h * factorpixelcanvas;
    n.strokeStyle = c;
    n.globalAlpha = b;
    n.lineWidth = h;
    n.lineCap = (l == 2 ? "butt" : "round");
    n.beginPath();
    n.moveTo(f * factorpixelcanvas, k * factorpixelcanvas);
    n.lineTo(d * factorpixelcanvas, j * factorpixelcanvas);
    n.stroke()
}
var lastx = 0,
    lasty = 0;
var drawing = false;
var erasing = false;
var numline = 0;
var lineax = new Array();
var lineay = new Array();
var tipolinea = new Array();
var colorlinea = new Array();
var notesArray = new Array();
var offsetcanvas;

function updateActiveCanvas(b) {
    if (b) {
        elem = b.target
    } else {
        elem = document.getElementById("canvasdiv" + getIndiceStoreDrawing())
    }
    offsetcanvas = $(elem).offset()
}

function startDraw(b) {
    if (herramientaPizarra != blink.tools.NOTE) {
        blink.tools.closeNotesOnEvent(b)
    }
    if (herramientaPizarra == 0) {
        return
    }
    updateActiveCanvas(b);
    pos = getCoordinates(b);
    lastx = pos.x;
    lasty = pos.y;
    id = getIndiceStoreDrawing();
    if (lineax[id] == undefined) {
        lineax[id] = new Array()
    }
    if (lineay[id] == undefined) {
        lineay[id] = new Array()
    }
    if (tipolinea[id] == undefined) {
        tipolinea[id] = new Array()
    }
    if (colorlinea[id] == undefined) {
        colorlinea[id] = new Array()
    }
    if (notesArray[id] == undefined) {
        notesArray[id] = new Array()
    }
    if (herramientaPizarra != blink.tools.NOTE) {
        drawing = true
    }
    if (herramientaPizarra == blink.tools.ERASER) {
        erasing = true
    }
    if (blink.isAndroid) {
        b.preventDefault()
    }
    b.stopImmediatePropagation();
    return false
}

function stopDraw(d) {
    if ($(d.target).closest(".nota").size() == 0) {
        d.stopImmediatePropagation()
    }
    if (herramientaPizarra == 0) {
        return
    }
    if (herramientaPizarra == blink.tools.NOTE) {
        pos = getCoordinates(d);
        var f = getIndiceStoreDrawing();
        var b = blink.tools.getNewID(f);
        var c = {
            x: parseInt(pos.x),
            y: parseInt(pos.y),
            ID: "note" + f + "_" + b,
            txt: ""
        };
        notesArray[f].push(c);
        selectPizarraColor("boton_notes", blink.tools.NOTE);
        blink.tools.drawNote(c, $("#canvas" + getIndiceStoreDrawing()).parent().get(0), true)
    } else {
        updateDraw(d)
    }
    if (blink.isAndroid) {
        d.preventDefault()
    }
    drawing = false;
    erasing = false;
    if (window.scormAPI) {
        updateSCORM()
    }
}

function updateDraw(b) {
    if (herramientaPizarra == 0) {
        return
    }
    if (herramientaPizarra == blink.tools.ERASER) {
        if (!blink.theme.useIndepentEraser && erasing) {
            ejecutarBorrador(b)
        }
        return
    }
    if (!drawing) {
        return
    }
    pos = getCoordinates(b);
    if (herramientaPizarra == 2) {
        pos.y = lasty
    }
    esPunto = false;
    if (esInfantil && pos.x == lastx && pos.y == lasty && herramientaPizarra != 2) {
        esPunto = true;
        pos.x = lastx + 1;
        pos.y = lasty + 1
    }
    if (esPunto || Math.abs(pos.x - lastx) + Math.abs(pos.y - lasty) > 4) {
        drawLine(getCanvas(), lastx, lasty, pos.x, pos.y, herramientaPizarra, colorSelected);
        id = getIndiceStoreDrawing();
        lineax[id].push(parseInt(lastx));
        lineay[id].push(parseInt(lasty));
        lineax[id].push(parseInt(pos.x));
        lineay[id].push(parseInt(pos.y));
        tipolinea[id].push(herramientaPizarra);
        colorlinea[id].push(colorSelected);
        numline++;
        lastx = pos.x;
        lasty = pos.y
    }
    if (blink.isAndroid) {
        b.preventDefault()
    }
    b.stopImmediatePropagation()
}

function redrawCanvas(j) {
    redrawing = true;
    id = getIndiceStoreDrawing();
    clearCanvas();
    if (j) {
        $("#canvas" + id).parent().find(".nota_pos").remove()
    }
    if (lineax[id]) {
        var g = lineax[id],
            f = lineay[id];
        var k = g.length - 1;
        var l = getCanvas();
        for (var h = 0; h < k; h = h + 2) {
            drawLine(l, g[h], f[h], g[h + 1], f[h + 1], tipolinea[id][h / 2], colorlinea[id][h / 2])
        }
    }
    if (j && notesArray[id]) {
        var d = notesArray[id];
        var b = d.length;
        for (var h = 0; h < b; h++) {
            _note = d[h];
            blink.tools.drawNote(_note, $("#canvas" + id).parent().get(0))
        }
    }
    redrawing = false
}

function getCoordinates(d) {
    var b = 0;
    var g = 0;
    if (!d) {
        d = window.event
    }
    if (blink.hasTouch) {
        d.preventDefault();
        if (!d.touches && !d.changedTouches) {
            d = d.originalEvent
        }
        b = (d.touches[0]) ? d.touches[0].pageX : d.changedTouches[0].pageX;
        g = (d.touches[0]) ? d.touches[0].pageY : d.changedTouches[0].pageY;
        d.stopPropagation()
    } else {
        if (d.pageX || d.pageY) {
            b = d.pageX;
            g = d.pageY
        } else {
            if (d.clientX || d.clientY) {
                b = d.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
                g = d.clientY + document.body.scrollTop + document.documentElement.scrollTop
            }
        }
    }
    var c = $(d.target).offset();
    var f = {
        x: (b - c.left) / factorpixelcanvas,
        y: (g - c.top) / factorpixelcanvas
    };
    return f
}

function distanciacuadradapuntoasegmento(d, l, c, h, b, f) {
    var o = c - d,
        n = h - l;
    var k = o * o + n * n;
    var p = ((b - d) * o + (f - l) * n) / k;
    if (p > 1) {
        p = 1
    }
    if (p < 0) {
        p = 0
    }
    var j = d + p * o,
        g = l + p * n;
    var r = j - b,
        q = g - f;
    return r * r + q * q
}
var areaBorrador = 500;

function ejecutarBorrador(j) {
    updateActiveCanvas();
    id = getIndiceStoreDrawing();
    if (!lineax[id]) {
        return
    }
    var c, o;
    if (!j.target) {
        c = $(j).offset();
        o = {
            x: c.left + $(j).width() / 2 - offsetcanvas.left,
            y: c.top + $(j).height() / 2 - offsetcanvas.top
        }
    } else {
        c = getCoordinates(j);
        o = c
    }
    if (factorpixelcanvas) {
        o.x = o.x / factorpixelcanvas;
        o.y = o.y / factorpixelcanvas
    }
    var p = lineax[id],
        n = lineay[id];
    var k = 10000000;
    var r = p.length - 1;
    var f = Array(),
        d = Array(),
        q = Array(),
        l = Array();
    var s = false;
    for (var h = 0; h < r; h = h + 2) {
        var g = distanciacuadradapuntoasegmento(p[h], n[h], p[h + 1], n[h + 1], o.x, o.y);
        k = Math.min(k, g);
        if (g < areaBorrador) {
            s = true
        } else {
            f.push(p[h]);
            d.push(n[h]);
            f.push(p[h + 1]);
            d.push(n[h + 1]);
            q.push(tipolinea[id][h / 2]);
            l.push(colorlinea[id][h / 2])
        }
    }
    $("canvasborrador").html("Min:" + k);
    lineax[id] = f;
    lineay[id] = d;
    tipolinea[id] = q;
    colorlinea[id] = l;
    if (s) {
        var b = $("#canvasdiv" + activeSlide + " canvas").get(0);
        blink.isAndroidApp && (b.width = b.width);
        setTimeout(redrawCanvas, 0)
    }
}

function ejecutarBorradorCompleto(c) {
    id = getIndiceStoreDrawing();
    if (!lineax[id]) {
        return
    }
    var b = $("#canvasborrador").offset();
    updateActiveCanvas();
    var d = 200;
    $("#canvas" + id).fadeOut();
    $("#canvasborrador").offset(offsetcanvas).animate({
        top: "+=100",
        left: "+=800"
    }, d).animate({
        top: "+=100",
        left: "-=800"
    }, d).animate({
        top: "+=100",
        left: "+=800"
    }, d).animate({
        top: "+=100",
        left: "-=800"
    }, d).animate(b, d, function() {
        lineax[id] = Array();
        lineay[id] = Array();
        tipolinea[id] = Array();
        colorlinea[id] = Array();
        $("#canvas" + id).show();
        clearCanvas();
        updateActiveCanvas();
        if (c) {
            posicionarBorrador()
        }
    })
}

function prepararCamposTexto() {
    $("input[textodefault='si']").focus(function() {
        if (this.value == this.defaultValue) {
            this.value = ""
        }
        if (this.value != this.defaultValue) {
            this.select()
        }
    });
    $("input[textodefault='si']").blur(function() {
        if ($.trim(this.value) == "") {
            this.value = (this.defaultValue ? this.defaultValue : "")
        }
    });
    $("textarea[textodefault='si']").focus(function() {
        if (this.value == this.defaultValue) {
            this.value = ""
        }
        if (this.value != this.defaultValue) {
            this.select()
        }
    });
    $("textarea[textodefault='si']").blur(function() {
        if ($.trim(this.value) == "") {
            this.value = (this.defaultValue ? this.defaultValue : "")
        }
    });
    $("[sample]").each(function() {
        if (this.value == "") {
            this.value = $(this).attr("sample")
        }
    });
    $("[sample]").focus(function() {
        if (this.value == $(this).attr("sample")) {
            this.value = ""
        } else {
            this.select()
        }
    });
    $("[sample]").blur(function() {
        if (this.value == "") {
            this.value = $(this).attr("sample");
            $(this).addClass("sample")
        }
    });
    $(".contenidos_curso input, .contenidos_curso textarea, .contenidos_curso select").change(function() {
        try {
            marcarHaCambiado(getIDSlideFromIdElement(this.name))
        } catch (b) {}
    });
    $(".contenidos input, .contenidos select").focus(function() {
        $("#topSpace").hide()
    });
    $("[help]").each(function() {
        if (this.value == "") {
            this.value = $(this).attr("help");
            $(this).addClass("help")
        }
    });
    $("[help]").focus(function() {
        if (this.value == $(this).attr("help")) {
            this.value = "";
            $(this).removeClass("help")
        } else {
            this.select()
        }
    });
    $("[help]").blur(function() {
        if (this.value == "") {
            this.value = $(this).attr("help");
            $(this).addClass("help")
        }
    });
    $("[tooltip]").each(function() {
        this.title = $(this).attr("tooltip");
        $(this).tooltip()
    })
}

function borrarValoresDefecto() {
    $("[help]").each(function() {
        if (this.value == $(this).attr("help")) {
            this.value = "";
            $(this).removeClass("help")
        }
    })
}

function buscarActividades(g, h, b, f, d, c) {
    blink.theme.buscarActividades(g, h, b, f, d, c)
}

function _buscarActividades(g, b, d, c, h, f, l, k, j) {
    blink.theme._buscarActividades(g, b, d, c, h, f, l, k, j)
}

function buscarNovedadesCurso(b) {
    blink.theme.buscarNovedadesCurso(b)
}

function _buscarNovedadesCurso(b, c) {
    blink.theme._buscarNovedadesCurso(b, c)
}

function desactivarVinculosAccessControl() {
    $('[hasaccess="ac_disabled"]').each(function() {
        $(this).addClass("disabled").unbind("click");
        var b = $(this).is("a") ? this : $(this).find("a").get(0);
        $(b).attr("href", "javascript:void(0);").attr("onclick", "javascript:void(0);")
    });
    $('[hasaccess="ac_demo_blocked"]').each(function() {
        $(this).unbind("click");
        var b = $(this).is("a") ? this : $(this).find("a").get(0);
        link = "javascript:showMsgBox('', '/LMS/msgbox.php?typemsg=mustnotbedemo',550);";
        $(b).attr("href", "javascript:void(0);").attr("onclick", link)
    });
    $('[hasaccess="ac_must_be_online"]').each(function() {
        $(this).unbind("click");
        var c = $(this).is("a") ? this : $(this).find("a").get(0);
        var d = ($(".menu_lateral").find(c).length > 0);
        var b = $(this).attr("class");
        var f = b.indexOf(" ");
        if (f != -1) {
            b = b.substring(0, f)
        }
        if (d) {
            link = "javascript:mostrarRequiereOnline('." + b + "', 'arrow', true);"
        } else {
            link = "javascript:mostrarRequiereOnline('', 'none', true);"
        }
        $(c).attr("href", "javascript:void(0);").attr("onclick", link)
    });
    $('[hasaccess="ac_only_premium_users"]').each(function() {
        $(this).addClass("premium").unbind("click");
        var c = $(this).is("a") ? this : $(this).find("a").get(0);
        var d = ($(".menu_lateral").find(c).length > 0);
        var b = $(this).attr("class");
        var f = b.indexOf(" ");
        if (f != -1) {
            b = b.substring(0, f)
        }
        if (d) {
            link = "javascript:mostrarBloqueoLicencia('." + b + "', 'arrow', true);"
        } else {
            link = "javascript:mostrarBloqueoLicencia('', 'none', true);"
        }
        $(c).attr("href", "javascript:void(0);").attr("onclick", link)
    });
    $('[hasaccess="invisible"]').remove()
}

function escribe_correo(c, b, f) {
    var g = "";
    for (var d = 0; d < c.length; d++) {
        g += String.fromCharCode(c[d])
    }
    document.write('<a href="mailto:' + g + ((f) ? "?subject=" + f : "") + '">' + ((b) ? b : g) + "</a>")
}
var temaini = null;

function initCursoDrag() {
    blink.theme.initCursoDrag()
}
var posini = null;
var pagMoving = false;

function pagUp(c, b) {
    if (!c) {
        c = (esInfantil && !editar) ? 160 * 3 : 150
    }
    if (!b) {
        b = 500
    }
    if (window.myScroll) {
        myScroll.scrollTo(0, -c, b, true);
        myScroll.refresh()
    } else {
        if (!pagMoving) {
            c = Math.min(c, -$("#ulCapaTemas").position().top);
            if (c > 0) {
                pagMoving = true;
                $("#ulCapaTemas").animate({
                    top: "+=" + Math.min(c, -$("#ulCapaTemas").position().top)
                }, b, function() {
                    pagMoving = false
                })
            }
        }
    }
    return false
}

function pagDown(d, c) {
    if (!d) {
        d = (esInfantil && !editar) ? 160 * 3 : 150
    }
    if (!c) {
        c = 500
    }
    if (window.myScroll) {
        myScroll.scrollTo(0, d, c, true);
        myScroll.refresh()
    } else {
        if (posini == null) {
            posini = $("#ulCapaTemas").position().top
        }
        if (!pagMoving) {
            var b = $("#ulCapaTemas").height();
            d = Math.min(d, $("#ulCapaTemas").height() + $("#ulCapaTemas").position().top - d);
            if (d > 0) {
                pagMoving = true;
                $("#ulCapaTemas").animate({
                    top: "-=" + d
                }, c, function() {
                    pagMoving = false
                })
            }
        }
    }
    return false
}

function showSection(b, d) {
    var c = 800;
    if (!d && !$("li[id=tema" + b + "]").hasClass("on")) {
        $("li[id^='tema']").removeClass("on").find(".contenido_tema").hide(c)
    }
    repositionSection(b, c);
    $("li[id=tema" + b + "]").toggleClass("on").find(".contenido_tema").stop().slideToggle(c, function() {
        if (window.myScroll) {
            window.myScroll.refresh()
        }
    })
}

function repositionSection(d, c, b) {}

function openSection(b) {
    $("li[id=tema" + b + "]").addClass("on").find(".contenido_tema:hidden").toggle("height")
}

function dlgCreateNewEditSection(c, b) {
    if (!b) {
        b = 0
    }
    showMsgBox("", "/LMS/msgbox.php?op=neweditsection&idcurso=" + c + "&idtema=" + b, 550)
}

function borrarSeccion(c, b) {
    if (confirm(text_web.course_41)) {
        getAJAX("/LMS/ajax.php?op=deletesection&idcurso=" + c + "&idtema=" + b, standardAJAX)
    }
}

function dlgCopyClass(b) {
    showMsgBox("", "/LMS/msgbox.php?op=neweditclass&only_copy=1&callback=" + b, 770)
}

function dlgCreateNewEditClass(j, g, f, o, n, k, l) {
    var h = "/LMS/msgbox.php?op=neweditclass";
    h += "&idcurso=" + j;
    h += "&idtema=" + g;
    h += (f) ? "&idclase=" + f : "";
    h += (o) ? "&justrefresh=" + o : "";
    h += (n) ? "&public=" + n : "";
    h += (k) ? "&isResource=1" : "";
    h += (l) ? "&typeClass=" + l : "";
    showMsgBox("", h, 770)
}

function dlgCreateReviewActivity(h, g, f, k, j) {
    showMsgBox("", "/LMS/msgbox.php?op=newreviewactivity&idcurso=" + h + "&idtema=" + g, 770)
}

function dlgUsuarioAutor(c, d) {
    var b = "";
    if (d) {
        b = "&refresh=1"
    }
    showMsgBox("", "/LMS/msgbox.php?op=viewuserauthor&iduser=" + c + b, 550)
}

function borrarClaseConPermiso(g, f, k, j, h) {
    blink.theme.borrarClaseConPermiso(g, f, k, j, h)
}

function changeImagenClase(b, f, c) {
    var d = "finSeleccionarImagenClase";
    if (c == 1) {
        d = "finSeleccionarImagenClaseRepos"
    }
    seleccionarMultimedia(b, "", d, "borrarImagenClase", "image", null, "activity", f)
}

function changeImagenTema(b, d) {
    var c = "finSeleccionarImagenTema";
    seleccionarMultimedia(b, "", c, "borrarImagenTema", "image", null, "section", d)
}

function switchClaseOnline(g, f, d, c, b) {
    blink.theme.switchClaseOnline(g, f, d, c, b)
}

function switchClaseRevisada(c, b) {
    getAJAX("/LMS/ajax.php?op=switchclaserevisada&idclase=" + c + "&seacepta=" + b, function(d) {
        if (d.startsWith("OK")) {
            $("#actividad" + c).hide()
        } else {
            standardAJAX()
        }
    }, false)
}

function addClickToEditActivityButtonAction(h, g, f, d, c, b) {
    blink.theme.addClickToEditActivityButtonAction(h, g, f, d, c, b)
}

function editActivityButtonAction(h, g, f, d, b) {
    if (d == 7) {
        var c = 1;
        dlgCreateNewEditClass(f, g, h, c)
    } else {
        blink.editClass(h, b)
    }
}

function borrarImagenClase() {
    closeMsgBox();
    getAJAX("/LMS/ajax.php?op=updateclassimage&idcurso=" + idCursoSeleccionMultimedia + "&idclase=" + idAppSeleccionarMultimedia + "&img=", function(b) {
        if (b == "OK" || b == "RELOAD") {
            window.location.reload(true)
        } else {
            _showAlert(text_web.course_46)
        }
    }, false)
}

function borrarImagenTema() {
    closeMsgBox();
    getAJAX("/LMS/ajax.php?op=updatesectionimage&idcurso=" + idCursoSeleccionMultimedia + "&idtema=" + idAppSeleccionarMultimedia + "&img=", function(b) {
        if (b == "OK" || b == "RELOAD") {
            window.location.reload(true)
        } else {
            _showAlert(text_web.course_46)
        }
    }, false)
}

function openSendActivityHomework(b) {
    showMsgBox("", "/LMS/msgbox.php?op=sendActivityHomework&idclase=" + b, 550)
}

function mostrarPopupAyuda(b) {
    showMsgBox("", "/LMS/msgbox.php?op=help&seccion=" + b, 550)
}

function mostrarPopupAyudaTexto(b) {
    showMsgBox("", "text:" + b, 550)
}

function generarPublisherPackageScorm(b) {
    showMsgBox("", "/LMS/msgbox.php?op=generaroutputscorm" + ((b) ? "&idcurso=" + b : ""), "550")
}

function generarPackageScorm(g, c, f, b) {
    if (!b) {
        if (confirm(text_web.scorm_incluir_contenido)) {
            b = true
        }
    }
    blink.theme.spinner.show();
    var h = (b) ? "generastandalone" : "generapkgscorm";
    var d = "/LMS/ajax.php?op=" + h + "&idcursos=" + g + ((c) ? "&idtemas=" + c : "") + ((f) ? "&idclases=" + f : "");
    blink.events.on("ajax:success ajax:error", function() {
        blink.theme.spinner.hide()
    });
    getAJAX(d, standardAJAX, false)
}

function generarBlinkZIP(b) {
    var c = "/LMS/ajax.php?op=generablinkzip&idcursos=" + b;
    getAJAX(c, standardAJAX, false)
}

function exportarDiagnostico(c, b) {
    blink.theme.exportarDiagnostico(c, b)
}

function importarPackageScorm(b) {
    showMsgBox("", "/LMS/msgbox.php?op=importpkgscorm" + ((b) ? "&idcurso=" + b : ""), 550)
}

function importarDatos(b) {
    showMsgBox("", "/LMS/msgbox.php?op=importdata" + ((b) ? "&idtipo=" + b : ""), 550)
}

function enableFloatingObjects() {
    $(".borrador").each(function() {
        $(this).dblclick(function() {
            ejecutarBorradorCompleto(true)
        });
        $(this).css("cursor", "pointer")
    });
    $(".draggable, .borrador, .eraser").blinkDraggable();
    if ($.browser.msie) {
        $(".unselectable").attr("unselectable", "on")
    }
}

function _savePosition(d) {
    xy = $(d).offset();
    var b = xy.left;
    var c = xy.top;
    xy = $(d).position();
    var b = xy.left;
    var c = xy.top;
    $(d).attr("blink-left-start-drag", b).attr("blink-top-start-drag", c)
}

function _loadPosition(d) {
    var b = $(d).attr("blink-left-start-drag");
    var c = $(d).attr("blink-top-start-drag");
    $(d).position({
        left: b,
        top: c
    })
}
var _lastDraggableObj;
var _draggablemindist = 50 * 50;
var DragScrollLibroDigital;

function _onStartDragDraggable(c, b) {
    if ($(c).hasClass("borrador")) {
        updateActiveCanvas()
    } else {
        if ($(c).hasClass("html_page")) {
            DragScrollLibroDigital.mouseDown = true;
            DragScrollLibroDigital.prevX = b.screenX;
            DragScrollLibroDigital.prevY = b.screenY;
            DragScrollLibroDigital.iniX = parseInt($(DragScrollLibroDigital.tgt).css("left"));
            DragScrollLibroDigital.iniY = parseInt($(DragScrollLibroDigital.tgt).css("top"))
        } else {
            _lastDraggableObj = c
        }
    }
}

function _onDragDraggable(c, b) {
    if ($(c).hasClass("borrador")) {
        ejecutarBorrador(c)
    } else {
        if ($(c).hasClass("html_page")) {
            DragScrollLibroDigital.getMousePosition(b)
        }
    }
}

function _onEndDragDraggable(h, g) {
    if ($(h).hasClass("html_page")) {
        DragScrollLibroDigital.terminarmouse(g)
    } else {
        _lastDraggableObj = h;
        xy = $(h).offset();
        var c = null;
        var d = _draggablemindist;
        var f = $(h).width(),
            j = $(h).height();
        xy.left += f / 2;
        xy.top += j / 2;
        $(".droppable").each(function() {
            var l = $(this).offset();
            var o = $(this).width(),
                p = $(this).height();
            l.left += o / 2;
            l.top += p / 2;
            var k = $(this).attr("tamanoradiodrop");
            if (k == undefined) {
                k = _draggablemindist
            }
            var n = (l.left - xy.left) * (l.left - xy.left) + (l.top - xy.top) * (l.top - xy.top);
            if ((c == null && n < k) || (c != null & n < d)) {
                c = this;
                d = n
            }
        });
        var b = false;
        if (c != null) {
            b = _activateDroppable(c, h)
        }
        if ($(h).hasClass("draggablereturnorigin")) {
            $(h).data({
                dropped: b
            });
            $(h).draggable("option", "revertDuration", b ? 0 : 500)
        }
    }
}

function _onStopDragDraggable(b) {
    if ($(b).data().dropped) {
        $(b).hide().fadeIn(1000).addClass("dropped")
    }
}

function _activateDroppable(c, g) {
    var d = false;
    if (c.nodeName == "INPUT" && c.type == "text" && !c.disabled) {
        var l = $(g).attr("dropvalue");
        if (l != undefined && l != "") {
            c.value = l;
            $(c).trigger("change")
        }
    }
    if (c.nodeName == "DIV") {
        if ($(c).hasClass("dropcenter")) {
            var k = $(c).offset();
            var b = $(g).offset();
            var j = $(c).width(),
                h = $(c).height();
            var o = $(g).width(),
                n = $(g).height();
            var f = {
                left: k.left + j / 2 - o / 2,
                top: k.top + h / 2 - n / 2
            };
            $(g).offset(f)
        }
    }
    d = true;
    if ($(g).hasClass("draggableremove") && d) {
        $(g).hide()
    }
    return d
}

function prepararNota(f, b, d) {
    if (f === "") {
        return "-"
    }
    if (f == "-") {
        return "-"
    }
    if (f == "P") {
        return "P"
    }
    if (f == null) {
        return "-"
    }
    if (b == 100) {
        return parseFloat(f).toFixed() + "%"
    } else {
        var c = parseFloat(f) / 100 * b;
        return c.toFixed(d)
    }
}

function obtenerNotaPendiente(b) {
    return "P"
}

function cambiarEstadoActividadUsuario(c, b, f, d) {
    getAJAX("/LMS/ajax.php?op=cambiarEstadoActividadUsuario&estado=" + d + "&idalumno=" + c + "&idcurso=" + b + (f ? "&idclase=" + f : ""), function() {}, false)
}

function cambiarEstadoActividades(f, c, d, h, b) {
    var g = b ? "cerrarActividades" : "abrirActividades";
    getAJAX("/LMS/ajax.php?op=" + g + "&idgrupo=" + f + "&idcurso=" + c + (d ? "&idtema=" + idema : "") + (h ? "&idclase=" + h : ""), function() {}, false)
}

function buscarPalabrasBuscador() {
    var d = document.referrer;
    var b = d.split("&");
    var g = "q";
    if (b[0].indexOf("yahoo") != -1) {
        g = "p"
    }
    if (b[0].indexOf("blinklearning.com") != -1 || b[0].indexOf("localhost") != -1) {
        g = "busqueda"
    }
    var f = "";
    for (var c = 1; c < b.length; c++) {
        if (b[c].startsWith(g + "=")) {
            f = unescape(b[c].substring(2));
            break
        }
    }
    buscarPalabras(f)
}

function buscarPalabras(f) {
    if (f == "") {
        return
    }
    var d = f.split(" ");
    var g = "",
        b = 0;
    $(".contenidos_curso").each(function() {
        var k = $(this).html().toUpperCase();
        var h = 0;
        for (var j = 0; j < d.length; j++) {
            if (d[j].length < 3) {
                continue
            }
            h += k.split(d[j].toUpperCase()).length - 1
        }
        if (h > b) {
            b = h;
            g = this.id
        }
    });
    if (g != "") {
        var c = $("#" + g).parent().parent().parent().parent().parent().attr("id").substring(6);
        showSlideFromID(c)
    }
}

function CSVToArray(g, j) {
    j = (j || ",");
    var h = new RegExp(("(\\" + j + '|\\r?\\n|\\r|^)(?:"([^"]*(?:""[^"]*)*)"|([^"\\' + j + "\\r\\n]*))"), "gi");
    var c = [
        []
    ];
    var f = null;
    while (f = h.exec(g)) {
        var b = f[1];
        if (b.length && (b != j)) {
            c.push([])
        }
        if (f[2]) {
            var d = f[2].replace(new RegExp('""', "g"), '"')
        } else {
            var d = f[3]
        }
        c[c.length - 1].push(d)
    }
    return (c)
}

function duplicateActividad(b, c) {
    getAJAX("/LMS/ajax.php?op=duplicateclass&idcurso=" + b + "&idclase=" + c, standardAJAXPopup);
    return false
}

function showSlideGenerator() {
    if (!editar) {
        return
    }
    return;
    datos = prompt("Introduce los datos para replicar la transparencia");
    oldID = secuencia[activeSlide];
    prefijo = "t" + secuencia[activeSlide];
    tipotransp = document.f[prefijo + "_type"].value;
    transparray = datos.split(";");
    createNewSlide(tipotransp, transparray.length, function(b) {
        populateWithCSVData(tipotransp, oldID, b, transparray)
    })
}

function populateWithCSVData(k, h, b, d) {
    numslides = d.length;
    actualizarCamposTexto();
    try {
        for (i = 0; i < numslides; i++) {
            datosarray = CSVToArray(d[i])[0];
            IDtransp = b + i;
            $("[name^='t" + IDtransp + "_']").each(function() {
                var j = this.name.substring(3);
                if (j != "type" && j != "idtransp" && this.type) {
                    if (this.type == "input" || this.type == "text" || this.type == "hidden" || this.type == "textarea") {
                        if (document.f["t" + h + "_" + j]) {
                            this.value = document.f["t" + h + "_" + j].value
                        }
                    }
                    if (this.type.startsWith("select")) {
                        if (document.f["t" + h + "_" + j]) {
                            this.selectedIndex = document.f["t" + h + "_" + j].selectedIndex
                        }
                    }
                }
            });
            if (k == 9) {
                numoperaciones = Math.floor(datosarray.length / 3);
                var g = ["+", "-", "x", "/"];
                for (var c = 1; c <= numoperaciones; c++) {
                    document.f["t" + IDtransp + "_operando1_" + c].value = datosarray[3 * (c - 1)];
                    document.f["t" + IDtransp + "_operacion_" + c].selectedIndex = g.findIndex(datosarray[3 * (c - 1) + 1]);
                    document.f["t" + IDtransp + "_operando2_" + c].value = datosarray[3 * (c - 1) + 2]
                }
            }
            if (k == 6) {
                txt = document.f["t" + IDtransp + "_textFillblanks"].value;
                for (var c = 0; c < datosarray.length; c++) {
                    txt = txt.replace("::", datosarray[c])
                }
                document.f["t" + IDtransp + "_textFillblanks"].value = txt
            }
        }
    } catch (f) {
        _showAlert(f.description)
    }
    setTimeout("actualizarCamposTexto(false)", 1000)
}

function editImagePicnik(n, k, o, h) {
    if (verificarHaCambiado()) {
        _showAlert(text_web.edit_slide_39);
        return false
    }
    if (h == undefined || h == null) {
        h = n
    }
    if (document.location.href.indexOf("?") != -1) {
        var g = document.location.href.substring(0, document.location.href.indexOf("?"));
        var r = g.substring(0, g.lastIndexOf("/") + 1)
    } else {
        var r = document.location.href.substring(0, document.location.href.lastIndexOf("/") + 1)
    }
    var p = document.location.href;
    var l = p.indexOf("&numSec=");
    if (l != -1) {
        p = p.substring(0, l)
    }
    var j = p + ((p.indexOf("?") == -1) ? "?" : "") + ((k) ? "&" + k : "");
    var u = $("#" + n).attr("src");
    if (u.indexOf("/") == 0) {
        u = ".." + u
    }
    var c = new RegExp("/ctx/.*/[0-9]+/r", "g");
    u = u.replace(c, "/r");
    var t = u.split("/");
    var q;
    var v = Math.ceil(Math.random() * 100);
    var f = "tmp" + v + ".jpg";
    if (typeof(o) == "undefined" || o == "") {
        if (u.indexOf(".php") == -1) {
            f = t[t.length - 1]
        }
    }
    q = j + ((j.indexOf("?") == -1) ? "?" : "") + "&picnik_idimg=" + h;
    var d = r + "../coursePlayer/picnikSave.php?" + ((k) ? k + "&" : "") + "urlback=" + encodeURIComponent(q);
    var b = {
        _apikey: "56f2cca4c643fc771c0c8aec1ac227f5",
        _export: d,
        _close_target: j,
        _imageid: f,
        _import: ((u.indexOf("://") != -1) ? u : r + u),
        _locale: locale,
        _export_method: "POST",
        _export_agent: "browser",
        _export_title: text_web.picnik_2,
        _replace: "yes",
        _host_name: "Blinklearning.com",
        _exclude: "home,in,out"
    };
    var s = "http://www.picmonkey.com/service/?";
    for (var w in b) {
        s += w + "=" + encodeURIComponent(b[w]) + "&"
    }
    redireccionar(s)
}

function updateImagePicnik(b, d, g, c) {
    var f = adjustUseruploadsUrl(d, g, c);
    $("#" + b).attr("src", d);
    $("#" + b + "v").val(d);
    if (window.activeSlide) {
        $("#slide_miniatura_" + activeSlide).attr("src", d)
    }
}

function borrarFicheroMultimediaCurso(c, b, d) {
    if (confirm(text_web.select_multimedia_27)) {
        getAJAX("/LMS/ajax.php?op=deletefile&idcurso=" + c + "&file=" + b, d)
    }
}

function borrarFicheroMultimedia(d, c, b, f) {
    if (confirm(text_web.select_multimedia_27)) {
        getAJAX("/LMS/ajax.php?op=deletefile&app=" + d + "&appid=" + c + "&file=" + b, f)
    }
}

function borrarFicheroAPIidfile(b, c, d) {
    if (confirm(text_web.select_multimedia_27)) {
        getAJAX("/LMS/ajax.php?op=deletefile&api_name=" + b + "&idfile=" + c, d)
    }
}
var optimizado = false;

function optimizarEspacio() {
    optimizado = !optimizado;
    if (optimizado) {
        $(".cabecera_peq, .titulo_pagina_curso, .pie_blanco").hide()
    } else {
        $(".cabecera_peq, .titulo_pagina_curso, .pie_blanco").show()
    }
    conmutarEstadoBoton("boton_optimizar", !optimizado)
}
var modoContinuo = false;
var _vieneDeModoContinuo = false;
var menu_lateral_topini = 35;
var _edadRecomendada = 0;

function scrollToSlide(b) {
    blink.theme.scrollToSlide(b)
}

function posicionarMenuLateral(b) {
    if (!b) {
        b = false
    }
    var d = $('[id="transp' + activeSlide + '"]').position();
    var c = $("#contenedor_slides").position();
    if (d == null || c == null) {
        return
    }
    if (b) {
        $(".menu_lateral").animate({
            top: d.top - c.top
        }, {
            duration: "fast",
            easing: "swing"
        })
    } else {
        $(".menu_lateral").css({
            top: d.top - c.top
        })
    }
}

function posicionarBorrador() {
    if ($(".libro2paginas").size() > 0) {
        var b = $(".libro_me").offset();
        b.top += $(".libro_me").height() - 80;
        b.left += 10
    } else {
        if (esInfantil) {
            var b = $("#t" + secuencia[activeSlide] + "contenidos_curso").offset();
            if (b != null) {
                b.top += 500;
                b.left += 820
            }
        } else {
            var b = $("#t" + secuencia[activeSlide] + "contenidos_curso").offset();
            if (b != null) {
                b.left -= 120;
                b.top -= 60;
                if (b.left < 0) {
                    b.left = 0
                }
            }
        }
    }
    if (b != null) {
        $("#canvasborrador:visible").offset(b)
    }
}

function conmutarModoContinuo() {
    blink.theme.conmutarModoContinuo()
}

function printError(b) {
    setTimeout(function() {
        _showAlert(b)
    }, 500)
}
var DragScroll;
(DragScroll = {
    e: null,
    x: 0,
    y: 0,
    t: 0,
    prevX: 0,
    prevY: 0,
    prevT: 0,
    velX: 0,
    velY: 0,
    mouseDown: false,
    init: function() {
        var b = this;
        $(document).mousemove(function(c) {
            b.getMousePosition(c);
            return false
        });
        $(document).mousedown(function(c) {
            b.mouseDown = true
        });
        $(document).mouseup(function() {
            b.mouseDown = false;
            return false;
            $("html,body").animate({
                scrollTop: "-=" + Math.floor(b.velY * 1000)
            }, "slow")
        });
        $(document.body).css("overflow", "hidden");
        $(document).disableSelection()
    },
    getMousePosition: function(b) {
        this.e = b;
        if (b.which != 1) {
            return
        }
        if ($(this.e.target).hasClass("draggable")) {
            return
        }
        this.x = this.e.screenX;
        this.y = this.e.screenY;
        this.t = new Date().getTime();
        this.velX = (this.x - this.prevX) / (this.t - this.prevT);
        this.velY = (this.y - this.prevY) / (this.t - this.prevT);
        if (this.mouseDown && (this.x != this.prevX || this.y != this.prevY)) {
            window.scrollBy(0, -(this.y - this.prevY))
        }
        this.prevX = this.x;
        this.prevY = this.y;
        this.prevT = this.t
    }
});

function BlockMove(b) {
    return true;
    b.preventDefault();
    return false
}

function getStandardUrlResourceFile(b) {
    getAJAX("/LMS/ajax.php?op=getStandardUrlResource&url=" + encodeURIComponent(b) + "&app=activity&app_id=" + idclase, function(c) {
        if (c.startsWith("OK")) {
            b = c.substring(2)
        }
    }, false, undefined, undefined, true);
    return b
}

function adjustUseruploadsUrl(c, h, b) {
    var f = c;
    var d = c.indexOf(MEDIA_URL);
    var g = c.indexOf(FILE_RESOURCES_PATH);
    if (d != -1 && g != -1) {
        f = MEDIA_URL + "/" + FILE_RESOURCES_SHORT_PATH + h + "/" + b + "/" + c.substring(g + FILE_RESOURCES_PATH.length)
    }
    return f
}
var lupaOff = true;

function hideLupa() {
    if (!lupaOff) {
        toggleLupa()
    }
}
var waitLupaTimer;

function waitLupa() {
    if ($("#lupa_" + activeSlide).get(0) && $("#lupa_" + activeSlide).css("visibility") == "hidden") {
        $("#lupa_" + activeSlide).css("visibility", "visible").css("opacity", "1")
    } else {
        waitLupaTimer = setTimeout("waitLupa()", 500)
    }
}

function toggleLupa(b) {
    if (lupaOff) {
        loupe.defaultResopath = "../images/";
        $(b).eq(activeSlide).each(function() {
            $(this).parent().css("background-image", 'url("' + $(this).attr("src") + '" no-repeat)').width($(this).width());
            loupe.add($(this).get(0), {
                name: "lupa_" + activeSlide,
                visible: false
            })
        });
        loupe.toggle("lupa_" + activeSlide);
        waitLupa()
    } else {
        $('[id^="lupa_"]:visible').each(function() {
            loupe.remove(this)
        })
    }
    if (lupaOff) {
        setPizarraOff(false);
        if (miniaturasInfantil) {
            mostrarMiniaturasInfantil()
        }
        $(".gometusado").hide()
    } else {
        $(".gometusado").show()
    }
    setTimeout(function() {
        $("[id$='_Switch']").hide()
    }, 100);
    lupaOff = (lupaOff) ? false : true;
    conmutarEstadoBoton("boton_lupa", lupaOff);
    $("#boton_lupa").toggleClass("on")
}

function markAsModif() {
    if ($('[name="pwdChange"]').val() == "0") {
        $('[name="pwdChange"]').val("1")
    }
}

function actualizarCamposFormulario() {
    blink.theme.actualizarCamposFormulario()
}

function enviarTicket() {
    if (window.openHelpPanel) {
        if (window.openHelpPanel()) {
            return false
        }
    }
    showMsgBox("", "/LMS/msgbox.php?op=sendticket", 560);
    return false
}

function editarUsuario(b, c) {
    redireccionar("/LMS/registration.php?nextURL=" + encodeURIComponent("../admin/admin.php?op=listadousuarios") + "&edituserid=" + b + "&blinkdomain=" + c)
}

function nuevoUsuario() {
    redireccionar("/LMS/registration.php?nextURL=" + encodeURIComponent("../admin/admin.php?op=listadousuarios") + "&newuser=1")
}

function nuevoDominio() {
    showMsgBox("", "/LMS/msgbox.php?op=neweditdomain", 560);
    return false
}

function invitarProfesor() {
    redireccionar("/LMS/registration.php?nextURL=" + encodeURIComponent("../admin/admin.php?op=listadousuarios") + "&newuser=1&invitarprofesor=1")
}

function logoff(b) {
    if (blink.isApp) {
        blink.rest.logout()
    } else {
        if (b == "1" && $.browser.msie) {
            window.close()
        } else {
            redireccionar("../LMS/index.php?logoff=1")
        }
    }
}

function mostrarIndiceCurso(b, d, c) {
    $("#capaTemas").height($(window).height() - 133);
    if ($("#indice:visible").get(0)) {
        $(".home_curso_de").animate({
            "margin-left": "+=" + $(".listado_temas").width()
        }, "fast", "swing", function() {
            $("#indice").fadeOut()
        })
    } else {
        if ($("#divindicecurso").html() == "") {
            getMsgBoxFromURL("/coursePlayer/capa_indice_curso.php?idcurso=" + b + "&idclase=" + d + "&editar=" + c, undefined, "divindicecurso")
        }
        $("#indice").fadeIn();
        $(".home_curso_de").animate({
            "margin-left": "-=" + $(".listado_temas").width()
        }, "fast", "swing");
        $("#leccion" + d + " tr td.td_actividad").addClass("selected")
    }
}

function mostrarAnteriorActividad() {
    $("#leccion" + idclase).prev().prev().find("td.td_actividad").click()
}

function mostrarSiguienteActividad(b) {
    idclaseToGo = (b) ? b : idclase;
    $("#leccion" + idclaseToGo).next().next().find("td.td_actividad").click()
}
var _indiceCurso;
(_indiceCurso = {
    offset: 0,
    timer: null,
    interval: 100,
    setOffset: function(b) {
        this.offset = b;
        this.resetTick(false)
    },
    resetOffset: function() {
        this.offset = 0;
        if (this.timer) {
            clearTimeout(this.timer);
            this.timer = null
        }
    },
    resetTick: function(b) {
        if (!this.timer || b) {
            this.timer = setTimeout("_indiceCurso.tick()", this.interval)
        }
    },
    tick: function() {
        if (this.offset >= 0) {
            pagUp(20, 10)
        } else {
            pagDown(20, 10)
        }
        this.resetTick(true)
    }
});

function isInside(b, c) {
    var d = null;
    $(b).each(function() {
        if (d) {
            return
        }
        var k = $(this).offset();
        var f = $(this).width();
        var g = $(this).height();
        var j = (c.x >= k.left && c.x <= k.left + f && c.y >= k.top && c.y <= k.top + g);
        if (j) {
            d = this
        }
    });
    return d
}

function generarClaseDemo(b) {
    getAJAX("/LMS/ajax.php?op=generardatosdemo" + ((b != null) ? "&idcurso=" + b : ""), standardAJAX, false)
}

function indiceCursoRellenarNota(f, d, b, c) {
    blink.theme.indiceCursoRellenarNota(f, d, b, c)
}

function doPrint(b, c) {
    printw = window.open("/coursePlayer/clases2.php?idcurso=" + b + "&idclase=" + c + "&print=true", "print", "status=0,toolbar=0,width=966,height=660,scrollbars=yes")
}

function printPreview() {
    if (!modoContinuo) {
        conmutarModoContinuo()
    }
    $("div.caja_inner, div.caja_outer").each(function() {
        $(this).css("border", "2px solid " + $(this).css("background-color"))
    });
    $("div").css({
        background: "none",
        "background-image": "none !important"
    });
    $("#menu_div, .menu_gris, .cabecera_peq, .paginas_curso, .titulo_pagina_curso, .editar_ver, .pie_blanco, .cabecera_curso, .pie_curso, .corregir_quedan, .solucion_div, .player").hide();
    $(".headlibro").remove();
    $(".print").show();
    $(".contenidos").css("min-width", "940px");
    $(".contenidos2, .contenidos3").width(940);
    $(".libro").height(448);
    $("div.circulo_gris:has(p:visible)").prepend('<img style="position:absolute; z-index:1;" src="../images/i/drop_izquierda2.png"/>');
    $("div.drop_ok").prepend('<img style="position:absolute; margin-left: -26px; z-index:1; " src="../images/i/drop_miniok.png"/>');
    $("div.drop_ko").prepend('<img style="position:absolute; margin-left: -26px; z-index:1; " src="../images/i/drop_miniko.png"/>');
    $("div.drop_ok p").css({
        "z-index": "1",
        position: "relative",
        color: "black"
    });
    $("div.drop_nada").each(function(b) {
        $(this).prepend('<span style="color: black;">' + (b + 1) + '</span><img style="position:absolute; margin-left: -23px; margin-top: -7px; z-index:3;" src="../images/i/drop_derecha2.png"/>')
    });
    $("div.clasificar_conjuntos div").prepend('<img style="position:absolute; left: 0px; z-index:1;" src="../images/i/clasificar_globo.png"/>');
    $("div.clasificar_conjuntos div ul").css({
        "z-index": "2",
        position: "relative"
    });
    $("div.clasificar_conjuntos div p").css({
        position: "relative"
    });
    $("div.page_border").css({
        background: "url(../../images/i/page_border.png) 0 0 no-repeat !important",
        height: "1370px",
        width: "940px"
    });
    $("div.page_inner").css({
        height: "1280px",
        width: "940px"
    });
    if ($.browser.msie) {
        $(".print_pie").css("margin-bottom", "50px")
    }
    window.print()
}

function mostrarGloboAyuda(c, b, f, j, h, g, d, k) {
    blink.theme.mostrarGloboAyuda(c, b, f, j, h, g, d, k)
}

function mostrarRequiereOnline(b, d, c) {
    blink.theme.mostrarRequiereOnline(b, d, c)
}

function mostrarBloqueoLicencia(b, d, c) {
    blink.theme.mostrarBloqueoLicencia(b, d, c)
}

function _showAlert(b) {
    if (mostrarMensajesPersonalizados()) {
        $(".generic-custom-error").showBlink().find("p").html(b).end().find(".generic-help-button").attr("id", "offline-btn-reload").click(function() {
            $(".generic-custom-error").hideBlink()
        })
    } else {
        if (blink.isApp) {
            //blink.rest.alert(b)
        } else {
            //alert(b)
        }
    }
}

function initAndroidApp() {
    $("#close_session").remove();
    $(".logo a").attr("href", "#");
    $(".logo3 a").attr("href", "#")
}

function getLabelModo(b) {
    modos = new Array("ver", "editar", "standalone", "embed", "drm");
    if (b >= 0 && b < modos.length) {
        return modos[b]
    }
    return modos[0]
}

function isModoOffline(b) {
    return (getLabelModo(b) == "standalone" || getLabelModo(b) == "drm")
}

function setModoVisualizacion(b) {
    modoactual = getLabelModo(b);
    $(".no_modo_" + modoactual).remove();
    for (m = 0; m < modos.length; m++) {
        if (modos[m] != modoactual) {
            $(".modo_" + modos[m]).filter(":not(.modo_" + modoactual + ")").remove()
        }
    }
    for (m = 0; m < modos.length; m++) {
        if (modos[m] != modoactual) {
            $(".no_modo_" + modos[m]).filter(":not(.no_modo_" + modoactual + ")").showBlink()
        }
    }
    $(".modo_" + modoactual).show()
}

function setModoBlocked() {
    $(".access_type_blocked").attr("disabled", "disabled");
    $(".contenidos").find("a, input, textarea, button").attr("disabled", "disabled");
    $(".contenidos").find("a, input, textarea, button").attr("href", "javascript:void(0)").attr("onclick", "javascript:void(0)");
    mostrarBloqueoLicencia("", "none", false)
}

function setDisabledCKEditor(c, b) {
    setTimeout("CKEDITOR.instances['" + c + "'].document.$.body.setAttribute('contenteditable', " + !b + ")", 500);
    if (b) {
        $("#cke_" + c + " .cke_top").hide()
    } else {
        $("#cke_" + c + " .cke_top").show()
    }
}

function checkStatusOffline() {
    setTimeout("statusOffline()", 5000)
}

function statusOffline() {
    $.getJSON("/drm:DRMstatus", function(c) {
        var b = c.porcentaje;
        $("#porcentaje_offline").attr("class", "").addClass("porcentaje_" + b / 10);
        if (b != 100) {
            setTimeout("statusOffline()", 5000)
        }
    })
}

function enviarInvitacion(b) {
    if (confirm(text_web.reinvitar_1)) {
        getAJAX("/LMS/ajax.php?op=sendInvitation&idusuario=" + b, standardAJAX)
    }
}

function sincronizarAtria() {
    if (confirm(text_web.sincronizar_atria)) {
        getAJAX("/LMS/ajax.php?op=cargaLicenciasAtria", function(b) {
            if (b.startsWith("OK")) {
                _showAlert(b.substring(2));
                location.reload()
            } else {
                _showAlert(text_web.error_general_AJAX)
            }
        })
    }
}

function dlgSyncroCourse(b) {
    showMsgBox("", "/LMS/msgbox.php?op=syncrocourse&idcurso=" + b, 770)
}

function mostrarTextoIncidencia(c) {
    var b = "/LMS/msgbox.php?op=mostrarIncidencias&idincidencia=" + c;
    showMsgBox("", b, 550)
}

function refrescaTooltip(b) {
    b.each(function() {
        this.title = $(this).attr("tooltip");
        $(this).tooltip()
    })
}

function drmAccess() {
    if (!navigator.javaEnabled()) {
        if (confirm(text_web.drmaccess_instalar_java)) {
            window.open("http://www.java.com/es/download/")
        }
        return false
    }
    return true
}

function getTime() {
    var b = new Date();
    return b.getTime()
}

function closeWindow() {
    window.open("", "_self", "");
    window.close()
}

function matchFilter(f, d, b) {
    var c = true;
    if (f.length) {
        if ($("#filtros #" + f).hasClass("selected")) {
            $("#filtros #" + f).removeClass("selected");
            $("li[id^=tema]").show();
            c = false
        }
    }
    if (c) {
        $("#filtros a").removeClass("selected");
        if (f != "") {
            $("#filtros #" + f).addClass("selected")
        }
        jsonfilter = json_decode('{"' + d.replace(":", '":"') + '"}');
        $("li[id^=tema]").each(function() {
            filteri = $(this).attr("filter");
            if (d == "" || !filteri) {
                $(this).show()
            } else {
                jsonfilteri = json_decode('{"' + filteri.replace(":", '":"') + '"}');
                attrs = ["lang", "role", "loc", "idtemaprev"];
                matchi = null;
                for (i = 0; i < attrs.length; i++) {
                    at = attrs[i];
                    if (jsonfilter[at] && jsonfilteri[at]) {
                        matchi = _.indexOf(jsonfilteri[at].split(","), jsonfilter) != -1;
                        break
                    }
                }
                if (matchi != null) {
                    if (matchi) {
                        $(this).show()
                    } else {
                        if (b) {
                            $(this).hide()
                        }
                    }
                }
            }
        })
    }
}
var hasChangesInFields = false;

function registerChanges() {
    $("input, select").change(function() {
        hasChangesInFields = true
    })
}

function checkRegisterChanges(b) {
    if (hasChangesInFields) {
        return b
    }
}

function markRegisterChange() {
    hasChangesInFields = true
}

function resetRegisterChanges() {
    hasChangesInFields = false
}

function changeUserLicense(b) {
    if (!b || b == 0) {
        return
    }
    showMsgBox("", "/LMS/msgbox.php?op=updateuserlicense&iduser=" + b, 550)
}

function prolongUserLicense(c, b) {
    if (!c || c == 0) {
        return
    }
    if (!b || b == 0) {
        b = 15
    }
    getAJAX("/LMS/ajax.php?op=prolonguserlicense&iduser=" + c + "&days=" + b, function(d) {
        if (d.startsWith("OK")) {
            _showAlert("Licencia actualizada hasta " + d.substr(2))
        } else {
            _showAlert("Ha ocurrido un error al actualizar la licencia")
        }
    })
}

function getCoursesList(n, b, l, f, d, c, h, k, j, g) {
    showMsgBox("", "/LMS/msgbox.php?op=viewschoolcourses&idschool=" + encodeURIComponent(n) + "&from_activation=" + encodeURIComponent(b) + "&until_activation=" + encodeURIComponent(l) + "&marsutype=" + encodeURIComponent(f) + "&demotype=" + encodeURIComponent(d) + "&dispositivetype=" + encodeURIComponent(c) + "&comment=" + encodeURIComponent(h) + "&userlicensetype=" + encodeURIComponent(k) + "&idpublisher=" + encodeURIComponent(j) + "&funcionalidad=" + encodeURIComponent(g), 550)
}

function getCoursesListByIDUser(n, b, l, f, d, c, h, k, j, g) {
    showMsgBox("", "/LMS/msgbox.php?op=viewschoolcoursesbyiduser&idschool=" + encodeURIComponent(n) + "&from_activation=" + encodeURIComponent(b) + "&until_activation=" + encodeURIComponent(l) + "&marsutype=" + encodeURIComponent(f) + "&demotype=" + encodeURIComponent(d) + "&dispositivetype=" + encodeURIComponent(c) + "&comment=" + encodeURIComponent(h) + "&userlicensetype=" + encodeURIComponent(k) + "&idpublisher=" + encodeURIComponent(j) + "&funcionalidad=" + encodeURIComponent(g), 550)
}

function isValidDate(c, h, g, b, f, k) {
    if (!b) {
        b = 0
    }
    if (!f) {
        f = 0
    }
    if (!k) {
        k = 0
    }
    var j = new Date(g, h - 1, c, b, f, k);
    return j.getFullYear() == g && j.getMonth() + 1 == h && j.getDate() == c && b == j.getHours() && f == j.getMinutes() && k == j.getSeconds()
}

function esFechaValida(c, b) {
    var d = "-";
    if (c.indexOf(d) == -1) {
        d = "/"
    }
    c = c.split(d);
    if (b) {
        b = b.split(":");
        return isValidDate(c[0], c[1], c[2], b[0], b[1])
    }
    return isValidDate(c[0], c[1], c[2])
}

function fechaHoy() {
    var c = new Date();
    var f = c.getDate();
    var b = c.getMonth() + 1;
    var g = c.getFullYear();
    return "" + (f <= 9 ? "0" + f : f) + "-" + (b <= 9 ? "0" + b : b) + "-" + g
}

function format_duracion(b) {
    return b
}

function fechaMayor(c, b) {
    if (c.length != 10 || b.length != 10) {
        return null
    }
    f1 = "" + c.substr(6) + c.substr(3, 2) + c.substr(0, 2);
    f2 = "" + b.substr(6) + b.substr(3, 2) + b.substr(0, 2);
    return f1 > f2
}

function addBookToList(d, b) {
    if ($.trim($("#isbnadd").attr("value")) == "") {
        if (b == "profesor") {
            _showAlert("Debe indicar el ISBN o ID del libro.")
        } else {
            _showAlert("Debe indicar los ISBN o ID de libros separados por (,) o (;)")
        }
        return
    } else {
        var c = "";
        if (b == "centro" || b == "libros-demo") {
            c = "/LMS/ajax.php?op=addbooktoschool&idcentro=" + d + "&pantalla=" + b + "&isbn=" + $("#isbnadd").attr("value")
        } else {
            if (b == "profesor") {
                c = "/LMS/ajax.php?op=addbooktoteacher&idprof=" + d + "&isbn=" + $("#isbnadd").attr("value")
            } else {
                c = "/LMS/ajax.php?op=addbooktogroup&idgrupo=" + d + "&isbn=" + $("#isbnadd").attr("value")
            }
        }
        if (b != "grupo" || (b == "grupo" && confirm(text_web.confirm_add_course_to_group))) {
            getAJAX(c, function(l) {
                if (l.startsWith("OK")) {
                    var h = l.substr(2);
                    var g = h.split(",");
                    var k = g.length;
                    var j = "";
                    var f = (b == "centro" || b == "libros-demo") ? "idcentro" : "idg";
                    getAJAX("/LMS/msgbox.php?op=getlibrohtmlcursotinyicon&" + f + "=" + d + "&idcurso=" + h + "&pantalla=" + b, function(n) {
                        if (l.startsWith("OK")) {
                            j = n.substr(2);
                            $(j).appendTo("#div_libros");
                            var o = parseInt($("#div_nlibros").html());
                            o += k;
                            $("#div_nlibros").html(o);
                            $("#isbnadd").val("")
                        }
                    })
                } else {
                    _showAlert(l.substr(5))
                }
                $("#isbnadd").val("")
            })
        }
    }
}

function removeBookFromSchool(c, b) {
    blink.theme.removeBookFromSchool(c, b)
}

function removeBookFromGroup(c, b) {
    blink.theme.removeBookFromGroup(c, b)
}

function chooseOSInstallerCurso(b) {
    showMsgBox("", "/LMS/msgbox.php?op=choose_os&idcurso=" + b, msgBoxWidth, null, true)
}

function chooseOSInstallerApp(b) {
    if (offline) {
        mostrarAvisoOffline()
    } else {
        showMsgBox("", "/LMS/msgbox.php?op=choose_os&app=" + b, msgBoxWidth, null, true)
    }
}

function autocompleteCenter(f, c, d, b) {
    if (d == undefined) {
        d = 400
    }
    if (b == undefined) {
        b = 50
    }
    if ($("#" + f).length == 0) {
        return false
    }
    $("#" + f).change(function() {
        if ($(this).val() == "") {
            $("#" + c).val("")
        }
    }).blinkcomplete({
        minLength: 2,
        source: function(h, g) {
            if ($("#pais").val() != "00") {
                blink.getJSON("/LMS/ajax.php?op=searchcentro&maxlist=10", g, {
                    data: {
                        term: h.term,
                        pais: $("#pais").val()
                    }
                })
            } else {
                blink.getJSON("/LMS/ajax.php?op=searchcentro&maxlist=10", g, {
                    data: {
                        term: h.term
                    }
                })
            }
        },
        getItemLine1: function(g) {
            return g.value
        },
        getItemLine2: function(g) {
            return g.address
        },
        getItemWidth: function(g) {
            return b
        },
        open: function(g, h) {
            $(".ui-autocomplete").css("z-index", 4200);
            $(".ui-autocomplete").css("width", $("#" + f).outerWidth(true))
        },
        select: function(g, h) {
            if (h.item.id != 0) {
                $("#" + f).val(h.item.value);
                $("#" + c).val(h.item.id)
            } else {
                $("#" + f).val("")
            }
            return false
        }
    })
}

function detalleCredito(b) {
    showMsgBox("", "/LMS/msgbox.php?op=mostrardetallecredito&id=" + b, 550)
}

function accionMiembro(c, b) {
    if (b == "rechazar" && !confirm(text_web.new_edit_group_32)) {
        return
    }
    getAJAX("/LMS/ajax.php?op=" + b + "miembro&idusuario=" + c + "&idgrupo=" + $("#idgrupo").val(), standardAJAXFunc)
}

function checkBookIndexEndMode() {}

function verCajaTexto() {
    var b = $(".caja_texto");
    if (b.attr("visible") == "false") {
        b.attr("visible", true).show();
        if ($("textarea", b).attr("disabled")) {
            $(".caja_texto div").hide();
            b.addClass("disabled")
        }
    } else {
        b.attr("visible", false).hide()
    }
}

function android_iframe_height_hack() {
    var d = navigator.userAgent || "";
    d = d.toLowerCase();
    if (d.indexOf("android") != -1 && d.indexOf("version/") != -1) {
        var b = d.match("android ([0-9]+.[0-9]+)");
        if (b) {
            b = parseFloat(b[1]);
            if (b < 4.4) {
                var c = parseInt($("#t0_iframe").css("height"));
                setInterval(function() {
                    try {
                        var f = parseInt(document.getElementById("t0_iframe").contentWindow.document.body.scrollHeight);
                        if (f <= 0) {
                            return
                        }
                        if (f < c) {
                            f = c
                        }
                        if (f != parseInt($("#t0_iframe").css("height"))) {
                            $("#t0_iframe").css("height", f + "px")
                        }
                    } catch (g) {}
                }, 500)
            }
        }
    }
}

function dlgNewDigitalBookLink(c) {
    var b = blink.getReqParam(location.href, "idclase");
    c = c ? "&callback=" + c : "";
    showMsgBox("", "/LMS/msgbox.php?op=neweditdigitalbooklink&idclase=" + b + "&idelem=" + c, 770)
}

function editLinkDigitalBook(c) {
    var b = blink.getReqParam(location.href, "idclase");
    showMsgBox("", "/LMS/msgbox.php?op=neweditdigitalbooklink&idclase=" + b + "&idelem=" + c, 770)
}

function editFileDigitalBook(f, c, b) {
    var d = blink.getReqParam(location.href, "idclase");
    showMsgBox("", "/LMS/msgbox.php?op=editdigitalbookfile&idclase=" + d + "&idelem=" + f + "&thumb=" + c + "&tipoFichero=" + b, 770)
}

function editActiviyDigitalBook(c) {
    var b = blink.getReqParam(location.href, "idclase");
    showMsgBox("", "/LMS/msgbox.php?op=editdigitalbookactivity&idclase=" + b + "&idelem=" + c + "&tipoFichero=actividad", 770)
}

function activarLinksLibroDigital(b) {
    $("#canvasdiv0, #capa, .html_page").css("pointer-events", (b) ? "none" : "auto")
}

function generarExcelCentrosDemo() {
    blink.theme.generarExcelCentrosDemo()
}

function marcarCursoDemoElegido(b) {
    blink.theme.marcarCursoDemoElegido(b)
}

function borrarCursoDemo(c, b, d) {
    blink.theme.borrarCursoDemo(c, b, d)
}

function mostrarErrorusuarios(b, c) {
    //alert(b);
    closeMsgBox();
    redireccionar(c)
}

function onCreateEditComunity(c, d) {
    var b = "/LMS/msgbox.php?op=group.addComunity";
    if (d) {
        b += "&idComunity=" + d
    }
    showMsgBox(c, b, 580, null, true)
}

function busquedaClaustro(g, f, b, d) {
    borrarValoresDefecto();
    if (!g) {
        g = "buscadorClaustro"
    }
    var c = $("#" + g).attr("value") || "";
    if (d == "miclaustro") {
        redireccionar("/LMS/claustro.php?busqueda=" + encodeURIComponent(c) + "&idclaustro=" + b)
    } else {
        if (d == "community") {
            redireccionar("/LMS/claustro.php?busqueda=" + encodeURIComponent(c) + "&idgrupo=" + f)
        }
    }
}

function seguirComunidadMsg(b) {
    getAJAX("/LMS/ajax.php?op=group.executejoincommunity&id=" + b + "&privado=1", function(c) {
        if (c.startsWith("OK")) {
            redireccionar("/LMS/claustro.php?idgroup=" + b)
        } else {
            standardAJAXFunc(c)
        }
    })
}

function busquedaClase(h, f, c) {
    var b = "/LMS/clase.php";
    var g = "idgrupo";
    if (c == "") {
        c = "clase"
    }
    borrarValoresDefecto();
    if (!h) {
        h = "buscadorClase"
    }
    var d = $("#" + h).attr("value") || "";
    if (c == "claustro") {
        b = "/LMS/claustro.php";
        g = "idgroup"
    }
    redireccionar(b + "?busqueda=" + encodeURIComponent(d) + "&" + g + "=" + f)
}

function imprimirClase(c, d, b) {
    doPrint(c, d)
}

function detallesLibroMochila(f, b, d, c) {
    showMsgBox("", "/LMS/msgbox.php?op=detallesMochila&id=" + f + "&nvl=" + b + "&asg=" + d + "&idsch=" + c, 700)
}

function quitarLibroMochila(f, b, d, c) {
    getAJAX("/LMS/ajax.php?op=quitarLibroMochila&id=" + f + "&nivel=" + b + "&asignatura=" + d + "&centro=" + c, function(g) {
        if (g.startsWith("OK")) {
            location.reload()
        } else {
            //alert("ERROR", g.substring(5))
        }
    })
}

function aceptarRechazarLibro(b, g, c, d) {
    function f(h) {
        getAJAX("/LMS/ajax.php?op=cambiarEstadoLibro&id=" + g + "&acc=" + h, function(j) {
            if (h == "OK" && j.startsWith("OK")) {
                $("#btn" + g).html(text_web["admin.global.editar"]);
                $("#btn" + g).parent().parent().parent().addClass("selected");
                detallesLibroMochila(g, c, d)
            } else {
                if (h == "KO" && j.startsWith("OK")) {
                    location.reload()
                } else {
                    //alert("Error")
                }
            }
        })
    }
    if (!$(b).prop("checked")) {
        if (confirm(text_web.confirm_remove_course_selected)) {
            f("KO")
        } else {
            $(b).prop("checked", "checked")
        }
    } else {
        f("OK")
    }
}

function confirmaMochila(b) {
    if (!$(".listadomochila .selected").length > 0) {
        //alert(text_web.error_sin_libros_mochila)
    } else {
        if (confirm(text_web.confirm_close_selection)) {
            getAJAX("/LMS/ajax.php?op=confirmaMochila&id=" + b, function(c) {
                if (c.startsWith("OK")) {
                    location.reload()
                } else {
                    //alert("ERROR", c.substring(5))
                }
            })
        }
    }
}

function abrirMochila(b) {
    getAJAX("/LMS/ajax.php?op=abrirMochila&id=" + b, function(c) {
        if (c.startsWith("OK")) {
            location.reload()
        } else {
            //alert("ERROR", respuesta.substring(5))
        }
    })
}

function pedirLicencias(b) {
    if (confirm(text_web.confirm_ask_licenses)) {
        getAJAX("/LMS/ajax.php?op=pedirLicencias&id=" + b, function(c) {
            if (c.startsWith("OK")) {
                //alert(text_web.ask_licenses_ok);
                location.reload()
            } else {
                //alert(text_web.ask_licenses_error)
            }
        })
    }
}

function cambiaVisibilidad(c, b) {
    var d = false;
    if (b == "S" && confirm(text_web.confirm_oculta_grupo)) {
        d = true
    }
    if (!(b == "S") && confirm(text_web.confirm_muestra_grupo)) {
        d = true
    }
    if (d) {
        getAJAX("/LMS/ajax.php?op=cambiaVisibilidad&id=" + c, function(f) {
            if (f.startsWith("OK")) {
                location.reload()
            } else {
                //alert(text_web.ask_licenses_error)
            }
        })
    }
}

function gestionaLibrosProfesor(b) {
    showMsgBox("", "/LMS/msgbox.php?op=gestionaLibrosProfesor&id=" + b, 550)
}

function conectarModuloExterno(modulo, origen) {
    blink.theme.spinner.show();
    blink.ajax(WEBS + "/LMS/ajax.php?op=externalIntegration.conectar&nombre=" + modulo + "&origen=" + origen, function(resp) {
        if (resp.startsWith("OK")) {
            blink.theme.spinner.hide()
        } else {
            if (resp.startsWith("<script>")) {
                resp = resp.substring(8, resp.length - 11).trim();
                eval(resp)
            }
        }
    }, {
        withCredentials: true
    })
}

function desconectarModuloExterno(b) {
    blink.theme.spinner.show();
    getAJAX(WEBS + "/LMS/ajax.php?op=externalIntegration.desconectar&nombre=" + b, function(c) {
        if (c.startsWith("OK")) {
            location.reload()
        } else {
            blink.theme.spinner.hide()
        }
    })
}
blink.domain = blink.domain || {};
blink.domain.getDownloadingText = function(b, c) {
    return b + " " + c + "%"
};
blink.domain.doLoginError = function() {
    _showAlert(text_web.login_campos_vacios);
    return false
};
blink.domain.writeScriptOffline = function(b, c, k, n, p, f, d, g, o) {
    var j = "",
        h = new Date(),
        l = $.datepicker.formatDate("dd-mm-yy", h);
    j = "actividades[" + idclase + "] = {'idtema':'" + idtema + "','tipo':'" + evaltype + "','estado':" + b + ",'avance':'" + c + "','nota':'" + k + "','clasificacion':'" + n + "','fecha':'" + l + "','tiempo':'" + p;
    _.each(f, function(r, q) {
        j += "', 'clasificacion_eje" + (q) + "':'" + f[q]
    });
    j += "'" + d + ",'fecha_modificacion':'" + l + "'};";
    return j
};;
if (!Array.prototype.indexOf) {
    Array.prototype.indexOf = function(a) {
        return $.inArray(this, a)
    }
}
if (!String.prototype.includes) {
    String.prototype.includes = function() {
        return String.prototype.indexOf.apply(this, arguments) !== -1
    }
}
if (!String.prototype.contains) {
    String.prototype.contains = function() {
        return String.prototype.indexOf.apply(this, arguments) !== -1
    }
}
if (!Array.prototype.contains) {
    Array.prototype.contains = function(a) {
        return this.indexOf(a) != -1
    }
}
String.prototype.startsWith = function(a) {
    return (this.match("^" + a) == a)
};
String.prototype.endsWith = function(a) {
    return (this.match(a + "$") == a)
};
if ((!window.JSON || !JSON.stringify || !JSON.parse) && window.YAHOO) {
    if (!window.JSON) {
        window.JSON = {}
    }
    window.JSON.stringify = window.YAHOO.lang.JSON.stringify;
    window.JSON.parse = window.YAHOO.lang.JSON.parse
}
Array.prototype.longerContent = function() {
    var b = trim(this[0]);
    for (var a = 1; a < this.length; a++) {
        if (trim(this[a]).length > b.length) {
            b = this[a]
        }
    }
    return b
};
Array.prototype.maxLength = function() {
    return this.longerContent().length
};
Array.prototype.max = function() {
    var b = this[0];
    var a = this.length;
    for (var c = 1; c < a; c++) {
        if (this[c] > b) {
            b = this[c]
        }
    }
    return b
};
Array.prototype.exists = function(b) {
    for (var a = 0; a < this.length; a++) {
        if (this[a] == b) {
            return true
        }
    }
    return false
};
Array.prototype.findIndex = function(b) {
    for (var a = 0; a < this.length; a++) {
        if (this[a] == b) {
            return a
        }
    }
    return -1
};
Array.prototype.rotate = (function() {
    var a = Array.prototype.push,
        b = Array.prototype.splice;
    return function(d) {
        var c = this.length >>> 0,
            d = d >> 0;
        d = ((d % c) + c) % c;
        a.apply(this, b.call(this, 0, d));
        return this
    }
})();
if (typeof Object.create != "function") {
    (function() {
        var a = function() {};
        Object.create = function(b) {
            if (arguments.length > 1) {
                throw Error("Second argument not supported")
            }
            if (b === null) {
                throw Error("Cannot set a null [[Prototype]]")
            }
            if (typeof b != "object") {
                throw TypeError("Argument must be an object")
            }
            a.prototype = b;
            return new a()
        }
    })()
}
blink.String = (function() {
    var b = function(c) {
        if (!(this instanceof b)) {
            return new b(c)
        }
        this._wrapped = "" + c
    };
    b.prototype.value = function a() {
        return this._wrapped
    };
    b.prototype.trim = function() {
        if (String.prototype.trim) {
            this._wrapped = this._wrapped.trim()
        } else {
            var c = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g;
            this._wrapped = this._wrapped.replace(c, "")
        }
        this._wrapped = this._wrapped.replace(/ +(?= )/g, "");
        return this
    };
    b.prototype.removePunctuation = function() {
        this._wrapped = this._wrapped.replace(/([\.,\/#¡!$%\^&\*;:{}\-_~()¿?\[\]]+)/g, " ");
        this.trim();
        return this
    };
    b.prototype.replaceEspaciosBlancos = function() {
        this._wrapped = this._wrapped.replace(/\s/g, "");
        this.trim();
        return this
    };
    b.prototype.lower = function() {
        this._wrapped = this._wrapped.toLowerCase();
        return this
    };
    return b
})();
blink.Url = (function() {
    var c = function(f) {
        var g = {};
        if (f.length === 0) {
            return g
        }
        if (f[0] === "?") {
            f = f.substring(1)
        }
        var e;
        f.split("&").forEach(function(h) {
            e = h.split("=");
            g[e[0]] = e[1]
        });
        return g
    };
    var a = function(e) {
        var g = "?",
            f = [];
        for (var h in e) {
            f.push(h + "=" + e[h])
        }
        return g + f.join("&")
    };
    var d = function(e) {
        e.search = a(e.params);
        return e.href
    };
    var b = function(e) {
        if (!(this instanceof b)) {
            return new b(e)
        }
        var f = document.createElement("a");
        f.href = e;
        f.params = c(f.search);
        this.getParams = function() {
            return f.params
        };
        this.setParam = function(g, h) {
            f.params[g] = h;
            return this
        };
        this.getParam = function(g) {
            return f.params[g]
        };
        this.removeParam = function(g) {
            delete f.params[g];
            return this
        };
        this.getUrl = function() {
            return d(f)
        }
    };
    return b
})();;

function noenter() {
    return !(window.event && window.event.keyCode == 13)
}

function checkEnter(b) {
    var a = window.event ? window.event.keyCode : b.which;
    return a == 13
}

function keyPressNumerico(b) {
    var a = window.event ? window.event.keyCode : b.which;
    var c = String.fromCharCode(a);
    reg = /\d/;
    return reg.test(c) || (a >= 48 && a <= 57) || (a >= 96 && a <= 105) || ("|" + allowedSpecialCodes.join("|") + "|").indexOf("|" + a + "|") != -1
}

function checkPressNumerico(b) {
    var a = b.keyCode;
    var c = String.fromCharCode(a);
    reg = /\d/;
    return reg.test(c) || (a >= 48 && a <= 57) || (a >= 96 && a <= 105) || ("|" + allowedSpecialCodes.join("|") + "|").indexOf("|" + a + "|") != -1
}

function stripHTML(c, b) {
    var d = /(<([^>]+)>)/gi;
    if (b == null) {
        b = ""
    }
    if (c !== undefined) {
        return c.replace(d, b)
    }
}

function mostrarMensajesPersonalizados() {
    return false
}

function escapeHtml(a) {
    if (a !== undefined && a !== "") {
        return a.replace(/&amp;/g, "&").replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&quot;/g, '"').replace(/&#39;/g, "'").replace(/&nbsp;/g, " ")
    } else {
        return ""
    }
}

function escapeQuotes(a) {
    if (!a) {
        return ""
    }
    return a.replace(/'/g, "&#39;").replace(/"/g, "&quot;")
}

function compressXML(b) {
    b = b.replace(/\n/gi, "");
    b = b.replace(/>(\s{2,})</gi, "><");
    return b
}

function trim(b, a) {
    return ltrim(rtrim(b, a), a)
}

function ltrim(b, a) {
    if (b == undefined) {
        return ""
    }
    a = a || "\\s";
    return b.replace(new RegExp("^[" + a + "]+", "g"), "")
}

function rtrim(b, a) {
    if (b == undefined) {
        return ""
    }
    a = a || "\\s";
    return b.replace(new RegExp("[" + a + "]+$", "g"), "")
}

function clean(c) {
    var b = "\\t\\n\\r\\0\\x0B";
    c = c.replace(new RegExp("[" + b + "]+", "g"), "");
    c = trim(c);
    c = rtrim(c, ".,");
    var d = /\s+/g;
    c = c.replace(d, " ");
    return c
}

function replaceAccents(c) {
    var b = {
        à: "à",
        è: "è",
        é: "é"
    };
    var a = new RegExp(Object.keys(b).join("|"), "gi");
    return c.replace(a, function(d) {
        return b[d]
    })
}

function limitarString(d, c) {
    if (d.length > c) {
        return d.substr(0, c) + "..."
    } else {
        return d
    }
}

function pintaDosCifras(a) {
    return ((a < 10) ? "0" : "") + a
}

function json_encode(a) {
    return JSON.stringify(a)
}

function json_decode(a) {
    return JSON.parse(a)
}

function encode_utf8(a) {
    return unescape(encodeURIComponent(a))
}

function decode_utf8(a) {
    return decodeURIComponent(escape(a))
}

function getCookie(b) {
    var c = document.cookie;
    var d = c.indexOf(" " + b + "=");
    if (d == -1) {
        d = c.indexOf(b + "=")
    }
    if (d == -1) {
        c = ""
    } else {
        d = c.indexOf("=", d) + 1;
        var a = c.indexOf(";", d);
        if (a == -1) {
            a = c.length
        }
        c = decodeURIComponent(c.substring(d, a))
    }
    return c
}

function setCookie(a, d, b) {
    var e = new Date();
    e.setDate(e.getDate() + b);
    var c = encodeURIComponent(d) + ((b == null) ? "" : "; expires=" + e.toUTCString());
    document.cookie = a + "=" + c
}

function isOrientationPortrait() {
    return $(window).height() > $(window).width()
}

function isOrientationLandscape() {
    return $(window).width() > $(window).height()
}

function rgb2hex(a) {
    if (/^#[0-9A-F]{6}$/i.test(a)) {
        return a
    }
    a = a.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
    var b = function(c) {
        return ("0" + parseInt(c).toString(16)).slice(-2)
    };
    return "#" + b(a[1]) + b(a[2]) + b(a[3])
}

function hex2rgb(e) {
    var d = e >> 16;
    var c = e >> 8 & 255;
    var a = e & 255;
    return [d, c, a]
}

function hex2dec(a) {
    if (a.length == 3) {
        a = a.charAt(0) + a.charAt(0) + a.charAt(1) + a.charAt(1) + a.charAt(2) + a.charAt(2)
    }
    return parseInt(a, 16)
}

function isValidHex(a) {
    return /(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(a)
}

function _ago(a) {
    cur_tm = new Date().getTime();
    tm = new Date(a).getTime();
    dif = cur_tm - tm;
    lngh = [60, 3600, 86400, 604800, 2630880];
    for (v = lngh.length - 1;
        (v >= 0) && ((no = (dif / lngh[v]) / 1000) <= 1); v--) {}
    if (v < 0) {
        v = 0
    }
    no = Math.floor(no);
    x = no + " " + text_web["mensaje_" + (v + 3)];
    return x
}

function isValidSHA1(a) {
    return !!a.match("[a-fA-F0-9]{40}")
}

function isInt(a) {
    return Number(a) === a && a % 1 === 0
}

function isFloat(a) {
    return Number(a) === a && a % 1 !== 0
}

function toggleClasses(a, c, b) {
    c = c.replace(".", "");
    b = b.replace(".", "");
    var d = $(a);
    if (d.hasClass(c)) {
        d.removeClass(c).addClass(b);
        return true
    } else {
        if (d.hasClass(b)) {
            d.removeClass(b).addClass(c);
            return true
        } else {
            return false
        }
    }
}

function getCondicionAlumnosCorreccion(a) {
    return '.item[data-tema="' + a + '"]'
}

function mostrarAlertaPersonalizada(c) {
    try {
        var a = JSON.parse(c);
        if (a && typeof a === "object") {
            c = '<span class="customAlertTitle"> ' + a.title + "</span>";
            c += '<span class="customAlertMessage"> ' + a.message + "</span>"
        }
    } catch (b) {
        return c
    }
    return c
};;
var fullmaskmode = true;
var iframe = {};

function hideHTMLOverflow() {
    blink.theme.hideHTMLOverflow()
}

function restoreHTMLOverflow() {
    blink.theme.restoreHTMLOverflow()
}

function showMask(a, b) {
    blink.theme.showMask(a, b)
}

function hideMask() {
    blink.theme.hideMask()
}

function resizeMask() {
    callOfflinePCParent("events.mask.onResize");
    var c = $(document.body).attr("scrollWidth") ? $(document.body).attr("scrollWidth") : 0;
    var a = $(document.body).attr("scrollHeight") ? $(document.body).attr("scrollHeight") : 0;
    if (fullmaskmode) {
        $("#background").css({
            height: Math.max($(document).height(), a, $(window).height()),
            width: Math.max($.browser.msie ? 0 : $(document).width(), c, $(window).width()),
            "margin-top": 0
        })
    } else {
        var b = $(".cabecera_peq").height() + $(".menu_gris").height();
        $("#background").css({
            height: Math.max($(document).height(), a, $(window).height()) - b,
            width: Math.max($.browser.msie ? 0 : $(document).width(), c, $(window).width()),
            "margin-top": b
        })
    }
}
var abrirEnPopup = false;
var windowPopup;
var allowed_external_urls_iframe = ["youtube.com/embed/", "player.vimeo.com/video/"];
var allowed_exts_iframe = ["swf", "png", "jpeg", "jpg", "gif"];

function allowUrlInIframe(a) {
    if (!isURLAllowedByProtocol(a)) {
        return false
    }
    if (isBlinkHost(a) || isLocalHost(a) || isCacheHost(a)) {
        return true
    }
    for (var b = 0; b < allowed_external_urls_iframe.length; b++) {
        if (a.contains(allowed_external_urls_iframe[b])) {
            return true
        }
    }
    if (!isExternalURL(a)) {
        return true
    }
    if (allowed_exts_iframe.length > 0) {
        var c = new RegExp("\\.(" + allowed_exts_iframe.join("|") + ")$", "i");
        if (deleteQuery(a).match(c)) {
            return true
        }
    }
    return false
}

function shouldShowUrlInIframe(a) {
    if (!allowUrlInIframe(a)) {
        return false
    }
    var b = getMediaType(a);
    return $.inArray(b, ["image", "flash", "video", "sound"]) != -1
}

function showIFrame(b, o, i, k, c, e, d) {
    $("#iframe_div").find(".btn-close-iframe").showBlink();
    callOfflinePCParent("events.popup.onBeforeShow");
    if (b != null && !e) {
        if (offline && b.match(/^https?:\/\//)) {} else {
            if (modoVisualizacion == 2 && b.indexOf("/coursePlayer/webclass_html_.htm") != -1) {
                if (b.startsWith("/")) {
                    b = ".." + b
                }
            } else {
                if (b.indexOf("/coursePlayer/webclass_html_.htm") == -1) {
                    b = adjustURL(b, false)
                }
            }
        }
        b = getFinalUrl(b)
    }
    iframe.dims = {
        w: o,
        h: i
    };
    resizeIframe();
    var m = $(window).height() - 40;
    var a = $(window).width() - 80;
    i = i ? Math.min(i, m) : m;
    o = o ? Math.min(o, a) : a;
    if (abrirEnPopup) {
        windowPopup = window.open(b, "ActBlink", "width=" + o + ",height=" + i + ",status=0");
        windowPopup.moveTo(0, 0)
    } else {
        if (b != null && !allowUrlInIframe(b)) {
            openPopup(b)
        } else {
            showMask();
            var n = {
                width: parseInt(o),
                height: parseInt(i)
            };
            var f = $("#class_iframe").hide();
            var p = $("#iframe_div").attr("style", "").css(n);
            k ? p.show() : p.fadeIn();
            var l = getFinalPosition(n);
            var g = function() {
                if (!b) {
                    return
                }
                f.css(n).attr("src", b).show().showBlink().on("load", function(h) {
                    if ($("#class_iframe").contents().text() !== "ERROR") {
                        $body = f.contents().find("body");
                        if (c) {
                            f.contents().find("html").css("overflow", "hidden")
                        } else {
                            $body.css({
                                margin: 0,
                                padding: 0
                            })
                        }
                        if ($body.find(" > *").length == 1 && $body.find(" > img").length) {
                            $body.css("text-align", "center")
                        }
                        $body.find("#contenedor_slides").css("margin-left", "-30px");
                        $body.find(".cabecera_peq, .paginador_temas, .pie_blanco").hide();
                        $body.find(".contenidos, .contenidos2, .contenidos3").css({
                            width: "970px",
                            "min-width": "970px"
                        });
                        if (modoVisualizacionLabel === "standalone") {
                            $body.find(".close-back-wrapper").remove()
                        }
                    } else {
                        hideIFrame();
                        showOKOrErrorMsg("Error", text_web.url_no_disponible);
                        h.preventDefault();
                        h.stopImmediatePropagation()
                    }
                });
                blink.events.trigger("iframe:show:after")
            };
            var j = {
                top: l.fintop,
                left: l.finleft,
                width: o,
                height: i,
                position: "fixed"
            };
            if (d && d.behaviour == "video") {
                f.css("background-color", "black")
            }
            if (b.indexOf("popup=2") !== -1) {
                j.width = "100%";
                j.height = "100%";
                j.top = "0px";
                j.left = "0px";
                p.find(".btn-close-iframe").addClass("inside-close-btn").css("bottom", "0px")
            }
            if (k) {
                p.css(j);
                g()
            } else {
                p.animate(j, "fast", "swing", function() {
                    g()
                })
            }
        }
    }
}

function resizeIframe() {
    $(window).resize(function() {
        var e = $(window).width() - 80;
        var a = $(window).height() - 40;
        iframe.dimsCalc = {
            h: iframe.dims.h ? Math.min(iframe.dims.h, a) : a,
            w: iframe.dims.w ? Math.min(iframe.dims.w, e) : e
        };
        var f = iframe.dimsCalc;
        var b = $("#class_iframe").attr("src");
        if (b && b.indexOf("popup=2") >= 0) {
            $("#iframe_div").css({
                width: "100%",
                height: "100%"
            })
        } else {
            var d = {
                width: parseInt(f.w),
                height: parseInt(f.h)
            };
            var g = getFinalPosition(d);
            var c = {
                top: g.fintop,
                left: g.finleft,
                width: d.width,
                height: d.height
            };
            $("#iframe_div").css(c);
            $("#class_iframe").css(c)
        }
    })
}

function hideIFrame() {
    if (abrirEnPopup) {
        windowPopup.close()
    } else {
        if (_vieneDeModoContinuo) {
            _vieneDeModoContinuo = false;
            conmutarModoContinuo()
        }
        blink.events.trigger("iframe:hide:before");
        removeItems();
        blink.events.trigger(true, "iframe:hide:after");
        callOfflinePCParent("events.popup.onAfterHide")
    }
}

function removeItems() {
    hideMask();
    blink.theme.removeVideoJS($("#iframe_div"), true);
    $("#iframe_div").removeClass("audio panel image scorm");
    $("#iframe_div, #iframe_div iframe, #multimedia_iframe, #class_iframe").stop(true).attr("style", "display:none");
    $("#iframe_div iframe, #class_iframe").attr("src", "about:blank");
    $(".btn-close-iframe").find("h4").remove();
    $("#multimedia_iframe").html("");
    getQueryParamValue("popup") == 2 && blink.theme.buttonState.hidden(".close-back", true);
    $("#iframe_div").find(".btn-close-iframe").removeClass("inside-close-btn")
}

function getFinalPosition(a) {
    return blink.theme.getFrameFinalPosition(a)
}

function cerrarIframe() {
    $("#iframe_div").find(".btn-close-iframe").showBlink();
    hideIFrame();
    return false
}

function setMsgBoxTitle(a) {
    blink.theme.setMsgBoxTitle(a)
}

function showMsgBox(f, c, d, b, a, e) {
    callOfflinePCParent("events.popup.onBeforeShow");
    if (c.indexOf("text:") !== 0 && c.indexOf("template:") !== 0) {
        if (offline) {} else {
            c = adjustURL(c, false)
        }
    }
    if (d == null) {
        d = "771"
    }
    if (a == null) {
        a = true
    }
    blink.theme.showMsgBox(f, c, d, b, a, e)
}

function showOKOrErrorMsg(a, b) {
    blink.theme.showOKOrErrorMsg(a, b)
}

function showWarningMsg(a, b) {
    blink.theme.showWarningMsg(a, b)
}

function showOKOrErrorAJAXMsg(b, a) {
    if (b.startsWith("OK")) {
        if (a) {
            redireccionar(a)
        }
        return
    } else {
        if (b.startsWith("ERROR")) {
            errormsg = b.substring(5);
            if (errormsg == "") {
                errormsg = text_web.error_general_AJAX
            }
            _showAlert(errormsg)
        }
    }
}

function closeMsgBox() {
    blink.theme.closeMsgBox()
}

function submitMsgBox() {
    $("#background").fadeOut("slow");
    getMsgBoxFromURL(document.forms.dlgForm.action)
}

function openPopup(c, b) {
    c = getFinalUrl(c);
    var a = window.open(c, b);
    a && a.focus();
    return a || false
}

function maxZIndex(a) {
    a = a || "*";
    var b = 0;
    $(a).each(function() {
        if ($(this).css("zIndex") !== "auto" && $(this).css("zIndex") > b) {
            b = $(this).css("zIndex")
        }
    });
    return b
};;

function addSound(f) {
    var e = f.indexOf("_");
    var d = f.substring(2, e);
    editorNameMultimedia = f;
    var b = getFileAppDataFromEditorName(f);
    var a = b[0];
    var c = b[1];
    seleccionarMultimedia(idcurso, d, "finSeleccionarSonido", null, "sound", null, a, c)
}

function addVideo(f) {
    var e = f.indexOf("_");
    var d = f.substring(2, e);
    editorNameMultimedia = f;
    var b = getFileAppDataFromEditorName(f);
    var a = b[0];
    var c = b[1];
    seleccionarMultimedia(idcurso, d, "finSeleccionarVideo", null, "video", null, a, c)
}

function addVideo2(f) {
    var e = f.indexOf("_");
    var d = f.substring(2, e);
    editorNameMultimedia = f;
    var b = getFileAppDataFromEditorName(f);
    var a = b[0];
    var c = b[1];
    seleccionarMultimedia(idcurso, d, "finSeleccionarVideo2", null, "video", null, a, c)
}

function addFile(g, f) {
    var e = g.indexOf("_");
    var d = g.substring(2, e);
    editorNameMultimedia = g;
    var b = getFileAppDataFromEditorName(g);
    var a = b[0];
    var c = b[1];
    seleccionarMultimedia(idcurso, d, f ? f : "finSeleccionarArchivo", null, "", null, a, c)
}

function borrarSonidoFondo() {
    closeMsgBox();
    document.f.elements[prefijoSeleccionMultimedia + "_snd1v"].value = "";
    document.getElementById(prefijoSeleccionMultimedia + "_snd1v_info").innerHTML = "Sin sonido fondo";
    marcarHaCambiado(getIDSlideFromPrefijo(prefijoSeleccionMultimedia))
}
var soundOff = false;
var funcPlay;
var _useNativePlayer = true;
var AudioArray = Array();
try {
    var tryAudio = new Audio();
    _useNativePlayer = (tryAudio.canPlayType && "no" != tryAudio.canPlayType("audio/mpeg")) && ("" != tryAudio.canPlayType("audio/mpeg"))
} catch (err) {
    _useNativePlayer = false
}
var buttonPlaying = 0;

function stopButtonPlaySoundPressed() {
    buttonPlaying = 0;
    try {
        jwplayer("mp3floatingplayer_flash").stop()
    } catch (a) {}
    $("#mp3floatingplayer").hide()
}

function buttonPlaySoundPressed(e, b) {
    if (buttonPlaying == e) {
        stopButtonPlaySoundPressed()
    } else {
        if (blink.isApp && !blink.isOfflinePCApp && !blink.isWinRTApp) {
            if (b.startsWith("../")) {
                b = b.substr(2)
            }
            if (!b.startsWith("/") && !b.match(/^https?:\/\//)) {
                b = "/" + b
            }
            blink.rest.audio(b)
        } else {
            var a = $(".migas:visible");
            if (a.length > 0) {
                var c = $("#mp3floatingplayer");
                while (c.parent().attr("id") && c.parent().attr("id").contains("mp3")) {
                    c = c.parent()
                }
                var d = a.prev().attr("id");
                if (!d || !d.contains("mp3")) {
                    c.detach().insertBefore(a)
                }
            }
            writeAudioPlayer("mp3floatingplayer", b, true);
            pauseBackgroundSound();
            buttonPlaying = e
        }
    }
}

function playSound(b, a) {
    if (a) {
        document.getElementById("mp3player").style.display = "block"
    }
    try {
        var c = document.getElementById("mp3player_main");
        funcPlay = function() {
            _playSound(b, c)
        };
        setTimeout("funcPlay()", 1000)
    } catch (d) {}
}
var lastBackgroundSound = null;

function replayBackgroundSound() {
    if (lastBackgroundSound) {
        playBackgroundSound(lastBackgroundSound)
    }
    return false
}

function playBackgroundSound(c) {
    if (soundOff) {
        return false
    }
    lastBackgroundSound = c;
    if (_useNativePlayer) {
        for (var f = 0; f < AudioArray.length; f++) {
            if (AudioArray[f].urlobj == c) {
                try {
                    AudioArray[f].audioobj.currentTime = 0
                } catch (g) {}
                AudioArray[f].audioobj.play();
                return
            }
        }
        var b = new Audio();
        b.src = c;
        b.load();
        b.play();
        AudioArray.push({
            urlobj: c,
            audioobj: b
        })
    } else {
        try {
            var d = document.getElementById("mp3player_bg");
            if (!soundOff) {
                d.SetVariable("method:setUrl", c);
                d.SetVariable("method:play", "");
                d.SetVariable("enabled", "true")
            }
        } catch (g) {}
    }
}

function pauseBackgroundSound() {
    if (_useNativePlayer) {
        for (var a = 0; a < AudioArray.length; a++) {
            AudioArray[a].audioobj.pause()
        }
    } else {
        try {
            document.getElementById("mp3player_bg").SetVariable("method:pause", "")
        } catch (b) {}
    }
}

function _playSound(a, b) {
    if (!soundOff) {
        try {
            b.SetVariable("player:jsUrl", a);
            b.SetVariable("player:jsPlay", "")
        } catch (c) {}
    }
}

function setVolumen(a) {
    if (_useNativePlayer) {} else {
        try {
            document.getElementById("mp3player_bg").SetVariable("method:setVolume", a)
        } catch (b) {}
    }
}

function setSoundOn(a) {
    soundOff = false;
    conmutarEstadoBoton("boton_sonido", true);
    if (a) {
        setSessionAttribute("SONIDO", "true")
    }
    if (_useNativePlayer) {} else {
        try {
            document.getElementById("mp3player_bg").SetVariable("method:play", "")
        } catch (b) {}
    }
    setVolumen(100)
}

function setSoundOff(a) {
    soundOff = true;
    conmutarEstadoBoton("boton_sonido", false);
    if (a) {
        setSessionAttribute("SONIDO", "false")
    }
    if (_useNativePlayer) {
        pauseBackgroundSound()
    } else {
        try {
            document.getElementById("mp3player_bg").SetVariable("method:pause", "")
        } catch (b) {}
    }
    setVolumen(0)
}

function switchSound(a) {
    soundOff ? setSoundOn(a) : setSoundOff(a);
    return false
}

function createAudioButtons() {
    blink.theme.createAudioButtons()
}

function writeAudioPlayerButton(c, b, a) {
    return blink.theme.writeAudioPlayerButton(c, b, a)
}

function writeAudioPlayerButtonInfantil(a) {
    blink.theme.writeAudioPlayerButtonInfantil(a)
}
var audioPlayerObj = null;
var audioPlayerEnabled = true;

function writeAudioPlayer(e, a, i, b) {
    if (!audioPlayerEnabled) {
        return
    }
    audioPlayerEnabled = false;
    audioPlayerObj && audioPlayerObj.manualClose();
    var k = (e == "div_div_menu") ? "2000" : "420",
        j = (e.startsWith("t") ? e + "_multimedia" : e),
        c = $("#" + j),
        d = !!i,
        b = b && b.toString().replace(/\W/g, "_"),
        g = blink.theme;
    $("#iframe_div").find(".btn-close-iframe").hideBlink();
    if (b) {
        var h = '<audio id="' + b + '" class="video-js vjs-default-skin audio" controls><source src="' + a + '" type="audio/mp3"/></audio>';
        c.html(h).css("z-index", k).show();
        var f = blink.theme.audio.videojs(b, d);
        f.on("ready", function() {
            audioPlayerEnabled = true;
            this.play();
            this.addClass("vjs-has-started");
            this.hasStarted(true)
        }).on("ended", function() {
            hideIFrame()
        });
        blink.events.once("iframe:hide:before", function() {
            c.html("").hide();
            sonido_ultimo_id_abierto = 0
        });
        return f
    }
    c.html("<div id='" + e + "_flash'></div>").css("z-index", k).show();
    audioPlayerObj = jwplayer(e + "_flash").setup({
        file: a,
        autostart: d,
        controlbar: "bottom",
        screencolor: "",
        height: "25",
        width: "100%",
        repeat: false,
        closed: false,
        timer: 0,
        events: {
            onPlaylistComplete: function() {
                this.manualClose()
            },
            onReady: function() {
                var l = this;
                c.find(".jwgroup.jwright").append('<span class="jwclose"><button></button></span>').click(function() {
                    l.pause();
                    $("#iframe_div").find(".btn-close-iframe").showBlink();
                    cerrarIframe()
                });
                audioPlayerEnabled = true;
                if (i) {
                    this.play()
                }
                var l = this;
                this.timer = setInterval(function() {
                    var m = l.getPosition();
                    var n = l.getDuration();
                    if (m == n && !l.closed) {
                        l.manualClose()
                    }
                }, 500)
            },
            onSetupError: function() {
                audioPlayerEnabled = true
            }
        },
        analytics: {
            enabled: false
        }
    });
    audioPlayerObj.manualClose = function() {
        if (this.closed) {
            return
        }
        this.closed = true;
        clearInterval(this.timer);
        try {
            this.remove();
            audioPlayerEnabled = true
        } catch (l) {
            setTimeout(function() {
                audioPlayerEnabled = true
            }, 2000);
            this.onReady(function() {
                this.remove()
            })
        }
        $("#" + j).hide("").html("");
        $("#div_div").hide().html("");
        sonido_ultimo_id_abierto = 0;
        buttonPlaying = 0;
        audioPlayerObj = null;
        blink.events.trigger("audio:close")
    };
    $("#" + e + "_picnik").hide()
}
$(document).ready(function() {
    blink.events.on("iframe:hide:before", function() {
        audioPlayerObj && audioPlayerObj.manualClose()
    })
});

function writeDocPlayer(e, b, d, f) {
    var c = b.substring(b.lastIndexOf("/") + 1);
    var a = "../images/i/" + ((c.indexOf(".zip") != -1) ? "zip" : "documentos") + ".png";
    $("#" + e + "_multimedia").html(((!f) ? "<a href='" + b + "' target='_blank'>" : "") + "<img style='float:right;width:100%;max-height:" + d + "px;' src='" + a + "' name='" + e + "_img1' id='" + e + "_img1' title='" + ((!f) ? "Click to download " : "") + c + "'/>" + ((!f) ? "</a>" : ""));
    $("#" + e + "_picnik").hide()
}

function writeImgPlayer(f, b, c, a, g, d, e) {
    blink.theme.writeImgPlayer(f, b, c, a, g, d, e)
}

function writeOtherPlayer(c, a, b) {
    $("#" + c + "_multimedia").html("<iframe frameborder='0' style='z-index:1;height:" + b + "px;width:100%;' scrolling='no' src='" + a + "' name='" + c + "_img1' id='" + c + "_img1'/>");
    $("#" + c + "_picnik").hide();
    autozoomElement(c + "_img1")
}

function writeGeogebraPlayer(c, a, b) {
    var d = (c.startsWith("t") ? c + "_multimedia" : c);
    $("#" + d).html("<div id='" + c + "_flash'><applet name=\"" + c + 'ggbApplet" code="geogebra.GeoGebraApplet" codebase="../libs/geogebra/" archive="geogebra.jar" width="100%" height="100%" MAYSCRIPT><param name="filename" value="../' + a + '"><param name="java_arguments" value="-Xmx512m"/><param name="framePossible" value="false"/><param name="showResetIcon" value="true"/><param name="showResetIcon" value="false"/><param name="enableRightClick" value="false"/><param name="enableChooserPopups" value="false"/><param name="enableShiftDragZoom" value="false"/>Java 1.4.2 o superior de Java requerido. (<a href="http://java.sun.com/getjava">Haz clic aquí para instalar Java ahora.</a>)</applet></div>');
    $("#" + d).show()
}

function createVideoButtons() {
    blink.theme.createVideoButtons()
}

function writeVideoPlayerButton(c, b, a, d) {
    return blink.theme.writeVideoPlayerButton(c, b, a, d)
}

function writeVideoPlayerButtonInfantil(a) {
    panel_videos = class_video.parents(".curso").find(".panel_videos");
    url = class_video.filter("img").attr("alt");
    idplayervideo = a.attr("id");
    if (panel_videos.html().indexOf(url) == -1) {
        panel_videos.append('<div class="player_infantil"><a id="playervideo_' + idplayervideo + '" href="javascript:buttonPlaySoundPressed(\'' + idplayervideo + "','" + url + "');\"><p>" + (true ? "&nbsp;" : idplayervideo) + "</p></a></div>");
        class_video.remove()
    }
}

function writeVideoPlayer(f, a, i, m, j, h, c) {
    var k = (f.startsWith("t") ? f + "_multimedia" : f),
        b = $("#" + k),
        c = c && c.toString().replace(/\W/g, "_") + "-player",
        g = blink.theme;
    if (c && !isYoutubeUrl(a)) {
        var l = g.video.getMarkUp(c, a),
            d = !!j;
        b.html(l).show();
        return g.video.videojs(c, {
            autoplay: d
        })
    }
    if (isVimeoUrl(a)) {
        var n = '<iframe class="vimeo-iframe" src="' + adaptUrlToEmbed(a) + '" height="270" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>';
        $("#" + k).html(n);
        return
    }
    if (!j) {
        j = false
    }
    b.html("<div id='" + f + "_flash'></div>").show();
    if (isYoutubeUrl(a)) {
        a = getOriginalYoutubeUrl(a)
    }
    if (a.indexOf("rtmp://") == 0) {
        pos = a.lastIndexOf("/");
        fileParam = a.substring(pos + 1);
        streamerParam = a.substring(0, pos);
        jwplayer(f + "_flash").setup({
            file: fileParam,
            streamer: streamerParam,
            autostart: j,
            controlbar: ((i) ? "none" : "over"),
            screencolor: "cccccc",
            height: m,
            width: "100%",
            analytics: {
                enabled: false
            }
        })
    } else {
        jwplayer(f + "_flash").setup({
            file: a,
            autostart: j,
            controlbar: ((i) ? "none" : "over"),
            screencolor: "cccccc",
            height: m,
            width: "100%",
            analytics: {
                enabled: false
            },
            tracks: h
        })
    }
    jwplayer().onBeforePlay(function() {
        var p = window.event,
            o = (p.screenX === 0 && p.screenY === 0);
        o && (this.stop())
    });
    var e = calculateTimeParameter(a);
    if (e != 0) {
        if (j) {
            jwplayer().onReady(function() {
                jwplayer().seek(e)
            })
        } else {
            jwplayer().onPlay(function() {
                jwplayer().seek(e)
            })
        }
    }
    $("#" + f + "_picnik").hide()
}

function writeFlashPlayer(d, b, c) {
    c = c || 389;
    var e = (d.startsWith("t") ? d + "_multimedia" : d);
    var a = e + "_aux";
    $("#" + e).html('<div id="' + a + '"></div>');
    swfobject.embedSWF(b, a, "100%", c, "9", "", {}, {
        allowfullscreen: "true",
        allowscriptaccess: "always",
        wmode: "transparent",
        bgcolor: "ffffff"
    });
    $("#" + d + "_picnik").hide();
    $("#" + e).show()
}

function addImage(f) {
    var e = f.indexOf("_");
    var d = f.substring(2, e);
    editorNameMultimedia = f;
    var b = getFileAppDataFromEditorName(f);
    var a = b[0];
    var c = b[1];
    seleccionarMultimedia(idcurso, d, "finSeleccionarImagenEditor", null, "image", null, a, c)
}

function addImageGallery(f) {
    var e = f.indexOf("_");
    var d = f.substring(2, e);
    editorNameMultimedia = f;
    var b = getFileAppDataFromEditorName(f);
    var a = b[0];
    var c = b[1];
    seleccionarMultimedia(idcurso, d, "finSeleccionarImagenGaleria", null, "image", null, a, c)
}

function getPhotoSwipeDOM() {
    return '<div class="pswp" tabindex="-1" role="dialog" aria-hidden="true"><div class="pswp__bg"></div><div class="pswp__scroll-wrap"><div class="pswp__container"><div class="pswp__item"></div><div class="pswp__item"></div><div class="pswp__item"></div></div><div class="pswp__ui pswp__ui--hidden"><div class="pswp__top-bar"><div class="pswp__counter"></div><button class="pswp__button pswp__button--close" title="Close (Esc)"></button><button class="pswp__button pswp__button--share" title="Share"></button><button class="pswp__button pswp__button--fs" title="Toggle fullscreen"></button><button class="pswp__button pswp__button--zoom" title="Zoom in/out"></button><div class="pswp__preloader"><div class="pswp__preloader__icn"><div class="pswp__preloader__cut"><div class="pswp__preloader__donut"></div></div></div></div></div><div class="pswp__share-modal pswp__share-modal--hidden pswp__single-tap"><div class="pswp__share-tooltip"></div></div><button class="pswp__button pswp__button--arrow--left" title="Previous (arrow left)"></button><button class="pswp__button pswp__button--arrow--right" title="Next (arrow right)"></button><div class="pswp__caption"><div class="pswp__caption__center"></div></div></div></div></div>'
}
var galleryManager;

function initPhotoSwipeFromDOM(a) {
    var b = function(d) {
        this.galleryDOMElements = [];
        this.galleryList = [];
        this.init(d)
    };
    b.prototype = {
        parseThumbnailElements: function(e) {
            var o = e.getElementsByTagName("figure"),
                d = o.length,
                j = [],
                h, k, l, n, g, m;
            for (var f = 0; f < d; f++) {
                h = o[f];
                if (h.nodeType !== 1) {
                    continue
                }
                g = $(h).find("img");
                n = {
                    w: (g.attr("width")) ? g.attr("width") : g.get(0).naturalWidth,
                    h: (g.attr("height")) ? g.attr("height") : g.get(0).naturalHeight
                };
                m = {
                    src: g.get(0).getAttribute("src"),
                    w: parseInt(n.w, 10),
                    h: parseInt(n.h, 10)
                };
                if (h.children.length > 1) {
                    m.msrc = h.children[0].getAttribute("src");
                    m.title = h.children[1].innerHTML
                }
                m.el = h;
                j.push(m)
            }
            return j
        },
        closest: function c(e, d) {
            return e && (d(e) ? e : this.closest(e.parentNode, d))
        },
        createPhotoSwipe: function(i, j, f) {
            var k = j.getAttribute("data-pswp-uid"),
                h = document.querySelectorAll(".pswp")[parseInt(k) - 1],
                d, g, e = [];
            e = this.parseThumbnailElements(j);
            g = {
                index: i,
                galleryUID: k,
                getThumbBoundsFn: function(m) {
                    var q = e[m].el.getElementsByTagName("img")[0],
                        p = window.pageYOffset || document.documentElement.scrollTop,
                        l = q.getBoundingClientRect();
                    var n = {
                        x: l.left,
                        y: l.top + p,
                        w: l.width
                    };
                    var o = h.parentElement.getBoundingClientRect();
                    n.x -= o.left;
                    n.y -= o.top;
                    return n
                },
                pinchToClose: false,
                closeOnScroll: false,
                closeOnVerticalDrag: false,
                escKey: false,
                closeEl: false,
                tapToClose: false,
                clickToCloseNonZoomable: false,
                closeElClasses: [],
                fullscreenEl: true,
                zoomEl: false,
                shareEl: false,
                modal: false,
                closeOnScroll: false,
                history: false,
                getDoubleTapZoom: function(m, l) {}
            };
            if (f) {
                g.showAnimationDuration = 0
            }
            d = new PhotoSwipe(h, PhotoSwipeUI_Default, e, g);
            d.listen("updateScrollOffset", function(l) {
                var m = h.getBoundingClientRect();
                l.x += m.left;
                l.y += m.top
            });
            d.listen("launchZoom", function() {
                if (d.options.modal) {
                    d.options.modal = false;
                    d.ui.showControls();
                    d.options.barsSize.bottom = 45;
                    d.options.barsSize.top = 45;
                    h.style.position = "absolute"
                } else {
                    d.options.modal = true;
                    d.ui.hideControls();
                    d.options.barsSize.bottom = 0;
                    d.options.barsSize.top = 0;
                    h.style.position = "fixed";
                    $(h).one("tap", function(l) {
                        l.preventDefault();
                        l.stopPropagation();
                        d.shout("launchZoom")
                    })
                }
                d.updateSize(true)
            });
            return d
        },
        addGallery: function(d) {
            var e = this.galleryDOMElements.length + 1;
            d.setAttribute("data-pswp-uid", e);
            this.galleryDOMElements.push(d);
            this.galleryList.push(this.createPhotoSwipe(e, d, true))
        },
        closeAllGalleries: function() {
            var d = this;
            _.each(this.galleryList, function(f, e) {
                d.closeGallery(e + 1)
            })
        },
        closeGallery: function(d) {
            this.galleryList[d - 1].close()
        },
        initGallery: function(d) {
            this.galleryList[d - 1].init()
        },
        updateGallery: function(d) {
            this.galleryDOMElements[d - 1] = $("[data-pswp-uid=" + d + "]").get(0);
            this.galleryList[d - 1] = this.createPhotoSwipe(d, this.galleryDOMElements[d - 1], true)
        }
    };
    b.prototype.init = function(h) {
        var e = (h) ? h : ".bck-gallery-images";
        var d = (e instanceof jQuery) ? e : document.querySelectorAll(e);
        if (d.length) {
            for (var g = 0, f = d.length; g < f; g++) {
                this.addGallery(d[g])
            }
        }
    };
    return new b(a)
}

function getFileAppDataFromEditorName(a) {
    tipoelem = "slide";
    idelem = idtransact;
    if (idtransact == undefined) {
        if (a.indexOf("contestar_") == 0) {
            tipoelem = "message_body";
            idelem = a.substr("contestar_".length)
        } else {
            tipoelem = "activity";
            idelem = blink.getReqParam(location.href, "idclase")
        }
    }
    return new Array(tipoelem, idelem)
}

function cargarImagen(a, b, c) {
    if (a == "") {
        a = "unica"
    }
    var d = document.images[a + "_img1"];
    tmp_img = new Image();
    tmp_img.onload = function() {
        if (!c) {
            d.width = this.width;
            d.height = this.height
        }
        d.src = b
    };
    try {
        tmp_img.src = b
    } catch (f) {}
    if (a != "unica") {
        $("#" + a + "_img1v").val(b)
    }
}

function cambiarTamanoImagen(c, b, d) {
    var a = document.getElementById(c + "_img1");
    if (a) {
        a.width = imgsizearray[c].width * b / 100;
        a.height = imgsizearray[c].height * b / 100;
        $("#" + c + "_imagezoom").val(imgsizearray[c].width * b / 100)
    }
    if (d) {
        marcarHaCambiado(getIDSlideFromPrefijo(c))
    }
}

function registrarTamanoImagen(d, c, b) {
    var e = document.getElementById(c + "_imagezoomaux");
    if (d.width == 0 || !e) {
        setTimeout('registrarTamanoImagen(document.getElementById("' + c + '_img1"), "' + c + '", ' + b + ")", 500);
        return
    }
    primeravez = (typeof(imgsizearray[c]) == "undefined");
    imgsizearray[c] = {
        width: d.width,
        height: d.height
    };
    if (b != "" && b != 0 && primeravez) {
        e.selectedIndex = 10 - Math.round(b * 10 / d.width);
        cambiarTamanoImagen(c, Math.round(b * 10 / d.width) * 10, false)
    }
}

function borrarImagenFondo() {
    closeMsgBox();
    setBackgroundImage("", prefijoSeleccionMultimedia);
    document.f.elements[prefijoSeleccionMultimedia + "_img_bg"].value = "";
    marcarHaCambiado(getIDSlideFromPrefijo(prefijoSeleccionMultimedia))
};;

function getHost(a) {
    var b = document.createElement("a");
    b.href = a;
    return b.hostname
}

function removeHost(a) {
    if (a.match(/^https?:\/\//)) {
        a = a.substr("https://".length)
    }
    var b = a.indexOf("/");
    if (b != -1) {
        a = a.substr(b)
    } else {
        a = "/" + a
    }
    return a
}

function isCacheHost(e) {
    if (!e) {
        return false
    }
    var c = "";
    var d = "";
    if (WEB_CACHE) {
        c += d + WEB_CACHE;
        d = ","
    }
    if (WEBS_CACHE) {
        c += d + WEBS_CACHE;
        d = ","
    }
    var a;
    var b;
    if (c && (a = c.split(","))) {
        b = a.map(function(f) {
            return getHost(f)
        });
        return (b.indexOf(e) != -1)
    }
    return false
}

function isBlinkHost(a) {
    if (!a) {
        return false
    }
    return a == getHost(WEB) || a == getHost(WEBS)
}

function isBlinkUrl(a) {
    return isBlinkHost(getHost(a))
}

function isLocalHost(a) {
    if (typeof(a) == "undefined") {
        a = location.hostname
    }
    return a == "localhost" || a == "127.0.0.1"
}

function isLocalUrl(a) {
    return isLocalHost(getHost(a))
}

function isOutsideHost(a) {
    return a && a != location.hostname
}

function isOutsideURL(a) {
    return isOutsideHost(getHost(a))
}

function isExternalHost(a) {
    return a && !isLocalHost(a) && !isBlinkHost(a) && !isCacheHost(a) && isOutsideHost(a)
}

function isExternalURL(a) {
    return isExternalHost(getHost(a))
}

function esContenidoEditorial(a) {
    if (!String.prototype.includes) {
        String.prototype.includes = function() {
            return String.prototype.indexOf.apply(this, arguments) !== -1
        }
    }
    return a.includes("accesoContenidoEditorial")
}

function getProtocol(b) {
    var c;
    if (b) {
        var a = b.match(/^([a-z]+):\/\//i);
        if (a) {
            c = a[1]
        }
    }
    if (!c) {
        c = location.protocol;
        c = c.match(/[a-z]+/i)[0]
    }
    return c.toLowerCase()
}

function isURLAllowedByProtocol(a) {
    return getProtocol() != "https" || getProtocol(a) == "https"
}

function removeAppParams(a) {
    var e = ["appBundleVersion", "app", "device", "offlinePort", "modo", "bd", "IDSESSIONDIRECT"];
    a = a.replace("?", "?&");
    for (var b = 0; b < e.length; b++) {
        var d = e[b];
        var c = new RegExp("&" + d + "=[^&]+");
        a = a.replace(c, "")
    }
    a = a.replace("?&", "?");
    return a
}

function getFragment(a) {
    var b = a.indexOf("#");
    return b == -1 ? "" : a.substr(b + 1)
}

function deleteFragment(a) {
    var b = a.indexOf("#");
    return b == -1 ? a : a.substr(0, b)
}

function deleteQuery(a) {
    var b = a.indexOf("?");
    return b == -1 ? a : a.substr(0, b)
}

function getExt(a, c) {
    a = deleteQuery(a);
    var d = a.lastIndexOf(".");
    if (d == -1) {
        return null
    }
    var b = a.substring(d + 1);
    if (c) {
        return b.toLowerCase()
    } else {
        return b
    }
}

function addAppParams(b) {
    if (!blink.isApp) {
        return b
    }
    b = b.replace(/^http:\/\/(localhost|127.0.0.1)(\:[0-9]+)?/, offlineServer);
    if (!isBlinkHost(getHost(b))) {
        return b
    }
    var a = getFragment(b);
    if (a) {
        b = deleteFragment(b)
    }
    b += b.indexOf("?") == -1 ? "?" : "&";
    if (!b.match(/[&|?]appBundleVersion=/)) {
        b += "appBundleVersion=" + blink.appVersion
    }
    if (!b.match(/[&|?]app=/)) {
        b += "&app=" + blink.appName
    }
    if (!b.match(/[&|?]device=/)) {
        b += "&device=" + blink.appDevice
    }
    if (!b.match(/[&|?]offlinePort=/)) {
        b += "&offlinePort=" + blink.appPort
    }
    if (!b.match(/[&|?]modo=/)) {
        b += "&modo=4"
    }
    if (!b.match(/[&|?]bd=/)) {
        b += "&bd=" + BLINKDOMAIN
    }
    if (!b.match(/[&|?]IDSESSIONDIRECT=/)) {
        b += "&IDSESSIONDIRECT=" + userToken
    }
    if (a) {
        b += "#" + a
    }
    return b
}

function addParamUrl(c, b, e) {
    var a = getFragment(c);
    if (a) {
        c = deleteFragment(c)
    }
    if (blink.getReqParam(c, b)) {
        var d = new RegExp("(\\?|&)" + b + "=[^&]+");
        c = c.replace(d, "$1" + b + "=" + e)
    } else {
        c += c.indexOf("?") == -1 ? "?" : "&";
        c += b + "=" + encodeURIComponent(e)
    }
    return c + a
}

function getFinalUrl(c) {
    if (blink.isApp && esContenidoEditorial(c)) {
        var d = blink.getReqParam(c, "urla");
        var a = blink.getReqParam(c, "urlp");
        var b = d;
        if (blink.user.esProfesor() && a != "") {
            b = a
        }
        if (b != "") {
            blink.ajax("/" + decodeURIComponent(b), function(e) {
                if (e != "ERROR") {
                    c = "/coursePlayer/webclass_html_.htm?marsupial=1&idcurso=" + idcurso + "&idclase=" + blink.getReqParam(c, "idclase") + "&extraAbsoluto=/" + decodeURIComponent(b)
                }
            }, {
                type: "GET",
                async: false
            }, {
                urlMode: "noDijest"
            })
        }
    }
    if (blink.isApp && blink.appVersion >= 4.1) {
        return c
    }
    if (!window.offline) {
        return c
    }
    if (needBeOnlineUrl(c)) {
        c = getOnlineUrl(c)
    }
    if (!blink.isApp) {
        return c
    }
    if (canUseProxyUrl(c)) {
        return getProxyUrl(c)
    } else {
        return addAppParams(c)
    }
}

function canUseProxyUrl(a) {
    return blink.appVersion >= 4 && ((isBlinkUrl(a) || isLocalUrl(a)) && !esContenidoEditorial(a))
}

function getProxyUrl(a) {
    if (canUseProxyUrl(a)) {
        if (isBlinkUrl(a)) {
            a = removeHost(a);
            a = offlineServer + a
        }
        a = removeAppParams(a)
    } else {
        blink.log.error("Pedida una url proxy cuando no debe ser " + a)
    }
    return a
}
var onlinePaths = [
    ["/admin/admin.php", true],
    ["/LMS/busqueda.php", true],
    ["/coursePlayer/accesoContenidoEditorial.php", false],
    ["/coursePlayer/accesoContenidoEditorial2.php", false],
    ["/LMS/index.php", false],
    ["/LMS/webinars.php", true]
];

function needBeOnlineUrl(a) {
    for (var b in onlinePaths) {
        if (a.indexOf(onlinePaths[b][0]) != -1) {
            return true
        }
    }
    return false
}

function getOnlineUrl(a) {
    for (var b in onlinePaths) {
        if (a.indexOf(onlinePaths[b][0]) != -1) {
            return adjustOnlineURL(a, onlinePaths[b][1])
        }
    }
    blink.log.warning("Pedida una url online cuando no debe ser " + a)
}

function canUseOfflineUrls() {
    return window.offline && (!blink.isApp || valid_modes == 3 || (blink.appVersion >= 4 && !blink.isOfflinePCApp && valid_modes != 1))
}
var offline_allowed = ["curso2", "clases2", "librodigital_html", "clase", "claustro", "alumnos", "students", "teachers", "fichaalumno", "mensajes", "registration", "avisolegal", "faqs", "contactus", "aboutus", "webclass.html", "termsofuse", "policyprivacy", "calendario", "desktop", "Module_output", "mensajes_hiloforo", "ventana_chat", "attendances_view", "epubviewer.html"];

function redireccionar(a, h, k, j) {
    j |= !canUseOfflineUrls();
    j |= (a.contains("/coursePlayer/clases2") || a.contains("/coursePlayer/curso2")) && a.match(/(&|\?)editar=1/) != null;
    j |= a.contains("/LMS/alumnos");
    if (h === undefined) {
        h = true
    }
    if (loadpagewithajax) {
        loadPageWithAJAX(a);
        return
    }
    if (offline && (!blink.isApp || blink.appVersion < 4.1)) {
        if (needBeOnlineUrl(a)) {
            a = getOnlineUrl(a);
            if (k) {
                blink.rest.openUrl("fullscreen", a)
            } else {
                goToHref(a)
            }
            return
        }
        var o = false;
        for (var b = 0; b < offline_allowed.length && !o; b++) {
            o = a.indexOf("/" + offline_allowed[b] + ".php") != -1
        }
        if (!o) {
            mostrarAvisoOffline();
            return false
        }
        if (j) {
            if (h) {
                a = adjustURLSeleccion(a)
            }
            a = (a.contains("/LMS/alumnos")) ? adjustURL(a, h, true) : adjustOnlineURL(a);
            if (!a.match(/^https?:\/\//)) {
                a = (offlineServer ? offlineServer : "..") + "/" + a
            }
        } else {
            a = adjustURL(a, h, true);
            if (!a.match(/^https?:\/\//)) {
                a = ((offlineServer && !window.location.pathname.contains("marsupial")) ? offlineServer : "..") + "/" + a
            }
        }
    } else {
        if (h) {
            a = adjustURLSeleccion(a)
        }
    }
    if (blink.isApp && (k || k === undefined)) {
        var l = ["coursePlayer/clases2", "coursePlayer/webclass", "LMS/mensajes_hiloforo"],
            m = location.href,
            c, n;
        for (var f = 0; f < l.length; f++) {
            if (a.contains(l[f])) {
                c = f
            }
            if (m.contains(l[f])) {
                n = f
            }
        }
        var d = c === n,
            e = c !== undefined;
        if (!d && e) {
            blink.rest.openUrl("fullscreen", a);
            return
        } else {
            if (a.contains("portal/")) {
                var g = a.contains("termsofuse") ? "targetBlank" : "viewer";
                blink.rest.openUrl(g, a);
                return
            } else {
                if ((blink.isOfflinePCApp || blink.appVersion >= 3) && a.contains("coursePlayer/curso2")) {
                    blink.rest.openUrl("fullscreen", a);
                    return
                } else {
                    if (a.contains("LMS/fichaalumno")) {
                        blink.rest.openUrl("fullscreen", a);
                        return
                    }
                }
            }
        }
    }
    if (k) {
        blink.rest.openUrl("fullscreen", a)
    } else {
        goToHref(a)
    }
}

function gotoMyLibrary() {
    redireccionar(blink.user.getMyLibraryURL())
}

function goToHref(a) {
    location.href = getFinalUrl(a)
}

function adjustURLSeleccion(a) {
    if (window.seleccion) {
        found = false;
        if (a.indexOf("?") != -1) {
            urlnew = a.substring(0, a.indexOf("?") + 1);
            var c = a.substring(a.indexOf("?") + 1).split("&");
            p = window.seleccion.substring(0, window.seleccion.indexOf("="));
            for (var b = 0; b < c.length; b++) {
                if (c[b].indexOf(p + "=") == 0) {
                    found = true
                }
                urlnew += c[b] + ((b < c.length - 1) ? "&" : "")
            }
        }
        if (!found) {
            a += ((a.indexOf("?") == -1) ? "?" : "&") + window.seleccion
        } else {
            a = urlnew
        }
    }
    return a
}

function adjustURL(a, b, d) {
    if (blink.isApp && blink.appVersion >= 4.1) {
        if (b) {
            a = adjustURLSeleccion(a)
        }
        if (a.indexOf("/") == 0) {
            return prefijoURL + a
        } else {
            if (a.indexOf("://") == -1) {
                return "../" + a
            }
        }
        return a
    } else {
        if (canUseOfflineUrls()) {
            if (a.indexOf("drm:DRM") != -1) {
                return a
            }
            var c = "";
            if (d != 1 && a.indexOf("../") != 0) {
                c = "../"
            }
            a = c + blink.getLocalURL(a)
        } else {
            if (b) {
                a = adjustURLSeleccion(a)
            }
            if (a.indexOf("/") == 0) {
                return prefijoURL + a
            } else {
                if (a.indexOf("://") == -1) {
                    return "../" + a
                }
            }
        }
    }
    return a
}

function adjustOnlineURL(a, b) {
    if (b === undefined) {
        b = true
    }
    if (a.startsWith("../")) {
        a = a.substr(2)
    }
    if (!a.match(/^https?:\/\//)) {
        a = (b ? WEBS : WEB) + a
    }
    return a
}

function getQueryParamValue(a) {
    a = a.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var c = new RegExp("[\\?&]" + a + "=([^&#]*)"),
        b = c.exec(location.search);
    return b == null ? "" : decodeURIComponent(b[1].replace(/\+/g, " "))
}

function isYoutubeUrl(a) {
    return !!a.match(/(youtube\.com.*?(embed|watch)|youtu\.be)/i)
}

function isVimeoUrl(a) {
    return !!a.match(/(vimeo.com|player.vimeo.com\/video)\/[0-9]+/i)
}

function isOnlineServiceUrlVideo(a) {
    return isYoutubeUrl(a) || isVimeoUrl(a)
}

function getYoutubeID(a) {
    var b = new RegExp('(?:youtube(?:-nocookie)?.com/(?:[^/]+/.+/|(?:v|e(?:mbed)?)/|.*[?&]v=)|youtu.be/)([^"&?/ ]{11})', "i");
    var c = a.match(b);
    return c ? c[1] : null
}

function getOriginalYoutubeUrl(a) {
    if (!isYoutubeUrl(a)) {
        return a
    }
    if (a.contains("/watch")) {
        return a
    }
    var b = getYoutubeID(a);
    if (!b) {
        return a
    }
    return "https://www.youtube.com/watch?v=" + b
}

function adaptUrlToEmbed(a) {
    if (isYoutubeUrl(a)) {
        if (a.indexOf("/embed/") != -1) {
            return a.replace("http://", "https://")
        } else {
            var b = getYoutubeID(a);
            if (b) {
                a = "https://www.youtube.com/embed/" + b
            }
        }
    } else {
        if (isVimeoUrl(a)) {
            a = a.replace("/vimeo.com/", "/player.vimeo.com/video/").replace("http://", "https://")
        }
    }
    return a
}

function procesarURL(a) {
    a = a.replace(/^\.\.\//, "/");
    if (a.indexOf("www") === 0) {
        a = "http://" + a
    } else {
        if (a.indexOf("://") === -1) {
            a = WEB + a
        }
    }
    return a
}

function goPage(a) {
    if (a == "clase") {
        url = "/LMS/clase.php"
    } else {
        if (a == "alumnos") {
            url = "/LMS/alumnos.php"
        } else {
            if (a == "claustro") {
                url = "/LMS/claustro.php"
            } else {
                if (a == "ficha") {
                    url = "/LMS/fichaalumno.php"
                } else {
                    if (a == "mensajes") {
                        url = "/LMS/mensajes.php"
                    } else {
                        if (a == "perfil") {
                            url = "/LMS/registration.php"
                        } else {
                            if (a == "cursos_alumno") {
                                url = "/LMS/students.php"
                            } else {
                                if (a == "cursos_padre") {
                                    url = "/LMS/parents.php"
                                } else {
                                    if (a == "cursos_profesor") {
                                        url = "/LMS/teachers.php"
                                    } else {
                                        if (a == "allstudents") {
                                            url = "/LMS/allstudents.php"
                                        } else {
                                            if (a == "teacherassignments") {
                                                url = "/LMS/teacherassignments.php"
                                            } else {
                                                if (a == "desktop") {
                                                    url = "/LMS/desktop.php"
                                                } else {
                                                    if (a == "calendar") {
                                                        url = "/LMS/calendario.php"
                                                    } else {
                                                        if (a == "community") {
                                                            url = "/LMS/claustro.php?idgrupo="
                                                        } else {
                                                            if (a == "librero") {
                                                                url = "/admin/admin.php?op=listadolibrero"
                                                            } else {
                                                                if (a == "blkAnalytic") {
                                                                    url = "/LMS/analytics2.php"
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    redireccionar(url, !blink.isApp);
    return false
}
blink.goToActivity = function(idcourse, idactivity, page) {
    blink.getActivity(idcourse, idactivity).done(function(obj) {
        if (!obj) {
            return
        }
        if (false) {
            _showAlert(text_web.seguridad_17);
            return
        }
        if (false) {
            blink.pages.catalog.requestSample(window.idcurso);
            return
        }
        if (!blink.isApp || blink.appVersion >= 4.01) {
            var _mode = (blink.currentPage.name === "TOC" || blink.currentPage.name === "webclass") && obj.type !== "libro" && blink.isApp ? "fullscreen" : "replace";
            if (obj.type === "libro" && blink.isApp && !blink.isOfflinePCApp) {
                blink.rest.openPDF(_mode, obj.url, page)
            } else {
                blink.rest.openUrl(_mode, obj.url)
            }
            return
        }
        eval(obj.onclickTitle)
    })
};

function irClase(g, f, e, b, d, a, c) {
    abrirEnPopup = typeof d !== "undefined" ? d : false;
    if (e != undefined && e != "") {
        idcurso = e
    }
    blink.getActivity(idcurso, g).done(function(i) {
        var j = ((b != undefined && b != "") ? "&IDSec=" + b : "") + ((editar) ? "editar=1&" : "") + ((f != undefined && f != "") ? "&idalumno=" + f : "") + "&popup=1";
        if (i) {
            var h = i.url
        } else {
            var h = "/coursePlayer/clases2.php?idclase=" + g;
            if (typeof a != "undefined" && a == 8) {
                h = "/coursePlayer/librodigital_html.php?idclase=" + g
            }
            if (idcurso) {
                h += "&idcurso=" + idcurso
            }
        }
        if (h.indexOf("redireccionar(") !== -1) {
            splittedUrlClase = h.split("'");
            h = splittedUrlClase[1]
        }
        if (h.indexOf("?") < 0) {
            h += "?"
        }
        h += j;
        if (c && typeof c != "undefined") {
            h += c
        }
        if (blink.isApp && (!blink.isOfflinePCApp && !blink.isIpadApp)) {
            if (!canUseOfflineUrls()) {
                blink.rest.openUrl("viewer", WEBS + h)
            } else {
                blink.rest.openUrl("viewer", offlineServer + "/" + adjustURL(h, false, true))
            }
        } else {
            alto = 620;
            showIFrame(h, blink.theme.iframeWidth, alto, true, !blink.theme.isAdaptative())
        }
    });
    return false
}

function diagIrClase(h, g, f, b, e, a) {
    var c = "";
    if ($("#select_attempt").length > 0) {
        var d = $("#select_attempt").val();
        if (d && d != "") {
            c = "&attempt=" + d
        }
    }
    return irClase(h, g, f, b, e, a, c)
}

function irFichaAlumno(b, c) {
    var a = "/LMS/fichaalumno.php?idalumno=" + b;
    if (c) {
        a += "&" + c
    }
    if (blink.isApp && (blink.user.esProfesor() || blink.user.esPadre())) {
        blink.rest.connection(function(e) {
            if (!e) {
                _showAlert(text_web.tablettxt_require_connection)
            } else {
                var d = !location.href.contains("fichaalumno");
                redireccionar(a, undefined, d, true)
            }
        })
    } else {
        redireccionar(a)
    }
}

function irClaseDesdeNombre(a) {
    urlclase = "/coursePlayer/clases2.php?idcurso=" + idcurso + "&nombreclase=" + a + (idalumno != undefined && idalumno != "" ? "&idalumno=" + idalumno : "");
    if (offline) {
        urlclase = adjustURL(urlclase, false);
        urlclase = top.location.href.substring(0, top.location.href.lastIndexOf("/") + 1) + urlclase
    }
    if (blink.isOfflinePCApp) {
        urlclase += "#layout=fullscreen"
    }
    location = urlclase
}

function irIndiceCurso() {
    top.history.go(-1)
};;
(function(r) {
    var d = "2.0",
        z = false,
        t = ($.browser.msie && parseInt($.browser.version, 10) == "7"),
        i = ($.browser.msie && parseInt($.browser.version, 10) <= 7),
        E = ($.browser.msie && parseInt($.browser.version, 10) <= 8),
        q = ($.browser.msie && parseInt($.browser.version, 10) == "9"),
        n = (navigator.userAgent.indexOf("Trident/") > -1 && parseInt($.browser.version, 10) == "11"),
        s = i;
    var u = false;
    var A = 0;
    var C = "";
    var a = "";
    var e = "";
    var G = navigator.userAgent.toLowerCase();
    if (navigator && G) {
        var H = G.match(/blinklearning ?app[^0-9]*([0-9]+\.*[0-9]+)/i);
        if (H && H.length > 1) {
            var d = parseFloat(H[1]);
            if (d > 0) {
                u = true;
                A = d
            }
        }
    }
    if (!u) {
        if (getQueryParamValue("appBundleVersion") > 0) {
            u = true;
            A = getQueryParamValue("appBundleVersion");
            C = getQueryParamValue("app");
            a = getQueryParamValue("device");
            e = getQueryParamValue("offlinePort");
            if (A < 3.3) {
                setCookie("appBundleVersion", A);
                setCookie("app", C);
                setCookie("device", a);
                setCookie("offlinePort", e)
            }
        } else {
            if (getCookie("appBundleVersion") > 0) {
                u = true;
                A = getCookie("appBundleVersion");
                C = getCookie("app");
                a = getCookie("device");
                e = getCookie("offlinePort")
            } else {
                if (isLocalHost()) {
                    var j = "/rest/version";
                    $.ajax({
                        url: j,
                        dataType: "script",
                        async: false,
                        statusCode: {
                            200: function() {
                                if (typeof(app) == "undefined") {
                                    return
                                }
                                if (app && app.version > 0) {
                                    u = true;
                                    A = app.version;
                                    C = app.name;
                                    a = app.device;
                                    e = app.port;
                                    if (A < 3.3) {
                                        setCookie("appBundleVersion", A);
                                        setCookie("app", C);
                                        setCookie("device", a);
                                        setCookie("offlinePort", e)
                                    }
                                }
                            }
                        }
                    })
                }
            }
        }
    }
    if (!E) {
        E = (document.documentMode && document.documentMode <= 8) ? true : false, r.version = d
    }
    r.isIE7 = t;
    r.isIE7orlower = i;
    r.isIE8orlower = E;
    r.isIE9 = q;
    r.isIE11 = n;
    r.browserNotSupported = s;
    r.isApp = u;
    r.appVersion = parseFloat(A);
    r.appName = C;
    r.appDevice = a;
    r.appPort = e;
    r.isBrowser = !u;
    r.isIpad = C == "ipadapp" || G.contains("ipad");
    r.isIphone = G.contains("iphone");
    r.isAndroid = C == "androidapp" || G.contains("android");
    r.isWinRT = C == "winrt" || a == "winrt";
    var x = ["blinkoffline", "blinkoffline_wallstreet", "blinkoffline_escholarium"];
    r.isOfflinePC = x.indexOf(C) != -1;
    r.isChromebook = a == "chromebook";
    r.isIos = r.isIpad || r.isIphone;
    r.isTablet = r.isIpad || r.isAndroid || r.isWinRT;
    r.hasTouch = (("ontouchstart" in window) || (navigator.MaxTouchPoints > 0) || (navigator.msMaxTouchPoints > 0));
    r.supportsPointerEvents = !($.browser.msie);
    window.hideCanvasElement = !r.supportsPointerEvents;
    r.isAndroidApp = r.isAndroid && r.isApp;
    r.isIpadApp = r.isIpad && r.isApp;
    r.isWinRTApp = r.isWinRT && r.isApp;
    r.isOfflinePCApp = r.isOfflinePC && r.isApp;
    r.isChromebookApp = r.isChromebook && r.isApp;
    r.isTabletApp = r.isAndroidApp || r.isIpadApp || r.isWinRTApp;
    r.isChrome = G.contains("chrome");
    r.isFirefox = G.contains("firefox");
    r.isSafari = G.contains("safari") && !G.contains("chrome");

    function c() {
        if (r.isIos) {
            var B = (navigator.appVersion).match(/OS (\d+)_(\d+)_?(\d+)?/);
            return [parseInt(B[1], 10), parseInt(B[2], 10), parseInt(B[3] || 0, 10)]
        }
    }
    r.isIosGreaterThan = function(B) {
        if (r.isIos) {
            ver = c();
            return ver[0] > B
        }
    };
    r.isAndroidChrome = !r.isApp && G.contains("chrome") && G.contains("android");
    if (r.isAndroidChrome) {
        var d = G.match(/chrome\/([0-9]+)/);
        if (!d || parseInt(d[1]) < 40) {
            r.isAndroidChrome = false
        }
    }
    if (u) {
        var k;
        if (isLocalHost()) {
            k = location.hostname
        } else {
            if (r.isWinRT) {
                k = "localhost"
            } else {
                k = "127.0.0.1"
            }
        }
        offlineServer = "http://" + k + ":" + (e ? e : "8080")
    }

    function g(J) {
        var I = /^(?:([A-Za-z]+):)?(\/{0,3})([0-9.:\-A-Za-z]+)(?::(\d+))?(?:\/([^?#]*))?(?:\?([^#]*))?(?:#(.*))?$/;
        var B = I.exec(J);
        var K = ["url", "scheme", "slash", "host", "port", "path", "query", "hash"];
        return B
    }
    r.contexts = [];
    r.escapeJS = function(B) {
        var I = document.createElement("div");
        I.appendChild(document.createTextNode(B));
        return I.innerHTML
    };
    r.getReqParam = function(B, N, K) {
        var L = g(B);
        paramsstring = L[6] || "";
        var M = paramsstring.split("&");
        for (var I = 0; I < M.length; I++) {
            var J = M[I].split("=");
            if (J.length == 2 && J[0] == N) {
                var O = decodeURIComponent(J[1]);
                return K === true ? this.escapeJS(O) : O
            }
        }
        return ""
    };

    function o(B, I) {
        var J = _.find(B, function(K) {
            return (I.startsWith(K + "="))
        });
        return !!J
    }

    function y(J, K) {
        if (J === "webclass_html_.htm?") {
            return J + K
        }
        ext = "htm";
        var I = ["video", "image", "flash", "doc", "sound", "geogebra"];
        var B = getMediaType(J);
        var L = getExt(J, true);
        if (I.indexOf(B) != -1 || ["html"].contains(L)) {
            return J
        }
        if (J.indexOf(".json") != -1) {
            ext = "json"
        } else {
            if (J.indexOf(".js") != -1) {
                ext = "js"
            } else {
                if (J.indexOf("executeexportexcel") != -1) {
                    ext = "xlsx"
                } else {
                    if (J.indexOf("popup") != -1) {
                        J = J.replace("&popup=1", "")
                    }
                }
            }
        }
        return J.replace(".php", "").replace(/[\.\?=&]/g, "_") + "." + ext + ((K) ? "?" + K : "")
    }
    r.getLocalURL = function(J) {
        var N = g(J);
        if (N[1] != "http" && N[1] != "https") {
            N = g("localhost" + (J.startsWith("/") ? J : "/" + J))
        }
        var Q = N[5].split(/\/+/g),
            I = Q.pop(),
            S = Q.join("/"),
            B = N[6] || "";
        var M = B.split("&"),
            R = M.length;
        query_string = "";
        for (var P = 0; P < R; P++) {
            var K = M[P].toLowerCase(),
                O = false;
            if (K.startsWith("as=") || K.startsWith("modo=") || (I == "curso2.php" && K.startsWith("idtema=")) || ((I == "clases2.php" || I == "curso2.php") && K.startsWith("editar="))) {
                O = true
            }
            if ((I == "clases2.php" || I == "curso2.php" || I.indexOf("scormAPI") != -1) && (K.startsWith("idalumno=") || K.startsWith("popup=") || K.startsWith("numsec="))) {
                O = true;
                query_string += M[P] + "&"
            }
            if (I == "clases2.php" && (K.startsWith("idcurso=") || K.startsWith("idclase="))) {
                query_string += M[P] + "&"
            }
            if (I == "librodigital_html.php") {
                O = !o(["idcurso", "idclase"], K);
                query_string += M[P] + "&"
            }
            if (I == "webclass.html.php" || I == "webclass_html_.htm" || I == "epubviewer.html.php") {
                O = true;
                query_string += M[P] + "&"
            }
            if (I == "clases2.php" && K.startsWith("rtmm=")) {
                O = true;
                query_string += M[P] + "&"
            }
            if (I == "clases2.php" && K.startsWith("rtagi=")) {
                O = true;
                query_string += M[P] + "&"
            }
            if (I.indexOf(".php") != -1 && K.startsWith("_") && K.indexOf("=") != -1) {
                O = true;
                query_string += M[P] + "&"
            }
            if (I == "alumnos.php" && K.startsWith("idgrupo=")) {
                query_string += M[P] + "&"
            }
            if (O) {
                M.splice(P, 1);
                P--;
                R--
            }
        }
        M.sort();
        var L = S + "/" + y(I + "?" + (M.join("&") || ""), query_string);
        return L
    };
    var w = false;
    r.doTick = function(I) {
        var J = $(I);
        v = $(I).attr("nota");
        aprobado = $(I).attr("aprobado") == "true";
        status = 2;
        if (!v) {
            return
        }
        if (v == "-") {
            status = 0
        } else {
            if (v && v.indexOf("*") != -1) {
                status = 1
            }
        }
        if (w) {
            $.data(I, "cache-html", J.html());
            if (status == 0) {
                img = "../images/tick_white.png"
            } else {
                img = "../images/tick_" + ((aprobado) ? "1" : "0") + ((status == 2) ? "end" : "") + ".png"
            }
            J.html('<img src="' + img + '">')
        } else {
            var B = J.data("cache-html");
            J.html(B)
        }
    };
    r.showTicks = function() {
        w = !w;
        conmutarEstadoBoton("boton_ticks", !w);
        $(".td_progreso, .td_progreso_subtema").each(function() {
            r.doTick(this)
        })
    };
    var l = null,
        p = null,
        f = null;

    function m(B) {
        if (!r.isTablet) {
            return B
        }
        var I = B.changedTouches[0];
        return {
            type: "mousedown",
            which: 1,
            pageX: I.pageX,
            pageY: I.pageY,
            screenX: I.screenX,
            screenY: I.screenY,
            clientX: I.clientX,
            clientY: I.clientY
        }
    }

    function b(K) {
        var B = $(K.target),
            J = B.closest(".draggable");

        function I() {
            J.css("opacity", "1");
            l = null
        }
        if (!J.size()) {
            return
        }
        if (p) {
            I();
            clearTimeout(p)
        }
        p = setTimeout(I, 1500);
        J.css("opacity", "0.50");
        f = r.makeMouseEvent(K);
        l = J.get(0)
    }

    function D(L) {
        if (!l) {
            return
        }
        var J = m(L),
            B = $(l),
            K = B.position();
        _onStartDragDraggable(l, J);
        var I = J.pageX - f.pageX + K.left,
            M = J.pageY - f.pageY + K.top;
        B.animate({
            left: I,
            top: M
        }, "fast", function() {
            _onEndDragDraggable(this, J)
        });
        l = null
    }
    r.initPC = function() {};
    r.initAndroid = function() {
        document.addEventListener("touchstart", function(J) {
            return true;
            if (l) {
                var K = J.changedTouches[0],
                    I = {
                        type: "mousedown",
                        which: 1,
                        pageX: K.pageX,
                        pageY: K.pageY,
                        screenX: K.screenX,
                        screenY: K.screenY,
                        clientX: K.clientX,
                        clientY: K.clientY
                    };
                _onStartDragDraggable(l, I);
                _onEndDragDraggable(l, I);
                var B = $(l);
                B.css("position", "absolute").animate({
                    left: I.pageX,
                    top: I.pageY
                }, "fast");
                l = null
            }
            J.stopPropagation();
            return false
        });
        document.addEventListener("touchmove", function(B) {
            return true;
            B.preventDefault();
            return false
        })
    };
    r.loadObject = function(I, L) {
        var B = "obj_" + I + L;

        function K() {
            if (I == "group") {
                var O = 20;
                var N = 50;
                var S = 50;
                var R = 400;

                function Q() {
                    return (Math.random() * 2 - 1) + (Math.random() * 2 - 1) + (Math.random() * 2 - 1)
                }

                function M(W, X) {
                    return Math.round(Q() * X + W)
                }
                var P, V = document.getElementsByTagName("head")[0].style,
                    U = "transformProperty WebkitTransform OTransform msTransform MozTransform".split(" ");
                for (var T = 0; T < U.length; T++) {
                    if (V[U[T]] !== undefined) {
                        P = U[T]
                    }
                }
                $("#" + B).find("img").css("border", "5px solid #eeeeee").css("position", "absolute").offset({
                    left: 0,
                    top: 0
                }).css("border-radius", "8px").each(function(W) {
                    var X = Math.floor((Math.random() - 0.5) * S);
                    deg2 = (W - 10) * 1;
                    $(this).offset({
                        left: N + M(0, O),
                        top: N + M(0, O)
                    }).css("zIndex", R + Math.floor(Math.random() * 10));
                    $(this).get(0).style[P] = "rotate(" + X + "deg)"
                })
            }
        }
        var J = $('<div class="obj" id="' + B + '"></div>').load("/obj/getHTML.php?t=" + I + "&id=" + L, K).appendTo(document.body).blinkDraggable().show();
        return J
    };
    r.viewClass = function(M, I, L, B, J) {
        var K = false;
        getAJAX("/LMS/ajax.php?op=checkIncompatibleDevice&idcontent=" + M + "&content_type=Clase", function(N) {
            if (!N.startsWith("OK")) {
                msgIncompatibleDevice();
                K = true
            }
        }, false, undefined, undefined, true);
        if (K) {
            return
        }
        if (B == "1") {
            if (blink.isApp && J == "1") {
                blink.rest.openUrl("fullscreen", I);
                return
            }
            redireccionar(I, undefined, undefined, J)
        } else {
            if (blink.isOfflinePC) {
                redireccionar(I + ((I.indexOf("?") == -1) ? "?" : "&") + "popup=1" + ((typeof(L) != undefined && L == 1) ? "&previa=1" : ""), undefined, true, J)
            } else {
                if (blink.isApp) {
                    blink.rest.openUrl("fullscreen", I)
                } else {
                    ventana = window.open(I + ((I.indexOf("?") == -1) ? "?" : "&") + "popup=1" + ((typeof(L) != undefined && L == 1) ? "&previa=1" : ""), "actividad", "menubar=0,resizable=1,scrollbars=1,width=1040,height=730,top=0,left=0");
                    ventana.focus()
                }
            }
        }
        getAJAX("/LMS/ajax.php?op=countclassview&idclase=" + M, nullAJAXFunc)
    };
    r.editClass = function(I, B) {
        location.href = B;
        getAJAX("/LMS/ajax.php?op=countclassview&idclase=" + I, nullAJAXFunc)
    };
    r.getAutocompleteItem = function(K, J, I, B) {
        if (!B) {
            B = 50
        }
        var L = "";
        if (!I) {
            if (K) {
                L = '<img src="' + K + '" style="width:20px;margin:0 10px 0 0;">'
            }
            return "<a>" + L + "<span>" + limitarString(J, B) + "</span></a>"
        }
        if (!K) {
            return '<a style="height:40px;"><b>' + limitarString(J, B) + '</b><br><span style="color:#999999;">' + limitarString(I, B) + "</span></a>"
        }
        if (K) {
            L = '<img src="' + K + '" style="float:left;margin-right:10px;max-width:40px; max-height:40px;">'
        }
        return '<a style="height:40px;">' + L + "<span><b>" + limitarString(J, B - 5) + "</b><br>" + limitarString(I, B - 5) + "</span></a>"
    };
    jQuery.fn.adjustTextarea = function() {
        return this.each(function() {
            $(this).css("overflow-y", "hidden").keyup(function() {
                var J = $(this),
                    B = J.attr("scrollHeight");
                if (B > J.height()) {
                    var I = J.css("line-height");
                    J.height(B + (isNaN(I) ? parseInt(J.css("font-size")) : I))
                }
            })
        })
    };
    jQuery.fn.blinkGesture = function(B) {
        return this.each(function(I) {
            if (!r.hasTouch) {
                return
            }
            this.ongesturestart = function(J) {};
            this.ongesturechange = function(J) {
                J.preventDefault();
                this.style.webkitTransition = "";
                var K = Math.max(1 + (J.scale - 1) * 2, 0.3);
                this.style.webkitTransform = "scale(" + K + ") rotate(" + J.rotation + "deg)"
            };
            this.ongestureend = function(K) {
                var L = Math.max(1 + (K.scale - 1) * 2, 0),
                    J = true;
                if (L < 0.8) {
                    if (B.callback) {
                        J = B.callback()
                    }
                }
                if (J) {
                    this.style.webkitTransition = "-webkit-transform 0.3s";
                    this.style.webkitTransform = "scale(" + 1 + ") rotate(" + 0 + "deg)"
                }
            }
        })
    };
    jQuery.fn.blinkDraggable = function(B) {
        var I = $("[id^=blinkdraggable]").size();
        return this.each(function(K) {
            if (this.id == undefined || this.id == "") {
                this.id = "blinkdraggable" + (K + I)
            }
            if (r.hasTouch && $.fn.touch) {
                $(this).touch({
                    animate: false,
                    sticky: false,
                    dragx: true,
                    dragy: true,
                    rotate: true,
                    resort: false,
                    scale: false
                })
            }
            var J = {
                revert: function() {
                    _onEndDragDraggable(this);
                    return $(this).hasClass("draggablereturnorigin")
                },
                start: function(M, L) {
                    _onStartDragDraggable(this)
                },
                drag: function(L) {
                    _onDragDraggable(this)
                },
                stop: function(M, L) {
                    _onStopDragDraggable(this);
                    blink.events.trigger("onStopDragDraggable")
                },
                containment: "document",
                scroll: true
            };
            $(this).draggable($.extend(J, B)).mousedown(function(L) {
                _savePosition(this);
                L.stopPropagation()
            }).css("cursor", "pointer")
        })
    };
    r.setDigitalWhiteboardMode = function(B) {
        if (B) {
            h = $(window).height() - 38 - 88;
            $("html").css("overflow", "hidden");
            $(document.body).css("overflow", "hidden").children().not("#menubar, script, #cabecera").prependTo(document.body).wrapAll('<div id="digital_whiteboard" style="width:100%;float:left;height:' + h + 'px;overflow:auto;" class="digital_whiteboard"></div>');
            $(window).resize(function() {
                $("#digital_whiteboard").height($(window).height() - $("#menubar").height())
            });
            $(window).resize()
        }
    };
    r.currentPage = {
        name: "notset",
        setName: function(B) {
            this.name = B
        }
    };
    r.currentPage.reloadPage = function() {
        window.location.href = window.location.href
    };
    r.currentPage.getButtons = function() {
        return "[]"
    };
    r.currentPage.refresh = function() {};
    r.currentPage.setContexts = function() {
        if (blink.contexts) {
            blink.rest.setContexts(blink.contexts)
        }
    };
    r.currentPage.setButtons = function() {
        if (blink.buttons) {
            blink.rest.setButtons(blink.buttons)
        }
    };
    r.currentPage.enterEditMode = function() {
        location = blink.Url(location.href).setParam("editar", 1).getUrl()
    };
    r.currentPage.enterViewMode = function() {
        location = blink.Url(location.href).setParam("editar", 0).getUrl()
    };
    blink.currentPage.setInfoLibroHeight = function() {};
    r.pages = {};
    r.pages.messages = {
        closeThread: function(B) {
            getAJAX("/LMS/ajax.php?op=closemessagethread&idmsg=" + B, function(I) {
                if (I.startsWith("OK")) {
                    blink.theme.ocultarHilo(B)
                } else {
                    _showAlert(text_web.error_general_AJAX)
                }
            })
        }
    };
    r.modules = {};
    r.defined = function(B) {
        return typeof(B) != "undefined"
    };
    r.log = {
        level: 2,
        debug: function(B) {
            if (this.level >= 2) {
                console.debug(B)
            }
        },
        info: function(B) {
            if (this.level >= 3) {
                console.info(B)
            }
        },
        warning: function(B) {
            if (this.level >= 1) {
                console.warn(B)
            }
        },
        error: function(I, B) {
            if (this.level >= 0) {
                console.error(I);
                if (B && B.message) {
                    console.error(B.message)
                }
                if (B && B.stack) {
                    console.error(B.stack)
                } else {
                    if (I.stack) {
                        console.error(I.stack)
                    } else {
                        console.trace()
                    }
                }
            }
        }
    };
    if (!window.console || !console.error || !console.warn || !console.info || !console.debug || !console.trace) {
        r.log.level = -1
    }
    r.events = {
        list: {},
        trigger: function() {
            var I, L = false,
                B = 1;
            if (typeof arguments[0] === "boolean") {
                L = arguments[0];
                I = arguments[1];
                B = 2
            } else {
                I = arguments[0]
            }
            if (!this.list[I]) {
                if (!L) {
                    return
                }
                this.list[I] = {
                    callbacks: []
                }
            }
            this.list[I].unique = L;
            var K = [];
            for (var J = B; J < arguments.length; J++) {
                K.push(arguments[J])
            }
            for (var J = 0; J < this.list[I].callbacks.length; J++) {
                this._run(this.list[I].callbacks[J], K);
                if (this.list[I].callbacks[J].once) {
                    this.list[I].callbacks.splice(J, 1);
                    J--
                }
            }
            if (this.list[I].unique) {
                this.list[I].callbacks = [];
                this.list[I].params = K
            }
        },
        _run: function(I, K) {
            var J, B;
            J = I.func;
            B = I.context;
            if (B === undefined) {
                B = J
            }
            setTimeout(function() {
                J.apply(J, K)
            }, 0)
        },
        on: function(B, J, I) {
            this._register(B, J, I, false)
        },
        once: function(B, J, I) {
            this._register(B, J, I, true)
        },
        _register: function(B, M, K, L) {
            var N = B.split(" ");
            if (N.length > 1) {
                for (var J = 0; J < N.length; J++) {
                    this._register(N[J], M, K, L)
                }
                return
            }
            var I = {
                func: M,
                context: K,
                once: L
            };
            if (!this.list[B]) {
                this.list[B] = {
                    callbacks: [I]
                }
            } else {
                if (this.list[B].unique) {
                    this._run(I, this.list[B].params)
                } else {
                    this.list[B].callbacks.push(I)
                }
            }
        },
        off: function(B, J) {
            if (J === undefined) {
                this.list[B] = []
            } else {
                if (this.list[B]) {
                    for (var I = 0; I < this.list[B].length; I++) {
                        if (this.list[B][I].func === J) {
                            this.list[B].splice(I, 1)
                        }
                    }
                }
            }
        }
    };
    var F = function(B) {
        return B + ":" + window.RELEASE_UID
    };
    r.sessionStorage = {
        isAvailable: function() {
            return typeof(sessionStorage) !== "undefined"
        },
        set: function(B, I) {
            if (!this.isAvailable()) {
                return
            }
            sessionStorage.setItem(F(B), json_encode(I))
        },
        get: function(B) {
            if (!this.isAvailable()) {
                return
            }
            return json_decode(sessionStorage.getItem(F(B)))
        }
    };
    r.localStorage = {
        isAvailable: function() {
            var I = "test";
            try {
                localStorage.setItem(I, I);
                localStorage.removeItem(I);
                return true
            } catch (B) {
                return false
            }
        },
        set: function(B, I) {
            if (!this.isAvailable()) {
                return
            }
            localStorage.setItem(B, json_encode(I))
        },
        get: function(B) {
            if (!this.isAvailable()) {
                return
            }
            return json_decode(localStorage.getItem(B))
        },
        remove: function(B) {
            if (!this.isAvailable()) {
                return
            }
            localStorage.removeItem(B)
        }
    };
    r.domain = {
        getDownloadingText: function(B, I) {
            return B + " " + I + "%"
        },
        doLoginError: function() {
            _showAlert(text_web.login_campos_vacios);
            return false
        },
        writeScriptOffline: function(B, I, O, Q, S, K, J, L, R) {
            var N = "",
                M = new Date(),
                P = $.datepicker.formatDate("dd-mm-yy", M);
            N = "actividades[" + idclase + "] = {'idtema':'" + idtema + "','tipo':'" + evaltype + "','estado':" + B + ",'avance':'" + I + "','nota':'" + O + "','clasificacion':'" + Q + "','fecha':'" + P + "','tiempo':'" + S;
            _.each(K, function(U, T) {
                N += "', 'clasificacion_eje" + (T) + "':'" + K[T]
            });
            N += "'" + J + ",'fecha_modificacion':'" + P + "'};";
            return N
        }
    }
})(blink);;
(function(b) {
    b.activity = b.activity || {};
    var a = b.activity;
    a.state = {
        ONLINE: 1,
        REVISION: 3
    };
    a.type = {
        WEB: 7
    };
    a.getFirstSlideIndex = function() {
        return window.secuencia[window.activeSlide]
    }
})(blink);;
(function(b) {
    var a = {
        hashs: [],
        getHash: function(c, d) {
            return sha1(c + JSON.stringify(d))
        },
        getNum: function() {
            return this.hashs.length
        },
        register: function(c) {
            this.hashs[c] = 1
        },
        unregister: function(c) {
            delete this.hashs[c]
        },
        exists: function(c) {
            return this.hashs[c] !== undefined
        }
    };
    b.isAJAXInProgress = function() {
        return a.getNum() > 0
    };
    b.ajax = function(e, j, h, d) {
        if (!h) {
            h = {}
        }
        if (h.success || h.error || h.complete || h.statusCode) {
            blink.log.error("Sólo se puede obtener respuesta ajax a través del parámetro callback");
            return
        }
        if (j === undefined) {
            j = standardAJAX
        }
        var g = {
            form: null,
            responseContainer: null,
            waitingElement: "#waitingImage",
            animation: false,
            changeCursor: false,
            urlMode: "auto"
        };
        d = $.extend(g, d || {});
        var f = {
            type: "POST",
            async: true
        };
        h = $.extend(f, h || {});
        if (d.responseContainer && !$(d.responseContainer).attr("id")) {
            blink.log.error("Por el momento, responseContainer necesita un id como atributo");
            return
        }
        if (OFFLINE_ENGINE && d.urlMode != "noDijest") {
            if (offline && d.urlMode != "canOffline" && (e.contains("ajax.php") || e.contains("msgbox.php"))) {
                e = adjustOnlineURL(e)
            } else {
                e = adjustURL(e, false)
            }
        }
        e = addAppParams(e);
        h.url = e;
        if (!blink.isApp) {
            var c = typeof(anti_csrf_token) === "undefined" ? "" : anti_csrf_token;
            h.headers = $.extend(h.headers, {
                anti_csrf_token: c
            })
        }
        if (isOutsideURL(e)) {
            h.crossDomain = true;
            if (!h.async) {
                blink.log.error("Imposible hacer llamada síncrona a host externo " + e)
            }
        }
        if (d.form) {
            if (h.data) {
                blink.log.error("No se puede realizar petición ajax con formularios y datos");
                return
            }
            h.data = $(d.form).serialize()
        }
        if (window.onBeforeUnloadCalled && h.async) {
            blink.log.warning("Realizando llamada ajax asíncrona antes de cerrar pestaña")
        }
        var i = a.getHash(h.url, h.data);
        if (a.exists(i)) {
            blink.log.warning("Llamada AJAX '" + h.url + "' en progreso. Abortar");
            return
        }
        a.register(i);
        blink.events.trigger("ajax:begin", h, d);
        if (d.changeCursor) {
            document.body.style.cursor = "wait"
        }
        if (d.waitingElement) {
            blink.theme.setWaitingAjax(d.waitingElement)
        }
        if (d.responseContainer) {
            blink.theme.setWaitingAjax(d.responseContainer)
        }
        $("#msgdiv").html("");
        resetPingTimer();
        return $.ajax($.extend(h, {
            success: function(l, m, k) {
                if (d.responseContainer) {
                    setAndExecute($(d.responseContainer).attr("id"), l)
                }
                if (j) {
                    d.sendAllCallbackParams ? j(l, {
                        jqXHR: k,
                        textStatus: m
                    }) : j(l)
                }
                blink.events.trigger("ajax:success", h, d, l)
            },
            error: function(k, m, l) {
                if (j) {
                    d.sendAllCallbackParams ? j("ERROR", {
                        jqXHR: k,
                        textStatus: m
                    }) : j("ERROR")
                }
                blink.events.trigger("ajax:error", h, d)
            },
            complete: function(k, l) {
                a.unregister(i);
                if (d.changeCursor) {
                    document.body.style.cursor = "default"
                }
                if (d.waitingElement) {
                    blink.theme.clearWaitingAjax(d.waitingElement)
                }
                blink.events.trigger("ajax:complete", h, d)
            }
        }))
    };
    b.getJSON = function(d, f, e, c) {
        if (!e) {
            e = {}
        }
        e.dataType = "json";
        return blink.ajax(d, function(g) {
            if (g == "ERROR") {
                c && c.onError && c.onError()
            } else {
                if (typeof(g) == "string") {
                    f(JSON.parse(g))
                } else {
                    f(g)
                }
            }
        }, e, c)
    };
    b.getScript = function(d, f, c) {
        var e = {
            async: false
        };
        f = $.extend(e, f || {});
        f.dataType = "script";
        return blink.ajax(d, null, f, c)
    }
})(blink);

function getAJAX(a, d, c, h, f, i) {
    (jQuery.type(c) === "string") && (c = "#" + c);
    var g = h ? "#" + h : null;
    var b = f == "cursor";
    var e = {
        form: c,
        responseContainer: g,
        changeCursor: b
    };
    if (!b && f) {
        e.waitingElement = "#" + f
    }
    blink.ajax(a, d, {
        async: !i
    }, e)
}

function nullAJAXFunc() {}

function standardAJAX(a) {
    standardAJAXFunc(a, false)
}

function standardAJAXPopup(a) {
    standardAJAXFunc(a, true)
}

function standardAJAXFunc(msg, msgbox) {
    if (msg == "RELOAD") {
        if (msgbox) {
            closeMsgBox()
        }
        location.reload();
        return
    }
    if (msg.startsWith("GO")) {
        if (msgbox) {
            closeMsgBox()
        }
        redireccionar(msg.substr(3));
        return
    }
    if (msg == "OK") {
        if (msgbox) {
            closeMsgBox()
        }
        return
    }
    if (msg.startsWith("OK")) {
        var okmsg = msg.substring(2);
        showOKOrErrorMsg("OK", okmsg);
        return
    }
    if (msg.startsWith("ERROR")) {
        errormsg = msg.substring(5);
        if (errormsg == "") {
            blink.rest.connection(function(connected) {
                if (connected == 0) {
                    errormsg = text_web.tablettxt_require_connection
                } else {
                    errormsg = text_web.error_general_AJAX
                }
                showOKOrErrorMsg(msg, errormsg)
            })
        } else {
            showOKOrErrorMsg(msg, errormsg)
        }
    }
    if (msg.startsWith("WARNING")) {
        errormsg = msg.substring(7);
        if (errormsg == "") {
            errormsg = text_web.warning_general_AJAX
        }
        showWarningMsg(msg, errormsg)
    }
    if (msg.startsWith("JSCRIPT")) {
        jscript = msg.substring(7);
        eval(jscript)
    }
}

function loadScript(a, c, k, g, h, d, i) {
    _crossDomain = (i != undefined) ? i : false;
    _url = a;
    _finished = false;
    if (d == undefined) {
        d = "script"
    }
    if (modoVisualizacionLabel == "drm") {
        if (OFFLINE_ENGINE) {
            h = false;
            _url = "/localdata/include/" + adjustURL(a)
        } else {
            _crossDomain = true;
            _url = WEBS + _url + "&modo=4&IDSESSIONDIRECT=" + userToken + "&bd=" + BLINKDOMAIN + "&device=" + userDevice
        }
    }
    if (modoVisualizacionLabel != "standalone" && modoVisualizacionLabel != "embed") {
        try {
            _asyncSCORM = (c) ? _crossDomain : false;
            if (c && g) {
                showMask("white")
            }

            function j(e) {
                if (c && g) {
                    hideMask()
                }
                _finished = true;
                if (k) {
                    k(e)
                }
            }
            var b = $.ajax({
                url: _url,
                dataType: d,
                async: _asyncSCORM,
                crossDomain: _crossDomain
            }).done(function(e) {
                j(e)
            }).fail(function(e, m, l) {
                j(e)
            });
            if (_asyncSCORM) {
                setTimeout(function() {
                    if (b) {
                        b.abort()
                    }
                    if (_asyncSCORM && g) {
                        hideMask()
                    }
                    if (!_finished) {
                        if (h) {
                            _showAlert(text_web.error_loading_scorm_1)
                        }
                        connected = false
                    }
                }, 6000)
            }
        } catch (f) {
            blink.log.error("loadScript: ", f)
        }
    }
}

function loadPageWithAJAX(a) {
    a = addAppParams(a);
    $(document.body).load(a)
}

function setAndExecute(divID, innerHTML) {
    resetPingTimer();
    var div = document.getElementById(divID);
    if (div) {
        div.innerHTML = innerHTML;
        var x = div.getElementsByTagName("script");
        for (var i = 0; i < x.length; i++) {
            eval(x[i].text)
        }
    }
};;
(function(B) {
    B.pages.catalog = {};
    var C = B.pages.catalog;
    C.requestSample = function(idcourse) {
        showMsgBox("", "/LMS/msgbox.php?op=requestsample&idcourse=" + idcourse, "560")
    };
    var scriptURI, searchURL, page, mode = 0,
        panel = null,
        universe = 1,
        order = 1,
        f_group1 = 0,
        f_group2 = 0,
        f_group3 = 0,
        f_group4 = 0,
        grpby, onlynew;
    C.setInitParams = function(_scriptURI, _page, _searchURL, _mode, _panel, _universe, _order, _f_group1, _f_group2, _f_group3, _f_group4, _grpby, _onlynew) {
        if (_order == undefined) {
            _order = ""
        }
        if (_f_group1 == undefined || _f_group1 == "undefined") {
            _f_group1 = ""
        }
        if (_f_group2 == undefined || _f_group2 == "undefined") {
            _f_group2 = ""
        }
        if (_f_group3 == undefined || _f_group3 == "undefined") {
            _f_group3 = ""
        }
        if (_f_group4 == undefined || _f_group4 == "undefined") {
            _f_group4 = ""
        }
        if (_grpby == undefined || _grpby == "undefined") {
            _grpby = ""
        }
        if (_onlynew == undefined || _onlynew == "undefinded") {
            _onlynew = ""
        }
        scriptURI = _scriptURI + "?";
        searchURL = _searchURL;
        page = _page;
        mode = _mode;
        panel = _panel;
        universe = _universe;
        order = _order;
        f_group1 = _f_group1;
        f_group2 = _f_group2;
        f_group3 = _f_group3;
        f_group4 = _f_group4;
        grpby = _grpby;
        onlynew = _onlynew
    };
    C.loadPage = function(pagenum) {
        for (i = 0; i <= pagenum; i++) {
            if ($("#page" + i).size() == 0) {
                $('<div id="page' + i + '" class="cursos_small_icon"></div>').insertAfter($("#page" + (i - 1))).load(scriptURI + searchURL + "&icons=1&s=" + i + "&m=" + mode + "&u=" + universe)
            }
        }
        $("#catalog_pages").width($("#catalog_pages").children().size() * panel.pageStep + 100)
    };
    C.gotoPage = function(pagenum) {
        if (panel) {
            panel.gotoPage(pagenum)
        } else {
            redireccionar(scriptURI + searchURL + "&s=" + pagenum + "&m=" + mode + "&u=" + universe + "&o=" + order + "&fg1=" + f_group1 + "&fg2=" + f_group2 + "&fg3=" + f_group3 + "&fg4=" + f_group4 + "&onlynew=" + onlynew)
        }
    };
    C.getPage = function() {
        if (panel) {
            return panel.activePage
        } else {
            return page
        }
    };
    C.prevPage = function(pagenum) {
        C.gotoPage(C.getPage() - 1)
    };
    C.nextPage = function(pagenum) {
        C.gotoPage(C.getPage() + 1)
    };
    C.changeMode = function(mode) {
        redireccionar(scriptURI + searchURL + "&s=0&m=" + mode + "&u=" + universe + "&o=" + order + "&fg1=" + f_group1 + "&fg2=" + f_group2 + "&fg3=" + f_group3 + "&fg4=" + f_group4 + "&grp=" + grpby + "&onlynew=" + onlynew)
    };
    C.changeUniverse = function(universe, onlynew) {
        var url = scriptURI + searchURL + "&resetbusqueda=1&s=0&m=" + mode + "&u=" + universe + "&o=" + order;
        if (onlynew != undefined) {
            url += "&onlynew=1"
        }
        redireccionar(url)
    };
    C.changeOrder = function(order) {
        redireccionar(scriptURI + searchURL + "&s=0&m=" + mode + "&u=" + universe + "&o=" + order + "&fg1=" + f_group1 + "&fg2=" + f_group2 + "&fg3=" + f_group3 + "&fg4=" + f_group4 + "&grp=" + grpby + "&onlynew=" + onlynew)
    };
    C.changeGroupBy = function(grpby) {
        var current_fgvalue = blink.getReqParam(location.href, "fg" + grpby);
        var current_grp = parseInt(blink.getReqParam(location.href, "grp"));
        var groupdata = "&grp=" + grpby;
        if (current_grp == grpby) {
            groupdata = ""
        }
        if (current_fgvalue != "") {
            eval("f_group" + grpby + "='';")
        }
        redireccionar(scriptURI + searchURL + "&s=0&m=" + mode + "&u=" + universe + "&o=" + order + "&fg1=" + f_group1 + "&fg2=" + f_group2 + "&fg3=" + f_group3 + "&fg4=" + f_group4 + groupdata + "&onlynew=" + onlynew)
    };
    C.changeGroupFilter = function(f_group, f_value) {
        if (f_group == 1) {
            params_group = "&fg1=" + f_value + "&fg2=" + f_group2 + "&fg3=" + f_group3 + "&fg4=" + f_group4
        } else {
            if (f_group == 2) {
                params_group = "&fg1=" + f_group1 + "&fg2=" + f_value + "&fg3=" + f_group3 + "&fg4=" + f_group4
            } else {
                if (f_group == 3) {
                    params_group = "&fg1=" + f_group1 + "&fg2=" + f_group2 + "&fg3=" + f_value + "&fg4=" + f_group4
                } else {
                    if (f_group == 4) {
                        params_group = "&fg1=" + f_group1 + "&fg2=" + f_group2 + "&fg3=" + f_group3 + "&fg4=" + f_value
                    }
                }
            }
        }
        redireccionar(scriptURI + searchURL + "&s=0&m=" + mode + "&u=" + universe + "&o=" + order + params_group + "&onlynew=" + onlynew)
    };
    C.changeOnlyNew = function(checked) {
        var url = scriptURI + searchURL + "&s=0&m=" + mode + "&u=" + universe + "&o=" + order + f_group1 + "&fg2=" + f_group2 + "&fg3=" + f_group3 + "&fg4=" + f_group4 + (checked ? "&onlynew=1" : "");
        redireccionar(url)
    }
})(blink);;
(function(b) {
    b.modules.contact = {};
    var a = b.modules.contact;
    a.sendContactForm = function(e, c) {
        if (!verificarSelect(["device"])) {
            return false
        }
        if (!verificarVacios(["name", "email", "country", "center", "locale"])) {
            return false
        }
        if ($("#type").val() == "1" || $("#type").val() == "6") {
            if (!verificarVacios(["telefono"])) {
                return false
            }
        }
        if (!verificarEmail(["email"])) {
            return false
        }
        if ($("#acepto").size() > 0 && e.aceptocondiciones.checked == false) {
            _showAlert(text_web.registro_42);
            e.aceptocondiciones.focus();
            return false
        }
        var d = "/LMS/ajax.php?op=contacto";
        getAJAX(d, function(f) {
            if (f.startsWith("OK")) {
                _showAlert(f.substring(2));
                if (c) {
                    redireccionar(c)
                }
                if (!c) {
                    closeMsgBox()
                }
            } else {
                _showAlert("Error")
            }
        }, e);
        return true
    }
})(blink);;
(function(b) {
    b.pages.courseIndex = {};
    var a = b.pages.courseIndex;
    a.loadSeguimientoCurso = function(c, e) {
        e = e || "";
        b.trackCourse = {};
        b.trackCourse.gradoavancecurso = 0;
        b.trackCourse.gradoavancetemas = new Array();
        b.trackCourse.gradoavancetransparencias = new Array();
        b.trackCourse.gradotipotransparencias = new Array();
        b.trackCourse.gradoavanceintentos = new Array();
        b.trackCourse.numacttem = new Array();
        b.trackCourse.lastact = 0;
        b.trackCourse.lastchange = 0;
        var d = "/include/javascript/seguimientoCurso.js.php?idcurso=" + c;
        if (e != "") {
            d += "&idalumno=" + e
        }
        loadScript(d, true, function() {
            if (actividades) {
                var h = $(".td_actividad").size();
                var j = 0;
                for (id_clase in actividades) {
                    if (parseInt(id_clase) > 0) {
                        if (actividades[id_clase] != null) {
                            reg = actividades[id_clase]
                        } else {
                            reg = {
                                estado: -1,
                                nota: 0
                            }
                        }
                        if (reg.estado_transparencias) {
                            b.trackCourse.gradoavancetransparencias[id_clase] = reg.estado_transparencias
                        }
                        var i = 0;
                        if (b.trackCourse.gradoavancetransparencias[id_clase] && b.trackCourse.gradoavancetransparencias[id_clase].length) {
                            i = b.trackCourse.gradoavancetransparencias[id_clase].split("1").length - 1;
                            b.trackCourse.gradoavancetransparencias[id_clase] = b.trackCourse.gradoavancetransparencias[id_clase].split(",")
                        }
                        b.trackCourse.gradotipotransparencias[id_clase] = (reg.tipo_transparencias && reg.tipo_transparencias.length) ? reg.tipo_transparencias.split(",") : [];
                        b.trackCourse.gradoavanceintentos[id_clase] = (reg.intentos && reg.intentos.length) ? reg.intentos.split(",") : reg.intentos;
                        indiceCursoRellenarNota(id_clase, reg.estado, reg.nota, window.maxClasificacion || 10);
                        addavance = 0;
                        if (reg.estado == 0 && i > 0) {
                            addavance += 0.5
                        }
                        if (reg.estado == 1 || reg.estado == 2) {
                            addavance += 1
                        }
                        if (reg.estado > 0) {
                            j += 1
                        }
                        if (reg.idtema) {
                            g = reg.idtema;
                            valtem = 0;
                            if (b.trackCourse.gradoavancetemas[g] !== undefined) {
                                valtem = b.trackCourse.gradoavancetemas[g]
                            }
                            valtem += addavance;
                            b.trackCourse.gradoavancetemas[g] = valtem;
                            if (b.trackCourse.numacttem[g] === undefined) {
                                b.trackCourse.numacttem[g] = 0
                            }
                            b.trackCourse.numacttem[g] += 1
                        }
                        if (blink.theme.isAdaptative() && blink.user.esAlumno() && reg.fecha_modificacion) {
                            if (!b.trackCourse.lastact || moment(b.trackCourse.lastchange, "YYYY-MM-DD HH:mm:dd").isBefore(moment(reg.fecha_modificacion, "YYYY-MM-DD HH:mm:dd"))) {
                                b.trackCourse.lastact = id_clase;
                                b.trackCourse.lastchange = reg.fecha_modificacion
                            }
                        }
                    }
                }
            }
            if (window.ntotacts == undefined) {
                var f = $(".reviewsection .td_actividad").size();
                ntotacts = h - f
            }
            b.trackCourse.gradoavancecurso = 100 * (j / ntotacts);
            for (var g in b.trackCourse.gradoavancetemas) {
                if (parseInt(g) == g) {
                    if (b.trackCourse.gradoavancetemas[g] == b.trackCourse.numacttem[g]) {
                        matchFilter("", "idtemaprev:" + g, false)
                    }
                    if (window.temasnact && temasnact[g] != undefined) {
                        b.trackCourse.numacttem[g] = temasnact[g]
                    }
                    b.trackCourse.gradoavancetemas[g] = 100 * (b.trackCourse.gradoavancetemas[g] / b.trackCourse.numacttem[g])
                }
            }
            b.events.trigger("loadSeguimientoCurso")
        }, false, false)
    }
})(blink);;
(function(b) {
    b.messages = b.messages || {};
    b.messages.poll = {};
    var a = b.messages.poll;
    a.vote = function(d) {
        var c = $(d),
            f = c.data("poll-id"),
            e = c.data("option");
        getAJAX("/LMS/ajax.php?op=messagepoll_vote&pollid=" + f + "&vote=" + e, function(g) {
            if (g.startsWith("OK")) {
                c.closest(".js-message-wrapper").replaceWith(g.substring(2))
            } else {
                standardAJAXFunc(g)
            }
        }, false)
    };
    a.reply = function(f, e) {
        f.preventDefault();
        var h = $(e),
            c = h.closest(".js-reply-wrapper"),
            d = h.closest(".js-message").find(".reply-wrapper"),
            g = d.find("textarea");
        c.hide();
        d.slideDown();
        g.focus();
        var i = d.offset().top;
        mainNavOpen && (i -= 100);
        $("html, body").animate({
            scrollTop: i
        }, 400)
    };
    a.openReplies = function(e, d) {
        e.preventDefault();
        var c = $(d);
        currentContent = c.html(), nextContent = c.data("alt-text"), showed = c.data("showed"), replies = c.closest(".js-message").find(".js-message-wrapper"), hiddenDerivedList = $(".listado_derivados.hidden");
        c.data("alt-text", currentContent).html(nextContent);
        if (hiddenDerivedList) {
            var f = hiddenDerivedList.find(".js-message-wrapper");
            f.hide();
            hiddenDerivedList.removeClass("hidden");
            f.slideUp("slow")
        }
        if (showed) {
            replies.slideDown("slow")
        } else {
            replies.slideUp("slow")
        }
        c.data("showed", !showed)
    }
})(blink);;
(function(c) {
    var m = "/rest/";
    var f = 2.8;
    var h = false;
    var g = [];
    $(document).ready(function() {
        h = true;
        for (var n = 0; n < g.length; n++) {
            g[n].call(window)
        }
    });
    var k = {
        location: function(p, o) {
            if (typeof(o) == "undefined") {
                o = {}
            }
            var n = i(p, o);
            if (blink.isWinRTApp && blink.appVersion < 2.9) {
                window.external.notify(n)
            } else {
                goToHref(n)
            }
        },
        form: function(s, q) {
            var p = l(s);
            var r = $("#rest_form_aux");
            if (!r.size()) {
                r = $("<form />").attr("method", "post").attr("id", "rest_form_aux").css({
                    width: 0,
                    height: 0,
                    position: "absolute"
                });
                $("body").append(r)
            }
            r.html("").attr("action", p);
            for (var o in q) {
                var n = $("<input />").attr("type", "hidden").attr("name", o).val(q[o]);
                r.append(n)
            }
            r.submit()
        },
        ajax: function(t, o, r) {
            var n = d(t);
            o = o ? a(o) : [];
            var p = $.extend({}, {
                url: n,
                data: o,
                dataType: "json",
                crossDomain: true,
                error: function(u, w, v) {
                    blink.log.error("Error al ejecutar API Rest por ajax " + t + ": " + v + " (" + w + ")")
                }
            }, r);
            var s = p.type || "get";
            var q = p.complete || p.success;
            if (window.location.protocol == "https:" && s == "get" && q) {
                k.image(t, o);
                return
            }
            $.ajax(p)
        },
        image: function(p, o) {
            if (!o) {
                o = {}
            }
            o.nocache = Math.random();
            var n = l(p, o);
            (new Image()).src = n
        }
    };
    var d = function(n) {
        if (!h) {
            window.blink.log.error("Llamando a funciones de la rest antes de iniciarse")
        }
        return b(offlineServer + m + n)
    };
    var j = function(o) {
        var q = [];
        var p;
        for (var n in o) {
            q.push(n + "=" + window.encodeURIComponent(o[n]))
        }
        return q.join("&")
    };
    var l = function(p, o) {
        var n = d(p);
        if (o) {
            o = a(o);
            n += "?" + j(o)
        }
        return n
    };
    var i = function(r, p) {
        var o;
        if (blink.isWinRTApp && blink.appVersion < 2.9) {
            p = a(p);
            p.protocol = r;
            return window.JSON.stringify(p)
        } else {
            if (blink.appVersion >= f) {
                return l(r, p)
            } else {
                var q;
                if (r == "openUrl") {
                    q = p.mode;
                    o = p.url
                } else {
                    q = r;
                    o = "";
                    if (p) {
                        for (var n in p) {
                            o = p[n];
                            break
                        }
                    }
                }
                o = b(o);
                return q + "://" + o.replace("://", "//")
            }
        }
    };
    var a = function(o) {
        for (var n in o) {
            o[n] = b(o[n])
        }
        return o
    };
    var b = function(n) {
        if (typeof(n) == "string") {
            if (n.startsWith("{")) {
                return n
            }
            if (n.startsWith("../")) {
                n = n.substr(2)
            }
            if (n.match(/^https?:\/\//) || deleteQuery(n).match(/\.php$/)) {
                n = addAppParams(n)
            }
        }
        return n
    };
    var e = {};
    e.onReady = function(n) {
        g.push(n)
    };
    e.alert = function(p, o) {
        if (blink.isOfflinePCApp) {
            //window.alert(p)
        } else {
            if (blink.isAndroidApp) {
                window.Android.showToast(p)
            } else {
                if (blink.appVersion >= 2.8) {
                    p = base64_encode(p)
                }
                var n = {
                    msg: p
                };
                if (o) {
                    n.title = o
                }
                k.location("alert", n)
            }
        }
    };
    e.ibooks = function(n) {
        k.location("ibooks", {
            path: n
        })
    };
    if (!blink.isOfflinePCApp) {
        e.flash = function() {
            msgIncompatibleDevice()
        };
        if (blink.appVersion >= 3.8) {
            e.audio = function(n) {
                k.image("audio", {
                    url: n
                })
            };
            e.video = function(n) {
                if (isOnlineServiceUrlVideo(n)) {
                    blink.rest.openUrl("viewer", adaptUrlToEmbed(n))
                } else {
                    k.image("video", {
                        url: n
                    })
                }
            };
            e.image = function(n) {
                k.image("image", {
                    url: n
                })
            }
        } else {
            e.audio = function(n) {
                k.location("media", {
                    url: n
                })
            }
        }
    }
    e.updateoffline = function(o, q, p) {
        closeMsgBox();
        callOfflinePCParent("events.rest.onBeforeUpdateOffline");
        showMask(null, true);
        if (o) {
            if (p) {
                o = adjustOnlineURL(o, false)
            } else {
                o = adjustURL(o, false, true);
                if (o.startsWith("../")) {
                    o = o.substr(2)
                } else {
                    if (!o.startsWith("http") && !o.startsWith("/")) {
                        o = "/" + o
                    }
                }
            }
            var n = {
                url: o,
                section: q
            };
            k.location("updateoffline", n)
        } else {
            k.location("updateoffline")
        }
    };
    e.updateofflineWithoutReload = function() {
        k.image("updateofflineWithoutReload")
    };
    e.openUrl = function(q, o, p) {
        if (o.indexOf("page://") !== -1) {
            blink.rest.goToPageFromToc(o.split("page://")[1]);
            return
        }
        o = getFinalUrl(o);
        if (p === undefined) {
            p = blink.getReqParam(o, "allowOrientationChange") == 1
        }
        o = o.replace(/[&|?]allowOrientationChange=[0-1]/, "");
        var n = {
            mode: q,
            url: o
        };
        if (p) {
            n.allowOrientationChange = 1
        }
        if (blink.isOfflinePCApp) {
            switch (true) {
                case isExternalURL(o) || o.contains("popup=1") || o.contains("marsupial=1"):
                    openPopup(o);
                    break;
                case q === "targetBlank":
                    window.open(o, "_blank");
                    break;
                default:
                    k.location("openUrl", n)
            }
            return
        }
        n.mode = n.mode === "targetBlank" ? "fullscreen" : n.mode;
        k.location("openUrl", n)
    };
    e.openUrlInExternalWindow = function(o) {
        o = getFinalUrl(o);
        var n = {
            url: o
        };
        k.location("openUrlInExternalWindow", n)
    };
    e.openPDF = function(q, o, p) {
        o = getFinalUrl(o);
        var n = {
            mode: q,
            url: o,
            page: p !== undefined ? p : -1
        };
        if (blink.isOfflinePCApp) {
            return
        }
        k.location("openPDF", n)
    };
    e.photo = function() {
        k.location("photo")
    };
    e.closeWindow = function() {
        k.image("closeWindow")
    };
    e.logout = function() {
        k.location("logout")
    };
    e.login = function(p, o) {
        var n = {
            userToken: p,
            userId: o
        };
        k.location("login", n)
    };
    e.setParam = function(o, p, q) {
        var n = {
            name: o,
            value: p
        };
        k.ajax("setParam", n, {
            success: q
        })
    };
    e.getParam = function(o, r, q) {
        var n = {
            name: o
        };
        var p = r;
        if (typeof(r) == "function") {
            p = function(t) {
                var s = t && t.value && t.value !== null ? t.value.toString() : q;
                (r)(s)
            }
        }
        k.ajax("getParam", n, {
            success: p
        })
    };
    e.delParam = function(o, p) {
        var n = {
            name: o
        };
        k.ajax("delParam", n, {
            success: p
        })
    };
    e.showWebView = function(n) {
        k.image("showWebView", {
            state: JSON.stringify(n)
        })
    };
    e.setContexts = function(n) {
        k.image("setContexts", {
            contexts: JSON.stringify(n)
        })
    };
    e.setButton = function(n) {
        k.image("setButton", {
            button: JSON.stringify(n)
        })
    };
    e.setButtons = function(o) {
        for (var n = 0; n < o.length; n++) {
            this.setButton(o[n])
        }
    };
    e.connection = function(n) {
        k.ajax("connection", {}, {
            success: function(p) {
                var o = p && p.connected !== undefined ? p.connected : -1;
                (n)(o)
            },
            error: function() {
                (n)(-1)
            }
        })
    };
    e.exit = function() {
        window.onBeforeUnloadCalled = true;
        if (blink.isOfflinePCApp || blink.appVersion < 3.91) {
            showCurso()
        } else {
            if (blink.isAndroidApp) {
                k.ajax("exit", {}, {
                    error: function() {}
                })
            } else {
                k.location("exit")
            }
        }
    };
    e.searchWordInDictionary = function(n) {
        k.image("searchWordInDictionary", {
            search: JSON.stringify(n)
        })
    };
    e.audioRecorderWindow = false;
    e.saveAudio = function(r, q, p, u, t) {
        if (c.isWinRTApp) {
            //alert(text_web["audiorecorder.not_suported"]);
            return
        }
        var o = {
            name: r,
            callback: t,
            id: u,
            maxsecs: p,
            script: q
        };
        if (c.isApp && !c.isOfflinePCApp) {
            k.image("saveAudio", o);
            return
        }
        var s = "BlinkAudioRecorder",
            n = openPopup("about:blank", s);
        n && n.blur();
        window.focus();
        c.ajax("/LMS/ajax.php?op=audioRecorder.getURL", function(x) {
            if (x !== "ERROR") {
                var w = json_decode(x),
                    v = w && w.URL;
                if (v) {
                    v += "&" + j(o);
                    openPopup(v, s);
                    n && n.focus();
                    return
                }
            }
            n && n.close();
            //alert(text_web.error_general_AJAX)
        })
    };
    c.restApp = e
})(blink);;
(function(b) {
    b.rest = {};
    var a = b.rest;
    a.exit = function() {
        showCurso()
    };
    a.connection = function(c) {
        (c)(-1)
    };
    a.tarea = function(c, e) {
        var f = c.split("-");
        var d = f.length == 2 ? parseInt(f[1]) : 0;
        if (!e) {
            e = window.idcurso
        }
        c = "/coursePlayer/clases2.php?" + (e ? ("idcurso=" + e + "&") : "") + "idclase=" + f[0] + "&modo=" + window.modoVisualizacion + "&popup=1";
        if (d > 0) {
            c += "&numSec=" + d
        }
        openPopup(c)
    };
    a.openUrl = function(e, c, d) {
        if (c.indexOf("page://") !== -1) {
            this.goToPageFromToc(c.split("page://")[1]);
            return
        }
        if (e === "replace") {
            redireccionar(c)
        } else {
            if (shouldShowUrlInIframe(c)) {
                showIFrame(c)
            } else {
                openPopup(c)
            }
        }
    };
    a.showWebView = function(c) {
        blink.log.debug("showWebView - not implemented: " + c);
        return
    };
    a.openUrlInExternalWindow = function(c) {
        openPopup(c)
    };
    a.openPDF = function(e, c, d) {
        blink.log.debug("openPDF - not implemented: " + c + "," + e);
        return
    };
    a.goToPageFromToc = function(c) {
        blink.theme.spinner.show();
        blink.getCourse(window.idcurso).done(function(h) {
            var f = h;
            var g;
            var d = 0;
            var e;
            $.each(f.units, function(j, k) {
                $.each(k.subunits, function(o, m) {
                    if (m.type == "libro") {
                        if (e == undefined) {
                            e = parseInt(m.offset) || 0
                        } else {
                            if (e >= q) {
                                e == q
                            }
                        }
                        var q = parseInt(m.offset) || (e + d);
                        if ($.type(m.pags) == "array") {
                            g = m.pags.length
                        } else {
                            if ($.type(m.pags) == "string") {
                                g = parseInt(m.pags)
                            } else {
                                if ($.type(m.pags) == "number") {
                                    g = m.pags
                                }
                            }
                        }
                        d += g;
                        if (c > q && c <= q + g) {
                            var n = "/coursePlayer/librodigital_html.php?idcurso=" + window.idcurso + "&idclase=" + m.id;
                            if (blink.isTabletApp) {
                                blink.rest.openPDF(window.idclase ? "replace" : "viewer", n, c - q);
                                blink.theme.spinner.hide()
                            } else {
                                if (m.id == window.idclase) {
                                    bpdf.webViewer.setCurrentPageNumber(c - q);
                                    blink.lateralToc.hide();
                                    blink.theme.spinner.hide()
                                } else {
                                    var p = m.id;
                                    var l = window.idcurso;
                                    blink.localStorage.set("user" + blink.user.getID() + "_clase" + p + "_curso" + l + "_eBookActualPage", c - q);
                                    redireccionar(n)
                                }
                            }
                            return false
                        }
                    }
                })
            });
            if (c < e || c > e + d) {
                $(".no-exists").removeClass("hidden")
            }
            blink.theme.spinner.hide()
        })
    };
    a.panel = function(c, d) {
        showIFrame(c, 500, 400, true);
        $("#modal-backdrop").hideBlink();
        $("#iframe_div").addClass("panel").draggable({
            containment: "parent"
        });
        $(".btn-close-iframe").find("a").on("tap", function(f) {
            cerrarIframe()
        }).before("<h4></h4>").end().find("h4").text(d);
        blink.events.once("iframe:hide:before", function() {
            $("#iframe_div").removeClass("panel").draggable("destroy")
        })
    };
    a.saveAudio = function(e, d, c, g, f) {
        if (!b.isApp) {
            showMsgBox(false, "template:audiorecorder", false, {
                name: e,
                callback: f,
                id: g,
                maxsecs: c,
                script: d
            });
            return
        }
        blink.restApp.saveAudio(e, d, c, g, f)
    };
    a.isDictionaryAvailable = function() {
        return blink.dictionary !== undefined && blink.dictionary.isAvailable() && (window.__MACMILLAN_DEV_1_ACTIVE === true || true)
    };
    a.searchWordInDictionary = function(d) {
        if (!this.isDictionaryAvailable()) {
            //alert(text_web.seguridad_3);
            return
        }
        var e = "BlinkDict",
            c = openPopup("about:blank", e);
        c && c.blur();
        window.focus();
        blink.ajax((window.IN_DEVELOPMENT ? "" : window.WEBS) + "/coursePlayer/dictionary.php?q=" + encodeURIComponent(d), function(h, f) {
            if (f && f.jqXHR.status === 200) {
                var g = json_decode(h);
                if (g && g.url) {
                    openPopup(g.url, e);
                    c && c.focus();
                    return
                }
            }
            c && c.close();
            if (f && f.jqXHR.status === 403) {
                //alert(text_web.error_general_AJAX);
                return
            } else {
                if (f && f.jqXHR.status === 404) {
                    //alert(text_web.tablettxt_word_not_found);
                    return
                } else {
                    if (f && f.jqXHR.readyState === 0) {
                        //alert(text_web.tablettxt_require_connection);
                        return
                    } else {
                        standardAJAXFunc(h);
                        return
                    }
                }
            }
        }, {
            method: "GET"
        }, {
            urlMode: "noDijest",
            sendAllCallbackParams: true,
            animation: true
        })
    }
})(blink);;
(function(e) {
    var a = function() {
        try {
            _loadSCORMData()
        } catch (f) {
            b(f)
        }
        c()
    };
    var c = function() {
        $("#loadingScorm").hide();
        var f = $("#t0_iframe").attr("src_wrk");
        if (f) {
            $("#t0_iframe").attr("src", f)
        }
    };
    var b = function(f) {
        window.scormFailed = true;
        blink.log.error("Error en blink.scorm.init()", f)
    };
    var d = function() {
        if (window.editar || ["embed", "standalone"].contains(window.modoVisualizacionLabel)) {
            $(document).ready(function() {
                a()
            })
        } else {
            if (!window.shouldLoadScorm) {
                $(document).ready(function() {
                    a()
                })
            } else {
                var g = function(h) {
                    if (h && h.mode != undefined) {
                        try {
                            processJsonScormData(h)
                        } catch (i) {
                            b(i)
                        }
                    }
                    $(document).ready(function() {
                        a();
                        if (window.scormFailed && !editar) {
                            _showAlert(text_web.scorm_1)
                        }
                    })
                };
                if (blink.user.esAnonimo() || !window._permitirFinishClass) {
                    g(null)
                } else {
                    var f = "/include/javascript/scormAPI_new.js.php?idcurso=" + window.idcurso + "&idclase=" + window.idclase + (window.idalumno ? "&idalumno=" + window.idalumno : "") + (window.iddesafio ? "&iddesafio=" + window.iddesafio : "");
                    loadScript(f, true, g, window.offline, true, "json")
                }
            }
        }
    };
    e.initScorm = d
})(blink);;
(function(b, a) {
    b.TemplateCache = {
        templates: {},
        get: function(c) {
            var d = this.templates[c];
            if (!d) {
                d = $(c).html();
                this.set(c, d)
            }
            return d
        },
        set: function(d, c) {
            this.templates[d] = c
        },
        render: function(d, f, c, e) {
            $(c).html(this.fetch(d, f, e))
        },
        fetch: function(c, g, e) {
            var h = null;
            if (e !== undefined) {
                h = {};
                for (var d in e) {
                    h[d] = this.get(e[d]);
                    a.parse(h[d])
                }
            }
            var f = this.get(c);
            a.parse(f);
            return a.render(f, g, h)
        },
        DropDown: function(e, d, i, h, c) {
            if (h === undefined) {
                h = false
            }
            if (c === undefined) {
                c = false
            }
            var f = function(l, n) {
                var k = [];
                for (var m in l) {
                    if (l.hasOwnProperty(m)) {
                        var j = [];
                        j.key = m;
                        j.text = l[m];
                        j.selected = (l[m] === n);
                        k.push(j)
                    }
                }
                if (c) {
                    k.reverse()
                }
                if (h) {
                    var j = [];
                    j.key = "";
                    j.text = "";
                    j.selected = (n === "");
                    k.unshift(j)
                }
                return k
            };
            var g = {
                name: e,
                options: f(d, i)
            };
            return g
        }
    }
})(window.blink, window.Mustache);;
(function(b) {
    b.tools = {
        DRAW: 1,
        HIGHLIGHT: 2,
        BRUSH: 4,
        NOTE: 8,
        ERASER: 16
    };
    var a = b.tools;
    a.startw = 40;
    a.starth = 40;
    a.endw = 200;
    a.endh = 200;
    a.mmToPx = function(c) {
        return c
    };
    a.pxToMm = function(c) {
        return c
    };
    a.closeNotesOnEvent = function(c) {
        if ($(c.target).parents(".nota").size() == 0) {
            blink.tools.closeNotes()
        }
    };
    a.getIndiceFromID = function(c, e) {
        for (var d = 0; d < c.length; d++) {
            if (c[d].ID == e) {
                return d
            }
        }
        return -1
    };
    a.getCanvasIndexFromID = function(d) {
        var c = d.indexOf("_");
        if (c == -1) {
            return -1
        }
        return d.substring(4, c)
    };
    a.updateNotes = function() {
        $(".digitalnote").each(function() {
            var d = this.id.substr(10);
            var e = a.getCanvasIndexFromID(d);
            var c = a.getIndiceFromID(notesArray[e], d);
            if (c != -1) {
                notesArray[e][c].txt = $(this).val()
            }
        })
    };
    a.updateNote = function(c) {
        a.updateNotes()
    };
    a.closeNotes = function() {
        b.theme.toolsCloseNotes()
    };
    a.deleteNote = function(e) {
        var d = a.getCanvasIndexFromID(e);
        if (d == -1) {
            return
        }
        var c = a.getIndiceFromID(notesArray[d], e);
        $("#" + e).fadeOut("slow", function() {
            $(this).parent(".nota_pos").remove()
        });
        notesArray[d].splice(c, 1)
    };
    a.getNewID = function(g) {
        var e = -1;
        var d = window.notesArray[g];
        if (!d) {
            d = []
        }
        for (var f = 0; f < d.length; f++) {
            var j = d[f];
            if (!j || !j.ID) {
                continue
            }
            var i = j.ID;
            var c = i.indexOf("_");
            if (c == -1) {
                return 0
            }
            var h = parseInt(i.substring(c + 1));
            if (h > e) {
                e = h
            }
        }
        return e + 1
    };
    a.onEndDrag = function(c, j, g, f) {
        var h = j.target.id.substring(4);
        var k = a.getCanvasIndexFromID(h);
        if (k == -1) {
            return
        }
        var d = this.getIndiceFromID(c[k], h);
        a.readUI(c[k], d, g)
    };
    a.allocateInContainment = function(g, f) {
        var e = g.parent(),
            l = g.closest(".canvas-wrapper"),
            k = a.endw,
            j = a.startw,
            h = k,
            d = l.width() - h,
            i, c;
        if (f) {
            i = (e.position().left < d) ? "initial" : 0;
            c = (g.offset().top < k / 2) ? "initial" : j * (-1)
        } else {
            i = c = "initial"
        }
        g.css({
            right: i,
            bottom: c
        })
    };
    a.readUI = function(c, d, e) {
        c[d].x = parseInt(a.pxToMm(e.position.left));
        c[d].y = parseInt(a.pxToMm(e.position.top))
    };
    a.urlify = function(d) {
        var c = /((?:(http|https|Http|Https|rtsp|Rtsp):\/\/(?:(?:[a-zA-Z0-9\$\-\_\.\+\!\*\'\(\)\,\;\?\&\=]|(?:\%[a-fA-F0-9]{2})){1,64}(?:\:(?:[a-zA-Z0-9\$\-\_\.\+\!\*\'\(\)\,\;\?\&\=]|(?:\%[a-fA-F0-9]{2})){1,25})?\@)?)?((?:(?:[a-zA-Z0-9][a-zA-Z0-9\-]{0,64}\.)+(?:(?:aero|arpa|asia|a[cdefgilmnoqrstuwxz])|(?:biz|b[abdefghijmnorstvwyz])|(?:cat|com|coop|c[acdfghiklmnoruvxyz])|d[ejkmoz]|(?:edu|e[cegrstu])|f[ijkmor]|(?:gov|g[abdefghilmnpqrstuwy])|h[kmnrtu]|(?:info|int|i[delmnoqrst])|(?:jobs|j[emop])|k[eghimnrwyz]|l[abcikrstuvy]|(?:mil|mobi|museum|m[acdghklmnopqrstuvwxyz])|(?:name|net|n[acefgilopruz])|(?:org|om)|(?:pro|p[aefghklmnrstwy])|qa|r[eouw]|s[abcdeghijklmnortuvyz]|(?:tel|travel|t[cdfghjklmnoprtvwz])|u[agkmsyz]|v[aceginu]|w[fs]|y[etu]|z[amw]))|(?:(?:25[0-5]|2[0-4][0-9]|[0-1][0-9]{2}|[1-9][0-9]|[1-9])\.(?:25[0-5]|2[0-4][0-9]|[0-1][0-9]{2}|[1-9][0-9]|[1-9]|0)\.(?:25[0-5]|2[0-4][0-9]|[0-1][0-9]{2}|[1-9][0-9]|[1-9]|0)\.(?:25[0-5]|2[0-4][0-9]|[0-1][0-9]{2}|[1-9][0-9]|[0-9])))(?:\:\d{1,5})?)(\/(?:(?:[a-zA-Z0-9\;\/\?\:\@\&\=\#\~\-\.\+\!\*\'\(\)\,\_])|(?:\%[a-fA-F0-9]{2}))*)?(?:\b|$)/gi;
        var e = d.replace(c, function(g) {
            var f = g;
            if (!g.match(/^http[s]?\:\/\//)) {
                f = "http://" + g
            }
            return "<a href=\"javascript:blink.rest.openUrl('fullscreen','" + f + "')\">" + g + "</a>"
        });
        return e
    };
    a.htmltoTexarea = function(c) {
        return c.replace(/<br\/>/g, "\r\n")
    };
    a.drawNote = function(f, c, e, d) {
        b.theme.toolsDrawNote(f, c, e, d)
    }
})(blink);;
(function(a) {
    a.toolsNew = {};
    var b = function() {
        this.name = "search";
        this.isReady = false;
        this.documents = Array()
    };
    b.prototype.add = function(g) {
        this.documents.push(g);
        this.searchEngine.add({
            id: g.id,
            title: g.title,
            body: g.body
        })
    };
    b.prototype.loadIndexFromCourseID = function(n, i, m, g) {
        var l = this;
        var k = function(o) {
            var p = l.loadIndexFromJSON(n, json_encode(o), g);
            i && i(p, o)
        };
        var j = function(o) {
            i && i(false)
        };
        if (m) {
            var h = window.WEBS + "/coursePlayer/curso_json.php?idcurso=" + n;
            a.getJSON(h, k, {
                method: "GET"
            }, {
                urlMode: "noDijest",
                onError: j
            })
        } else {
            a.getCourse(n).fail(j).done(k)
        }
    };
    b.prototype.loadIndexFromJSON = function(n, k, g) {
        var h = lunr(function() {
            String.prototype.startsWith = function(p, o) {
                o = o || 0;
                return this.indexOf(p, o) === o
            };
            try {
                this.use(lunr[window.IDIOMA.toLowerCase()])
            } catch (i) {}
            this.pipeline._stack = this.pipeline._stack.filter(function(o) {
                return !o.label.startsWith("stopWordFilter")
            });
            this.field("title", {
                boost: 10
            });
            this.field("body");
            this.ref("id")
        });
        h.pipeline.remove(h.stopWordFilter);
        this.searchEngine = h;
        var m = json_decode(k),
            j = 1,
            l = this;
        _.each(m.units, function(i) {
            if (g) {
                l.add({
                    title: i.title,
                    body: i.description || "",
                    href: "javascript:void(0)",
                    id: i.id,
                    disabled: !i.resources.length && !i.subunits.length,
                    isResouce: false,
                    isActivity: false
                })
            }
            _.each(i.resources, function(o) {
                l.add({
                    title: o.title,
                    body: o.description || o.summary && o.summary.text[0] || "",
                    href: o.url,
                    id: o.id,
                    isResource: true,
                    isActivity: false
                })
            });
            _.each(i.subunits, function(o) {
                l.add({
                    id: j++,
                    title: o.title,
                    body: o.description || o.summary && o.summary.text[0] || "",
                    href: o.url,
                    id: o.id,
                    isResource: false,
                    isActivity: true
                })
            })
        });
        this.isReady = true;
        return true
    };
    b.prototype.search = function(i) {
        if (!this.isReady) {
            return false
        }
        var g = this.searchEngine.search(i);
        var h = this;
        return _.map(g, function(j) {
            return _.find(h.documents, function(k) {
                return k.id == j.ref
            })
        })
    };
    a.toolsNew.searchTool = b;
    var e = function() {
        this.name = "search";
        this.isReady = false;
        this.documents = Array()
    };
    e.prototype = new b();
    e.prototype.loadIndexFromJSON = function(n, j, l) {
        var g = lunr(function() {
            this.field("tags");
            this.ref("id")
        });
        g.pipeline._stack = [];
        this.searchEngine = g;
        var m = json_decode(j),
            h = 1,
            k = this;
        _.each(m.units, function(p) {
            var i = l ? l(p.number) : false;
            var o = p.description;
            _.each(p.subunits, function(q) {
                k.searchEngine.add({
                    id: h++,
                    title: q.title,
                    body: q.description,
                    href: q.url,
                    isResource: false,
                    id: q.id,
                    tags: o
                });
                k.add({
                    id: h++,
                    title: q.title,
                    body: q.description,
                    href: q.url,
                    isResource: false,
                    id: q.id,
                    tags: o
                })
            })
        });
        this.isReady = true;
        return true
    };
    a.toolsNew.contextualSearchTool = e;
    var d = (function() {
        function g() {
            this.name = "rangy"
        }
        g.prototype.init = function() {
            this.enable = false;
            this.activeCssClass = "color-" + colorSelected.substr(1);
            this.toolType;
            rangy.init();
            this.highlighter = new Array();
            var h = this;
            _.each(a.activity.getPrefijos(), function(i) {
                $(document).ready(function() {
                    h.highlighter[i] = rangy.createHighlighter();
                    $(h.getRootNode(i)).on("mouseup", function() {
                        if (h.enable) {
                            var k = $.trim(window.getSelection().toString()).length;
                            if ((h.toolType == "highlight" && k > 0)) {
                                h.saveSelection(i, h.activeCssClass, h.toolType)
                            } else {
                                if ((h.toolType == "note" && k == 0)) {
                                    var j = rangy.getSelection().expand("character", {
                                        wordOptions: {
                                            includeTrailingSpace: true
                                        }
                                    });
                                    h.saveSelection(i, h.toolType, h.toolType, j);
                                    if (h.toolType == "note" && k == 0) {
                                        console.log("guardo nota")
                                    }
                                }
                            }
                        }
                    })
                })
            });
            $(document).on("mouseenter", ".highlight", function() {
                var i = $(this);
                if (!i.data("bs.popover")) {
                    h.initPopover(this)
                }
            });
            $(document).on("click", function(i) {
                if (!$(i.target).data("bs.popover") && ($(i.target).closest(".popover").length == 0)) {
                    a.popovers.hideAll()
                }
            });
            $(document).on("shown.bs.popover", function(i) {
                a.popovers.hideAll([$(i.target)])
            });
            $(document).on("click", ".js-delete-highlight", function() {
                h.removeHighlight($(this).data("prefix"));
                $(".highlight").popover("destroy")
            })
        };
        g.prototype.setActivation = function(h, i) {
            this.enable = h;
            if (i) {
                this.toolType = i
            }
            if (h) {
                a.events.trigger("rangy:enable")
            } else {
                a.events.trigger("rangy:disable")
            }
        };
        g.prototype.getActivation = function(h) {
            return this.enable
        };
        g.prototype.setStatus = function(h, i) {
            this.deserialize(h, i)
        };
        g.prototype.getStatus = function(i) {
            var h = this.serialize(i);
            return h
        };
        g.prototype.setColor = function(h) {
            this.activeCssClass = "color-" + h
        };
        g.prototype.getColor = function() {
            return this.activeCssClass.substr(6)
        };
        g.prototype.loadClass = function(l, h, m) {
            var i = {
                ignoreWhiteSpace: true,
                tagNames: ["span", "a"],
                elementProperties: {
                    className: "highlight rangy"
                }
            };
            var k = {
                ignoreWhiteSpace: false,
                tagNames: ["*"],
                elementProperties: {
                    className: "rangy"
                }
            };
            var j;
            switch (m) {
                case "highlight":
                    j = i;
                    break;
                case "note":
                    j = k;
                    break
            }
            this.highlighter[l].addClassApplier(rangy.createClassApplier(h, j))
        };
        g.prototype.saveSelection = function(l, h, m, j) {
            if (!_.has(this.highlighter[l].classAppliers, h)) {
                this.loadClass(l, h, m)
            }
            var i = {
                containerElementId: this.getRootNode(l).id
            };
            if (j) {
                i.selection = j
            }
            this.highlighter[l].highlightSelection(h, i);
            var k = rangy.getSelection();
            k.collapseToEnd()
        };
        g.prototype.serialize = function(h) {
            return this.highlighter[h].serialize()
        };
        g.prototype.deserialize = function(j, i) {
            var h = this;
            $(document).ready(function() {
                var m = i.split("|");
                for (var k = m.length, l; k-- > 0;) {
                    var l = m[k].split("$");
                    if (!_.has(h.highlighter[j].classAppliers, l[3])) {
                        h.loadClass(j, l[3], "highlight")
                    }
                }
                h.highlighter[j].deserialize(i)
            })
        };
        g.prototype.getRootNode = function(h) {
            return $("#" + h + "left").get(0)
        };
        g.prototype.removeHighlight = function(h) {
            this.highlighter[h].unhighlightSelection()
        };
        g.prototype.initPopover = function(i) {
            var j = $(i).closest(".slide-wrapper").data("prefix");
            var h = {
                content: '<button class="btn btn-default js-delete-highlight" data-prefix="' + j + '">Delete Highlight</button>',
                container: "body",
                toggle: "popover",
                placement: "top auto",
                trigger: "click",
                html: true
            };
            a.popovers.register($(i).popover(h))
        };
        return g
    })();
    a.toolsNew.rangyTool = d;
    var f = (function() {
        function g() {
            this.name = "painter"
        }
        return g
    })();
    a.toolsNew.painterTool = f;
    var c = (function() {
        function g(h) {
            this.name = "mask";
            this.ready = false;
            this.options = h
        }
        g.prototype.showMask = function() {
            if (!this.ready) {
                var k = $(window).width() / 2,
                    l = $(window).height() / 2;
                var j = {
                    opacity: 0.5
                };
                var h = {
                    autoHide: true,
                    minWidth: 100,
                    minHeight: 100,
                    handles: "all"
                };
                var i = (this.options && this.options.containment) || document.body;
                $('<div id="maskToolObj" style="width:' + k + "px;height:" + l + 'px;background-color:#CCC;z-index:100;"></div>').appendTo(i).center().blinkDraggable($.extend(j, this.options)).resizable($.extend(h, this.options));
                this.ready = true
            }
            $("#maskToolObj").show()
        };
        g.prototype.hideMask = function() {
            $("#maskToolObj").hide()
        };
        return g
    })();
    a.toolsNew.maskTool = c
})(window.blink);;
(function(a) {
    var c = 2;
    var g = 4;
    var b = 8;
    var i = -1;
    var d = -1;

    function h() {
        return window.userType ? parseInt(window.userType) : 0
    }

    function f(j) {
        var k = h() & j;
        return k > 0
    }
    var e = {
        getID: function() {
            return i
        },
        setID: function(j) {
            i = j || i
        },
        getExternalID: function() {
            return d
        },
        setExternalID: function(j) {
            d = j || d
        },
        esProfesor: function() {
            return f(c)
        },
        esAlumno: function() {
            return f(g)
        },
        esPadre: function() {
            return f(b)
        },
        esAnonimo: function() {
            return !h()
        },
        getMyLibraryURL: function() {
            return window.myLibraryURL
        },
        getUserTheme: function() {
            var j = {
                "1": "default",
                "2": "responsive"
            };
            j["0"] = j[window.defaulThemeDomain];
            return j[window.userIDTheme]
        }
    };
    a.user = e
})(blink);;
(function(b) {
    b.utils = b.utils || {};
    var a = b.utils;
    a.getWidthInput = function(e) {
        if (e.length == 0) {
            return 0
        }
        var d = window.parent || window;
        var c = d.$("#tester-width");
        c.html(e);
        return c.width()
    }, a.getScrollbarWidth = function() {
        var f = $("<div></div>").appendTo("body").css({
            width: 100,
            visibility: "hidden"
        });
        var d = f.get(0).offsetWidth;
        f.css("overflow", "scroll");
        var c = $("<div></div>").appendTo(f).css("width", "100%");
        var e = c.get(0).offsetWidth;
        f.remove();
        return d - e
    }, a.attachImageEvents = function() {
        $("img").unbind("error.loaderrorimg");
        $("img").bind("error.loaderrorimg", function() {
            var d = $(this);
            if (($("#mensajes").length > 0 || $(".mis_mensajes").length > 0) && d.attr("alt")) {
                var i = d.parent("div"),
                    h = d.attr("alt"),
                    g = base64_encode(h),
                    c = 3.446,
                    f = parseInt((g.charCodeAt(0) - "0".charCodeAt(0)) * c),
                    e = parseInt((g.charCodeAt(1) - "0".charCodeAt(0)) * c),
                    j = parseInt((g.charCodeAt(2) - "0".charCodeAt(0)) * c);
                d.remove();
                i.css({
                    display: "table",
                    "background-color": "rgb(" + f + "," + e + "," + j + ")",
                    color: "white",
                    "text-align": "center",
                    "border-radius": "4px",
                    "margin-right": "15px",
                    width: "60px",
                    height: "60px"
                });
                i.append("<p>" + h.charAt(0).toUpperCase() + "</p>");
                i.find("p").css({
                    display: "table-cell",
                    "font-size": "50px",
                    "vertical-align": "middle"
                })
            } else {
                if (d && d.attr("src") && d.attr("src").indexOf("images/common/load_error.png") == -1) {
                    d.attr("src_old", d.attr("src"));
                    d.attr("src", "../images/common/load_error.png")
                }
            }
        })
    };
    a.cleanTextareaCKEDITOR = function(d) {
        var f = function() {
                return d.find("[contenteditable=false][tabindex=-1]")
            },
            c = function() {
                return d.find("span").filter(function() {
                    return $(this).css("background-image").indexOf("/handle.png") != -1
                })
            },
            g = c(),
            e = f();
        if (g.length > 0) {
            g.remove()
        }
        if (e.length > 0) {
            e.children().unwrap();
            e = f();
            if (e.length > 0 && e.children().length == 0) {
                e.remove()
            }
        }
    }
})(blink);;
(function(c) {
    var b = c.currentPage;
    var a = function() {
        Object.defineProperty(this, "name", {
            enumerable: true,
            value: "LateralToc"
        })
    };
    a.prototype.init = function() {};
    a.prototype.openIndexAtStartIfNeeded = function(d) {
        this.openMenuAtStart = b.openMenuAtStart || false;
        d = d || false;
        if (this.openMenuAtStart && !d) {
            return this.show()
        }
        return false
    };
    a.prototype.openIndexLibro = function() {
        var g = this;
        if (b && b.openIndexLibro) {
            return b.openIndexLibro()
        }
        $("#help-panel-error").hideBlink();
        var l = $("#book-index"),
            f = $("#book-index .col-main"),
            j = c.TemplateCache.get("#course"),
            h = "book-index-" + window.idcurso,
            i = {
                esInfantil: g.infantBook,
                initTemasOrdenados: function() {
                    var n = []
                },
                user: {
                    isPublisher: g.editorialUser
                },
                editar: window.editar,
                textweb: {
                    course_7: text_web.course_7,
                    course_12: text_web.course_12,
                    course_20: text_web.course_20,
                    course_22: text_web.course_22,
                    course_75: text_web.course_75,
                    course_76: text_web.course_76,
                    course_77: text_web.course_77,
                    course_78: text_web.course_78,
                    course_79: text_web.course_79,
                    course_abrev_pag: text_web.course_abrev_pag,
                    course_unit_activities: text_web.course_unit_activities,
                    course_supplement_content: text_web.course_supplement_content,
                    course_create_new_resource: text_web.course_create_new_resource
                },
                course: {
                    id: window.idcurso
                }
            },
            e = function(s, q) {
                var u = $("#book-index .col-units").outerWidth();
                var p = $("#book-index .col-main").outerWidth();
                var r = p + u;
                var t = l.hasClass("filled"),
                    w = l.hasClass("active"),
                    o = w ? -r : "0";
                if (!t) {
                    Mustache.parse(s);
                    l.children().html(Mustache.render(s, q))
                }
                conmutarEstadoBoton("btn-book-index", w);
                if (!w) {
                    $(".side-panel").removeClass("active");
                    $("#boton_buscar").removeClass("active")
                }
                l.animate({
                    left: o
                }, 500, "easeInOutQuart").toggleClass("active").addClass("filled");
                m();
                if (!w) {
                    var v = $('.js-list-activities [data-id="' + window.idclase + '"]');
                    var n = v.closest("[data-parent]").attr("data-parent");
                    if (v) {
                        v.addClass("current");
                        $('#list-units [data-id="' + n + '"]').addClass("current-parent");
                        if (!$('#list-units [data-id="' + n + '"]').hasClass("active")) {
                            $('#list-units [data-id="' + n + '"]').find(".js-tema").click()
                        }
                    }
                }
            },
            m = function() {
                var n = {
                    ellipsis: "... ",
                    wrap: "word",
                    fallbackToLetter: true,
                    watch: true,
                    height: 106
                };
                $(".js-indice-tema").each(function() {
                    var o = $(this),
                        p = o.data("id");
                    items = $('.js-unit-content[data-id="' + p + '"]').find(".item span.js-acceso:not(.lock)").length;
                    if (items > 0) {
                        o.removeClass("locked")
                    }
                    items = $('.js-unit-content[data-id="' + p + '"]').find(".item").length;
                    if (items > 0) {
                        o.removeClass("disabled")
                    }
                });
                $(".js-item .title").each(function(o, p) {
                    if ($(p).is(":empty")) {
                        $(p).text(text_web.course_actividad_no_name)
                    }
                });
                $(".js-item").each(function(o, p) {
                    if ($(this).attr("data-ocultar") === "true") {
                        $(this).remove()
                    }
                });
                $(".js-title").on("tap", function() {});
                indexIScroll();
                c.events.trigger("indexLoaded")
            };
        l.animate({
            left: 0
        }, 500, "easeInOutQuart");
        c.theme.spinner.show("#toc-spinner-backdrop, #toc-spinner");
        var d = "/coursePlayer/curso_json.php?idcurso=" + window.idcurso,
            k = function(n) {
                $("#help-panel-error").hideBlink();
                e(j, $.extend(n, i));
                c.theme.spinner.hide("#toc-spinner-backdrop, #toc-spinner")
            };
        c.getCourse(window.idcurso).done(k).fail(function() {
            $("#help-panel-error").showBlink()
        })
    };
    a.prototype.isActive = function() {
        if (b && b.isActive) {
            return b.isActive()
        }
        var d = $("#book-index");
        return d.hasClass("active")
    };
    a.prototype.isFilled = function() {
        if (b && b.isFilled) {
            return b.isFilled()
        }
        var d = $("#book-index");
        return d.hasClass("filled")
    };
    a.prototype.show = function() {
        c.events.trigger("widget:widgetShows", "LateralToc");
        if (this.isActive()) {
            return false
        }
        if (b && b.showIndex) {
            return b.showIndex()
        }
        this.toggle()
    };
    a.prototype.hide = function(d) {
        if (!this.isActive()) {
            return false
        }
        if (b && b.closeIndex) {
            b.closeIndex();
            var e = d || false;
            if (!e) {
                c.events.trigger("widget:widgetHides")
            }
            return
        }
        this.toggle(d);
        c.events.trigger("indexClosed")
    };
    a.prototype.toggle = function(d) {
        var e = d || false;
        if (b) {
            if (b.isActive && !b.isActive()) {
                c.events.trigger("widget:widgetShows", "LateralToc")
            } else {
                if (!this.isActive()) {
                    c.events.trigger("widget:widgetShows", "LateralToc")
                }
            }
            if (b.toggleIndex) {
                return b.toggleIndex()
            }
        } else {
            if (!this.isActive()) {
                c.events.trigger("widget:widgetShows", "LateralToc")
            }
        }
        this.openIndexLibro();
        if (b && b.isActive && !b.isActive() && !e) {
            c.events.trigger("widget:widgetHides", "LateralToc")
        } else {
            if (!this.isActive() && !e) {
                c.events.trigger("widget:widgetHides", "LateralToc")
            }
        }
    };
    a.prototype.updatePageVariables = function(d) {
        d = d || 0;
        if (b && b.updatePageVariables) {
            return b.updatePageVariables(window.idcurso, window.idclase, d)
        }
        return false
    };
    a.prototype.toogleIndex = function(d) {
        this.toggle(d)
    };
    a.prototype.closeIndex = function(d) {
        this.hide(d)
    };
    a.prototype.showIndex = function() {
        this.show()
    };
    c.lateralToc = new a()
})(blink);;
(function(e) {
    var c = e.tools || {};
    var b = {};
    var a = null;
    var d = false;
    b.colors = {
        RED: {
            className: "red",
            hex: "#fc4236"
        },
        PINK: {
            className: "pink",
            hex: "#ff7bac"
        },
        PURPLE: {
            className: "purple",
            hex: "#81007f"
        },
        DARK_BLUE: {
            className: "dark-blue",
            hex: "#0071bd"
        },
        LIGHT_BLUE: {
            className: "light-blue",
            hex: "#29aae3"
        },
        BROWN: {
            className: "brown",
            hex: "#a67c52"
        },
        ORANGE: {
            className: "orange",
            hex: "#ff931e"
        },
        YELLOW: {
            className: "yellow",
            hex: "#ffff01"
        },
        LIGHT_GREEN: {
            className: "light-green",
            hex: "#79c942"
        },
        DARK_GREEN: {
            className: "dark-green",
            hex: "#009345"
        },
        WHITE: {
            className: "white",
            hex: "#ffffff"
        },
        GREY: {
            className: "grey",
            hex: "#9e9e9c"
        },
        BLACK: {
            className: "black",
            hex: "#000000"
        }
    };
    b.tools = {};
    b.buttons = {
        boton_rotulador: {
            tool: "pencil",
            clickAction: "primaryAction",
            pressAction: "primaryAction"
        },
        boton_borrador: {
            tool: "pencil",
            clickAction: "secondaryAction",
            pressAction: null
        },
        boton_subrayador: {
            tool: "highlighter",
            clickAction: "primaryAction",
            pressAction: "enable"
        },
        boton_notes: {
            tool: "note",
            clickAction: "primaryAction",
            pressAction: null
        },
        "tool-ink": {
            tool: "bpdftool",
            clickAction: "primaryAction",
            pressAction: "primaryAction"
        },
        "tool-text": {
            tool: "bpdftool",
            clickAction: "freeTextAction",
            pressAction: "freeTextAction"
        },
        "tool-highlight": {
            tool: "bpdftool",
            clickAction: "secondaryAction",
            pressAction: "secondaryAction"
        }
    };
    b.initialize = function(g) {
        d = true;
        var f = this;
        _.each(g, function(h) {
            h.init();
            f.tools[h.name] = h
        });
        this.$buttons = $("#boton_rotulador").add("#boton_subrayador").add("#boton_borrador").add("#boton_notes");
        var f = this;
        e.events.on("note:created", function() {
            f.disableButtons()
        });
        blink.events.trigger(true, "managerTools:inited")
    };
    b.setColor = function(f) {
        a = f;
        window.colorSelected = f.hex
    };
    b.getColor = function() {
        return a
    };
    b.isInitialized = function() {
        return d
    };
    b.disableTools = function(f) {
        _.each(this.tools, function(g) {
            if (f !== g) {
                g.disable()
            }
        })
    };
    b.disableButtons = function() {
        $.each(this.$buttons, function(f, g) {
            blink.theme.buttonState.active($(g), false)
        })
    };
    b.discardNextAction = function(g) {
        var f = this.buttons[g];
        if (!f) {
            return
        }
        f.shouldDiscardNext = true
    };
    b.buttonPress = function(i) {
        var g = this.buttons[i];
        if (!g) {
            return
        }
        var f = c[g.tool],
            h = f[g.pressAction];
        this.disableTools(f);
        this.disableButtons();
        h && h.call(f);
        blink.theme.buttonState.active("#" + i, f.enabled)
    };
    b.buttonClick = function(i) {
        var g = this.buttons[i];
        if (!g) {
            return
        }
        if (g.shouldDiscardNext) {
            g.shouldDiscardNext = false;
            return
        }
        var f = c[g.tool],
            h = f[g.clickAction];
        this.disableTools(f);
        this.disableButtons();
        h && h.call(f);
        blink.theme.buttonState.active("#" + i, f.enabled)
    };
    c.manager = b
})(window.blink);;
(function(c) {
    var b = c.tools || {};
    var a = function() {
        var d;
        var f;
        var e;
        Object.defineProperty(this, "enabled", {
            configurable: false,
            enumerable: false,
            get: function() {
                return d
            },
            set: function(g) {
                d = !!g
            }
        });
        Object.defineProperty(this, "color", {
            configurable: false,
            enumerable: false,
            get: function() {
                return f
            },
            set: function(g) {
                f = g
            }
        });
        Object.defineProperty(this, "defaultColor", {
            configurable: false,
            enumerable: false,
            get: function() {
                return e
            },
            set: function(g) {
                e = g
            }
        })
    };
    a.prototype.init = function() {};
    a.prototype.getStatus = function(d) {
        return null
    };
    a.prototype.setStatus = function(e, d) {};
    a.prototype.getGlobalStatus = function() {
        return null
    };
    a.prototype.setGlobalStatus = function(d) {};
    a.prototype.primaryAction = function(d) {
        if (!this.enabled) {
            this.enable()
        } else {
            this.disable()
        }
    };
    a.prototype.enable = function() {
        this.enabled = true
    };
    a.prototype.disable = function() {
        this.enabled = false
    };
    b.tool = a
})(window.blink);;
(function(f) {
    var e = f.tools || {};
    var c = e.tool;
    var d = c.prototype;
    var b = {
        PENCIL: "AnnotationCreateFreeHand",
        FREE_TEXT: "AnnotationCreateFreeText",
        HIGHLIGTER: "AnnotationCreateTextHighlight"
    };
    var a = function() {
        c.apply(this, arguments);
        this.enabled = false;
        Object.defineProperty(this, "type", {
            configurable: true,
            enumerable: false,
            writable: true,
            value: b.PENCIL
        });
        Object.defineProperty(this, "name", {
            configurable: false,
            enumerable: false,
            writable: false,
            value: "bpdftool"
        })
    };
    a.prototype = Object.create(d);
    a.prototype.checkType = function(g) {
        if (this.type === g) {
            d.primaryAction.call(this)
        } else {
            this.type = g;
            this.disable();
            this.enable()
        }
    };
    a.prototype.primaryAction = function() {
        this.checkType(b.PENCIL)
    };
    a.prototype.secondaryAction = function() {
        this.checkType(b.HIGHLIGTER)
    };
    a.prototype.freeTextAction = function() {
        this.checkType(b.FREE_TEXT)
    };
    a.prototype.enable = function() {
        d.enable.apply(this);
        bpdf.tool.toggle(this.type, true)
    };
    a.prototype.disable = function() {
        bpdf.tool.toggle(this.type, false);
        d.disable.apply(this)
    };
    a.prototype.setGlobalStatus = function(g) {
        if (g.pencil) {
            g.pencil.color && bpdf.setStrokeColorAsHex(g.pencil.color);
            g.pencil.thickness && bpdf.setDefaultThickness(g.pencil.thickness)
        }
        if (g.highligter) {
            g.highligter.color && bpdf.setTextAnnotColorAsHex(g.highligter.color)
        }
        if (g.freeText) {
            g.freeText.color && bpdf.setFreeTextAnnotColorAsHex(g.freeText.color)
        }
        g.zoom && bpdf.zoom.set(g.zoom)
    };
    a.prototype.getGlobalStatus = function() {
        return {
            pencil: {
                color: bpdf.getStrokeColorAsHex(),
                thickness: bpdf.getDefaultThickness()
            },
            highligter: {
                color: bpdf.getTextAnnotColorAsHex()
            },
            freeText: {
                color: bpdf.getFreeTextColorAsHex()
            },
            zoom: bpdf.zoom.get()
        }
    };
    e.bpdftool = new a
})(window.blink);;
(function(e) {
    var d = e.tools || {};
    var b = d.tool;
    var c = b.prototype;
    var a = function() {
        b.apply(this, arguments);
        this.enabled = false;
        this.defaultColor = d.manager.colors.YELLOW;
        this.color = this.defaultColor.hex;
        Object.defineProperty(this, "name", {
            configurable: false,
            enumerable: false,
            writable: false,
            value: "highlight"
        });
        Object.defineProperty(this, "type", {
            configurable: true,
            enumerable: false,
            writable: true,
            value: "highlight"
        });
        this.workers = {}
    };
    a.prototype = Object.create(c);
    a.prototype.setBackgroundForSlide = function(g) {
        var f = $(g),
            h = f ? f.find('[class*="hl-"]').not(".setted") : $('[class*="hl-"]').not(".setted");
        f.find(".setted").not('[class*="hl-"]').css("background-color", "transparent");
        this.setBackgroundToElements(h)
    };
    a.prototype.setBackgroundToElements = function(f) {
        $(f).each(function() {
            var m = $(this),
                h = m.attr("class").indexOf("hl-#"),
                l = m.attr("class").substr(h + 4),
                i = hex2rgb(hex2dec(l)),
                k = i[0],
                j = i[1],
                g = i[2];
            m.css("background-color", "rgba(" + k + "," + j + "," + g + ",0.5)").addClass("setted")
        })
    };
    a.prototype.init = function() {
        var f = this;
        $(document).ready(function() {
            !rangy.initialized && rangy.init();
            $(".item").scroll(function() {
                f.hideAllPopovers()
            });
            _.each(blink.activity.getPrefijos(), function(h) {
                f.workers[h] = rangy.createHighlighter();
                var g = f.getRootNode(h);
                $(g).on("tap", function(r, o) {
                    if (blink.isTablet && o) {
                        var v, m, q;
                        var k = $(o[0].target);
                        var l = k.position();
                        var u = k.offset();
                        var t = !!$(r.target).closest(".setted").length;
                        if (f.enabled && !t) {
                            if (typeof document.caretPositionFromPoint == "function") {
                                var p = document.caretPositionFromPoint(o.position.x, o.position.y);
                                v = rangy.createRange();
                                m = p.offsetNode;
                                q = p.offset;
                                v.setStartAndEnd(m, q)
                            } else {
                                if (typeof document.caretRangeFromPoint == "function") {
                                    var i = r.originalEvent.changedTouches[0].clientX,
                                        n = r.originalEvent.changedTouches[0].clientY;
                                    v = document.caretRangeFromPoint(i, n)
                                }
                            }
                            var j = rangy.getSelection();
                            j.setSingleRange(v);
                            var s = f.calculateAutomaticSelection(1);
                            if (s.anchorNode && f.type == "highlight") {
                                f.saveSelectionHighlight(h, f.getHighlightColor());
                                setTimeout(function() {
                                    try {
                                        j.removeAllRanges()
                                    } catch (w) {}
                                }, 0)
                            }
                        }
                    }
                }).on("doubletap", function(k, l) {
                    if (blink.isTablet) {
                        var i = !!$(k.target).closest(".setted").length;
                        if (f.enabled) {
                            var j = f.calculateAutomaticSelection(2, k.target);
                            if (j.anchorNode && f.type == "highlight") {
                                f.saveSelectionHighlight(h, f.getHighlightColor())
                            }
                        }
                    }
                }).on("click", function(k) {
                    if (f.enabled && !blink.isTablet) {
                        var l = $.trim(window.getSelection().toString()).length;
                        if (!blink.isTablet && f.type == "highlight" && l > 0) {
                            f.saveSelectionHighlight(h, f.getHighlightColor())
                        } else {
                            if (f.type == "note" && l == 0) {
                                rangy.getSelection().expand("character", {
                                    wordOptions: {
                                        includeTrailingSpace: true
                                    }
                                });
                                f.saveSelectionNote(h, "rangy-" + f.type);
                                f.secondaryAction($("#boton_notes"));
                                var j = rangy.getSelection(),
                                    i = j.focusNode.parentElement;
                                f.openNote(i, h);
                                f.editNote($(i));
                                k.preventDefault();
                                k.stopImmediatePropagation();
                                k.stopPropagation();
                                e.events.trigger("note:created")
                            }
                        }
                    }
                }).on("mousedown", ".setted", function() {
                    $(this).on("mouseup mousemove", function i(j) {
                        if (j.type == "mouseup") {
                            !$(this).hasClass("bs-popover") ? f.initPopover(this) : f.removePopover(this);
                            j.stopImmediatePropagation()
                        }
                        $(this).off("mouseup mousemove", i)
                    })
                })
            });
            $(document).on("click", function(g) {
                if (!$(g.target).data("bs.popover") && $(g.target).closest(".popover").length == 0) {
                    f.hideAllPopovers()
                }
            }).on("shown.bs.popover", function(g) {
                blink.popovers.hideAll([$(g.target)])
            }).on("click", ".js-delete-highlight", function() {
                var k = $(this),
                    i = k.data("elem");
                if (i) {
                    var g = f.getHighlightFromDOM(i);
                    if (g) {
                        var j = g.getHighlightElements();
                        f.cleanHighlights(j)
                    }
                    f.removePopover(i);
                    var h = rangy.getSelection();
                    h.setSingleRange(g.getRange());
                    f.removeHighlight(k.data("prefix"), h)
                }
            }).on("click", function(i) {
                var g = $(i.target).closest(".rangy-note");
                if (g.size() == 0 && $(".nota_wrapper").size() >= 0) {
                    f.closeNotes()
                } else {
                    if ($(".nota_wrapper").length == 0) {
                        var h = f.getPrefix(g);
                        f.openNote(g.get(0), h)
                    }
                }
            })
        })
    };
    a.prototype.getHighlightColor = function() {
        return "hl-" + this.color
    };
    a.prototype.checkType = function(f) {
        if (this.type === f) {
            c.primaryAction.call(this)
        } else {
            this.type = f;
            this.disable();
            this.enable()
        }
    };
    a.prototype.primaryAction = function() {
        var g = window.getSelection(),
            i = $.trim(g.toString()).length;
        if (i === 0) {
            this.checkType("highlight")
        } else {
            var f = $(g.anchorNode).closest(".js-highlighter-root");
            if (f.length && !$(g.anchorNode).closest(".setted").length) {
                var h = this.getPrefix(f);
                this.saveSelectionHighlight(h, this.getHighlightColor())
            } else {
                this.checkType("highlight")
            }
        }
    };
    a.prototype.secondaryAction = function() {
        this.checkType("note");
        $("#slider").toggleClass("canvasnote")
    };
    a.prototype.enable = function() {
        c.enable.apply(this);
        blink.events.trigger("rangy:enable")
    };
    a.prototype.disable = function() {
        c.disable.apply(this);
        blink.events.trigger("rangy:disable")
    };
    a.prototype.getStatus = function(i) {
        var f = [];
        var g = this;
        $("#" + i + "left .rangy-note").each(function() {
            var j = g.getHighlightFromDOM(this, i);
            if (j && !!j.textNote) {
                f.push({
                    id: j.id,
                    text: j.textNote
                })
            }
        });
        var h = {
            serializedString: this.serialize(i),
            notes: f
        };
        return h
    };
    a.prototype.setStatus = function(g, f) {
        this.deserialize(g, f)
    };
    a.prototype.getGlobalStatus = function() {
        return {
            color: this.color
        }
    };
    a.prototype.setGlobalStatus = function(f) {
        if (typeof f.color == "object") {
            this.color = "#ffff00"
        } else {
            this.color = f.color
        }
    };
    a.prototype.openNote = function(f, k) {
        var g = this.getHighlightFromDOM(f, k);
        if (!g) {
            return
        }
        var j = this;
        var i = blink.tools;
        if (g.textNote) {
            g.textNote = g.textNote.replace(/\\n/g, "\n")
        } else {
            g.textNote = ""
        }
        var l = '<div id="pos_' + g.id + '" class="nota_wrapper"><div id="' + g.id + '" class="nota"><div class="nota_content"><a class="deletedigitalnote control delete" id="borrarNota' + g.id + '" href="javascript:void(0);">' + text_web.mensaje_10 + '</a><div  class="js-save postit-save hidden" style="height: 100%;"><textarea id="postittext' + g.id + '" class="digitalnote">' + i.htmltoTexarea(g.textNote) + '</textarea><br><span id="savePostit"  class="save btn-postit">' + text_web.postit_close + '</span></div><div class="js-edit" style="height: 100%;"><div class="note-text"></div><br><span id="editPostit" class="btn-postit">' + text_web.postit_edit + "</span></div></div></div></div>";
        $(l).appendTo(f);
        var h = g.textNote.replace(/\n/g, "<br/>");
        h = i.urlify(h);
        $(f).find("#pos_" + g.id + " .note-text").html(h)
    };
    a.prototype.editNote = function(f) {
        var i = blink.tools;
        var j = f.closest(".rangy-note").get(0);
        var h = this.getHighlightFromDOM(j);
        var g = i.htmltoTexarea(h.textNote);
        $(j).find(".js-save").showBlink();
        $(j).find(".js-edit").hideBlink();
        $(j).find("textarea").val(g).focus()
    };
    a.prototype.closeNotes = function() {
        var f = this;
        $(".nota_wrapper").each(function() {
            var g = $(this);
            if (!g.find(".js-save").hasClass("hidden")) {
                f.saveNote(g)
            }
            g.fadeOut().remove()
        })
    };
    a.prototype.saveNote = function(f) {
        var i = f.closest(".rangy-note").get(0);
        var g = this.getHighlightFromDOM(i);
        var h = f.find("textarea").val();
        if (h) {
            h = h.replace(/\n/g, "<br/>");
            g.textNote = h;
            h = blink.tools.urlify(h);
            $(f).find(".js-edit .note-text").html(h);
            $(f).find(".js-save").hideBlink();
            $(f).find(".js-edit").showBlink();
            $(f).find("textarea").blur()
        }
    };
    a.prototype.deleteNote = function(f) {
        var j = this.getPrefix(f),
            h = f.closest(".rangy-note").get(0),
            g = rangy.createRange(),
            i = rangy.getSelection();
        $(h).removeClass("ui-draggable ui-draggable-handle ui-draggable-dragging").removeAttr("style").find(".nota_wrapper").remove();
        g.selectNodeContents(h);
        i.setSingleRange(g);
        this.removeHighlight(j, i)
    };
    a.prototype.deleteAllNotes = function() {
        var f = this;
        $(".rangy-note").each(function() {
            f.deleteNote($(this))
        })
    };
    a.prototype.noteDraggable = function(h, f) {
        var g = this;
        $(f).on("touchstart", function(i) {
            i.stopPropagation()
        }).draggable({
            opacity: 0.5,
            containment: "#" + g.getRootNode(h).id,
            stop: function(k, m) {
                var i = g.getHighlightFromDOM(this, h),
                    o = i.textNote,
                    n = document.caretRangeFromPoint(m.offset.left, m.offset.top),
                    l = rangy.getSelection();
                l.setSingleRange(n);
                rangy.getSelection().expand("character", {
                    wordOptions: {
                        includeTrailingSpace: true
                    }
                });
                var j = g.saveSelectionNote(h, "rangy-note");
                if (j[0]) {
                    j[0].textNote = o;
                    g.deleteNote($(this))
                }
                blink.events.trigger("rangy:disable")
            }
        })
    };
    a.prototype.loadClass = function(k, f, l) {
        var g = {
            ignoreWhiteSpace: true,
            tagNames: ["span", "a"]
        };
        var h = this;
        var j = {
            ignoreWhiteSpace: false,
            tagNames: ["*"]
        };
        var i;
        switch (l) {
            case "highlight":
                i = g;
                break;
            case "note":
                i = j;
                break
        }
        this.workers[k].addClassApplier(rangy.createClassApplier(f, i))
    };
    a.prototype.saveSelectionHighlight = function(j, f) {
        if (!_.has(this.workers[j].classAppliers, f)) {
            this.loadClass(j, f, "highlight")
        }
        var g = {
            containerElementId: this.getRootNode(j).id,
            exclusive: true
        };
        var h = this;
        var l = h.workers[j].highlightSelection(f, g);
        if (l.length > 0) {
            var k = l[0].getHighlightElements();
            h.setBackgroundForSlide(h.getRootNode(j));
            if (!blink.isIos && !blink.isAndroid) {
                var i = rangy.getSelection();
                i.collapseToEnd()
            }
        }
    };
    a.prototype.saveSelectionNote = function(i, f) {
        if (!_.has(this.workers[i].classAppliers, f)) {
            this.loadClass(i, f, "note")
        }
        var g = {
            containerElementId: this.getRootNode(i).id,
            exclusive: true
        };
        var j = this.workers[i].highlightSelection(f, g);
        var h = rangy.getSelection();
        h.collapseToEnd();
        return j
    };
    a.prototype.serialize = function(f) {
        return this.workers[f] ? this.workers[f].serialize() : null
    };
    a.prototype.deserialize = function(h, g) {
        if (!g || !g.serializedString) {
            return
        }
        var f = this;
        $(document).ready(function() {
            var m = g.serializedString.split("|");
            for (var j = m.length, l; j-- > 0;) {
                var l = m[j].split("$");
                if (!_.has(f.workers[h].classAppliers, l[3])) {
                    var k = "highlight";
                    if (l[3] == "note") {
                        k = "note"
                    }
                    f.loadClass(h, l[3], k)
                }
            }
            f.workers[h].deserialize(g.serializedString);
            $.each(g.notes, function() {
                var i = _.findWhere(f.workers[h].highlights, {
                    id: this.id
                });
                i.textNote = this.text
            });
            f.setBackgroundForSlide(f.getRootNode(h))
        })
    };
    a.prototype.calculateAutomaticSelection = function(h, i) {
        var g;
        switch (h) {
            case 1:
                g = rangy.getSelection();
                g.expand("word", {
                    wordOptions: {
                        includeTrailingSpace: false,
                        wordRegex: /[\S]+([\S]+)*/gi
                    }
                });
                break;
            case 2:
                var f = rangy.createRange();
                var j = $(i).parent();
                if (!j.hasClass("js-highlighter-root") && !j.find(".html-book").length && !j.find(".layout-panel").length) {
                    if ($(i).hasClass("setted")) {
                        f.selectNodeContents(j.get(0))
                    } else {
                        f.selectNodeContents(i)
                    }
                }
                g = rangy.getSelection();
                g.setSingleRange(f);
                break
        }
        return g
    };
    a.prototype.getRootNode = function(f) {
        return $("#" + f + "pg").find(".js-highlighter-root").get(0)
    };
    a.prototype.getPrefix = function(f) {
        return $(f).closest(".slide-wrapper").data("prefix")
    };
    a.prototype.getHighlightFromDOM = function(f, g) {
        if (!g) {
            var g = this.getPrefix(f)
        }
        return this.workers[g].getHighlightForElement(f)
    };
    a.prototype.removeHighlight = function(g, f) {
        this.workers[g].unhighlightSelection(f)
    };
    a.prototype.cleanHighlights = function(f) {
        $(f).removeClass("setted").removeAttr("style data-original-title title")
    };
    a.prototype.initPopover = function(h) {
        var i = this.getPrefix(h);
        var f = {
            content: '<button class="highlight-delete js-delete-highlight" data-prefix="' + i + '">' + text_web.highlight_delete + "</button>",
            container: "body",
            toggle: "popover",
            placement: "top auto",
            trigger: "mouseup",
            html: true
        };
        var g = $(h).popover(f);
        $(h).popover("show").addClass("bs-popover");
        blink.popovers.register(g);
        $(".js-delete-highlight").data("elem", h)
    };
    a.prototype.removePopover = function(f) {
        blink.popovers.deregister($(f).popover("hide").removeClass("bs-popover"))
    };
    a.prototype.hideAllPopovers = function() {
        blink.popovers.hideAll();
        $(".setted").removeClass("bs-popover")
    };
    d.highlighter = new a
})(window.blink);;
(function(e) {
    var d = e.tools || {};
    var b = d.tool;
    var c = b.prototype;
    var a = function() {
        b.apply(this, arguments);
        this.enabled = false;
        this.endEvents = ["touchend", "touchout", "mouseup", "mouseout"];
        this.startEvents = ["touchstart", "mousedown"];
        this.buttonId = "boton_notes";
        this.bindStartEvents()
    };
    a.prototype = Object.create(c);
    a.prototype.primaryAction = function() {
        window.selectPizarraColor("boton_notes", 8);
        c.primaryAction.call(this);
        this.bindDrawEvent()
    };
    a.prototype.bindStartEvents = function(f) {
        var g = this;
        $(document).ready(function() {
            $(".js-slider-item").on(g.startEvents.join(" "), blink.tools.closeNotesOnEvent)
        })
    };
    a.prototype.bindDrawEvent = function() {
        $(".canvasdivclass").on(this.endEvents.join(" "), {
            caller: this
        }, this.drawNote)
    };
    a.prototype.unbindDrawEvents = function() {
        $(".canvasdivclass").off(this.endEvents.join(" "), this.drawNote)
    };
    a.prototype.drawNote = function(h) {
        var j = window.getCoordinates(h);
        var i = window.getIndiceStoreDrawing();
        var f = e.tools.getNewID(i);
        var g = {
            x: parseInt(j.x),
            y: parseInt(j.y),
            ID: "note" + i + "_" + f,
            txt: ""
        };
        if (!window.notesArray[i]) {
            window.notesArray[i] = []
        }
        window.notesArray[i].push(g);
        window.selectPizarraColor(this.buttonId, e.tools.NOTE);
        e.tools.drawNote(g, $("#canvas-wrapper"), true, true);
        h.data.caller.unbindDrawEvents();
        h.data.caller.disable()
    };
    a.prototype.disable = function() {
        blink.theme.buttonState.active("#" + this.buttonId, false);
        c.disable.apply(this)
    };
    a.prototype.drawNotes = function(g) {
        var f = $("#canvas-wrapper");
        f.find(".nota_pos").remove();
        _.each(notesArray[g], function(h) {
            e.tools.drawNote(h, f, false, false)
        })
    };
    d.note = new a
})(window.blink);;
(function(f) {
    var e = f.tools || {};
    var c = e.tool;
    var d = c.prototype;
    var b = {
        PENCIL: e.DRAW,
        ERASER: e.ERASER
    };
    var a = function() {
        c.apply(this, arguments);
        this.enabled = false;
        this.defaultColor = e.manager.colors.DARK_BLUE;
        this.color = this.defaultColor.hex;
        var g = 3;
        Object.defineProperty(this, "name", {
            configurable: false,
            enumerable: false,
            writable: false,
            value: "pencil"
        });
        Object.defineProperty(this, "state", {
            configurable: true,
            enumerable: false,
            writable: true,
            value: b.PENCIL
        });
        Object.defineProperty(this, "thickness", {
            configurable: false,
            enumerable: false,
            get: function() {
                return g
            },
            set: function(h) {
                g = parseInt(h, 10) || 1
            }
        });
        this.status = {};
        this.currentStatus = null
    };
    a.prototype = Object.create(d);
    a.prototype.init = function() {
        this.scope = new window.paper.PaperScope();
        var j = this;
        var h = document.getElementById("activity-canvas");
        this.worker = new this.scope.Project(h);
        var k;
        var g = new j.scope.Tool();
        this.setDefaultStatus();
        g.onMouseDown = function(l) {
            if (!j.enabled) {
                return
            }
            if (j.isPencilMode()) {
                k = new window.paper.Path({
                    segments: [l.point],
                    strokeColor: j.color,
                    strokeWidth: j.thickness,
                    fullySelected: false
                })
            }
            l.stopPropagation()
        };
        g.onMouseDrag = function(l) {
            if (!j.enabled) {
                return
            }
            if (j.isPencilMode()) {
                k.add(l.point)
            } else {
                if (l.item) {
                    l.item.remove()
                }
            }
        };
        g.onMouseUp = function(l) {
            if (!j.enabled) {
                return
            }
            j.isPencilMode() && k.simplify(10)
        };
        blink.events.on("section:shown", function(m) {
            var l = ["#boton_rotulador", "#boton_borrador"];
            for (i = 0; i < l.length; i++) {
                if (blink.theme.buttonState.isActive(l[i])) {
                    blink.theme.buttonState.active(l[i], false);
                    blink.tools.pencil.enabled = false
                }
            }
            if (!blink.activity.currentStyle.shouldCleanCanvasOnSectionChange()) {
                return
            }
            if (j.currentStatus !== null) {
                j.saveStatus(j.currentStatus)
            }
            j.currentStatus = m;
            j.worker.clear();
            j.loadStatus(m);
            j.worker.activate()
        })
    };
    a.prototype.setWidthToAllCanvas = function(g) {
        this.worker.view.setViewSize({
            width: g,
            heigth: 0
        })
    };
    a.prototype.setCanvasSize = function(l, g, k) {
        var h = this.worker.view,
            j = h.getSize();
        j.setHeight(g);
        j.setWidth(k);
        h.setViewSize(j)
    };
    a.prototype.setCanvasHeight = function(k, g) {
        var h = this.worker.view,
            j = h.getSize();
        j.setHeight(g);
        h.setViewSize(j)
    };
    a.prototype.primaryAction = function() {
        if (this.state === b.PENCIL) {
            d.primaryAction.call(this)
        } else {
            this.state = b.PENCIL;
            this.disable();
            this.enable()
        }
    };
    a.prototype.secondaryAction = function() {
        if (this.state == b.ERASER) {
            d.primaryAction.call(this)
        } else {
            this.state = b.ERASER;
            this.disable();
            this.enable()
        }
    };
    a.prototype.isPencilMode = function() {
        return this.state == b.PENCIL
    };
    a.prototype.isEraserMode = function() {
        return this.state == b.ERASER
    };
    a.prototype.enableBlackboard = function() {
        blink.theme.selectPizarraColor(undefined, this.state)
    };
    a.prototype.disableBlackboard = function() {
        blink.theme.setPizarraOff(false)
    };
    a.prototype.enable = function() {
        d.enable.apply(this);
        this.enableBlackboard()
    };
    a.prototype.disable = function() {
        this.disableBlackboard();
        d.disable.apply(this)
    };
    a.prototype.getStatus = function(g) {
        if (g === this.currentStatus) {
            this.saveStatus(g)
        }
        return this.status[g] || {}
    };
    a.prototype.setStatus = function(h, g) {
        this.status[h] = g
    };
    a.prototype.loadStatus = function(g) {
        this.worker.importJSON(this.status[g]);
        this.worker.view.draw()
    };
    a.prototype.saveStatus = function(g) {
        this.status[g] = this.worker.exportJSON({
            asString: false
        })
    };
    a.prototype.clearStatus = function(g) {
        this.status[g] = this.getDefaultStatus()
    };
    a.prototype.getGlobalStatus = function() {
        return {
            color: this.color,
            thickness: this.thickness
        }
    };
    a.prototype.setGlobalStatus = function(g) {
        this.color = g.color;
        this.thickness = g.thickness
    };
    a.prototype.getDefaultStatus = function() {
        return this.defaultStatus
    };
    a.prototype.setDefaultStatus = function() {
        this.defaultStatus = this.worker.exportJSON({
            asString: false
        })
    };
    e.pencil = new a
})(window.blink);;
(function(g) {
    var e = g.tools || {};
    var c = e.tool;
    var d = c.prototype;
    var a;
    var f;
    var b = function() {
        c.apply(this, arguments);
        this.enabled = false;
        Object.defineProperty(this, "name", {
            enumerable: true,
            value: "Timer"
        });
        Object.defineProperty(this, "downTime", {
            enumerable: true,
            writable: true,
            value: 300
        });
        Object.defineProperty(this, "containerSelector", {
            value: "body"
        });
        Object.defineProperty(this, "mode", {
            enumerable: true,
            writable: true,
            value: "count-down"
        });
        Object.defineProperty(this, "leftPosX", {
            writable: true,
            value: "40px"
        });
        Object.defineProperty(this, "topPosY", {
            writable: true,
            value: "85px"
        });
        Object.defineProperty(this, "timeCountDown", {
            enumerable: true,
            writable: true,
            value: this.downTime
        });
        Object.defineProperty(this, "timeCountUp", {
            enumerable: true,
            writable: true,
            value: null
        });
        Object.defineProperty(this, "timeCountDownStartTime", {
            enumerable: true,
            writable: true,
            value: this.downTime
        });
        Object.defineProperty(this, "intervalSecond", {
            writable: true,
            value: null
        })
    };
    b.prototype = Object.create(d);
    b.prototype.init = function() {
        var h = '<div id="blink-timer" class="hidden"><div class="timer-bar"><span><i class="fa fa-clock-o"></i> ' + text_web.tool_timer + '</span><button class="fa fa-times timer-bar__close"></button></div><div class="timer-container"><div class="timer-count__background"></div><div class="timer-tabs"><button class="timer-tabs__count-down active">' + text_web.timer_count_down + '</button><button class="timer-tabs__count-up">' + text_web.timer_count_up + '</button></div><div class="timer-count-number"><div class="timer-count-number__col-minutes"><button class="plus fa fa-plus"></button><button class="minus fa fa-minus"></button></div><div class="timer-count-number__col-time"></div><div class="timer-count-number__col-seconds"><button class="plus fa fa-plus"></button><button class="minus fa fa-minus"></button></div></div></div><div class="timer-buttons"><button class="timer-buttons__start">Start</button><button class="timer-buttons__reset hidden"><span class="fa fa-undo"></span>Reset</button><button class="timer-buttons__pause hidden"><span class="fa fa-pause"></span>Pause</button><button class="timer-buttons__play hidden"><span class="fa fa-play"></span>Continue</a></div></div>';
        if (!$("#blink-timer").length) {
            $(this.containerSelector).append(h)
        }
        a = "timer" + blink.user.getID();
        if (blink.localStorage.isAvailable()) {
            if (typeof(blink.localStorage.get(a)) !== "undefined" && blink.localStorage.get(a) !== null) {
                f = JSON.parse(blink.localStorage.get(a))
            } else {
                f = {}
            }
            if (f.leftPosX) {
                this.leftPosX = f.leftPosX
            }
            if (f.topPosY) {
                this.topPosY = f.topPosY
            }
            if (f.timeCountDownStartTime) {
                this.timeCountDownStartTime = Number(f.timeCountDownStartTime)
            }
            if (f.timeCountDown) {
                this.timeCountDown = Number(f.timeCountDown)
            } else {
                if (f.timeCountDownStartTime) {
                    this.timeCountDown = Number(f.timeCountDownStartTime)
                }
            }
            if (f.mode) {
                if (f.mode == "count-down-play" && f.timeCountDown) {
                    this.modeChange("count-down-pause");
                    this.timeCountDown = Number(f.timeCountDown);
                    $("#blink-timer .timer-count__background").width(100 - Math.round(this.timeCountDown * 100 / this.timeCountDownStartTime) + "%");
                    this.doNext()
                } else {
                    if (f.mode == "count-down-pause" && f.timeCountDown) {
                        this.modeChange("count-down-pause");
                        this.timeCountDown = Number(f.timeCountDown);
                        $("#blink-timer .timer-count__background").width(100 - Math.round(this.timeCountDown * 100 / this.timeCountDownStartTime) + "%");
                        this.showTime(this.timeCountDown)
                    } else {
                        if (f.mode == "count-up") {
                            this.modeChange("count-up")
                        } else {
                            if (f.mode == "count-up-play" && f.timeCountUp) {
                                this.modeChange("count-up-pause");
                                this.timeCountUp = Number(f.timeCountUp);
                                this.doNext()
                            } else {
                                if (f.mode == "count-up-pause" && f.timeCountUp) {
                                    this.modeChange("count-up-pause");
                                    this.timeCountUp = Number(f.timeCountUp);
                                    this.showTime(this.timeCountUp)
                                } else {
                                    if (f.timeCountDown) {
                                        this.timeCountDown = Number(f.timeCountDown)
                                    }
                                    this.showTime(this.timeCountDown)
                                }
                            }
                        }
                    }
                }
            } else {
                if (f.timeCountDown) {
                    this.timeCountDown = Number(f.timeCountDown)
                }
                this.showTime(this.timeCountDown)
            }
        } else {
            this.showTime(this.timeCountDown)
        }
        $("#blink-timer").blinkDraggable().css({
            position: "absolute",
            left: this.leftPosX,
            top: this.topPosY
        });
        this.events()
    };
    b.prototype.minuteUp = function() {
        this.timeCountDown += 60;
        if (this.timeCountDown > 100 * 60 - 1) {
            this.timeCountDown = 100 * 60 - 1
        }
        this.timeCountDownStartTime = this.timeCountDown;
        this.setStorage("setDown");
        this.setStorage("setDownStartTime");
        this.showTime(this.timeCountDown)
    };
    b.prototype.minuteDown = function() {
        this.timeCountDown -= 60;
        if (this.timeCountDown < 0) {
            this.timeCountDown = 0
        }
        this.timeCountDownStartTime = this.timeCountDown;
        this.setStorage("setDown");
        this.setStorage("setDownStartTime");
        this.showTime(this.timeCountDown)
    };
    b.prototype.secondUp = function() {
        this.timeCountDown += 1;
        if (this.timeCountDown > 100 * 60 - 1) {
            this.timeCountDown = 100 * 60 - 1
        }
        this.timeCountDownStartTime = this.timeCountDown;
        this.setStorage("setDown");
        this.setStorage("setDownStartTime");
        this.showTime(this.timeCountDown)
    };
    b.prototype.secondDown = function() {
        this.timeCountDown -= 1;
        if (this.timeCountDown < 0) {
            this.timeCountDown = 0
        }
        this.timeCountDownStartTime = this.timeCountDown;
        this.setStorage("setDown");
        this.setStorage("setDownStartTime");
        this.showTime(this.timeCountDown)
    };
    b.prototype.modeChange = function(i) {
        var h = this;
        h.mode = i;
        $("#blink-timer").removeClass("blink-timer--count-down-active blink-timer--count-down-active-play blink-timer--count-down-active-pause blink-timer--count-down-active-finish blink-timer--count-up-active blink-timer--count-up-active-play blink-timer--count-up-active-pause");
        $("#blink-timer .timer-count-number__col-time").removeClass("blink");
        switch (h.mode) {
            case "count-down":
                $("#blink-timer").addClass("blink-timer--count-down-active");
                $("#blink-timer .timer-count__background").width("0%");
                $("#blink-timer .timer-tabs__count-up").removeClass("active");
                $("#blink-timer .timer-tabs__count-down").addClass("active");
                $("#blink-timer .timer-buttons button").hideBlink();
                $("#blink-timer .timer-buttons__start, #blink-timer .timer-count-number button").showBlink();
                clearInterval(h.intervalSecond);
                h.showTime(h.timeCountDown);
                h.setStorage("clear");
                break;
            case "count-down-play":
                $("#blink-timer").addClass("blink-timer--count-down-active-play");
                $("#blink-timer .timer-tabs__count-up").removeClass("active");
                $("#blink-timer .timer-tabs__count-down").addClass("active");
                $("#blink-timer .timer-buttons button, #blink-timer .timer-count-number button").hideBlink();
                $("#blink-timer .timer-buttons__reset, #blink-timer .timer-buttons__pause").showBlink();
                h.intervalSecond = setInterval(function() {
                    h.intervalAction("down")
                }, 1000);
                break;
            case "count-down-pause":
                $("#blink-timer").addClass("blink-timer--count-down-active-pause");
                $("#blink-timer .timer-tabs__count-up").removeClass("active");
                $("#blink-timer .timer-tabs__count-down").addClass("active");
                $("#blink-timer .timer-buttons button").hideBlink();
                $("#blink-timer .timer-buttons__reset, #blink-timer .timer-buttons__play, #blink-timer .timer-count-number button").showBlink();
                clearInterval(h.intervalSecond);
                break;
            case "count-down-finish":
                $("#blink-timer").addClass("blink-timer--count-down-active-finish");
                $("#blink-timer .timer-tabs__count-up").removeClass("active");
                $("#blink-timer .timer-tabs__count-down").addClass("active");
                $("#blink-timer .timer-count__background").width("100%");
                $("#blink-timer .timer-count-number__col-time").addClass("blink");
                $("#blink-timer .timer-buttons button, #blink-timer .timer-count-number button").hideBlink();
                $("#blink-timer .timer-buttons__reset").showBlink();
                clearInterval(h.intervalSecond);
                h.show();
                h.setStorage("setDownStartTime");
                break;
            case "count-up":
                $("#blink-timer").addClass("blink-timer--count-up-active");
                $("#blink-timer .timer-count__background").width("0%");
                $("#blink-timer .timer-tabs__count-down").removeClass("active");
                $("#blink-timer .timer-tabs__count-up").addClass("active");
                $("#blink-timer .timer-buttons button, #blink-timer .timer-count-number button").hideBlink();
                $("#blink-timer .timer-buttons__start").showBlink();
                clearInterval(h.intervalSecond);
                h.timeCountUp = 0;
                h.showTime(h.timeCountUp);
                h.setStorage("clear");
                break;
            case "count-up-play":
                $("#blink-timer").addClass("blink-timer--count-up-active-play");
                $("#blink-timer .timer-tabs__count-down").removeClass("active");
                $("#blink-timer .timer-tabs__count-up").addClass("active");
                $("#blink-timer .timer-buttons button, #blink-timer .timer-count-number button").hideBlink();
                $("#blink-timer .timer-buttons__reset, #blink-timer .timer-buttons__pause").showBlink();
                h.intervalSecond = setInterval(function() {
                    h.intervalAction("up")
                }, 1000);
                break;
            case "count-up-pause":
                $("#blink-timer").addClass("blink-timer--count-up-active-pause");
                $("#blink-timer .timer-tabs__count-down").removeClass("active");
                $("#blink-timer .timer-tabs__count-up").addClass("active");
                $("#blink-timer .timer-buttons button, #blink-timer .timer-count-number button").hideBlink();
                $("#blink-timer .timer-buttons__reset, #blink-timer .timer-buttons__play").showBlink();
                clearInterval(h.intervalSecond);
                break;
            default:
        }
        h.setStorage("setMode");
        h.setStorage("setDownStartTime")
    };
    b.prototype.start = function() {
        if (this.mode == "count-down") {
            $("#blink-timer .timer-count__background").width("0%");
            this.modeChange("count-down-play");
            this.timeCountDownStartTime = this.timeCountDown;
            this.setStorage("setDownStartTime")
        } else {
            if (this.mode == "count-up") {
                this.modeChange("count-up-play")
            }
        }
    };
    b.prototype.pause = function() {
        if (this.mode == "count-down-play") {
            this.modeChange("count-down-pause")
        } else {
            if (this.mode == "count-up-play") {
                this.modeChange("count-up-pause")
            }
        }
    };
    b.prototype.doNext = function() {
        if (this.mode == "count-down-pause") {
            this.modeChange("count-down-play")
        } else {
            if (this.mode == "count-up-pause") {
                this.modeChange("count-up-play")
            }
        }
    };
    b.prototype.reset = function() {
        if (this.mode == "count-down-play" || this.mode == "count-down-pause" || this.mode == "count-down-finish") {
            this.timeCountDown = this.timeCountDownStartTime;
            this.modeChange("count-down")
        } else {
            if (this.mode == "count-up-play" || this.mode == "count-up-pause") {
                this.timeCountUp = 0;
                this.modeChange("count-up")
            }
        }
        this.setStorage("clear")
    };
    b.prototype.intervalAction = function(h) {
        if (h == "down") {
            if (this.timeCountDown > 0) {
                this.timeCountDown--
            } else {
                clearInterval(this.intervalSecond);
                this.modeChange("count-down-finish")
            }
            $("#blink-timer .timer-count__background").width(100 - Math.round(this.timeCountDown * 100 / this.timeCountDownStartTime) + "%");
            this.showTime(this.timeCountDown);
            this.setStorage("setDown")
        } else {
            if (h == "up") {
                if (this.timeCountUp < 100 * 60 - 1) {
                    this.timeCountUp++
                } else {
                    clearInterval(this.intervalSecond);
                    $("#blink-timer .timer-count-number__col-time").addClass("blink")
                }
                this.showTime(this.timeCountUp);
                this.setStorage("setUp")
            }
        }
    };
    b.prototype.show = function() {
        blink.events.trigger("widget:widgetShows", "Timer");
        if (this.externalTimer) {
            this.externalTimer.show()
        } else {
            $("#blink-timer").showBlink()
        }
    };
    b.prototype.hide = function(h) {
        if (this.externalTimer) {
            this.externalTimer.hide()
        } else {
            $("#blink-timer").hideBlink()
        }
        var i = h || false;
        if (!i) {
            blink.events.trigger("widget:widgetHides")
        }
    };
    b.prototype.toggle = function() {
        if (!this.isActive()) {
            blink.events.trigger("widget:widgetShows", "Timer")
        }
        if (this.externalTimer) {
            this.externalTimer.toggle()
        } else {
            $("#blink-timer").toggleBlink()
        }
        if (!this.isActive()) {
            blink.events.trigger("widget:widgetHides", "Timer")
        }
    };
    b.prototype.isActive = function() {
        return this.externalTimer ? this.externalTimer.isActive() : !$("#blink-timer").hasClass("hidden")
    };
    b.prototype.secondsToStringTime = function(i) {
        var j = Math.floor(i / 60).toString();
        while (j.length < 2) {
            j = "0" + j
        }
        var h = i % 60;
        h = h.toString();
        while (h.length < 2) {
            h = "0" + h
        }
        return j + " : " + h
    };
    b.prototype.showTime = function(h) {
        $("#blink-timer .timer-count-number__col-time").text(this.secondsToStringTime(h))
    };
    b.prototype.setStorage = function(h) {
        if (blink.localStorage.isAvailable()) {
            switch (h) {
                case "onStopDragDraggable":
                    f.leftPosX = $("#blink-timer").css("left");
                    f.topPosY = $("#blink-timer").css("top");
                    break;
                case "clear":
                    if (f.timerCountDown) {
                        delete f.timerCountDown
                    }
                    if (f.timerCountUp) {
                        delete f.timerCountUp
                    }
                    break;
                case "setDown":
                    if (f.timerCountUp) {
                        delete f.timerCountUp
                    }
                    f.timeCountDown = this.timeCountDown;
                    break;
                case "setDownStartTime":
                    f.timeCountDownStartTime = this.timeCountDownStartTime;
                    break;
                case "setUp":
                    if (f.timerCountDown) {
                        delete f.timerCountDown
                    }
                    f.timeCountUp = this.timeCountUp;
                    break;
                case "setMode":
                    f.mode = this.mode;
                    break;
                default:
            }
            blink.localStorage.set(a, JSON.stringify(f))
        }
    };
    b.prototype.events = function() {
        var h = this;
        blink.events.on("onStopDragDraggable", function() {
            h.setStorage("onStopDragDraggable")
        });
        $("#blink-timer .timer-tabs__count-up").mousedown(function() {
            h.modeChange("count-up")
        });
        $("#blink-timer .timer-tabs__count-down").mousedown(function() {
            h.modeChange("count-down")
        });
        $("#blink-timer .timer-count-number__col-minutes .plus").mousedown(function() {
            h.minuteUp();
            h.plusMinusCounter = 0;
            h.plusMinusInterval = setInterval(function() {
                if (h.plusMinusCounter++ > 3) {
                    h.minuteUp()
                }
            }, 100)
        });
        $("#blink-timer .timer-count-number__col-minutes button.minus").mousedown(function() {
            h.minuteDown();
            h.plusMinusCounter = 0;
            h.plusMinusInterval = setInterval(function() {
                if (h.plusMinusCounter++ > 3) {
                    h.minuteDown()
                }
            }, 100)
        });
        $("#blink-timer .timer-count-number__col-seconds button.plus").mousedown(function() {
            h.secondUp();
            h.plusMinusCounter = 0;
            h.plusMinusInterval = setInterval(function() {
                if (h.plusMinusCounter++ > 3) {
                    h.secondUp()
                }
            }, 100)
        });
        $("#blink-timer .timer-count-number__col-seconds button.minus").mousedown(function() {
            h.secondDown();
            h.plusMinusCounter = 0;
            h.plusMinusInterval = setInterval(function() {
                if (h.plusMinusCounter++ > 3) {
                    h.secondDown()
                }
            }, 100)
        });
        $("#blink-timer .timer-count-number button").mouseup(function() {
            clearInterval(h.plusMinusInterval)
        }).mouseleave(function() {
            clearInterval(h.plusMinusInterval)
        });
        $("#blink-timer .timer-bar__close").mousedown(function() {
            h.hide()
        });
        $("#blink-timer .timer-buttons__start").mousedown(function() {
            h.start()
        });
        $("#blink-timer .timer-buttons__pause").mousedown(function() {
            h.pause()
        });
        $("#blink-timer .timer-buttons__play").mousedown(function() {
            h.doNext()
        });
        $("#blink-timer .timer-buttons__reset").mousedown(function() {
            h.reset()
        })
    };
    e.timer = new b()
})(window.blink);
$(document).ready(function() {
    $(document).on("documentLoaded", function() {
        if (bpdf.libroJSON.activateTimerTool == 1) {
            blink.tools.timer.init()
        }
    })
});;
(function(a) {
    a.widgetManager = {
        widgets: [a.lateralToc, a.tools.timer]
    };
    a.events.on("widget:widgetShows", function(b) {
        var e = false;
        for (var c = 0; c < a.widgetManager.widgets.length; c++) {
            if (a.widgetManager.widgets[c].isActive() && a.widgetManager.widgets[c].name !== b) {
                var d = a.widgetManager.widgets[c];
                d.hide(true);
                e = true
            }
        }
        if (!e) {
            if (a.isApp && !a.isOfflinePC) {
                a.restApp.showWebView(1)
            }
            $(".widgetBackground").show()
        }
    });
    a.events.on("widget:widgetHides", function() {
        for (var b = 0; b < a.widgetManager.widgets.length; b++) {
            if (a.widgetManager.widgets[b].isActive()) {
                var c = a.widgetManager.widgets[b];
                c.hide(true)
            }
        }
        $(".widgetBackground").hide();
        if (a.isApp && !a.isOfflinePC) {
            a.restApp.showWebView(0)
        }
    })
})(blink);
$(document).ready(function() {
    $('<div class="widgetBackground"></div>').insertBefore(".spinner");
    $(".libro-right.toolbar a:not(#tool-timer), .widgetBackground").click(function() {
        blink.events.trigger("widget:widgetHides")
    })
});;
(function(a) {
    var b = {};
    var c = {};
    a.isCourseJSONCached = function(d) {
        return (b[d] !== undefined)
    };
    a.getCourse = function(e) {
        var d = b[e];
        if (d) {
            return d
        } else {
            b[e] = a.getJSON("/coursePlayer/curso_json.php?idcurso=" + e, function() {}, {
                cache: true,
                method: "GET"
            });
            return b[e]
        }
    };
    a.getActivity = function(d, f) {
        var e = c[f];
        if (e) {
            return new jQuery.Deferred().resolve(e)
        } else {
            return a.getCourse(d).pipe(function(m) {
                var l = _.reduce(m.units, function(o, n) {
                    return o.concat(n.subunits)
                }, []);
                var j = _.reduce(m.units, function(o, n) {
                    return o.concat(n.resources)
                }, []);
                var k = $.merge(j, l);
                var h = _.pluck(k, "id"),
                    g = _.indexOf(h, "" + f),
                    i = k[g];
                c[f] = i;
                return i
            })
        }
    };
    a.reorderBooks = function(e) {
        var d = {};
        d.ordenarpor = e;
        d.ordenlibros = {};
        d.lastID = 0;
        $(".list-items.books").each(function(j, h) {
            var f = $(this).find("li");
            f.sort(function(l, i) {
                if (e == "sortByNameASC" || e == "sortByNameDESC") {
                    var l = l.getAttribute("data-nombre").toUpperCase();
                    var i = i.getAttribute("data-nombre").toUpperCase()
                }
                if (e == "sortByFechaASC" || e == "sortByFechaDESC") {
                    var l = moment(l.getAttribute("data-fecha-ult-modif"), "YYYY-MM-DD HH:mm").toDate();
                    var i = moment(i.getAttribute("data-fecha-ult-modif"), "YYYY-MM-DD HH:mm").toDate()
                }
                if (l < i) {
                    return -1
                }
                if (l > i) {
                    return 1
                }
                return 0
            });
            if (e == "sortByNameDESC" || e == "sortByFechaDESC") {
                f = f.get().reverse()
            }
            var g = new Array();
            $.each(f, function(l, i) {
                g.push(i.getAttribute("data-id"))
            });
            a.updateCategoriesCounters(h, g);
            var k = $(h).parent().find(".title-buttons .title").attr("data-title");
            d.ordenlibros[h.getAttribute("data-id")] = {};
            d.ordenlibros[h.getAttribute("data-id")]["title"] = k;
            d.ordenlibros[h.getAttribute("data-id")]["libros"] = g;
            if (h.getAttribute("data-id") > d.lastID) {
                d.lastID = h.getAttribute("data-id")
            }
            $(this).html(f)
        });
        return d
    };
    a.reorganizeBooks = function(e) {
        var d = [];
        $.each(e, function(g, f) {
            var h = ".list-items.books[data-id='" + g + "']";
            d.push(parseInt(g));
            if ($(h).length <= 0) {
                a.createNewSection(f.title, g)
            }
            if (f.libros.length > 0) {
                $.each(f.libros, function(i, k) {
                    $(".list-items.books:not([data-id='0']) li[data-id='" + k + "']").detach().appendTo(h)
                })
            }
        });
        $.each($(".list-items.books"), function(f, g) {
            if ($(g).find("li").length <= 0 && $("#editar_contenido.active").length <= 0) {
                $(g).parent().addClass("hidden")
            }
        })
    };
    a.createNewSection = function(e, f) {
        var d = '<div class="items-section"><div class="title-buttons "><div class="btn-group"><button type="button" class="btn btn-primary title disabled" data-title="' + e + '">' + e + ' </button><button type="button" class="btn delete_category hidden" data-id="' + f + '"><i class="blinkicon-close"></i> <span>' + text_web["delete.category"] + '</span></button><button type="button" class="btn edit_category hidden"><i class="blinkicon-edit"></i> <span>' + text_web.activities_edit + '</span></button></div></div><ul class="list-items books" data-id="' + f + '"></ul></div>';
        $(d).prependTo(".items.cursos");
        if ($("#editar_contenido.active").length > 0) {
            $('.list-items.books[data-id="' + f + '"]').closest(".items-section").find(".edit_category, .delete_category").removeClass("hidden")
        }
    };
    a.updateCategoriesCounters = function(e, d) {
        if ($(e).parent().find(".title-buttons .btn-primary .cantidad").length <= 0) {
            var f = $(e).parent().find(".title-buttons .title");
            f.html(f.html() + "(<span class='cantidad'>" + d.length + "</span>)")
        } else {
            var f = $(e).parent().find(".title-buttons .title");
            f.html(f.html().substring(0, f.html().indexOf("(")) + "(<span class='cantidad'>" + d.length + "</span>)")
        }
    };
    showCourseGrades = function(e, d) {
        a.theme.spinner.show();
        a.ajax("/LMS/fichaalumno.php?idalumno=" + e + "&idcurso=" + d + "&fromcourse", function(f) {
            var g = formatCourseGrades(f);
            $(".calificaciones").parent().toggleClass("hidden");
            $(".cerrar-calificaciones").parent().toggleClass("hidden");
            $(".content-wrapper.libro").first().before(g).css("display", "none");
            a.theme.spinner.count && a.theme.spinner.hide()
        })
    };
    formatCourseGrades = function(f) {
        var d, e;
        d = f.substring(f.indexOf('<div class="content-wrapper">'), f.indexOf("<script>blink.events.trigger('endOfDocument');<\/script>"));
        e = $('<div class="grade-container">' + d + "</div>");
        e.find(".footer").remove();
        e.find(".content-main-tabs").remove();
        return e
    };
    closeCourseGrades = function() {
        var d = $(".grade-container");
        $(".calificaciones").parent().toggleClass("hidden");
        $(".cerrar-calificaciones").parent().toggleClass("hidden");
        $(".content-wrapper.libro").attr("style", "");
        $(d).css("height", 0).remove()
    }
})(blink);;
(function(a) {
    a.Pictures = {
        goFullScreen: function(f, k) {
            var c = [],
                i = $(".pswp").get(0),
                p, j = f.first().closest(".blink-gallery"),
                o = {
                    index: k || 0,
                    getThumbBoundsFn: a.Pictures.getThumbBoundsFn,
                    showHideOpacity: true,
                    history: false,
                    shareEl: false,
                    counterEl: false,
                    closeOnScroll: false,
                    arrowEl: true
                };
            if (f.hasClass("bck-i-fullscreen") || f.closest("figure").hasClass("bck-i-fullscreen")) {
                if (f.is("img")) {
                    var b = f,
                        e = ""
                } else {
                    var b = f.find("img"),
                        h = $("figcaption", f),
                        e = h.text()
                }
                var g = new Image();
                g.src = b.attr("src");
                var m = g.naturalWidth,
                    l = g.naturalHeight,
                    d = b.data("width") || m,
                    n = b.data("height") || l;
                c.push({
                    src: b.attr("src"),
                    msrc: b.attr("src"),
                    history: false,
                    w: d,
                    h: n,
                    title: e
                })
            } else {
                if (f.is("img")) {
                    var b = f,
                        h = $(".base_foto", f),
                        e = h.text();
                    var g = new Image();
                    g.src = b.attr("src");
                    var m = g.naturalWidth,
                        l = g.naturalHeight,
                        d = b.data("width") || m,
                        n = b.data("height") || l;
                    c.push({
                        src: g.src,
                        msrc: g.src,
                        history: false,
                        w: d,
                        h: n,
                        title: e
                    })
                } else {
                    f.siblings().andSelf().addClass("blink-fullscreen-active").each(function(w, y) {
                        var t = $(y),
                            q = $("img", t),
                            v = $(".base_foto", t),
                            s = v.text();
                        var u = new Image();
                        u.src = q.attr("src");
                        var z = u.naturalWidth,
                            x = u.naturalHeight,
                            r = q.data("width") || z,
                            A = q.data("height") || x;
                        c.push({
                            src: u.src,
                            msrc: u.src,
                            history: false,
                            w: r,
                            h: A,
                            title: s
                        })
                    })
                }
            }
            p = new PhotoSwipe(i, PhotoSwipeUI_Default, c, o);
            p.listen("destroy", a.Pictures.fullScreenCleanup);
            p.init()
        },
        getThumbBoundsFn: function(b) {
            var e = $(".blink-fullscreen-active, .bck-i-fullscreen").get(b),
                d = window.pageYOffset || document.documentElement.scrollTop,
                c = e.getBoundingClientRect();
            return {
                x: c.left,
                y: c.top + d,
                w: c.width
            }
        },
        fullScreenCleanup: function() {
            $(".blink-fullscreen-active").removeClass("blink-fullscreen-active")
        }
    }
})(window.blink);;

function Attachment(b) {
    this.tmpId = 1;
    this.id = b.data("id");
    this.types = {
        FILE: 1,
        URL: 2,
        ACTIVITY: 3
    };
    this.files = [];
    this.urls = [];
    this.activities = [];
    this.$container = b.find(".js-attachments");
    this.$input = b.find(".js-attachments-input");
    if (!this.$container.length) {
        blink.log.error("Attachment container does not exist.")
    }
    if (!this.$input.length) {
        blink.log.error("Attachment input does not exist.")
    }
    var a = this;
    this.refreshInput = function() {
        a.$input.val("");
        var c = JSON.stringify({
            files: a.files,
            urls: a.urls,
            activities: a.activities
        });
        a.$input.val(c)
    };
    this.del = function(e) {
        var c = $("#msg-" + a.id + "-attach-" + e),
            f = c.data("type"),
            d = c.data("obj_id");
        c.remove();
        if (!a.$container.find(".js-attach").length) {
            a.$container.hideBlink()
        }
        if (f == a.types.FILE) {
            a.delFunc(a.files, d, function(h, g) {
                return h == g
            })
        } else {
            if (f == a.types.URL) {
                a.delFunc(a.urls, d, function(h, g) {
                    return h.id == g
                })
            } else {
                if (f == a.types.ACTIVITY) {
                    a.delFunc(a.activities, d, function(h, g) {
                        return h == g
                    })
                }
            }
        }
    };
    this.delFunc = function(c, f, d) {
        var g = -1;
        for (var e = 0; e < c.length; e++) {
            if (d(c[e], f)) {
                g = e;
                break
            }
        }
        if (g != -1) {
            c.splice(g, 1)
        }
    };
    this.append = function(f, h, e) {
        var d = a.tmpId++,
            c = document.createElement("li"),
            g = $(c);
        c.id = "msg-" + a.id + "-attach-" + d;
        g.addClass("js-attach");
        g.addClass("js-attach-type-" + h);
        g.data({
            type: h,
            id: d,
            obj_id: e
        }).html(f);
        a.$container.showBlink().find("ul").append(c);
        var i = g.find(".js-delete");
        if (!i.length) {
            blink.log.error("Attach delete button does not exists.")
        }
        i.click(function() {
            a.del(d)
        })
    };
    this.onSelectFile = function(e, d, f, c) {
        if (typeof(e) == "object") {
            e = finSeleccionarMultimedia(e, d, "attachfile")
        }
        if (typeof(e) == "string") {
            if (isBlinkUrl(e)) {
                a.getAttachmentFileData(e)
            } else {
                getAJAX("/LMS/ajax.php?op=setcontentbyurl&url=" + encodeURIComponent(e), function(h) {
                    if (h.startsWith("OK")) {
                        var g = JSON.parse(h.substr(2));
                        a.getAttachmentFileData(g.url)
                    } else {
                        standardAJAX(h)
                    }
                })
            }
        } else {
            blink.log.warning("error")
        }
    };
    this.getAttachmentFileData = function(c) {
        getAJAX("/LMS/ajax.php?op=attach.getAttachmentData&type=file&path=" + encodeURIComponent(c), function(e) {
            if (e.startsWith("OK")) {
                var d = JSON.parse(e.substr(2));
                a.files.push(d.obj_id);
                a.append(d.html, a.types.FILE, d.obj_id);
                closeMsgBox()
            } else {
                standardAJAX(e)
            }
        })
    };
    this.onSelectAudioRecorder = function(c) {
        return a.onSelectFile("/useruploads/tmp/" + c.substring(2), false, false, false)
    };
    this.onCreateURL = function(c, d) {
        var c = "/LMS/ajax.php?op=attach.getAttachmentData&type=url&url=" + encodeURIComponent(c) + "&desc=" + encodeURIComponent(d),
            e = function(g) {
                if (g.startsWith("OK")) {
                    var f = JSON.parse(g.substr(2));
                    a.urls.push({
                        id: f.obj_id,
                        desc: d
                    });
                    a.append(f.html, a.types.URL, f.obj_id);
                    closeMsgBox()
                } else {
                    standardAJAX(g)
                }
            };
        blink.ajax(c, e)
    };
    this.onSelectActivity = function(c) {
        getAJAX("/LMS/ajax.php?op=attach.getAttachmentData&type=activity&id=" + c, function(e) {
            if (e.startsWith("OK")) {
                var d = JSON.parse(e.substr(2));
                a.activities.push(c);
                a.append(d.html, a.types.ACTIVITY, d.obj_id);
                closeMsgBox()
            } else {
                standardAJAX(e)
            }
        })
    };
    this.onAfterSendMessage = function() {
        a.$input.val("");
        a.$container.hideBlink().find("ul").html("");
        a.tmp_id = 1;
        a.files = [];
        a.urls = [];
        a.activities = []
    }
}

function getAttachmentObjectName(c) {
    var a = c.closest(".js-message-wrapper"),
        b = a.data("id");
    if (!window.attachments[b]) {
        window.attachments[b] = new Attachment(a)
    }
    return "attachments[" + b + "]"
};;

function Destinatarios(a, b) {
    var c = this;
    this.element = $(a);
    this.idgrupohilo = b;
    this.input = this.element.find("input:eq(0)");
    if (this.element.length != 1 || this.input.length != 1) {
        blink.log.error("Elemento destinatarios mal construido");
        return
    }
    this.placeholder_singular = this.input.data("placeholder-singular");
    this.placeholder_plural = this.input.attr("placeholder");
    this.notIDs = [
        [],
        []
    ];
    this.types = {
        GRUPO: 0,
        PROFESOR: 1,
        ALUMNO: 2,
        PADRE: 3
    };
    this.clear = function() {
        this.notIDs = [
            [],
            []
        ];
        this.input.val("");
        $(".destinatario", this.element).remove()
    };
    this.getNotIDsByType = function(d) {
        return this.notIDs[parseInt(d) ? 1 : 0]
    };
    this.del = function(f) {
        var e = $(f).parent().data("type");
        var g = $(f).parent().data("id");
        var d = this.getNotIDsByType(e).indexOf(g);
        this.getNotIDsByType(e).splice(d, 1);
        $(f).parent().remove();
        this.refreshInput()
    };
    this.add = function(d, g, e) {
        if (this.getNotIDsByType(d).indexOf(g) != -1) {
            return
        }
        this.getNotIDsByType(d).push(g);
        this.input.val("");
        this.input.focus();
        var f = $('<div class="destinatario" data-id="' + g + '" data-type="' + d + '"><span class="nombre">' + e + '</span> <span class="borrar"></span></div>');
        f.find(".borrar").click(function() {
            c.del(this)
        });
        this.input.before(f);
        this.refreshInput()
    };
    this.refreshInput = function() {
        var d = this.element.find(".destinatario").length ? this.placeholder_singular : this.placeholder_plural;
        if (d != this.input.attr("placeholder")) {
            this.input.attr("placeholder", d)
        }
    };
    this.clearSelectedToDelete = function() {
        this.element.find(".destinatario.selected").removeClass("selected")
    };
    this.getGroupsIDs = function() {
        var d = [];
        this.element.find(".destinatario").each(function(e, f) {
            if ($(this).data("type") == 0) {
                d.push($(this).data("id"))
            }
        });
        return d
    };
    this.getUsersIDs = function() {
        var d = [];
        this.element.find(".destinatario").each(function(e, f) {
            if ($(this).data("type") > 0) {
                d.push($(this).data("id"))
            }
        });
        return d
    };
    this.bindInputWrapperEvents = function() {
        $(this.element).click(function(d) {
            $(this).children("input").focus()
        });
        $(this.element).children("input").on("focus", function(d) {
            c.element.addClass("highligth")
        }).on("blur", function(d) {
            c.element.removeClass("highligth")
        })
    };
    this.input.catcomplete({
        minLength: 2,
        position: { of: c.element
        },
        open: function() {
            setTimeout(function() {
                $(".ui-autocomplete").css("z-index", 9999)
            }, 0)
        },
        source: function(f, d) {
            var e = "/LMS/ajax.php?op=searchall";
            e += "&term=" + encodeURIComponent(f.term);
            e += "&notIDs_groups=" + encodeURIComponent(c.notIDs[0].join(","));
            e += "&notIDs_users=" + encodeURIComponent(c.notIDs[1].join(","));
            if (c.idgrupohilo > 0) {
                e += "&idgrupohilo=" + encodeURIComponent(c.idgrupohilo)
            }
            var g = function(h) {
                if (!h) {
                    h = "ERROR"
                }
                if (h.startsWith("ERROR")) {
                    if (!blink.isApp) {
                        standardAJAX(h)
                    }
                } else {
                    if (typeof(h) == "string") {
                        h = jQuery.parseJSON(h)
                    }
                    if (h.length == 0) {
                        h = [{
                            category: text_web.destinatarios_no_results
                        }]
                    }
                    if (h) {
                        d(h)
                    } else {
                        if (!blink.isApp) {
                            standardAJAX("ERROR")
                        }
                    }
                }
            };
            blink.ajax(e, g, {}, {
                waitingElement: "#waitingImage"
            })
        },
        select: function(d, e) {
            c.add(e.item.type, e.item.id, e.item.value);
            return false
        }
    })
};;

function DestinatariosTagsInputObj(f, e) {
    var a = f.selector,
        c = f.selectortagsinput,
        b = f.idgrupohilo;
    e.add = function(g, i, h) {
        $(c).tagsinput("add", {
            value: i,
            text: h,
            type: g
        });
        this.input.val("")
    };
    e.getIDs = function(l) {
        var j = $(c).tagsinput("items"),
            h = [];
        for (var k = 0, g = j.length; k < g; k++) {
            if (j[k].type === l) {
                h.push(j[k].value + ":" + j[k].type)
            }
        }
        return h
    };
    e.getGroupsIDs = function() {
        return this.getIDs(this.types.GRUPO)
    };
    e.getUsersIDs = function() {
        var g = [];
        g = g.concat(this.getIDs(this.types.PROFESOR));
        g = g.concat(this.getIDs(this.types.ALUMNO));
        g = g.concat(this.getIDs(this.types.PADRE));
        return g
    };
    e.input.on("drop", function(g) {
        g.preventDefault();
        g.stopPropagation()
    }).on("input paste", function() {
        e.refreshInput()
    }).focusout(function() {
        e.clearSelectedToDelete()
    }).keydown(function(h) {
        e.refreshInput();
        var g = (h.keyCode ? h.keyCode : h.which);
        if (g != 8) {
            destinatarios.clearSelectedToDelete()
        }
    }).keyup(function(h) {
        if ($(this).val().length == 0) {
            var g = (h.keyCode ? h.keyCode : h.which);
            if (g == 8) {
                if (e.element.find(".destinatario.selected").length > 0) {
                    e.element.find(".destinatario.selected").find("span").click()
                } else {
                    e.element.find(".destinatario").last().addClass("selected")
                }
            }
        } else {
            e.element.find(".destinatario.selected").removeClass("selected")
        }
    });
    var d = e;
    e.input.catcomplete({
        minLength: 2,
        position: { of: d.element,
            my: "left top",
            at: "left bottom"
        },
        open: function() {
            setTimeout(function() {
                $(".ui-autocomplete").css("z-index", 9999)
            }, 0)
        },
        source: function(i, g) {
            var h = "/LMS/ajax.php?op=searchall";
            if (f.urlajax != undefined) {
                h = f.urlajax
            }
            h += "&term=" + encodeURIComponent(i.term);
            h += "&notIDs_groups=" + encodeURIComponent(d.notIDs[0].join(","));
            h += "&notIDs_users=" + encodeURIComponent(d.notIDs[1].join(","));
            if (d.idgrupohilo > 0) {
                h += "&idgrupohilo=" + encodeURIComponent(d.idgrupohilo)
            }
            var j = function(k) {
                if (!k) {
                    k = "ERROR"
                }
                if (k.startsWith("ERROR")) {
                    if (!blink.isApp) {
                        standardAJAX(k)
                    }
                } else {
                    if (typeof(k) == "string") {
                        k = jQuery.parseJSON(k)
                    }
                    if (k.length == 0) {
                        k = [{
                            category: text_web.destinatarios_no_results
                        }]
                    }
                    if (k) {
                        g(k)
                    } else {
                        if (!blink.isApp) {
                            standardAJAX("ERROR")
                        }
                    }
                }
            };
            blink.ajax(h, j, {}, {
                waitingElement: null
            })
        },
        select: function(g, h) {
            d.add(h.item.type, h.item.id, h.item.value);
            return false
        }
    })
}
var DestinatariosTagsInput = function(b) {
    $(b.selectortagsinput).tagsinput({
        itemValue: "value",
        itemText: "text",
        tagClass: function(c) {
            return "label label-default"
        }
    });
    $destinatarios = new Destinatarios(b.selector, b.idgrupohilo);
    var a = $.extend($destinatarios, new DestinatariosTagsInputObj(b, $destinatarios));
    return a
};;
$.widget("blink.blinkcombobox", {
    _create: function() {
        this.wrapper = $("<div>").addClass("blink-combobox input-group").insertAfter(this.element);
        this.element.hide();
        this._createAutocomplete();
        this._createShowAllButton()
    },
    _createAutocomplete: function() {
        var b = this.element.children(":selected"),
            c = b.val() ? b.text() : "";
        this.input = $("<input>").appendTo(this.wrapper).val(c).attr("title", "").addClass("blink-combobox-input ui-widget ui-widget-content ui-state-default ui-corner-left form-control").autocomplete({
            delay: 0,
            minLength: 0,
            source: $.proxy(this, "_source"),
            open: function(d, e) {
                $(this).data("ui-autocomplete").menu.activeMenu.addClass("blink-combobox-menu");
                if ($(".modal:visible").length > 0) {
                    $(this).data("ui-autocomplete").menu.activeMenu.zIndex("9999")
                }
            },
            position: {
                collision: "flip"
            }
        }).tooltip();
        this._on(this.input, {
            autocompleteselect: function(d, e) {
                e.item.option.selected = true;
                this._trigger("select", d, {
                    item: e.item.option
                })
            },
            autocompletechange: "_removeIfInvalid"
        });
        var a = this.input;
        $(window).resize(function() {
            a.autocomplete();
            a.autocomplete("search", "");
            a.autocomplete("close")
        })
    },
    _createShowAllButton: function() {
        var a = this.input,
            b = false;
        $("<a>").attr("tabIndex", -1).attr("title", text_web["show.all.items"]).tooltip().appendTo(this.wrapper).button({
            icons: {
                primary: "ui-icon-triangle-1-s"
            },
            text: false
        }).removeClass("ui-corner-all").addClass("blink-combobox-toggle ui-corner-right input-group-addon fa-angle-down").on("mousedown", function() {
            b = a.autocomplete("widget").is(":visible")
        }).on("click", function() {
            a.trigger("focus");
            if (b) {
                return
            }
            a.autocomplete("search", "")
        })
    },
    _source: function(b, a) {
        var c = new RegExp($.ui.autocomplete.escapeRegex(b.term), "i");
        a(this.element.children("option").map(function() {
            var d = $(this).text();
            if (this.value && (!b.term || c.test(d))) {
                return {
                    label: d,
                    value: d,
                    option: this
                }
            }
        }))
    },
    _removeIfInvalid: function(c, e) {
        if (e.item) {
            return
        }
        var d = this.input.val(),
            a = d.toLowerCase(),
            b = false;
        this.element.children("option").each(function() {
            if ($(this).text().toLowerCase() === a) {
                this.selected = b = true;
                return false
            }
        });
        if (b) {
            return
        }
        this.input.val("").attr("title", d + " didn't match any item").tooltip();
        this.element.val("");
        this.input.autocomplete("instance").term = ""
    },
    _destroy: function() {
        this.wrapper.remove();
        this.element.show()
    }
});
$.widget("blink.blinkcomplete", $.ui.autocomplete, {
    options: {
        width: 300,
        getItemImg: function(a) {
            return a.img
        },
        getItemLine1: function(a) {
            return a.line1
        },
        getItemLine2: function(a) {
            return a.line2
        },
        getItemWidth: function(a) {
            return a.width
        },
        focus: function(a, b) {
            if (blink.isIpad) {
                $(this).data("blinkBlinkcomplete").options.select(a, b);
                $(this).data("blinkBlinkcomplete").close(a, b);
                return true
            }
            return false
        },
        change: function(a, b) {
            $(this).trigger("change")
        }
    },
    _resizeMenu: function() {
        this._super();
        this.menu.element.width(this.options.width)
    },
    _renderItem: function(a, b) {
        return $("<li></li>").data("ui-autocomplete-item", b).append(blink.getAutocompleteItem(this.options.getItemImg(b), this.options.getItemLine1(b), this.options.getItemLine2(b), this.options.getItemWidth(b))).appendTo(a)
    }
});
$.widget("blink.catcomplete", $.blink.blinkcomplete, {
    _create: function() {
        this._super();
        this.widget().menu("option", "items", "> :not(.ui-autocomplete-category)")
    },
    options: {
        getItemLine1: function(a) {
            return a.value
        },
        focus: function(a, b) {
            if (blink.isIpad) {
                $(this).data("blinkCatcomplete").options.select(a, b);
                $(this).data("blinkCatcomplete").close(a, b);
                return true
            }
            return false
        }
    },
    _renderMenu: function(b, a) {
        var c = this;
        b.addClass("ul-catcomplete");
        $.each(a, function(d, e) {
            if (e.category) {
                b.append("<li class='ui-autocomplete-category'>" + e.category + "</li>")
            } else {
                c._renderItem(b, e)
            }
        })
    }
});
jQuery.fn.center = function(a) {
    this.css("position", "absolute");
    if (!a || a == "vertical_only") {
        this.css("top", ($(window).height() - this.height()) / 2 + $(window).scrollTop() + "px")
    }
    if (!a || a == "horizontal_only") {
        this.css("left", ($(window).width() - this.width()) / 2 + $(window).scrollLeft() + "px")
    }
    return this
};
(function() {
    var b = jQuery.fn.fadeIn;
    var a = jQuery.fn.fadeOut;
    $.fn.fadeIn = function() {
        if ($.browser.msie && parseInt($.browser.version, 10) <= 8) {
            if (arguments && arguments.length > 0) {
                arguments[0] = 0
            }
            return $.fn.show.apply(this, arguments)
        } else {
            return b.apply(this, arguments)
        }
    };
    $.fn.fadeOut = function() {
        if ($.browser.msie && parseInt($.browser.version, 10) <= 8) {
            if (arguments && arguments.length > 0) {
                arguments[0] = 0
            }
            return $.fn.hide.apply(this, arguments)
        } else {
            return a.apply(this, arguments)
        }
    }
})();
(function() {
    $.fn.isIntoView = function() {
        var b = this;
        var f = $(window);
        var e = f.scrollTop();
        var d = e + f.height();
        var a = b.offset().top;
        var c = a + b.height();
        return ((c >= d) && (a <= e)) || ((c <= d) && (a >= e))
    }
})();
(function(a) {
    a.fn.autogrow = function(e) {
        var d = a(this).css({
                overflow: "hidden",
                resize: "none"
            }),
            b = d.selector,
            f = {
                context: a(document),
                animate: true,
                speed: 200,
                fixMinHeight: true,
                cloneClass: "autogrowclone",
                onInitialize: true
            };
        e = a.isPlainObject(e) ? e : {
            context: e ? e : a(document)
        };
        e = a.extend({}, f, e);
        d.each(function(h, j) {
            var g, k;
            j = a(j);
            if (j.is(":visible") || parseInt(j.css("height"), 10) > 0) {
                g = parseInt(j.css("height"), 10) || j.innerHeight()
            } else {
                k = j.clone().addClass(e.cloneClass).val(j.val()).css({
                    position: "absolute",
                    visibility: "hidden",
                    display: "block"
                });
                a("body").append(k);
                g = k.innerHeight();
                k.remove()
            }
            if (e.fixMinHeight) {
                j.data("autogrow-start-height", g)
            }
            j.css("height", g);
            if (e.onInitialize && j.length) {
                c.call(j[0])
            }
        });
        e.context.on("keyup paste", b, c);

        function c(j) {
            var h = a(this),
                l = h.innerHeight(),
                g = this.scrollHeight,
                i = h.data("autogrow-start-height") || 0,
                k;
            if (l < g) {
                this.scrollTop = 0;
                e.animate ? h.stop().animate({
                    height: g
                }, e.speed) : h.innerHeight(g)
            } else {
                if (!j || j.which == 8 || j.which == 46 || (j.ctrlKey && j.which == 88)) {
                    if (l > i) {
                        k = h.clone().addClass(e.cloneClass).css({
                            position: "absolute",
                            zIndex: -10,
                            height: ""
                        }).val(h.val());
                        h.after(k);
                        do {
                            g = k[0].scrollHeight - 1;
                            k.innerHeight(g)
                        } while (g === k[0].scrollHeight);
                        g++;
                        k.remove();
                        h.focus();
                        g < i && (g = i);
                        l > g && e.animate ? h.stop().animate({
                            height: g
                        }, e.speed) : h.innerHeight(g)
                    } else {
                        h.innerHeight(i)
                    }
                }
            }
        }
        return d
    }
})(jQuery);;
var VKI_attach, VKI_close;

function VKI_buildKeyboardInputs() {
    var p = this;
    this.VKI_version = "1.40";
    this.VKI_showVersion = false;
    this.VKI_target = false;
    this.VKI_shift = this.VKI_shiftlock = false;
    this.VKI_altgr = this.VKI_altgrlock = false;
    this.VKI_dead = false;
    this.VKI_deadkeysOn = false;
    this.VKI_kts = this.VKI_kt = "US Int'l";
    if (typeof(locale) != "undefined" && locale && locale.indexOf("ES") != -1) {
        this.VKI_kts = this.VKI_kt = "Spanish Es"
    }
    this.VKI_langAdapt = false;
    this.VKI_size = 4;
    this.VKI_sizeAdj = true;
    this.VKI_clearPasswords = true;
    this.VKI_imageURI = "";
    this.VKI_clickless = 0;
    this.VKI_keyCenter = 3;
    this.VKI_isIE = false;
    this.VKI_isIE6 = false;
    this.VKI_isIElt8 = false;
    this.VKI_isWebKit = RegExp("KHTML").test(navigator.userAgent);
    this.VKI_isOpera = RegExp("Opera").test(navigator.userAgent);
    this.VKI_isMoz = (!this.VKI_isWebKit && navigator.product == "Gecko");
    this.VKI_i18n = {
        "00": "Virtual Keyboard Interface",
        "01": "Display virtual keyboard interface",
        "02": "Select keyboard layout",
        "03": "Dead keys",
        "04": "On",
        "05": "Off",
        "06": "Close the keyboard",
        "07": "Clear",
        "08": "Clear this input",
        "09": "Version",
        "10": "Adjust keyboard size"
    };
    this.VKI_layout = {};
    this.VKI_layout.Arabic = [
        [
            ["\u0630", "\u0651 "],
            ["1", "!", "\u00a1", "\u00b9"],
            ["2", "@", "\u00b2"],
            ["3", "#", "\u00b3"],
            ["4", "$", "\u00a4", "\u00a3"],
            ["5", "%", "\u20ac"],
            ["6", "^", "\u00bc"],
            ["7", "&", "\u00bd"],
            ["8", "*", "\u00be"],
            ["9", "(", "\u2018"],
            ["0", ")", "\u2019"],
            ["-", "_", "\u00a5"],
            ["=", "+", "\u00d7", "\u00f7"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0636", "\u064e"],
            ["\u0635", "\u064b"],
            ["\u062b", "\u064f"],
            ["\u0642", "\u064c"],
            ["\u0641", "\u0644"],
            ["\u063a", "\u0625"],
            ["\u0639", "\u2018"],
            ["\u0647", "\u00f7"],
            ["\u062e", "\u00d7"],
            ["\u062d", "\u061b"],
            ["\u062c", "<"],
            ["\u062f", ">"],
            ["\\", "|"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0634", "\u0650"],
            ["\u0633", "\u064d"],
            ["\u064a", "]"],
            ["\u0628", "["],
            ["\u0644", "\u0644"],
            ["\u0627", "\u0623"],
            ["\u062a", "\u0640"],
            ["\u0646", "\u060c"],
            ["\u0645", "/"],
            ["\u0643", ":"],
            ["\u0637", '"'],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u0626", "~"],
            ["\u0621", "\u0652"],
            ["\u0624", "}"],
            ["\u0631", "{"],
            ["\u0644", "\u0644"],
            ["\u0649", "\u0622"],
            ["\u0629", "\u2019"],
            ["\u0648", ","],
            ["\u0632", "."],
            ["\u0638", "\u061f"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["Alt", "Alt"]
        ]
    ];
    this.VKI_layout.Arabic.lang = ["ar"];
    this.VKI_layout["Armenian East"] = [
        [
            ["\u055D", "\u055C"],
            [":", "1"],
            ["\u0571", "\u0541"],
            ["\u0575", "\u0545"],
            ["\u055B", "3"],
            [",", "4"],
            ["-", "9"],
            [".", "\u0587"],
            ["\u00AB", "("],
            ["\u00BB", ")"],
            ["\u0585", "\u0555"],
            ["\u057C", "\u054C"],
            ["\u056A", "\u053A"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u056D", "\u053D"],
            ["\u0582", "\u0552"],
            ["\u0567", "\u0537"],
            ["\u0580", "\u0550"],
            ["\u057F", "\u054F"],
            ["\u0565", "\u0535"],
            ["\u0568", "\u0538"],
            ["\u056B", "\u053B"],
            ["\u0578", "\u0548"],
            ["\u057A", "\u054A"],
            ["\u0579", "\u0549"],
            ["\u057B", "\u054B"],
            ["'", "\u055E"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0561", "\u0531"],
            ["\u057D", "\u054D"],
            ["\u0564", "\u0534"],
            ["\u0586", "\u0556"],
            ["\u0584", "\u0554"],
            ["\u0570", "\u0540"],
            ["\u0573", "\u0543"],
            ["\u056F", "\u053F"],
            ["\u056C", "\u053C"],
            ["\u0569", "\u0539"],
            ["\u0583", "\u0553"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u0566", "\u0536"],
            ["\u0581", "\u0551"],
            ["\u0563", "\u0533"],
            ["\u057E", "\u054E"],
            ["\u0562", "\u0532"],
            ["\u0576", "\u0546"],
            ["\u0574", "\u0544"],
            ["\u0577", "\u0547"],
            ["\u0572", "\u0542"],
            ["\u056E", "\u053E"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout["Armenian East"].lang = ["hy"];
    this.VKI_layout["Armenian West"] = [
        [
            ["\u055D", "\u055C"],
            [":", "1"],
            ["\u0571", "\u0541"],
            ["\u0575", "\u0545"],
            ["\u055B", "3"],
            [",", "4"],
            ["-", "9"],
            [".", "\u0587"],
            ["\u00AB", "("],
            ["\u00BB", ")"],
            ["\u0585", "\u0555"],
            ["\u057C", "\u054C"],
            ["\u056A", "\u053A"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u056D", "\u053D"],
            ["\u057E", "\u054E"],
            ["\u0567", "\u0537"],
            ["\u0580", "\u0550"],
            ["\u0564", "\u0534"],
            ["\u0565", "\u0535"],
            ["\u0568", "\u0538"],
            ["\u056B", "\u053B"],
            ["\u0578", "\u0548"],
            ["\u0562", "\u0532"],
            ["\u0579", "\u0549"],
            ["\u057B", "\u054B"],
            ["'", "\u055E"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0561", "\u0531"],
            ["\u057D", "\u054D"],
            ["\u057F", "\u054F"],
            ["\u0586", "\u0556"],
            ["\u056F", "\u053F"],
            ["\u0570", "\u0540"],
            ["\u0573", "\u0543"],
            ["\u0584", "\u0554"],
            ["\u056C", "\u053C"],
            ["\u0569", "\u0539"],
            ["\u0583", "\u0553"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u0566", "\u0536"],
            ["\u0581", "\u0551"],
            ["\u0563", "\u0533"],
            ["\u0582", "\u0552"],
            ["\u057A", "\u054A"],
            ["\u0576", "\u0546"],
            ["\u0574", "\u0544"],
            ["\u0577", "\u0547"],
            ["\u0572", "\u0542"],
            ["\u056E", "\u053E"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout["Armenian West"].lang = ["hy-arevmda"];
    this.VKI_layout.Assamese = [
        [
            ["+", "?"],
            ["\u09E7", "{", "\u09E7"],
            ["\u09E8", "}", "\u09E8"],
            ["\u09E9", "\u09CD\u09F0", "\u09E9"],
            ["\u09EA", "\u09F0\u09CD", "\u09EA"],
            ["\u09EB", "\u099C\u09CD\u09F0", "\u09EB"],
            ["\u09EC", "", "\u09EC"],
            ["\u09ED", "\u0995\u09CD\u09F0", "\u09ED"],
            ["\u09EE", "\u09B6\u09CD\u09F0", "\u09EE"],
            ["\u09EF", "(", "\u09EF"],
            ["\u09E6", ")", "\u09E6"],
            ["-", ""],
            ["\u09C3", "\u098B", "\u09E2", "\u09E0"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u09CC", "\u0994", "\u09D7"],
            ["\u09C8", "\u0990"],
            ["\u09BE", "\u0986"],
            ["\u09C0", "\u0988", "\u09E3", "\u09E1"],
            ["\u09C2", "\u098A"],
            ["\u09F1", "\u09AD"],
            ["\u09B9", "\u0999"],
            ["\u0997", "\u0998"],
            ["\u09A6", "\u09A7"],
            ["\u099C", "\u099D"],
            ["\u09A1", "\u09A2", "\u09DC", "\u09DD"],
            ["\u09BC", "\u099E"]
        ],
        [
            ["Caps", "Caps"],
            ["\u09CB", "\u0993", "\u09F4", "\u09F5"],
            ["\u09C7", "\u098F", "\u09F6", "\u09F7"],
            ["\u09CD", "\u0985", "\u09F8", "\u09F9"],
            ["\u09BF", "\u0987", "\u09E2", "\u098C"],
            ["\u09C1", "\u0989"],
            ["\u09AA", "\u09AB"],
            ["\u09F0", "", "\u09F0", "\u09F1"],
            ["\u0995", "\u0996"],
            ["\u09A4", "\u09A5"],
            ["\u099A", "\u099B"],
            ["\u099F", "\u09A0"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u09CE", "\u0983"],
            ["\u0982", "\u0981", "\u09FA"],
            ["\u09AE", "\u09A3"],
            ["\u09A8", "\u09F7"],
            ["\u09AC", '"'],
            ["\u09B2", "'"],
            ["\u09B8", "\u09B6"],
            [",", "\u09B7"],
            [".", ";"],
            ["\u09AF", "\u09DF"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Assamese.lang = ["as"];
    this.VKI_layout.Belarusian = [
        [
            ["\u0451", "\u0401"],
            ["1", "!"],
            ["2", '"'],
            ["3", "\u2116"],
            ["4", ";"],
            ["5", "%"],
            ["6", ":"],
            ["7", "?"],
            ["8", "*"],
            ["9", "("],
            ["0", ")"],
            ["-", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0439", "\u0419"],
            ["\u0446", "\u0426"],
            ["\u0443", "\u0423"],
            ["\u043a", "\u041a"],
            ["\u0435", "\u0415"],
            ["\u043d", "\u041d"],
            ["\u0433", "\u0413"],
            ["\u0448", "\u0428"],
            ["\u045e", "\u040e"],
            ["\u0437", "\u0417"],
            ["\u0445", "\u0425"],
            ["'", "'"],
            ["\\", "/"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0444", "\u0424"],
            ["\u044b", "\u042b"],
            ["\u0432", "\u0412"],
            ["\u0430", "\u0410"],
            ["\u043f", "\u041f"],
            ["\u0440", "\u0420"],
            ["\u043e", "\u041e"],
            ["\u043b", "\u041b"],
            ["\u0434", "\u0414"],
            ["\u0436", "\u0416"],
            ["\u044d", "\u042d"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["/", "|"],
            ["\u044f", "\u042f"],
            ["\u0447", "\u0427"],
            ["\u0441", "\u0421"],
            ["\u043c", "\u041c"],
            ["\u0456", "\u0406"],
            ["\u0442", "\u0422"],
            ["\u044c", "\u042c"],
            ["\u0431", "\u0411"],
            ["\u044e", "\u042e"],
            [".", ","],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout.Belarusian.lang = ["be"];
    this.VKI_layout.Belgian = [
        [
            ["\u00b2", "\u00b3"],
            ["&", "1", "|"],
            ["\u00e9", "2", "@"],
            ['"', "3", "#"],
            ["'", "4"],
            ["(", "5"],
            ["\u00a7", "6", "^"],
            ["\u00e8", "7"],
            ["!", "8"],
            ["\u00e7", "9", "{"],
            ["\u00e0", "0", "}"],
            [")", "\u00b0"],
            ["-", "_"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["a", "A"],
            ["z", "Z"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["^", "\u00a8", "["],
            ["$", "*", "]"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["q", "Q"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["m", "M"],
            ["\u00f9", "%", "\u00b4"],
            ["\u03bc", "\u00a3", "`"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">", "\\"],
            ["w", "W"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            [",", "?"],
            [";", "."],
            [":", "/"],
            ["=", "+", "~"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Belgian.lang = ["nl-BE", "fr-BE"];
    this.VKI_layout.Bengali = [
        [
            [""],
            ["1", "", "\u09E7"],
            ["2", "", "\u09E8"],
            ["3", "\u09CD\u09B0", "\u09E9"],
            ["4", "\u09B0\u09CD", "\u09EA"],
            ["5", "\u099C\u09CD\u09B0", "\u09EB"],
            ["6", "\u09A4\u09CD\u09B7", "\u09EC"],
            ["7", "\u0995\u09CD\u09B0", "\u09ED"],
            ["8", "\u09B6\u09CD\u09B0", "\u09EE"],
            ["9", "(", "\u09EF"],
            ["0", ")", "\u09E6"],
            ["-", "\u0983"],
            ["\u09C3", "\u098B", "\u09E2", "\u09E0"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u09CC", "\u0994", "\u09D7"],
            ["\u09C8", "\u0990"],
            ["\u09BE", "\u0986"],
            ["\u09C0", "\u0988", "\u09E3", "\u09E1"],
            ["\u09C2", "\u098A"],
            ["\u09AC", "\u09AD"],
            ["\u09B9", "\u0999"],
            ["\u0997", "\u0998"],
            ["\u09A6", "\u09A7"],
            ["\u099C", "\u099D"],
            ["\u09A1", "\u09A2", "\u09DC", "\u09DD"],
            ["\u09BC", "\u099E"]
        ],
        [
            ["Caps", "Caps"],
            ["\u09CB", "\u0993", "\u09F4", "\u09F5"],
            ["\u09C7", "\u098F", "\u09F6", "\u09F7"],
            ["\u09CD", "\u0985", "\u09F8", "\u09F9"],
            ["\u09BF", "\u0987", "\u09E2", "\u098C"],
            ["\u09C1", "\u0989"],
            ["\u09AA", "\u09AB"],
            ["\u09B0", "", "\u09F0", "\u09F1"],
            ["\u0995", "\u0996"],
            ["\u09A4", "\u09A5"],
            ["\u099A", "\u099B"],
            ["\u099F", "\u09A0"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            [""],
            ["\u0982", "\u0981", "\u09FA"],
            ["\u09AE", "\u09A3"],
            ["\u09A8"],
            ["\u09AC"],
            ["\u09B2"],
            ["\u09B8", "\u09B6"],
            [",", "\u09B7"],
            [".", "{"],
            ["\u09AF", "\u09DF"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Bengali.lang = ["bn"];
    this.VKI_layout["Bulgarian Ph"] = [
        [
            ["\u0447", "\u0427"],
            ["1", "!"],
            ["2", "@"],
            ["3", "#"],
            ["4", "$"],
            ["5", "%"],
            ["6", "^"],
            ["7", "&"],
            ["8", "*"],
            ["9", "("],
            ["0", ")"],
            ["-", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u044F", "\u042F"],
            ["\u0432", "\u0412"],
            ["\u0435", "\u0415"],
            ["\u0440", "\u0420"],
            ["\u0442", "\u0422"],
            ["\u044A", "\u042A"],
            ["\u0443", "\u0423"],
            ["\u0438", "\u0418"],
            ["\u043E", "\u041E"],
            ["\u043F", "\u041F"],
            ["\u0448", "\u0428"],
            ["\u0449", "\u0429"],
            ["\u044E", "\u042E"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0430", "\u0410"],
            ["\u0441", "\u0421"],
            ["\u0434", "\u0414"],
            ["\u0444", "\u0424"],
            ["\u0433", "\u0413"],
            ["\u0445", "\u0425"],
            ["\u0439", "\u0419"],
            ["\u043A", "\u041A"],
            ["\u043B", "\u041B"],
            [";", ":"],
            ["'", '"'],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u0437", "\u0417"],
            ["\u044C", "\u042C"],
            ["\u0446", "\u0426"],
            ["\u0436", "\u0416"],
            ["\u0431", "\u0411"],
            ["\u043D", "\u041D"],
            ["\u043C", "\u041C"],
            [",", "<"],
            [".", ">"],
            ["/", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout["Bulgarian Ph"].lang = ["bg"];
    this.VKI_layout["Bulgarian BDS"] = [
        [
            ["`", "~"],
            ["1", "!"],
            ["2", "?"],
            ["3", "+"],
            ["4", '"'],
            ["5", "%"],
            ["6", "="],
            ["7", ":"],
            ["8", "/"],
            ["9", "_"],
            ["0", "\u2116"],
            ["-", "\u0406"],
            ["=", "V"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            [",", "\u044b"],
            ["\u0443", "\u0423"],
            ["\u0435", "\u0415"],
            ["\u0438", "\u0418"],
            ["\u0448", "\u0428"],
            ["\u0449", "\u0429"],
            ["\u043a", "\u041a"],
            ["\u0441", "\u0421"],
            ["\u0434", "\u0414"],
            ["\u0437", "\u0417"],
            ["\u0446", "\u0426"],
            [";", "\u00a7"],
            ["(", ")"]
        ],
        [
            ["Caps", "Caps"],
            ["\u044c", "\u042c"],
            ["\u044f", "\u042f"],
            ["\u0430", "\u0410"],
            ["\u043e", "\u041e"],
            ["\u0436", "\u0416"],
            ["\u0433", "\u0413"],
            ["\u0442", "\u0422"],
            ["\u043d", "\u041d"],
            ["\u0412", "\u0412"],
            ["\u043c", "\u041c"],
            ["\u0447", "\u0427"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u042e", "\u044e"],
            ["\u0439", "\u0419"],
            ["\u044a", "\u042a"],
            ["\u044d", "\u042d"],
            ["\u0444", "\u0424"],
            ["\u0445", "\u0425"],
            ["\u043f", "\u041f"],
            ["\u0440", "\u0420"],
            ["\u043b", "\u041b"],
            ["\u0431", "\u0411"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout.Burmese = [
        [
            ["\u1039`", "~"],
            ["\u1041", "\u100D"],
            ["\u1042", "\u100E"],
            ["\u1043", "\u100B"],
            ["\u1044", "\u1000\u103B\u1015\u103A"],
            ["\u1045", "%"],
            ["\u1046", "/"],
            ["\u1047", "\u101B"],
            ["\u1048", "\u1002"],
            ["\u1049", "("],
            ["\u1040", ")"],
            ["-", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u1006", "\u1029"],
            ["\u1010", "\u1040"],
            ["\u1014", "\u103F"],
            ["\u1019", "\u1023"],
            ["\u1021", "\u1024"],
            ["\u1015", "\u104C"],
            ["\u1000", "\u1009"],
            ["\u1004", "\u104D"],
            ["\u101E", "\u1025"],
            ["\u1005", "\u100F"],
            ["\u101F", "\u1027"],
            ["\u2018", "\u2019"],
            ["\u104F", "\u100B\u1039\u100C"]
        ],
        [
            ["Caps", "Caps"],
            ["\u200B\u1031", "\u1017"],
            ["\u200B\u103B", "\u200B\u103E"],
            ["\u200B\u102D", "\u200B\u102E"],
            ["\u200B\u103A", "\u1004\u103A\u1039\u200B"],
            ["\u200B\u102B", "\u200B\u103D"],
            ["\u200B\u1037", "\u200B\u1036"],
            ["\u200B\u103C", "\u200B\u1032"],
            ["\u200B\u102F", "\u200B\u102F"],
            ["\u200B\u1030", "\u200B\u1030"],
            ["\u200B\u1038", "\u200B\u102B\u103A"],
            ["\u1012", "\u1013"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u1016", "\u1007"],
            ["\u1011", "\u100C"],
            ["\u1001", "\u1003"],
            ["\u101C", "\u1020"],
            ["\u1018", "\u1026"],
            ["\u100A", "\u1008"],
            ["\u200B\u102C", "\u102A"],
            ["\u101A", "\u101B"],
            [".", "\u101B"],
            ["\u104B", "\u104A"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout.Burmese.lang = ["my"];
    this.VKI_layout.Czech = [
        [
            [";", "\u00b0", "`", "~"],
            ["+", "1", "!"],
            ["\u011B", "2", "@"],
            ["\u0161", "3", "#"],
            ["\u010D", "4", "$"],
            ["\u0159", "5", "%"],
            ["\u017E", "6", "^"],
            ["\u00FD", "7", "&"],
            ["\u00E1", "8", "*"],
            ["\u00ED", "9", "("],
            ["\u00E9", "0", ")"],
            ["=", "%", "-", "_"],
            ["\u00B4", "\u02c7", "=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E", "\u20AC"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["\u00FA", "/", "[", "{"],
            [")", "(", "]", "}"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["\u016F", '"', ";", ":"],
            ["\u00A7", "!", "\u00a4", "^"],
            ["\u00A8", "'", "\\", "|"]
        ],
        [
            ["Shift", "Shift"],
            ["\\", "|", "", "\u02dd"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            [",", "?", "<", "\u00d7"],
            [".", ":", ">", "\u00f7"],
            ["-", "_", "/", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["Alt", "Alt"]
        ]
    ];
    this.VKI_layout.Czech.lang = ["cs"];
    this.VKI_layout.Danish = [
        [
            ["\u00bd", "\u00a7"],
            ["1", "!"],
            ["2", '"', "@"],
            ["3", "#", "\u00a3"],
            ["4", "\u00a4", "$"],
            ["5", "%", "\u20ac"],
            ["6", "&"],
            ["7", "/", "{"],
            ["8", "(", "["],
            ["9", ")", "]"],
            ["0", "=", "}"],
            ["+", "?"],
            ["\u00b4", "`", "|"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["\u00e5", "\u00c5"],
            ["\u00a8", "^", "~"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["\u00e6", "\u00c6"],
            ["\u00f8", "\u00d8"],
            ["'", "*"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">", "\\"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M", "\u03bc", "\u039c"],
            [",", ";"],
            [".", ":"],
            ["-", "_"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Danish.lang = ["da"];
    this.VKI_layout.Dari = [
        [
            ["\u200D", "\u00F7", "~"],
            ["\u06F1", "!", "`"],
            ["\u06F2", "\u066C", "@"],
            ["\u06F3", "\u066B", "#"],
            ["\u06F4", "\u060B", "$"],
            ["\u06F5", "\u066A", "%"],
            ["\u06F6", "\u00D7", "^"],
            ["\u06F7", "\u060C", "&"],
            ["\u06F8", "*", "\u2022"],
            ["\u06F9", ")", "\u200E"],
            ["\u06F0", "(", "\u200F"],
            ["-", "\u0640", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0636", "\u0652", "\u00B0"],
            ["\u0635", "\u064C"],
            ["\u062B", "\u064D", "\u20AC"],
            ["\u0642", "\u064B", "\uFD3E"],
            ["\u0641", "\u064F", "\uFD3F"],
            ["\u063A", "\u0650", "\u0656"],
            ["\u0639", "\u064E", "\u0659"],
            ["\u0647", "\u0651", "\u0655"],
            ["\u062E", "]", "'"],
            ["\u062D", "[", '"'],
            ["\u062C", "}", "\u0681"],
            ["\u0686", "{", "\u0685"],
            ["\\", "|", "?"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0634", "\u0624", "\u069A"],
            ["\u0633", "\u0626", "\u06CD"],
            ["\u06CC", "\u064A", "\u0649"],
            ["\u0628", "\u0625", "\u06D0"],
            ["\u0644", "\u0623", "\u06B7"],
            ["\u0627", "\u0622", "\u0671"],
            ["\u062A", "\u0629", "\u067C"],
            ["\u0646", "\u00BB", "\u06BC"],
            ["\u0645", "\u00AB", "\u06BA"],
            ["\u06A9", ":", ";"],
            ["\u06AF", "\u061B", "\u06AB"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u0638", "\u0643", "\u06D2"],
            ["\u0637", "\u0653", "\u0691"],
            ["\u0632", "\u0698", "\u0696"],
            ["\u0631", "\u0670", "\u0693"],
            ["\u0630", "\u200C", "\u0688"],
            ["\u062F", "\u0654", "\u0689"],
            ["\u067E", "\u0621", "\u0679"],
            ["\u0648", ">", ","],
            [".", "<", "\u06C7"],
            ["/", "\u061F", "\u06C9"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Dari.lang = ["da"];
    this.VKI_layout.Dutch = [
        [
            ["@", "\u00a7", "\u00ac"],
            ["1", "!", "\u00b9"],
            ["2", '"', "\u00b2"],
            ["3", "#", "\u00b3"],
            ["4", "$", "\u00bc"],
            ["5", "%", "\u00bd"],
            ["6", "&", "\u00be"],
            ["7", "_", "\u00a3"],
            ["8", "(", "{"],
            ["9", ")", "}"],
            ["0", "'"],
            ["/", "?", "\\"],
            ["\u00b0", "~", "\u00b8"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E", "\u20ac"],
            ["r", "R", "\u00b6"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["\u00a8", "^"],
            ["*", "|"],
            ["<", ">"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S", "\u00df"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["+", "\u00b1"],
            ["\u00b4", "`"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["]", "[", "\u00a6"],
            ["z", "Z", "\u00ab"],
            ["x", "X", "\u00bb"],
            ["c", "C", "\u00a2"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M", "\u00b5"],
            [",", ";"],
            [".", ":", "\u00b7"],
            ["-", "="],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Dutch.lang = ["nl"];
    this.VKI_layout.Dvorak = [
        [
            ["`", "~"],
            ["1", "!"],
            ["2", "@"],
            ["3", "#"],
            ["4", "$"],
            ["5", "%"],
            ["6", "^"],
            ["7", "&"],
            ["8", "*"],
            ["9", "("],
            ["0", ")"],
            ["[", "{"],
            ["]", "}"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["'", '"'],
            [",", "<"],
            [".", ">"],
            ["p", "P"],
            ["y", "Y"],
            ["f", "F"],
            ["g", "G"],
            ["c", "C"],
            ["r", "R"],
            ["l", "L"],
            ["/", "?"],
            ["=", "+"],
            ["\\", "|"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["o", "O"],
            ["e", "E"],
            ["u", "U"],
            ["i", "I"],
            ["d", "D"],
            ["h", "H"],
            ["t", "T"],
            ["n", "N"],
            ["s", "S"],
            ["-", "_"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            [";", ":"],
            ["q", "Q"],
            ["j", "J"],
            ["k", "K"],
            ["x", "X"],
            ["b", "B"],
            ["m", "M"],
            ["w", "W"],
            ["v", "V"],
            ["z", "Z"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout.Farsi = [
        [
            ["\u067e", "\u0651 "],
            ["1", "!", "\u00a1", "\u00b9"],
            ["2", "@", "\u00b2"],
            ["3", "#", "\u00b3"],
            ["4", "$", "\u00a4", "\u00a3"],
            ["5", "%", "\u20ac"],
            ["6", "^", "\u00bc"],
            ["7", "&", "\u00bd"],
            ["8", "*", "\u00be"],
            ["9", "(", "\u2018"],
            ["0", ")", "\u2019"],
            ["-", "_", "\u00a5"],
            ["=", "+", "\u00d7", "\u00f7"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0636", "\u064e"],
            ["\u0635", "\u064b"],
            ["\u062b", "\u064f"],
            ["\u0642", "\u064c"],
            ["\u0641", "\u0644"],
            ["\u063a", "\u0625"],
            ["\u0639", "\u2018"],
            ["\u0647", "\u00f7"],
            ["\u062e", "\u00d7"],
            ["\u062d", "\u061b"],
            ["\u062c", "<"],
            ["\u0686", ">"],
            ["\u0698", "|"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0634", "\u0650"],
            ["\u0633", "\u064d"],
            ["\u064a", "]"],
            ["\u0628", "["],
            ["\u0644", "\u0644"],
            ["\u0627", "\u0623"],
            ["\u062a", "\u0640"],
            ["\u0646", "\u060c"],
            ["\u0645", "\\"],
            ["\u06af", ":"],
            ["\u0643", '"'],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u0626", "~"],
            ["\u0621", "\u0652"],
            ["\u0632", "}"],
            ["\u0631", "{"],
            ["\u0630", "\u0644"],
            ["\u062f", "\u0622"],
            ["\u0626", "\u0621"],
            ["\u0648", ","],
            [".", "."],
            ["/", "\u061f"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["Alt", "Alt"]
        ]
    ];
    this.VKI_layout.Farsi.lang = ["fa"];
    this.VKI_layout.French = [
        [
            ["\u00b2", "\u00b3"],
            ["&", "1"],
            ["\u00e9", "2", "~"],
            ['"', "3", "#"],
            ["'", "4", "{"],
            ["(", "5", "["],
            ["-", "6", "|"],
            ["\u00e8", "7", "`"],
            ["_", "8", "\\"],
            ["\u00e7", "9", "^"],
            ["\u00e0", "0", "@"],
            [")", "\u00b0", "]"],
            ["=", "+", "}"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["a", "A"],
            ["z", "Z"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["^", "\u00a8"],
            ["$", "\u00a3", "\u00a4"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["q", "Q"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["m", "M"],
            ["\u00f9", "%"],
            ["*", "\u03bc"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">"],
            ["w", "W"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            [",", "?"],
            [";", "."],
            [":", "/"],
            ["!", "\u00a7"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.French.lang = ["fr"];
    this.VKI_layout.German = [
        [
            ["^", "\u00b0"],
            ["1", "!"],
            ["2", '"', "\u00b2"],
            ["3", "\u00a7", "\u00b3"],
            ["4", "$"],
            ["5", "%"],
            ["6", "&"],
            ["7", "/", "{"],
            ["8", "(", "["],
            ["9", ")", "]"],
            ["0", "=", "}"],
            ["\u00df", "?", "\\"],
            ["\u00b4", "`"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q", "@"],
            ["w", "W"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["z", "Z"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["\u00fc", "\u00dc"],
            ["+", "*", "~"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["\u00f6", "\u00d6"],
            ["\u00e4", "\u00c4"],
            ["#", "'"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">", "\u00a6"],
            ["y", "Y"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M", "\u00b5"],
            [",", ";"],
            [".", ":"],
            ["-", "_"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.German.lang = ["de"];
    this.VKI_layout.Greek = [
        [
            ["`", "~"],
            ["1", "!"],
            ["2", "@", "\u00b2"],
            ["3", "#", "\u00b3"],
            ["4", "$", "\u00a3"],
            ["5", "%", "\u00a7"],
            ["6", "^", "\u00b6"],
            ["7", "&"],
            ["8", "*", "\u00a4"],
            ["9", "(", "\u00a6"],
            ["0", ")", "\u00ba"],
            ["-", "_", "\u00b1"],
            ["=", "+", "\u00bd"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            [";", ":"],
            ["\u03c2", "^"],
            ["\u03b5", "\u0395"],
            ["\u03c1", "\u03a1"],
            ["\u03c4", "\u03a4"],
            ["\u03c5", "\u03a5"],
            ["\u03b8", "\u0398"],
            ["\u03b9", "\u0399"],
            ["\u03bf", "\u039f"],
            ["\u03c0", "\u03a0"],
            ["[", "{", "\u201c"],
            ["]", "}", "\u201d"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["\u03b1", "\u0391"],
            ["\u03c3", "\u03a3"],
            ["\u03b4", "\u0394"],
            ["\u03c6", "\u03a6"],
            ["\u03b3", "\u0393"],
            ["\u03b7", "\u0397"],
            ["\u03be", "\u039e"],
            ["\u03ba", "\u039a"],
            ["\u03bb", "\u039b"],
            ["\u0384", "\u00a8", "\u0385"],
            ["'", '"'],
            ["\\", "|", "\u00ac"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">"],
            ["\u03b6", "\u0396"],
            ["\u03c7", "\u03a7"],
            ["\u03c8", "\u03a8"],
            ["\u03c9", "\u03a9"],
            ["\u03b2", "\u0392"],
            ["\u03bd", "\u039d"],
            ["\u03bc", "\u039c"],
            [",", "<"],
            [".", ">"],
            ["/", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Greek.lang = ["el"];
    this.VKI_layout.Hebrew = [
        [
            ["~", "`"],
            ["1", "!"],
            ["2", "@"],
            ["3", "#"],
            ["4", "$", "\u20aa"],
            ["5", "%"],
            ["6", "^"],
            ["7", "&"],
            ["8", "*"],
            ["9", ")"],
            ["0", "("],
            ["-", "_"],
            ["=", "+"],
            ["\\", "|"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["/", "Q"],
            ["'", "W"],
            ["\u05e7", "E", "\u20ac"],
            ["\u05e8", "R"],
            ["\u05d0", "T"],
            ["\u05d8", "Y"],
            ["\u05d5", "U", "\u05f0"],
            ["\u05df", "I"],
            ["\u05dd", "O"],
            ["\u05e4", "P"],
            ["]", "}"],
            ["[", "{"]
        ],
        [
            ["Caps", "Caps"],
            ["\u05e9", "A"],
            ["\u05d3", "S"],
            ["\u05d2", "D"],
            ["\u05db", "F"],
            ["\u05e2", "G"],
            ["\u05d9", "H", "\u05f2"],
            ["\u05d7", "J", "\u05f1"],
            ["\u05dc", "K"],
            ["\u05da", "L"],
            ["\u05e3", ":"],
            [", ", '"'],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u05d6", "Z"],
            ["\u05e1", "X"],
            ["\u05d1", "C"],
            ["\u05d4", "V"],
            ["\u05e0", "B"],
            ["\u05de", "N"],
            ["\u05e6", "M"],
            ["\u05ea", ">"],
            ["\u05e5", "<"],
            [".", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Hebrew.lang = ["he"];
    this.VKI_layout.Hindi = [
        [
            ["\u200d", "\u200c", "`", "~"],
            ["1", "\u090D", "\u0967", "!"],
            ["2", "\u0945", "\u0968", "@"],
            ["3", "\u094D\u0930", "\u0969", "#"],
            ["4", "\u0930\u094D", "\u096A", "$"],
            ["5", "\u091C\u094D\u091E", "\u096B", "%"],
            ["6", "\u0924\u094D\u0930", "\u096C", "^"],
            ["7", "\u0915\u094D\u0937", "\u096D", "&"],
            ["8", "\u0936\u094D\u0930", "\u096E", "*"],
            ["9", "(", "\u096F", "("],
            ["0", ")", "\u0966", ")"],
            ["-", "\u0903", "-", "_"],
            ["\u0943", "\u090B", "=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u094C", "\u0914"],
            ["\u0948", "\u0910"],
            ["\u093E", "\u0906"],
            ["\u0940", "\u0908"],
            ["\u0942", "\u090A"],
            ["\u092C", "\u092D"],
            ["\u0939", "\u0919"],
            ["\u0917", "\u0918"],
            ["\u0926", "\u0927"],
            ["\u091C", "\u091D"],
            ["\u0921", "\u0922", "[", "{"],
            ["\u093C", "\u091E", "]", "}"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["\u094B", "\u0913"],
            ["\u0947", "\u090F"],
            ["\u094D", "\u0905"],
            ["\u093F", "\u0907"],
            ["\u0941", "\u0909"],
            ["\u092A", "\u092B"],
            ["\u0930", "\u0931"],
            ["\u0915", "\u0916"],
            ["\u0924", "\u0925"],
            ["\u091A", "\u091B", ";", ":"],
            ["\u091F", "\u0920", "'", '"'],
            ["\u0949", "\u0911", "\\", "|"]
        ],
        [
            ["Shift", "Shift"],
            [""],
            ["\u0902", "\u0901", "", "\u0950"],
            ["\u092E", "\u0923"],
            ["\u0928"],
            ["\u0935"],
            ["\u0932", "\u0933"],
            ["\u0938", "\u0936"],
            [",", "\u0937", ",", "<"],
            [".", "\u0964", ".", ">"],
            ["\u092F", "\u095F", "/", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Hindi.lang = ["hi"];
    this.VKI_layout.Hungarian = [
        [
            ["0", "\u00a7"],
            ["1", "'", "~"],
            ["2", '"', "\u02c7"],
            ["3", "+", "\u02c6"],
            ["4", "!", "\u02d8"],
            ["5", "%", "\u00b0"],
            ["6", "/", "\u02db"],
            ["7", "=", "`"],
            ["8", "(", "\u02d9"],
            ["9", ")", "\u00b4"],
            ["\u00f6", "\u00d6", "\u02dd"],
            ["\u00fc", "\u00dc", "\u00a8"],
            ["\u00f3", "\u00d3", "\u00b8"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q", "\\"],
            ["w", "W", "|"],
            ["e", "E", "\u00c4"],
            ["r", "R"],
            ["t", "T"],
            ["z", "Z"],
            ["u", "U", "\u20ac"],
            ["i", "I", "\u00cd"],
            ["o", "O"],
            ["p", "P"],
            ["\u0151", "\u0150", "\u00f7"],
            ["\u00fa", "\u00da", "\u00d7"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A", "\u00e4"],
            ["s", "S", "\u0111"],
            ["d", "D", "\u0110"],
            ["f", "F", "["],
            ["g", "G", "]"],
            ["h", "H"],
            ["j", "J", "\u00ed"],
            ["k", "K", "\u0141"],
            ["l", "L", "\u0142"],
            ["\u00e9", "\u00c9", "$"],
            ["\u00e1", "\u00c1", "\u00df"],
            ["\u0171", "\u0170", "\u00a4"]
        ],
        [
            ["Shift", "Shift"],
            ["\u00ed", "\u00cd", "<"],
            ["y", "Y", ">"],
            ["x", "X", "#"],
            ["c", "C", "&"],
            ["v", "V", "@"],
            ["b", "B", "{"],
            ["n", "N", "}"],
            ["m", "M", "<"],
            [",", "?", ";"],
            [".", ":", ">"],
            ["-", "_", "*"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Hungarian.lang = ["hu"];
    this.VKI_layout.Italian = [
        [
            ["\\", "|"],
            ["1", "!"],
            ["2", '"'],
            ["3", "\u00a3"],
            ["4", "$", "\u20ac"],
            ["5", "%"],
            ["6", "&"],
            ["7", "/"],
            ["8", "("],
            ["9", ")"],
            ["0", "="],
            ["'", "?"],
            ["\u00ec", "^"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["\u00e8", "\u00e9", "[", "{"],
            ["+", "*", "]", "}"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["\u00f2", "\u00e7", "@"],
            ["\u00e0", "\u00b0", "#"],
            ["\u00f9", "\u00a7"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            [",", ";"],
            [".", ":"],
            ["-", "_"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Italian.lang = ["it"];
    this.VKI_layout["\u65e5\u672c\u8a9e"] = [
        [
            ["\uff5e"],
            ["\u306c", "\u30cc"],
            ["\u3075", "\u30d5"],
            ["\u3042", "\u30a2", "\u3041", "\u30a1"],
            ["\u3046", "\u30a6", "\u3045", "\u30a5"],
            ["\u3048", "\u30a8", "\u3047", "\u30a7"],
            ["\u304a", "\u30aa", "\u3049", "\u30a9"],
            ["\u3084", "\u30e4", "\u3083", "\u30e3"],
            ["\u3086", "\u30e6", "\u3085", "\u30e5"],
            ["\u3088", "\u30e8", "\u3087", "\u30e7"],
            ["\u308f", "\u30ef", "\u3092", "\u30f2"],
            ["\u307b", "\u30db", "\u30fc", "\uff1d"],
            ["\u3078", "\u30d8", "\uff3e", "\uff5e"],
            ['"', '"', "\uffe5", "\uff5c"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u305f", "\u30bf"],
            ["\u3066", "\u30c6"],
            ["\u3044", "\u30a4", "\u3043", "\u30a3"],
            ["\u3059", "\u30b9"],
            ["\u304b", "\u30ab"],
            ["\u3093", "\u30f3"],
            ["\u306a", "\u30ca"],
            ["\u306b", "\u30cb"],
            ["\u3089", "\u30e9"],
            ["\u305b", "\u30bb"],
            ["\u3001", "\u3001", "\uff20", "\u2018"],
            ["\u3002", "\u3002", "\u300c", "\uff5b"],
            ["\uffe5", "", "", "\uff0a"]
        ],
        [
            ["Caps", "Caps"],
            ["\u3061", "\u30c1"],
            ["\u3068", "\u30c8"],
            ["\u3057", "\u30b7"],
            ["\u306f", "\u30cf"],
            ["\u304d", "\u30ad"],
            ["\u304f", "\u30af"],
            ["\u307e", "\u30de"],
            ["\u306e", "\u30ce"],
            ["\u308c", "\u30ec", "\uff1b", "\uff0b"],
            ["\u3051", "\u30b1", "\uff1a", "\u30f6"],
            ["\u3080", "\u30e0", "\u300d", "\uff5d"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u3064", "\u30c4"],
            ["\u3055", "\u30b5"],
            ["\u305d", "\u30bd"],
            ["\u3072", "\u30d2"],
            ["\u3053", "\u30b3"],
            ["\u307f", "\u30df"],
            ["\u3082", "\u30e2"],
            ["\u306d", "\u30cd", "\u3001", "\uff1c"],
            ["\u308b", "\u30eb", "\u3002", "\uff1e"],
            ["\u3081", "\u30e1", "\u30fb", "\uff1f"],
            ["\u308d", "\u30ed", "", "\uff3f"],
            ["Shift", "Shift"]
        ],
        [
            ["AltLk", "AltLk"],
            [" ", " ", " ", " "],
            ["Alt", "Alt"]
        ]
    ];
    this.VKI_layout["\u65e5\u672c\u8a9e"].lang = ["ja"];
    this.VKI_layout.Kazakh = [
        [
            ["(", ")"],
            ['"', "!"],
            ["\u04d9", "\u04d8"],
            ["\u0456", "\u0406"],
            ["\u04a3", "\u04a2"],
            ["\u0493", "\u0492"],
            [",", ";"],
            [".", ":"],
            ["\u04af", "\u04ae"],
            ["\u04b1", "\u04b0"],
            ["\u049b", "\u049a"],
            ["\u04e9", "\u04e8"],
            ["\u04bb", "\u04ba"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0439", "\u0419"],
            ["\u0446", "\u0426"],
            ["\u0443", "\u0423"],
            ["\u043A", "\u041A"],
            ["\u0435", "\u0415"],
            ["\u043D", "\u041D"],
            ["\u0433", "\u0413"],
            ["\u0448", "\u0428"],
            ["\u0449", "\u0429"],
            ["\u0437", "\u0417"],
            ["\u0445", "\u0425"],
            ["\u044A", "\u042A"],
            ["\\", "/"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0444", "\u0424"],
            ["\u044B", "\u042B"],
            ["\u0432", "\u0412"],
            ["\u0430", "\u0410"],
            ["\u043F", "\u041F"],
            ["\u0440", "\u0420"],
            ["\u043E", "\u041E"],
            ["\u043B", "\u041B"],
            ["\u0434", "\u0414"],
            ["\u0436", "\u0416"],
            ["\u044D", "\u042D"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\\", "|"],
            ["\u044F", "\u042F"],
            ["\u0447", "\u0427"],
            ["\u0441", "\u0421"],
            ["\u043C", "\u041C"],
            ["\u0438", "\u0418"],
            ["\u0442", "\u0422"],
            ["\u044C", "\u042C"],
            ["\u0431", "\u0411"],
            ["\u044E", "\u042E"],
            ["\u2116", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout.Kazakh.lang = ["kk"];
    this.VKI_layout.Kurdish = [
        [
            ["\u20ac", "~"],
            ["\u0661", "!"],
            ["\u0662", "@"],
            ["\u0663", "#"],
            ["\u0664", "$"],
            ["\u0665", "%"],
            ["\u0666", "^"],
            ["\u0667", "&"],
            ["\u0668", "*"],
            ["\u0669", "("],
            ["\u0660", ")"],
            ["-", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0642", "`"],
            ["\u0648", "\u0648\u0648"],
            ["\u06d5", "\u064a"],
            ["\u0631", "\u0695"],
            ["\u062a", "\u0637"],
            ["\u06cc", "\u06ce"],
            ["\u0626", "\u0621"],
            ["\u062d", "\u0639"],
            ["\u06c6", "\u0624"],
            ["\u067e", "\u062b"],
            ["[", "{"],
            ["]", "}"],
            ["\\", "|"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0627", "\u0622"],
            ["\u0633", "\u0634"],
            ["\u062f", "\u0630"],
            ["\u0641", "\u0625"],
            ["\u06af", "\u063a"],
            ["\u0647", "\u200c"],
            ["\u0698", "\u0623"],
            ["\u06a9", "\u0643"],
            ["\u0644", "\u06b5"],
            ["\u061b", ":"],
            ["'", '"'],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u0632", "\u0636"],
            ["\u062e", "\u0635"],
            ["\u062c", "\u0686"],
            ["\u06a4", "\u0638"],
            ["\u0628", "\u0649"],
            ["\u0646", "\u0629"],
            ["\u0645", "\u0640"],
            ["\u060c", "<"],
            [".", ">"],
            ["/", "\u061f"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout.Kurdish.lang = ["ku"];
    this.VKI_layout.Lithuanian = [
        [
            ["`", "~"],
            ["\u0105", "\u0104"],
            ["\u010D", "\u010C"],
            ["\u0119", "\u0118"],
            ["\u0117", "\u0116"],
            ["\u012F", "\u012E"],
            ["\u0161", "\u0160"],
            ["\u0173", "\u0172"],
            ["\u016B", "\u016A"],
            ["\u201E", "("],
            ["\u201C", ")"],
            ["-", "_"],
            ["\u017E", "\u017D"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["[", "{"],
            ["]", "}"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            [";", ":"],
            ["'", '"'],
            ["\\", "|"]
        ],
        [
            ["Shift", "Shift"],
            ["\u2013", "\u20AC"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            [",", "<"],
            [".", ">"],
            ["/", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout.Lithuanian.lang = ["lt"];
    this.VKI_layout.Macedonian = [
        [
            ["`", "~"],
            ["1", "!"],
            ["2", "\u201E"],
            ["3", "\u201C"],
            ["4", "\u2019"],
            ["5", "%"],
            ["6", "\u2018"],
            ["7", "&"],
            ["8", "*"],
            ["9", "("],
            ["0", ")"],
            ["-", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0459", "\u0409"],
            ["\u045A", "\u040A"],
            ["\u0435", "\u0415", "\u20AC"],
            ["\u0440", "\u0420"],
            ["\u0442", "\u0422"],
            ["\u0455", "\u0405"],
            ["\u0443", "\u0423"],
            ["\u0438", "\u0418"],
            ["\u043E", "\u041E"],
            ["\u043F", "\u041F"],
            ["\u0448", "\u0428", "\u0402"],
            ["\u0453", "\u0403", "\u0452"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0430", "\u0410"],
            ["\u0441", "\u0421"],
            ["\u0434", "\u0414"],
            ["\u0444", "\u0424", "["],
            ["\u0433", "\u0413", "]"],
            ["\u0445", "\u0425"],
            ["\u0458", "\u0408"],
            ["\u043A", "\u041A"],
            ["\u043B", "\u041B"],
            ["\u0447", "\u0427", "\u040B"],
            ["\u045C", "\u040C", "\u045B"],
            ["\u0436", "\u0416"]
        ],
        [
            ["Shift", "Shift"],
            ["\u0451", "\u0401"],
            ["\u0437", "\u0417"],
            ["\u045F", "\u040F"],
            ["\u0446", "\u0426"],
            ["\u0432", "\u0412", "@"],
            ["\u0431", "\u0411", "{"],
            ["\u043D", "\u041D", "}"],
            ["\u043C", "\u041C", "\u00A7"],
            [",", ";"],
            [".", ":"],
            ["/", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Macedonian.lang = ["mk"];
    this.VKI_layout.Norwegian = [
        [
            ["|", "\u00a7"],
            ["1", "!"],
            ["2", '"', "@"],
            ["3", "#", "\u00a3"],
            ["4", "\u00a4", "$"],
            ["5", "%"],
            ["6", "&"],
            ["7", "/", "{"],
            ["8", "(", "["],
            ["9", ")", "]"],
            ["0", "=", "}"],
            ["+", "?"],
            ["\\", "`", "\u00b4"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["\u00e5", "\u00c5"],
            ["\u00a8", "^", "~"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["\u00f8", "\u00d8"],
            ["\u00e6", "\u00c6"],
            ["'", "*"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M", "\u03bc", "\u039c"],
            [",", ";"],
            [".", ":"],
            ["-", "_"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Norwegian.lang = ["no", "nb", "nn"];
    this.VKI_layout.Numpad = [
        [
            ["$"],
            ["\u00a3"],
            ["\u20ac"],
            ["\u00a5"],
            ["/"],
            ["^"],
            ["Bksp", "Bksp"]
        ],
        [
            ["."],
            ["7"],
            ["8"],
            ["9"],
            ["*"],
            ["<"],
            ["("],
            ["["]
        ],
        [
            ["="],
            ["4"],
            ["5"],
            ["6"],
            ["-"],
            [">"],
            [")"],
            ["]"]
        ],
        [
            ["0"],
            ["1"],
            ["2"],
            ["3"],
            ["+"],
            ["Enter", "Enter"]
        ],
        [
            [" "]
        ]
    ];
    this.VKI_layout.Numpad.DDK = true;
    this.VKI_layout.Numpad.lang = ["num"];
    this.VKI_layout.Pashto = [
        [
            ["\u200d", "\u00f7", "`"],
            ["\u06f1", "!", "`"],
            ["\u06f2", "\u066c", "@"],
            ["\u06f3", "\u066b", "\u066b"],
            ["\u06f4", "\u00a4", "\u00a3"],
            ["\u06f5", "\u066a", "%"],
            ["\u06f6", "\u00d7", "^"],
            ["\u06f7", "\u00ab", "&"],
            ["\u06f8", "\u00bb", "*"],
            ["\u06f9", "(", "\ufdf2"],
            ["\u06f0", ")", "\ufefb"],
            ["-", "\u0640", "_"],
            ["=", "+", "\ufe87", "\u00f7"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0636", "\u0652", "\u06d5"],
            ["\u0635", "\u064c", "\u0653"],
            ["\u062b", "\u064d", "\u20ac"],
            ["\u0642", "\u064b", "\ufef7"],
            ["\u0641", "\u064f", "\ufef5"],
            ["\u063a", "\u0650", "'"],
            ["\u0639", "\u064e", "\ufe84"],
            ["\u0647", "\u0651", "\u0670"],
            ["\u062e", "\u0681", "'"],
            ["\u062d", "\u0685", '"'],
            ["\u062c", "]", "}"],
            ["\u0686", "[", "{"],
            ["\\", "\u066d", "|"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0634", "\u069a", "\ufbb0"],
            ["\u0633", "\u06cd", "\u06d2"],
            ["\u06cc", "\u064a", "\u06d2"],
            ["\u0628", "\u067e", "\u06ba"],
            ["\u0644", "\u0623", "\u06b7"],
            ["\u0627", "\u0622", "\u0671"],
            ["\u062a", "\u067c", "\u0679"],
            ["\u0646", "\u06bc", "<"],
            ["\u0645", "\u0629", ">"],
            ["\u06a9", ":", "\u0643"],
            ["\u06af", "\u061b", "\u06ab"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u0638", "\u0626", "?"],
            ["\u0637", "\u06d0", ";"],
            ["\u0632", "\u0698", "\u0655"],
            ["\u0631", "\u0621", "\u0654"],
            ["\u0630", "\u200c", "\u0625"],
            ["\u062f", "\u0689", "\u0688"],
            ["\u0693", "\u0624", "\u0691"],
            ["\u0648", "\u060c", ","],
            ["\u0696", ".", "\u06c7"],
            ["/", "\u061f", "\u06c9"],
            ["Shift", "Shift", "\u064d"]
        ],
        [
            [" ", " ", " ", " "],
            ["Alt", "Alt"]
        ]
    ];
    this.VKI_layout.Pashto.lang = ["ps"];
    this.VKI_layout.Pinyin = [
        [
            ["`", "~", "\u4e93", "\u301C"],
            ["1", "!", "\uFF62"],
            ["2", "@", "\uFF63"],
            ["3", "#", "\u301D"],
            ["4", "$", "\u301E"],
            ["5", "%", "\u301F"],
            ["6", "^", "\u3008"],
            ["7", "&", "\u3009"],
            ["8", "*", "\u302F"],
            ["9", "(", "\u300A"],
            ["0", ")", "\u300B"],
            ["-", "_", "\u300E"],
            ["=", "+", "\u300F"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q", "\u0101", "\u0100"],
            ["w", "W", "\u00E1", "\u00C1"],
            ["e", "E", "\u01CE", "\u01CD"],
            ["r", "R", "\u00E0", "\u00C0"],
            ["t", "T", "\u0113", "\u0112"],
            ["y", "Y", "\u00E9", "\u00C9"],
            ["u", "U", "\u011B", "\u011A"],
            ["i", "I", "\u00E8", "\u00C8"],
            ["o", "O", "\u012B", "\u012A"],
            ["p", "P", "\u00ED", "\u00CD"],
            ["[", "{", "\u01D0", "\u01CF"],
            ["]", "}", "\u00EC", "\u00CC"],
            ["\\", "|", "\u3020"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A", "\u014D", "\u014C"],
            ["s", "S", "\u00F3", "\u00D3"],
            ["d", "D", "\u01D2", "\u01D1"],
            ["f", "F", "\u00F2", "\u00D2"],
            ["g", "G", "\u00fc", "\u00dc"],
            ["h", "H", "\u016B", "\u016A"],
            ["j", "J", "\u00FA", "\u00DA"],
            ["k", "K", "\u01D4", "\u01D3"],
            ["l", "L", "\u00F9", "\u00D9"],
            [";", ":"],
            ["'", '"'],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["z", "Z", "\u01D6", "\u01D5"],
            ["x", "X", "\u01D8", "\u01D7"],
            ["c", "C", "\u01DA", "\u01D9"],
            ["v", "V", "\u01DC", "\u01DB"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            [",", "<", "\u3001"],
            [".", ">", "\u3002"],
            ["/", "?"],
            ["Shift", "Shift"]
        ],
        [
            ["AltLk", "AltLk"],
            [" ", " ", " ", " "],
            ["Alt", "Alt"]
        ]
    ];
    this.VKI_layout.Pinyin.lang = ["zh-Latn"];
    this.VKI_layout["Polish Prog"] = [
        [
            ["`", "~"],
            ["1", "!"],
            ["2", "@"],
            ["3", "#"],
            ["4", "$"],
            ["5", "%"],
            ["6", "^"],
            ["7", "&"],
            ["8", "*"],
            ["9", "("],
            ["0", ")"],
            ["-", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E", "\u0119", "\u0118"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O", "\u00f3", "\u00d3"],
            ["p", "P"],
            ["[", "{"],
            ["]", "}"],
            ["\\", "|"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A", "\u0105", "\u0104"],
            ["s", "S", "\u015b", "\u015a"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L", "\u0142", "\u0141"],
            [";", ":"],
            ["'", '"'],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["z", "Z", "\u017c", "\u017b"],
            ["x", "X", "\u017a", "\u0179"],
            ["c", "C", "\u0107", "\u0106"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N", "\u0144", "\u0143"],
            ["m", "M"],
            [",", "<"],
            [".", ">"],
            ["/", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["Alt", "Alt"]
        ]
    ];
    this.VKI_layout["Polish Prog"].lang = ["pl"];
    this.VKI_layout["Portuguese Br"] = [
        [
            ["'", '"'],
            ["1", "!", "\u00b9"],
            ["2", "@", "\u00b2"],
            ["3", "#", "\u00b3"],
            ["4", "$", "\u00a3"],
            ["5", "%", "\u00a2"],
            ["6", "\u00a8", "\u00ac"],
            ["7", "&"],
            ["8", "*"],
            ["9", "("],
            ["0", ")"],
            ["-", "_"],
            ["=", "+", "\u00a7"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q", "/"],
            ["w", "W", "?"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["\u00b4", "`"],
            ["[", "{", "\u00aa"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["\u00e7", "\u00c7"],
            ["~", "^"],
            ["]", "}", "\u00ba"],
            ["/", "?"]
        ],
        [
            ["Shift", "Shift"],
            ["\\", "|"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C", "\u20a2"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            [",", "<"],
            [".", ">"],
            [":", ":"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout["Portuguese Br"].lang = ["pt-br"];
    this.VKI_layout["Portuguese Pt"] = [
        [
            ["\\", "|"],
            ["1", "!"],
            ["2", '"', "@"],
            ["3", "#", "\u00a3"],
            ["4", "$", "\u00a7"],
            ["5", "%"],
            ["6", "&"],
            ["7", "/", "{"],
            ["8", "(", "["],
            ["9", ")", "]"],
            ["0", "=", "}"],
            ["'", "?"],
            ["\u00ab", "\u00bb"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["+", "*", "\u00a8"],
            ["\u00b4", "`"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["\u00e7", "\u00c7"],
            ["\u00ba", "\u00aa"],
            ["~", "^"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">", "\\"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            [",", ";"],
            [".", ":"],
            ["-", "_"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout["Portuguese Pt"].lang = ["pt"];
    this.VKI_layout.Romanian = [
        [
            ["\u201E", "\u201D", "`", "~"],
            ["1", "!", "~"],
            ["2", "@", "\u02C7"],
            ["3", "#", "^"],
            ["4", "$", "\u02D8"],
            ["5", "%", "\u00B0"],
            ["6", "^", "\u02DB"],
            ["7", "&", "`"],
            ["8", "*", "\u02D9"],
            ["9", "(", "\u00B4"],
            ["0", ")", "\u02DD"],
            ["-", "_", "\u00A8"],
            ["=", "+", "\u00B8", "\u00B1"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E", "\u20AC"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P", "\u00A7"],
            ["\u0103", "\u0102", "[", "{"],
            ["\u00EE", "\u00CE", "]", "}"],
            ["\u00E2", "\u00C2", "\\", "|"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S", "\u00df"],
            ["d", "D", "\u00f0", "\u00D0"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L", "\u0142", "\u0141"],
            [(this.VKI_isIElt8) ? "\u015F" : "\u0219", (this.VKI_isIElt8) ? "\u015E" : "\u0218", ";", ":"],
            [(this.VKI_isIElt8) ? "\u0163" : "\u021B", (this.VKI_isIElt8) ? "\u0162" : "\u021A", "'", '"'],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\\", "|"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C", "\u00A9"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            [",", ";", "<", "\u00AB"],
            [".", ":", ">", "\u00BB"],
            ["/", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Romanian.lang = ["ro"];
    this.VKI_layout.Russian = [
        [
            ["\u0451", "\u0401"],
            ["1", "!"],
            ["2", '"'],
            ["3", "\u2116"],
            ["4", ";"],
            ["5", "%"],
            ["6", ":"],
            ["7", "?"],
            ["8", "*"],
            ["9", "("],
            ["0", ")"],
            ["-", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0439", "\u0419"],
            ["\u0446", "\u0426"],
            ["\u0443", "\u0423"],
            ["\u043A", "\u041A"],
            ["\u0435", "\u0415"],
            ["\u043D", "\u041D"],
            ["\u0433", "\u0413"],
            ["\u0448", "\u0428"],
            ["\u0449", "\u0429"],
            ["\u0437", "\u0417"],
            ["\u0445", "\u0425"],
            ["\u044A", "\u042A"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0444", "\u0424"],
            ["\u044B", "\u042B"],
            ["\u0432", "\u0412"],
            ["\u0430", "\u0410"],
            ["\u043F", "\u041F"],
            ["\u0440", "\u0420"],
            ["\u043E", "\u041E"],
            ["\u043B", "\u041B"],
            ["\u0434", "\u0414"],
            ["\u0436", "\u0416"],
            ["\u044D", "\u042D"],
            ["\\", "/"]
        ],
        [
            ["Shift", "Shift"],
            ["/", "|"],
            ["\u044F", "\u042F"],
            ["\u0447", "\u0427"],
            ["\u0441", "\u0421"],
            ["\u043C", "\u041C"],
            ["\u0438", "\u0418"],
            ["\u0442", "\u0422"],
            ["\u044C", "\u042C"],
            ["\u0431", "\u0411"],
            ["\u044E", "\u042E"],
            [".", ","],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout.Russian.lang = ["ru"];
    this.VKI_layout.SerbianCyr = [
        [
            ["`", "~"],
            ["1", "!"],
            ["2", '"'],
            ["3", "#"],
            ["4", "$"],
            ["5", "%"],
            ["6", "&"],
            ["7", "/"],
            ["8", "("],
            ["9", ")"],
            ["0", "="],
            ["'", "?"],
            ["+", "*"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0459", "\u0409"],
            ["\u045a", "\u040a"],
            ["\u0435", "\u0415", "\u20ac"],
            ["\u0440", "\u0420"],
            ["\u0442", "\u0422"],
            ["\u0437", "\u0417"],
            ["\u0443", "\u0423"],
            ["\u0438", "\u0418"],
            ["\u043e", "\u041e"],
            ["\u043f", "\u041f"],
            ["\u0448", "\u0428"],
            ["\u0452", "\u0402"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0430", "\u0410"],
            ["\u0441", "\u0421"],
            ["\u0434", "\u0414"],
            ["\u0444", "\u0424"],
            ["\u0433", "\u0413"],
            ["\u0445", "\u0425"],
            ["\u0458", "\u0408"],
            ["\u043a", "\u041a"],
            ["\u043b", "\u041b"],
            ["\u0447", "\u0427"],
            ["\u045b", "\u040b"],
            ["\u0436", "\u0416"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">"],
            ["\u0455", "\u0405"],
            ["\u045f", "\u040f"],
            ["\u0446", "\u0426"],
            ["\u0432", "\u0412"],
            ["\u0431", "\u0411"],
            ["\u043d", "\u041d"],
            ["\u043c", "\u041c"],
            [",", ";", "<"],
            [".", ":", ">"],
            ["-", "_", "\u00a9"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.SerbianCyr.lang = ["sr-Cyrl"];
    this.VKI_layout.SerbianLat = [
        [
            ["\u201a", "~"],
            ["1", "!", "~"],
            ["2", '"', "\u02c7"],
            ["3", "#", "^"],
            ["4", "$", "\u02d8"],
            ["5", "%", "\u00b0"],
            ["6", "&", "\u02db"],
            ["7", "/", "`"],
            ["8", "(", "\u02d9"],
            ["9", ")", "\u00b4"],
            ["0", "=", "\u02dd"],
            ["'", "?", "\u00a8"],
            ["+", "*", "\u00b8"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q", "\\"],
            ["w", "W", "|"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["z", "Z"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["\u0161", "\u0160", "\u00f7"],
            ["\u0111", "\u0110", "\u00d7"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F", "["],
            ["g", "G", "]"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K", "\u0142"],
            ["l", "L", "\u0141"],
            ["\u010d", "\u010c"],
            ["\u0107", "\u0106", "\u00df"],
            ["\u017e", "\u017d", "\u00a4"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">"],
            ["y", "Y"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V", "@"],
            ["b", "B", "{"],
            ["n", "N", "}"],
            ["m", "M", "\u00a7"],
            [",", ";", "<"],
            [".", ":", ">"],
            ["-", "_", "\u00a9"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.SerbianLat.lang = ["sr"];
    this.VKI_layout.Slovak = [
        [
            [";", "\u00b0"],
            ["+", "1", "~"],
            ["\u013E", "2", "\u02C7"],
            ["\u0161", "3", "^"],
            ["\u010D", "4", "\u02D8"],
            ["\u0165", "5", "\u00B0"],
            ["\u017E", "6", "\u02DB"],
            ["\u00FD", "7", "`"],
            ["\u00E1", "8", "\u02D9"],
            ["\u00ED", "9", "\u00B4"],
            ["\u00E9", "0", "\u02DD"],
            ["=", "%", "\u00A8"],
            ["\u00B4", "\u02c7", "\u00B8"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q", "\\"],
            ["w", "W", "|"],
            ["e", "E", "\u20AC"],
            ["r", "R"],
            ["t", "T"],
            ["z", "Z"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P", "'"],
            ["\u00FA", "/", "\u00F7"],
            ["\u00E4", "(", "\u00D7"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S", "\u0111"],
            ["d", "D", "\u0110"],
            ["f", "F", "["],
            ["g", "G", "]"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K", "\u0142"],
            ["l", "L", "\u0141"],
            ["\u00F4", '"', "$"],
            ["\u00A7", "!", "\u00DF"],
            ["\u0148", ")", "\u00A4"]
        ],
        [
            ["Shift", "Shift"],
            ["&", "*", "<"],
            ["y", "Y", ">"],
            ["x", "X", "#"],
            ["c", "C", "&"],
            ["v", "V", "@"],
            ["b", "B", "{"],
            ["n", "N", "}"],
            ["m", "M"],
            [",", "?", "<"],
            [".", ":", ">"],
            ["-", "_", "*"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Slovak.lang = ["sk"];
    this.VKI_layout.Slovenian = [
        [
            ["\u00a8", "\u00a8", "\u00b8"],
            ["1", "!", "~"],
            ["2", '"', "\u02c7"],
            ["3", "#", "^"],
            ["4", "$", "\u02d8"],
            ["5", "%", "\u00b0"],
            ["6", "&", "\u02db"],
            ["7", "/", "`"],
            ["8", "(", "\u00B7"],
            ["9", ")", "\u00b4"],
            ["0", "=", "\u2033"],
            ["'", "?", "\u00a8"],
            ["+", "*", "\u00b8"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q", "\\"],
            ["w", "W", "|"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["z", "Z"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["\u0161", "\u0160", "\u00f7"],
            ["\u0111", "\u0110", "\u00d7"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F", "["],
            ["g", "G", "]"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K", "\u0142"],
            ["l", "L", "\u0141"],
            ["\u010D", "\u010C"],
            ["\u0107", "\u0106", "\u00df"],
            ["\u017E", "\u017D", "\u00a4"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">"],
            ["y", "Y"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V", "@"],
            ["b", "B", "{"],
            ["n", "N", "}"],
            ["m", "M", "\u00a7"],
            [",", ";"],
            [".", ":"],
            ["-", "_"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Slovenian.lang = ["sl"];
    this.VKI_layout["Spanish Es"] = [
        [
            ["\u00ba", "\u00aa", "\\"],
            ["1", "!", "|"],
            ["2", '"', "@"],
            ["3", "'", "#"],
            ["4", "$", "~"],
            ["5", "%", "\u20ac"],
            ["6", "&", "\u00ac"],
            ["7", "/"],
            ["8", "("],
            ["9", ")"],
            ["0", "="],
            ["'", "?"],
            ["\u00a1", "\u00bf"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["`", "^", "["],
            ["+", "*", "]"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["\u00f1", "\u00d1"],
            ["\u00b4", "\u00a8", "{"],
            ["\u00e7", "\u00c7", "}"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            [",", ";"],
            [".", ":"],
            ["-", "_"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout["Spanish Es"].lang = ["es"];
    this.VKI_layout.Swedish = [
        [
            ["\u00a7", "\u00bd"],
            ["1", "!"],
            ["2", '"', "@"],
            ["3", "#", "\u00a3"],
            ["4", "\u00a4", "$"],
            ["5", "%", "\u20ac"],
            ["6", "&"],
            ["7", "/", "{"],
            ["8", "(", "["],
            ["9", ")", "]"],
            ["0", "=", "}"],
            ["+", "?", "\\"],
            ["\u00b4", "`"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["\u00e5", "\u00c5"],
            ["\u00a8", "^", "~"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["\u00f6", "\u00d6"],
            ["\u00e4", "\u00c4"],
            ["'", "*"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">", "|"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M", "\u03bc", "\u039c"],
            [",", ";"],
            [".", ":"],
            ["-", "_"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.Swedish.lang = ["sv"];
    this.VKI_layout["Turkish-F"] = [
        [
            ["+", "*", "\u00ac"],
            ["1", "!", "\u00b9", "\u00a1"],
            ["2", '"', "\u00b2"],
            ["3", "^", "#", "\u00b3"],
            ["4", "$", "\u00bc", "\u00a4"],
            ["5", "%", "\u00bd"],
            ["6", "&", "\u00be"],
            ["7", "'", "{"],
            ["8", "(", "["],
            ["9", ")", "]"],
            ["0", "=", "}"],
            ["/", "?", "\\", "\u00bf"],
            ["-", "_", "|"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["f", "F", "@"],
            ["g", "G"],
            ["\u011f", "\u011e"],
            ["\u0131", "I", "\u00b6", "\u00ae"],
            ["o", "O"],
            ["d", "D", "\u00a5"],
            ["r", "R"],
            ["n", "N"],
            ["h", "H", "\u00f8", "\u00d8"],
            ["p", "P", "\u00a3"],
            ["q", "Q", "\u00a8"],
            ["w", "W", "~"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["u", "U", "\u00e6", "\u00c6"],
            ["i", "\u0130", "\u00df", "\u00a7"],
            ["e", "E", "\u20ac"],
            ["a", "A", " ", "\u00aa"],
            ["\u00fc", "\u00dc"],
            ["t", "T"],
            ["k", "K"],
            ["m", "M"],
            ["l", "L"],
            ["y", "Y", "\u00b4"],
            ["\u015f", "\u015e"],
            ["x", "X", "`"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">", "|", "\u00a6"],
            ["j", "J", "\u00ab", "<"],
            ["\u00f6", "\u00d6", "\u00bb", ">"],
            ["v", "V", "\u00a2", "\u00a9"],
            ["c", "C"],
            ["\u00e7", "\u00c7"],
            ["z", "Z"],
            ["s", "S", "\u00b5", "\u00ba"],
            ["b", "B", "\u00d7"],
            [".", ":", "\u00f7"],
            [",", ";", "-"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout["Turkish-Q"] = [
        [
            ['"', "\u00e9", "<"],
            ["1", "!", ">"],
            ["2", "'", "\u00a3"],
            ["3", "^", "#"],
            ["4", "+", "$"],
            ["5", "%", "\u00bd"],
            ["6", "&"],
            ["7", "/", "{"],
            ["8", "(", "["],
            ["9", ")", "]"],
            ["0", "=", "}"],
            ["*", "?", "\\"],
            ["-", "_", "|"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q", "@"],
            ["w", "W"],
            ["e", "E", "\u20ac"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["\u0131", "I", "i", "\u0130"],
            ["o", "O"],
            ["p", "P"],
            ["\u011f", "\u011e", "\u00a8"],
            ["\u00fc", "\u00dc", "~"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A", "\u00e6", "\u00c6"],
            ["s", "S", "\u00df"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            ["\u015f", "\u015e", "\u00b4"],
            ["i", "\u0130"],
            [",", ";", "`"]
        ],
        [
            ["Shift", "Shift"],
            ["<", ">", "|"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            ["\u00f6", "\u00d6"],
            ["\u00e7", "\u00c7"],
            [".", ":"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout["Turkish-Q"].lang = ["tr"];
    this.VKI_layout.UK = [
        [
            ["`", "\u00ac", "\u00a6"],
            ["1", "!"],
            ["2", '"'],
            ["3", "\u00a3"],
            ["4", "$", "\u20ac"],
            ["5", "%"],
            ["6", "^"],
            ["7", "&"],
            ["8", "*"],
            ["9", "("],
            ["0", ")"],
            ["-", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E", "\u00e9", "\u00c9"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U", "\u00fa", "\u00da"],
            ["i", "I", "\u00ed", "\u00cd"],
            ["o", "O", "\u00f3", "\u00d3"],
            ["p", "P"],
            ["[", "{"],
            ["]", "}"],
            ["Enter", "Enter"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A", "\u00e1", "\u00c1"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            [";", ":"],
            ["'", "@"],
            ["#", "~"]
        ],
        [
            ["Shift", "Shift"],
            ["\\", "|"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            [",", "<"],
            [".", ">"],
            ["/", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["AltGr", "AltGr"]
        ]
    ];
    this.VKI_layout.UK.lang = ["en-gb"];
    this.VKI_layout.Ukrainian = [
        [
            ["\u00b4", "~"],
            ["1", "!"],
            ["2", '"'],
            ["3", "\u2116"],
            ["4", ";"],
            ["5", "%"],
            ["6", ":"],
            ["7", "?"],
            ["8", "*"],
            ["9", "("],
            ["0", ")"],
            ["-", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["\u0439", "\u0419"],
            ["\u0446", "\u0426"],
            ["\u0443", "\u0423"],
            ["\u043A", "\u041A"],
            ["\u0435", "\u0415"],
            ["\u043D", "\u041D"],
            ["\u0433", "\u0413"],
            ["\u0448", "\u0428"],
            ["\u0449", "\u0429"],
            ["\u0437", "\u0417"],
            ["\u0445", "\u0425"],
            ["\u0457", "\u0407"],
            ["\u0491", "\u0490"]
        ],
        [
            ["Caps", "Caps"],
            ["\u0444", "\u0424"],
            ["\u0456", "\u0406"],
            ["\u0432", "\u0412"],
            ["\u0430", "\u0410"],
            ["\u043F", "\u041F"],
            ["\u0440", "\u0420"],
            ["\u043E", "\u041E"],
            ["\u043B", "\u041B"],
            ["\u0434", "\u0414"],
            ["\u0436", "\u0416"],
            ["\u0454", "\u0404"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["\u044F", "\u042F"],
            ["\u0447", "\u0427"],
            ["\u0441", "\u0421"],
            ["\u043C", "\u041C"],
            ["\u0438", "\u0418"],
            ["\u0442", "\u0422"],
            ["\u044C", "\u042C"],
            ["\u0431", "\u0411"],
            ["\u044E", "\u042E"],
            [".", ","],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout.Ukrainian.lang = ["uk"];
    this.VKI_layout.US = [
        [
            ["`", "~"],
            ["1", "!"],
            ["2", "@"],
            ["3", "#"],
            ["4", "$"],
            ["5", "%"],
            ["6", "^"],
            ["7", "&"],
            ["8", "*"],
            ["9", "("],
            ["0", ")"],
            ["-", "_"],
            ["=", "+"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q"],
            ["w", "W"],
            ["e", "E"],
            ["r", "R"],
            ["t", "T"],
            ["y", "Y"],
            ["u", "U"],
            ["i", "I"],
            ["o", "O"],
            ["p", "P"],
            ["[", "{"],
            ["]", "}"],
            ["\\", "|"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A"],
            ["s", "S"],
            ["d", "D"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L"],
            [";", ":"],
            ["'", '"'],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["z", "Z"],
            ["x", "X"],
            ["c", "C"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N"],
            ["m", "M"],
            [",", "<"],
            [".", ">"],
            ["/", "?"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " "]
        ]
    ];
    this.VKI_layout.US.lang = ["en-us"];
    this.VKI_layout["US Int'l"] = [
        [
            ["`", "~"],
            ["1", "!", "\u00a1", "\u00b9"],
            ["2", "@", "\u00b2"],
            ["3", "#", "\u00b3"],
            ["4", "$", "\u00a4", "\u00a3"],
            ["5", "%", "\u20ac"],
            ["6", "^", "\u00bc"],
            ["7", "&", "\u00bd"],
            ["8", "*", "\u00be"],
            ["9", "(", "\u2018"],
            ["0", ")", "\u2019"],
            ["-", "_", "\u00a5"],
            ["=", "+", "\u00d7", "\u00f7"],
            ["Bksp", "Bksp"]
        ],
        [
            ["Tab", "Tab"],
            ["q", "Q", "\u00e4", "\u00c4"],
            ["w", "W", "\u00e5", "\u00c5"],
            ["e", "E", "\u00e9", "\u00c9"],
            ["r", "R", "\u00ae"],
            ["t", "T", "\u00fe", "\u00de"],
            ["y", "Y", "\u00fc", "\u00dc"],
            ["u", "U", "\u00fa", "\u00da"],
            ["i", "I", "\u00ed", "\u00cd"],
            ["o", "O", "\u00f3", "\u00d3"],
            ["p", "P", "\u00f6", "\u00d6"],
            ["[", "{", "\u00ab"],
            ["]", "}", "\u00bb"],
            ["\\", "|", "\u00ac", "\u00a6"]
        ],
        [
            ["Caps", "Caps"],
            ["a", "A", "\u00e1", "\u00c1"],
            ["s", "S", "\u00df", "\u00a7"],
            ["d", "D", "\u00f0", "\u00d0"],
            ["f", "F"],
            ["g", "G"],
            ["h", "H"],
            ["j", "J"],
            ["k", "K"],
            ["l", "L", "\u00f8", "\u00d8"],
            [";", ":", "\u00b6", "\u00b0"],
            ["'", '"', "\u00b4", "\u00a8"],
            ["Enter", "Enter"]
        ],
        [
            ["Shift", "Shift"],
            ["z", "Z", "\u00e6", "\u00c6"],
            ["x", "X"],
            ["c", "C", "\u00a9", "\u00a2"],
            ["v", "V"],
            ["b", "B"],
            ["n", "N", "\u00f1", "\u00d1"],
            ["m", "M", "\u00b5"],
            [",", "<", "\u00e7", "\u00c7"],
            [".", ">"],
            ["/", "?", "\u00bf"],
            ["Shift", "Shift"]
        ],
        [
            [" ", " ", " ", " "],
            ["Alt", "Alt"]
        ]
    ];
    this.VKI_layout["US Int'l"].lang = ["en"];
    this.VKI_deadkey = {};
    this.VKI_deadkey['"'] = this.VKI_deadkey["\u00a8"] = [
        ["a", "\u00e4"],
        ["e", "\u00eb"],
        ["i", "\u00ef"],
        ["o", "\u00f6"],
        ["u", "\u00fc"],
        ["y", "\u00ff"],
        ["\u03b9", "\u03ca"],
        ["\u03c5", "\u03cb"],
        ["\u016B", "\u01D6"],
        ["\u00FA", "\u01D8"],
        ["\u01D4", "\u01DA"],
        ["\u00F9", "\u01DC"],
        ["A", "\u00c4"],
        ["E", "\u00cb"],
        ["I", "\u00cf"],
        ["O", "\u00d6"],
        ["U", "\u00dc"],
        ["Y", "\u0178"],
        ["\u0399", "\u03aa"],
        ["\u03a5", "\u03ab"],
        ["\u016A", "\u01D5"],
        ["\u00DA", "\u01D7"],
        ["\u01D3", "\u01D9"],
        ["\u00D9", "\u01DB"],
        ["\u304b", "\u304c"],
        ["\u304d", "\u304e"],
        ["\u304f", "\u3050"],
        ["\u3051", "\u3052"],
        ["\u3053", "\u3054"],
        ["\u305f", "\u3060"],
        ["\u3061", "\u3062"],
        ["\u3064", "\u3065"],
        ["\u3066", "\u3067"],
        ["\u3068", "\u3069"],
        ["\u3055", "\u3056"],
        ["\u3057", "\u3058"],
        ["\u3059", "\u305a"],
        ["\u305b", "\u305c"],
        ["\u305d", "\u305e"],
        ["\u306f", "\u3070"],
        ["\u3072", "\u3073"],
        ["\u3075", "\u3076"],
        ["\u3078", "\u3079"],
        ["\u307b", "\u307c"],
        ["\u30ab", "\u30ac"],
        ["\u30ad", "\u30ae"],
        ["\u30af", "\u30b0"],
        ["\u30b1", "\u30b2"],
        ["\u30b3", "\u30b4"],
        ["\u30bf", "\u30c0"],
        ["\u30c1", "\u30c2"],
        ["\u30c4", "\u30c5"],
        ["\u30c6", "\u30c7"],
        ["\u30c8", "\u30c9"],
        ["\u30b5", "\u30b6"],
        ["\u30b7", "\u30b8"],
        ["\u30b9", "\u30ba"],
        ["\u30bb", "\u30bc"],
        ["\u30bd", "\u30be"],
        ["\u30cf", "\u30d0"],
        ["\u30d2", "\u30d3"],
        ["\u30d5", "\u30d6"],
        ["\u30d8", "\u30d9"],
        ["\u30db", "\u30dc"]
    ];
    this.VKI_deadkey["~"] = [
        ["a", "\u00e3"],
        ["l", "\u0142"],
        ["n", "\u00f1"],
        ["o", "\u00f5"],
        ["A", "\u00c3"],
        ["L", "\u0141"],
        ["N", "\u00d1"],
        ["O", "\u00d5"]
    ];
    this.VKI_deadkey["^"] = [
        ["a", "\u00e2"],
        ["e", "\u00ea"],
        ["i", "\u00ee"],
        ["o", "\u00f4"],
        ["u", "\u00fb"],
        ["w", "\u0175"],
        ["y", "\u0177"],
        ["A", "\u00c2"],
        ["E", "\u00ca"],
        ["I", "\u00ce"],
        ["O", "\u00d4"],
        ["U", "\u00db"],
        ["W", "\u0174"],
        ["Y", "\u0176"]
    ];
    this.VKI_deadkey["\u02c7"] = [
        ["c", "\u010D"],
        ["d", "\u010f"],
        ["e", "\u011b"],
        ["s", "\u0161"],
        ["l", "\u013e"],
        ["n", "\u0148"],
        ["r", "\u0159"],
        ["t", "\u0165"],
        ["u", "\u01d4"],
        ["z", "\u017E"],
        ["\u00fc", "\u01da"],
        ["C", "\u010C"],
        ["D", "\u010e"],
        ["E", "\u011a"],
        ["S", "\u0160"],
        ["L", "\u013d"],
        ["N", "\u0147"],
        ["R", "\u0158"],
        ["T", "\u0164"],
        ["U", "\u01d3"],
        ["Z", "\u017D"],
        ["\u00dc", "\u01d9"]
    ];
    this.VKI_deadkey["\u02d8"] = [
        ["a", "\u0103"],
        ["g", "\u011f"],
        ["A", "\u0102"],
        ["G", "\u011e"]
    ];
    this.VKI_deadkey["-"] = this.VKI_deadkey["\u00af"] = [
        ["a", "\u0101"],
        ["e", "\u0113"],
        ["i", "\u012b"],
        ["o", "\u014d"],
        ["u", "\u016B"],
        ["y", "\u0233"],
        ["\u00fc", "\u01d6"],
        ["A", "\u0100"],
        ["E", "\u0112"],
        ["I", "\u012a"],
        ["O", "\u014c"],
        ["U", "\u016A"],
        ["Y", "\u0232"],
        ["\u00dc", "\u01d5"]
    ];
    this.VKI_deadkey["`"] = [
        ["a", "\u00e0"],
        ["e", "\u00e8"],
        ["i", "\u00ec"],
        ["o", "\u00f2"],
        ["u", "\u00f9"],
        ["\u00fc", "\u01dc"],
        ["A", "\u00c0"],
        ["E", "\u00c8"],
        ["I", "\u00cc"],
        ["O", "\u00d2"],
        ["U", "\u00d9"],
        ["\u00dc", "\u01db"]
    ];
    this.VKI_deadkey["'"] = this.VKI_deadkey["\u00b4"] = this.VKI_deadkey["\u0384"] = [
        ["a", "\u00e1"],
        ["e", "\u00e9"],
        ["i", "\u00ed"],
        ["o", "\u00f3"],
        ["u", "\u00fa"],
        ["y", "\u00fd"],
        ["\u03b1", "\u03ac"],
        ["\u03b5", "\u03ad"],
        ["\u03b7", "\u03ae"],
        ["\u03b9", "\u03af"],
        ["\u03bf", "\u03cc"],
        ["\u03c5", "\u03cd"],
        ["\u03c9", "\u03ce"],
        ["\u00fc", "\u01d8"],
        ["A", "\u00c1"],
        ["E", "\u00c9"],
        ["I", "\u00cd"],
        ["O", "\u00d3"],
        ["U", "\u00da"],
        ["Y", "\u00dd"],
        ["\u0391", "\u0386"],
        ["\u0395", "\u0388"],
        ["\u0397", "\u0389"],
        ["\u0399", "\u038a"],
        ["\u039f", "\u038c"],
        ["\u03a5", "\u038e"],
        ["\u03a9", "\u038f"],
        ["\u00dc", "\u01d7"]
    ];
    this.VKI_deadkey["\u02dd"] = [
        ["o", "\u0151"],
        ["u", "\u0171"],
        ["O", "\u0150"],
        ["U", "\u0170"]
    ];
    this.VKI_deadkey["\u0385"] = [
        ["\u03b9", "\u0390"],
        ["\u03c5", "\u03b0"]
    ];
    this.VKI_deadkey["\u00b0"] = this.VKI_deadkey["\u00ba"] = [
        ["a", "\u00e5"],
        ["u", "\u016f"],
        ["A", "\u00c5"],
        ["U", "\u016e"]
    ];
    this.VKI_deadkey["\u02DB"] = [
        ["a", "\u0106"],
        ["e", "\u0119"],
        ["i", "\u012f"],
        ["o", "\u01eb"],
        ["u", "\u0173"],
        ["y", "\u0177"],
        ["A", "\u0105"],
        ["E", "\u0118"],
        ["I", "\u012e"],
        ["O", "\u01ea"],
        ["U", "\u0172"],
        ["Y", "\u0176"]
    ];
    this.VKI_deadkey["\u02D9"] = [
        ["c", "\u010B"],
        ["e", "\u0117"],
        ["g", "\u0121"],
        ["z", "\u017C"],
        ["C", "\u010A"],
        ["E", "\u0116"],
        ["G", "\u0120"],
        ["Z", "\u017B"]
    ];
    this.VKI_deadkey["\u00B8"] = this.VKI_deadkey["\u201a"] = [
        ["c", "\u00e7"],
        ["s", "\u015F"],
        ["C", "\u00c7"],
        ["S", "\u015E"]
    ];
    this.VKI_deadkey[","] = [
        ["s", (this.VKI_isIElt8) ? "\u015F" : "\u0219"],
        ["t", (this.VKI_isIElt8) ? "\u0163" : "\u021B"],
        ["S", (this.VKI_isIElt8) ? "\u015E" : "\u0218"],
        ["T", (this.VKI_isIElt8) ? "\u0162" : "\u021A"]
    ];
    this.VKI_deadkey["\u3002"] = [
        ["\u306f", "\u3071"],
        ["\u3072", "\u3074"],
        ["\u3075", "\u3077"],
        ["\u3078", "\u307a"],
        ["\u307b", "\u307d"],
        ["\u30cf", "\u30d1"],
        ["\u30d2", "\u30d4"],
        ["\u30d5", "\u30d7"],
        ["\u30d8", "\u30da"],
        ["\u30db", "\u30dd"]
    ];
    this.VKI_symbol = {
        "\u200c": "ZW\r\nNJ",
        "\u200d": "ZW\r\nJ"
    };
    this.VKI_attachKeyboard = VKI_attach = function(w) {
        if (w.getAttribute("VKI_attached")) {
            return false
        }
        if (this.VKI_imageURI) {
            var v = document.createElement("img");
            v.src = this.VKI_imageURI;
            v.alt = this.VKI_i18n["00"];
            v.className = "keyboardInputInitiator";
            v.title = this.VKI_i18n["01"];
            v.elem = w;
            v.style.display = "none";
            v.onclick = function() {
                p.VKI_show(this.elem, event)
            };
            w.onfocus = function() {
                $(".keyboardInputInitiator").hide();
                v.style.display = "inline";
                if ($("#keyboardInputMaster:visible").size() > 0 && p.VKI_target != this) {
                    p.VKI_show(this)
                }
                w.focus()
            };
            $(w).blur(function(x) {});
            w.parentNode.insertBefore(v, (w.dir == "rtl") ? w : w.nextSibling)
        } else {
            w.ondblclick = function() {
                if (p.VKI_target != this) {
                    p.VKI_show(this, event)
                }
            }
        }
        w.setAttribute("VKI_attached", "true");
        if (this.VKI_isIE) {
            w.onclick = w.onselect = w.onkeyup = function(x) {
                if ((x || event).type != "keyup" || !this.readOnly) {
                    this.range = document.selection.createRange()
                }
            }
        }
    };
    var f = [document.getElementsByTagName("input"), document.getElementsByTagName("textarea")];
    for (var m = 0, u; u = f[m++];) {
        for (var l = 0, s; s = u[l++];) {
            if ((s.nodeName == "TEXTAREA" || s.type == "text" || s.type == "password") && s.className.indexOf("keyboardInput") > -1) {
                this.VKI_attachKeyboard(s)
            }
        }
    }
    this.VKI_keyboard = document.createElement("table");
    this.VKI_keyboard.id = "keyboardInputMaster";
    this.VKI_keyboard.dir = "ltr";
    this.VKI_keyboard.cellSpacing = this.VKI_keyboard.border = "0";
    var t = document.createElement("thead");
    var b = document.createElement("tr");
    var h = document.createElement("th");
    var q = document.createElement("abbr");
    q.title = this.VKI_i18n["00"];
    q.appendChild(document.createTextNode("VKI"));
    var k = document.createElement("select");
    k.title = this.VKI_i18n["02"];
    for (ktype in this.VKI_layout) {
        if (typeof this.VKI_layout[ktype] == "object") {
            if (!this.VKI_layout[ktype].lang) {
                this.VKI_layout[ktype].lang = []
            }
            var c = document.createElement("option");
            c.value = ktype;
            c.appendChild(document.createTextNode(ktype));
            k.appendChild(c)
        }
    }
    if (k.options.length) {
        k.value = this.VKI_kt;
        k.onchange = function() {
            p.VKI_kts = p.VKI_kt = this.value;
            p.VKI_buildKeys();
            p.VKI_position(true)
        };
        h.appendChild(k)
    }
    if (this.VKI_sizeAdj) {
        this.VKI_size = Math.min(5, Math.max(1, this.VKI_size));
        var e = document.createElement("select");
        e.title = this.VKI_i18n["10"];
        for (var m = 1; m <= 5; m++) {
            var c = document.createElement("option");
            c.value = m;
            c.appendChild(document.createTextNode(m));
            e.appendChild(c)
        }
        e.value = this.VKI_size;
        e.change = function() {
            p.VKI_size = this.value;
            p.VKI_keyboard.className = p.VKI_keyboard.className.replace(/ ?keyboardInputSize\d ?/, "");
            if (this.value != 2) {
                p.VKI_keyboard.className += " keyboardInputSize" + this.value
            }
            p.VKI_position(true)
        };
        e.onchange = e.change;
        h.appendChild(e)
    }
    var j = document.createElement("label");
    var o = document.createElement("input");
    o.type = "checkbox";
    o.title = this.VKI_i18n["03"] + ": " + ((this.VKI_deadkeysOn) ? this.VKI_i18n["04"] : this.VKI_i18n["05"]);
    o.defaultChecked = this.VKI_deadkeysOn;
    o.onclick = function() {
        p.VKI_deadkeysOn = this.checked;
        this.title = p.VKI_i18n["03"] + ": " + ((this.checked) ? p.VKI_i18n["04"] : p.VKI_i18n["05"]);
        p.VKI_modify("");
        return true
    };
    j.appendChild(this.VKI_deadkeysElem = o);
    o.checked = this.VKI_deadkeysOn;
    h.appendChild(j);
    b.appendChild(h);
    var i = document.createElement("td");
    var d = document.createElement("span");
    d.id = "keyboardInputClear";
    d.appendChild(document.createTextNode(this.VKI_i18n["07"]));
    d.title = this.VKI_i18n["08"];
    d.onmousedown = function() {
        this.className = "pressed"
    };
    d.onmouseup = function() {
        this.className = ""
    };
    d.onclick = function() {
        p.VKI_target.value = "";
        p.VKI_target.focus();
        return false
    };
    i.appendChild(d);
    var r = document.createElement("strong");
    r.id = "keyboardInputClose";
    r.appendChild(document.createTextNode("X"));
    r.title = this.VKI_i18n["06"];
    r.onmousedown = function() {
        this.className = "pressed"
    };
    r.onmouseup = function() {
        this.className = ""
    };
    r.onclick = function() {
        p.VKI_close()
    };
    i.appendChild(r);
    b.appendChild(i);
    t.appendChild(b);
    this.VKI_keyboard.appendChild(t);
    var a = document.createElement("tbody");
    var b = document.createElement("tr");
    var i = document.createElement("td");
    i.colSpan = "2";
    var n = document.createElement("div");
    n.id = "keyboardInputLayout";
    i.appendChild(n);
    if (this.VKI_showVersion) {
        var n = document.createElement("div");
        var g = document.createElement("var");
        g.title = this.VKI_i18n["09"] + " " + this.VKI_version;
        g.appendChild(document.createTextNode("v" + this.VKI_version));
        n.appendChild(g);
        i.appendChild(n)
    }
    b.appendChild(i);
    a.appendChild(b);
    this.VKI_keyboard.appendChild(a);
    if (this.VKI_isIE6) {
        this.VKI_iframe = document.createElement("iframe");
        this.VKI_iframe.style.position = "absolute";
        this.VKI_iframe.style.border = "0px none";
        this.VKI_iframe.style.filter = "mask()";
        this.VKI_iframe.style.zIndex = "999999";
        this.VKI_iframe.src = this.VKI_imageURI
    }
    this.VKI_buildKeys = function() {
        this.VKI_shift = this.VKI_shiftlock = this.VKI_altgr = this.VKI_altgrlock = this.VKI_dead = false;
        this.VKI_deadkeysOn = (this.VKI_layout[this.VKI_kt].DDK) ? false : this.VKI_keyboard.getElementsByTagName("label")[0].getElementsByTagName("input")[0].checked;
        var v = this.VKI_keyboard.tBodies[0].getElementsByTagName("div")[0];
        while (v.firstChild) {
            v.removeChild(v.firstChild)
        }
        for (var I = 0, w = false, B; B = this.VKI_layout[this.VKI_kt][I++];) {
            var K = document.createElement("table");
            K.cellSpacing = K.border = "0";
            if (B.length <= this.VKI_keyCenter) {
                K.className = "keyboardInputCenter"
            }
            var C = document.createElement("tbody");
            var G = document.createElement("tr");
            for (var H = 0, F; F = B[H++];) {
                var A = document.createElement("td");
                if (this.VKI_symbol[F[0]]) {
                    var J = document.createElement("span");
                    J.className = F[0];
                    J.appendChild(document.createTextNode(this.VKI_symbol[F[0]]));
                    A.appendChild(J)
                } else {
                    A.appendChild(document.createTextNode(F[0] || "\xa0"))
                }
                var D = [];
                if (this.VKI_deadkeysOn) {
                    for (key in this.VKI_deadkey) {
                        if (key === F[0]) {
                            D.push("alive");
                            break
                        }
                    }
                }
                if (B.length > this.VKI_keyCenter && H == B.length) {
                    D.push("last")
                }
                if (F[0] == " ") {
                    D.push("space")
                }
                A.className = D.join(" ");
                A.VKI_clickless = 0;
                if (!A.click) {
                    A.click = function() {
                        var x = this.ownerDocument.createEvent("MouseEvents");
                        x.initMouseEvent("click", true, true, this.ownerDocument.defaultView, 1, 0, 0, 0, 0, false, false, false, false, 0, null);
                        this.dispatchEvent(x)
                    }
                }
                A.onmouseover = function() {
                    if (p.VKI_clickless) {
                        var x = this;
                        clearTimeout(this.VKI_clickless);
                        this.VKI_clickless = setTimeout(function() {
                            x.click()
                        }, p.VKI_clickless)
                    }
                    if ((this.firstChild.nodeValue || this.firstChild.className) != "\xa0") {
                        this.className += " hover"
                    }
                };
                A.onmouseout = function() {
                    if (p.VKI_clickless) {
                        clearTimeout(this.VKI_clickless)
                    }
                    this.className = this.className.replace(/ ?(hover|pressed)/g, "")
                };
                A.onmousedown = function() {
                    if (p.VKI_clickless) {
                        clearTimeout(this.VKI_clickless)
                    }
                    if ((this.firstChild.nodeValue || this.firstChild.className) != "\xa0") {
                        this.className += " pressed"
                    }
                };
                A.onmouseup = function() {
                    if (p.VKI_clickless) {
                        clearTimeout(this.VKI_clickless)
                    }
                    this.className = this.className.replace(/ ?pressed/g, "")
                };
                A.ondblclick = function() {
                    return false
                };
                switch (F[1]) {
                    case "Caps":
                    case "Shift":
                    case "Alt":
                    case "AltGr":
                    case "AltLk":
                        A.onclick = (function(x) {
                            return function() {
                                p.VKI_modify(x);
                                return false
                            }
                        })(F[1]);
                        break;
                    case "Tab":
                        A.onclick = function() {
                            p.VKI_insert("\t");
                            return false
                        };
                        break;
                    case "Bksp":
                        A.onclick = function() {
                            p.VKI_target.focus();
                            if (p.VKI_target.setSelectionRange && !p.VKI_target.readOnly) {
                                var x = [p.VKI_target.selectionStart, p.VKI_target.selectionEnd];
                                if (x[0] < x[1]) {
                                    x[0]++
                                }
                                p.VKI_target.value = p.VKI_target.value.substr(0, x[0] - 1) + p.VKI_target.value.substr(x[1]);
                                p.VKI_target.setSelectionRange(x[0] - 1, x[0] - 1)
                            } else {
                                if (p.VKI_target.createTextRange && !p.VKI_target.readOnly) {
                                    try {
                                        p.VKI_target.range.select()
                                    } catch (y) {
                                        p.VKI_target.range = document.selection.createRange()
                                    }
                                    if (!p.VKI_target.range.text.length) {
                                        p.VKI_target.range.moveStart("character", -1)
                                    }
                                    p.VKI_target.range.text = ""
                                } else {
                                    p.VKI_target.value = p.VKI_target.value.substr(0, p.VKI_target.value.length - 1)
                                }
                            }
                            if (p.VKI_shift) {
                                p.VKI_modify("Shift")
                            }
                            if (p.VKI_altgr) {
                                p.VKI_modify("AltGr")
                            }
                            p.VKI_target.focus();
                            return true
                        };
                        break;
                    case "Enter":
                        A.onclick = function() {
                            if (p.VKI_target.nodeName != "TEXTAREA") {
                                p.VKI_close();
                                this.className = this.className.replace(/ ?(hover|pressed)/g, "")
                            } else {
                                p.VKI_insert("\n")
                            }
                            return true
                        };
                        break;
                    default:
                        A.onclick = function() {
                            var L = this.firstChild.nodeValue || this.firstChild.className;
                            if (p.VKI_deadkeysOn && p.VKI_dead) {
                                if (p.VKI_dead != L) {
                                    for (key in p.VKI_deadkey) {
                                        if (key == p.VKI_dead) {
                                            if (L != " ") {
                                                for (var M = 0, y = false, x; x = p.VKI_deadkey[key][M++];) {
                                                    if (x[0] == L) {
                                                        p.VKI_insert(x[1]);
                                                        y = true;
                                                        break
                                                    }
                                                }
                                            } else {
                                                p.VKI_insert(p.VKI_dead);
                                                y = true
                                            }
                                            break
                                        }
                                    }
                                } else {
                                    y = true
                                }
                            }
                            p.VKI_dead = false;
                            if (!y && L != "\xa0") {
                                if (p.VKI_deadkeysOn) {
                                    for (key in p.VKI_deadkey) {
                                        if (key == L) {
                                            p.VKI_dead = key;
                                            this.className += " dead";
                                            if (p.VKI_shift) {
                                                p.VKI_modify("Shift")
                                            }
                                            if (p.VKI_altgr) {
                                                p.VKI_modify("AltGr")
                                            }
                                            break
                                        }
                                    }
                                    if (!p.VKI_dead) {
                                        p.VKI_insert(L)
                                    }
                                } else {
                                    p.VKI_insert(L)
                                }
                            }
                            p.VKI_modify("");
                            if (p.VKI_isOpera) {
                                this.style.width = "50px";
                                var N = this.offsetWidth;
                                this.style.width = ""
                            }
                            return false
                        }
                }
                G.appendChild(A);
                C.appendChild(G);
                K.appendChild(C);
                for (var E = 0; E < 4; E++) {
                    if (this.VKI_deadkey[F[E] = F[E] || "\xa0"]) {
                        w = true
                    }
                }
            }
            v.appendChild(K)
        }
        this.VKI_deadkeysElem.style.display = (!this.VKI_layout[this.VKI_kt].DDK && w) ? "inline" : "none"
    };
    this.VKI_buildKeys();
    this.VKI_keyboard.onselectstart = function() {
        return false
    };
    this.VKI_keyboard.unselectable = "on";
    if (this.VKI_isOpera) {
        this.VKI_keyboard.onmousedown = function() {
            return false
        }
    }
    this.VKI_modify = function(D) {
        switch (D) {
            case "Alt":
            case "AltGr":
                this.VKI_altgr = !this.VKI_altgr;
                break;
            case "AltLk":
                this.VKI_altgr = 0;
                this.VKI_altgrlock = !this.VKI_altgrlock;
                break;
            case "Caps":
                this.VKI_shift = 0;
                this.VKI_shiftlock = !this.VKI_shiftlock;
                break;
            case "Shift":
                this.VKI_shift = !this.VKI_shift;
                break
        }
        var H = 0;
        if (!this.VKI_shift != !this.VKI_shiftlock) {
            H += 1
        }
        if (!this.VKI_altgr != !this.VKI_altgrlock) {
            H += 2
        }
        var I = this.VKI_keyboard.getElementsByTagName("table");
        for (var F = 0; F < I.length; F++) {
            var v = I[F].getElementsByTagName("td");
            for (var E = 0; E < v.length; E++) {
                var A = [],
                    C = this.VKI_layout[this.VKI_kt][F][E];
                if (v[E].className.indexOf("hover") > -1) {
                    A.push("hover")
                }
                switch (C[1]) {
                    case "Alt":
                    case "AltGr":
                        if (this.VKI_altgr) {
                            A.push("dead")
                        }
                        break;
                    case "AltLk":
                        if (this.VKI_altgrlock) {
                            A.push("dead")
                        }
                        break;
                    case "Shift":
                        if (this.VKI_shift) {
                            A.push("dead")
                        }
                        break;
                    case "Caps":
                        if (this.VKI_shiftlock) {
                            A.push("dead")
                        }
                        break;
                    case "Tab":
                    case "Enter":
                    case "Bksp":
                        break;
                    default:
                        if (D) {
                            v[E].removeChild(v[E].firstChild);
                            if (this.VKI_symbol[C[H]]) {
                                var G = document.createElement("span");
                                G.className = C[H];
                                G.appendChild(document.createTextNode(this.VKI_symbol[C[H]]));
                                v[E].appendChild(G)
                            } else {
                                v[E].appendChild(document.createTextNode(C[H]))
                            }
                        }
                        if (this.VKI_deadkeysOn) {
                            var w = v[E].firstChild.nodeValue || v[E].firstChild.className;
                            if (this.VKI_dead) {
                                if (w == this.VKI_dead) {
                                    A.push("dead")
                                }
                                for (var B = 0; B < this.VKI_deadkey[this.VKI_dead].length; B++) {
                                    if (w == this.VKI_deadkey[this.VKI_dead][B][0]) {
                                        A.push("target");
                                        break
                                    }
                                }
                            }
                            for (key in this.VKI_deadkey) {
                                if (key === w) {
                                    A.push("alive");
                                    break
                                }
                            }
                        }
                }
                if (E == v.length - 1 && v.length > this.VKI_keyCenter) {
                    A.push("last")
                }
                if (C[0] == " ") {
                    A.push("space")
                }
                v[E].className = A.join(" ")
            }
        }
    };
    this.VKI_insert = function(v) {
        this.VKI_target.focus();
        if (this.VKI_target.maxLength) {
            this.VKI_target.maxlength = this.VKI_target.maxLength
        }
        if (typeof this.VKI_target.maxlength == "undefined" || this.VKI_target.maxlength < 0 || this.VKI_target.value.length < this.VKI_target.maxlength) {
            this.VKI_target.value += v;
            if (this.VKI_shift) {
                this.VKI_modify("Shift")
            }
            if (this.VKI_altgr) {
                this.VKI_modify("AltGr")
            }
            this.VKI_target.focus()
        } else {
            if (this.VKI_target.createTextRange && this.VKI_target.range) {
                this.VKI_target.range.select()
            }
        }
    };
    this.VKI_show = function(z, B) {
        if (blink.activity.currentStyle && blink.activity.currentStyle.showKeyboard && blink.activity.currentStyle.showKeyboard() && this.elementCanShow(z)) {
            if (!this.VKI_target) {
                this.VKI_target = z;
                if (this.VKI_langAdapt && this.VKI_target.lang) {
                    var y = false,
                        w = [];
                    for (ktype in this.VKI_layout) {
                        if (typeof this.VKI_layout[ktype] == "object") {
                            for (var v = 0; v < this.VKI_layout[ktype].lang.length; v++) {
                                if (this.VKI_layout[ktype].lang[v].toLowerCase() == this.VKI_target.lang.toLowerCase()) {
                                    y = k.value = this.VKI_kt = ktype;
                                    break
                                } else {
                                    if (this.VKI_layout[ktype].lang[v].toLowerCase().indexOf(this.VKI_target.lang.toLowerCase()) == 0) {
                                        w.push([this.VKI_layout[ktype].lang[v], ktype])
                                    }
                                }
                            }
                        }
                        if (y) {
                            break
                        }
                    }
                    if (w.length) {
                        w.sort(function(C, x) {
                            return C[0].length - x[0].length
                        });
                        y = k.value = this.VKI_kt = w[0][1]
                    }
                    if (y) {
                        this.VKI_buildKeys()
                    }
                }
                if (this.VKI_isIE) {
                    if (!this.VKI_target.range) {
                        this.VKI_target.range = this.VKI_target.createTextRange();
                        this.VKI_target.range.moveStart("character", this.VKI_target.value.length)
                    }
                    this.VKI_target.range.select()
                }
                try {
                    this.VKI_keyboard.parentNode.removeChild(this.VKI_keyboard)
                } catch (A) {}
                if (this.VKI_clearPasswords && this.VKI_target.type == "password") {
                    this.VKI_target.value = ""
                }
                var z = this.VKI_target;
                this.VKI_target.keyboardPosition = "absolute";
                do {
                    if (VKI_getStyle(z, "position") == "fixed") {
                        this.VKI_target.keyboardPosition = "fixed";
                        break
                    }
                } while (z = z.offsetParent);
                if (this.VKI_isIE6) {
                    document.body.appendChild(this.VKI_iframe)
                }
                document.body.appendChild(this.VKI_keyboard);
                this.VKI_keyboard.style.position = this.VKI_target.keyboardPosition;
                if (this.VKI_isOpera) {
                    if (this.VKI_sizeAdj) {
                        e.value = this.VKI_size
                    }
                    k.value = this.VKI_kt
                }
                $("#keyboardInputMaster").blinkDraggable();
                this.VKI_position(true);
                if (p.VKI_isMoz || p.VKI_isWebKit) {
                    this.VKI_position(true)
                }
                $("#keyboardInputMaster").css("top", "" + (B.clientY + 10) + "px").css("left", "" + (B.clientX + 10) + "px");
                this.VKI_target.focus()
            } else {
                this.VKI_close()
            }
        }
    };
    this.elementCanShow = function(v) {
        if (v.isExample) {
            return false
        }
        return true
    };
    this.VKI_position = function(y) {
        if (p.VKI_target) {
            var w = VKI_findPos(p.VKI_keyboard),
                B = VKI_innerDimensions(),
                x = VKI_scrollDist();
            var v = false,
                z = p.VKI_target.offsetHeight + 3;
            if (y !== true) {
                if (w[1] + p.VKI_keyboard.offsetHeight - x[1] - B[1] > 0) {
                    v = true;
                    z = -p.VKI_keyboard.offsetHeight - 3
                } else {
                    if (w[1] - x[1] < 0) {
                        v = true
                    }
                }
            }
            if (v || y === true) {
                var A = VKI_findPos(p.VKI_target);
                p.VKI_keyboard.style.top = A[1] - ((p.VKI_target.keyboardPosition == "fixed" && !p.VKI_isIE && !p.VKI_isMoz) ? x[1] : 0) + z + "px";
                p.VKI_keyboard.style.left = Math.max(10, Math.min(B[0] - p.VKI_keyboard.offsetWidth - 25, A[0])) + "px";
                if (p.VKI_isIE6) {
                    p.VKI_iframe.style.width = p.VKI_keyboard.offsetWidth + "px";
                    p.VKI_iframe.style.height = p.VKI_keyboard.offsetHeight + "px";
                    p.VKI_iframe.style.top = p.VKI_keyboard.style.top;
                    p.VKI_iframe.style.left = p.VKI_keyboard.style.left
                }
            }
            if (y === true) {
                p.VKI_position()
            }
        }
    };
    if (window.addEventListener) {
        window.addEventListener("resize", this.VKI_position, false);
        window.addEventListener("scroll", this.VKI_position, false)
    } else {
        if (window.attachEvent) {
            window.attachEvent("onresize", this.VKI_position);
            window.attachEvent("onscroll", this.VKI_position)
        }
    }
    if (this.VKI_sizeAdj) {
        e.change()
    }
    this.VKI_close = VKI_close = function() {
        if (this.VKI_target) {
            try {
                this.VKI_keyboard.parentNode.removeChild(this.VKI_keyboard);
                if (this.VKI_isIE6) {
                    this.VKI_iframe.parentNode.removeChild(this.VKI_iframe)
                }
            } catch (v) {}
            if (this.VKI_kt != this.VKI_kts) {
                k.value = this.VKI_kt = this.VKI_kts;
                this.VKI_buildKeys()
            }
            this.VKI_target.focus();
            if (this.VKI_isIE) {
                setTimeout(function() {
                    p.VKI_target = false
                }, 0)
            } else {
                this.VKI_target = false
            }
        }
    }
}

function VKI_findPos(a) {
    var b = curtop = 0;
    do {
        b += a.offsetLeft;
        curtop += a.offsetTop
    } while (a = a.offsetParent);
    return [b, curtop]
}

function VKI_innerDimensions() {
    if (self.innerHeight) {
        return [self.innerWidth, self.innerHeight]
    } else {
        if (document.documentElement && document.documentElement.clientHeight) {
            return [document.documentElement.clientWidth, document.documentElement.clientHeight]
        } else {
            if (document.body) {
                return [document.body.clientWidth, document.body.clientHeight]
            }
        }
    }
    return [0, 0]
}

function VKI_scrollDist() {
    var a = document.getElementsByTagName("html")[0];
    if (a.scrollTop && document.documentElement.scrollTop) {
        return [a.scrollLeft, a.scrollTop]
    } else {
        if (a.scrollTop || document.documentElement.scrollTop) {
            return [a.scrollLeft + document.documentElement.scrollLeft, a.scrollTop + document.documentElement.scrollTop]
        } else {
            if (document.body.scrollTop) {
                return [document.body.scrollLeft, document.body.scrollTop]
            }
        }
    }
    return [0, 0]
}

function VKI_getStyle(b, a) {
    if (b.currentStyle) {
        var c = b.currentStyle[a]
    } else {
        if (window.getComputedStyle) {
            var c = window.getComputedStyle(b, null)[a]
        }
    }
    return c
}
if (window.addEventListener) {
    window.addEventListener("load", VKI_buildKeyboardInputs, false)
} else {
    if (window.attachEvent) {
        window.attachEvent("onload", VKI_buildKeyboardInputs)
    }
};;
var editorNameMultimedia = "";
var prefijoSeleccionMultimedia = "";
var idCursoSeleccionMultimedia = "";
var idAppSeleccionarMultimedia = "";
var nameAppSeleccionarMultimedia = "";
var dbook = {
    onSelectActivity: function(b) {
        closeMsgBox();
        var a = this;
        getAJAX("/LMS/ajax.php?op=getActivityData&idclase=" + b, function(e) {
            if (e.startsWith("OK")) {
                var d = JSON.parse(e.substr(2));
                var c = finCreaVinculoActividadDigitalBook(b, d.nombre, d.img, d.open_in, d.url_real)
            } else {
                standardAJAX(e)
            }
        })
    }
};

function finSeleccionarMultimediaPantallaCompleta(a, b, c) {
    return finSeleccionarMultimedia(a, b, "imagen_pantalla_completa")
}

function finSeleccionarImagenClase(a, b, c) {
    return finSeleccionarMultimedia(a, b, "imagen_clase")
}

function finSeleccionarImagenTema(a, b, c) {
    return finSeleccionarMultimedia(a, b, "imagen_tema")
}

function finSeleccionarImagenClaseRepos(a, b, c) {
    return finSeleccionarMultimedia(a, b, "imagen_clase_repositorio")
}

function finSeleccionarMultimediaDigitalBookApp(b, c, d, a) {
    return finSeleccionarMultimediaDigitalBook(b, c, "listaapps")
}

function finSeleccionarMultimediaDigitalBookAmpliaciones(b, c, d, a) {
    return finSeleccionarMultimediaDigitalBook(b, c, d, a, "listaampliaciones")
}

function preprocess_server_data_swf_upload(b) {
    var c = "ERROR";
    var a = "OK";
    if (b != undefined) {
        b = trim(b);
        if (b.startsWith(a)) {
            b = b.substring(a.length)
        } else {
            if (!b.startsWith(c)) {
                getAJAX("/LMS/ajax.php?op=escribirtraza&nivel=BlinkFW_LogFile::LEVEL_ERROR&texto=" + encodeURIComponent("ErrorSWFupload: " + b));
                b = "ERROR" + text_web.upload_error_12
            }
        }
    }
    return b
}
var err_flash_shown = false;

function createSWFUpload(f, d) {
    if (!err_flash_shown) {
        var b = swfobject.getFlashPlayerVersion();
        if (!b || !b.major || b.major < 9) {
            err_flash_shown = true;
            _showAlert(text_web.error_flash_required)
        }
    }
    if (d == null) {
        d = ""
    }
    var c = (text_web.upload_1 == undefined) ? "Upload" : text_web.upload_1;
    var a = "12px";
    if (c.length > 6) {
        a = "11px"
    }
    if (c.length > 8) {
        a = "9px"
    }
    if (c.length > 10) {
        a = "8px"
    }
    var e = {
        flash_url: "../libs/swfupload/swfupload.swf",
        upload_url: "../coursePlayer/upload_swf.php",
        post_params: {},
        file_size_limit: "10 MB",
        file_types: "*.*",
        file_types_description: "All Files",
        file_upload_limit: 1,
        file_queue_limit: 0,
        custom_settings: {
            progressTarget: "fsUploadProgress" + d
        },
        debug: false,
        button_image_url: "../images/XPButtonUploadText_61x22_blank.png",
        button_placeholder_id: "spanButtonPlaceholder" + d,
        button_width: 62,
        button_height: 22,
        button_text: '<span class="estiloBoton">' + c + "</span>",
        button_text_style: ".estiloBoton { font-size:" + a + "; font-family:Verdana,Arial; text-align:center; }",
        button_text_left_padding: 0,
        button_text_top_padding: 2,
        file_queued_handler: fileQueued,
        file_queue_error_handler: fileQueueError,
        file_dialog_complete_handler: fileDialogComplete,
        upload_start_handler: uploadStart,
        upload_progress_handler: uploadProgress,
        upload_error_handler: uploadError,
        upload_success_handler: uploadSuccess,
        upload_complete_handler: uploadComplete,
        queue_complete_handler: queueComplete,
        button_window_mode: SWFUpload.WINDOW_MODE.TRANSPARENT
    };
    for (var g in f) {
        e[g] = f[g]
    }
    swfobj = new SWFUpload(e);
    return swfobj
}

function createUploadFile(j, d) {
    var e = $("#progress-" + j).parents(".progress-container"),
        h = $("#" + j).parent(".fileinput-button"),
        b = $("." + j).find(".fs-upload-progress"),
        a = prefijoURL + "/LMS/ajax.php?op=uploadFile.upload",
        f = d.file_size_limit.substring(0, d.file_size_limit.indexOf(" ")) * 1000 * 1000,
        i = d.file_types.match(/[0-9a-z]+/g),
        c = "(.|/)(";
    _.each(i, function(l, k) {
        c += k > 0 ? "|" : "";
        c += l
    });
    c += ")$";
    var g = {
        url: a,
        dataType: "json",
        maxFileSize: f,
        acceptFileTypes: new RegExp(c, "i"),
        formData: d.post_params,
        done: function(m, l) {
            var k = l && l.result;
            if (!k) {
                return g.fail(false, {
                    errorThrown: "Error"
                })
            }
            $.each(k.files, function(n, o) {
                $files = $("#files").empty();
                $("<p/>").text(o.name).appendTo("#files")
            });
            d.upload_success_handler(k.files[0], k.files[0].ruta, j);
            e.addClass("hidden");
            h.removeClass("disabled")
        },
        fail: function(l, k) {
            blink.log.warning(k.errorThrown);
            b.text(k.errorThrown);
            e.addClass("hidden");
            h.removeClass("disabled")
        },
        progressall: function(m, l) {
            var k = parseInt(l.loaded / l.total * 100, 10);
            e.find(".progress-bar").css("width", k + "%")
        },
        processfail: function(l, k) {
            blink.log.warning("Error: " + k.files[k.index].error);
            e.addClass("hidden");
            h.removeClass("disabled");
            $.each(k.files, function(m, n) {
                $("<p/>").text(n.error).appendTo(b)
            })
        },
        process: function(l, k) {
            blink.log.info("Processing " + k.files[k.index].name);
            b.empty();
            e.removeClass("hidden");
            h.addClass("disabled")
        }
    };
    $("#" + j).fileupload(g).prop("disabled", !$.support.fileInput).parent().addClass($.support.fileInput ? undefined : "disabled")
}

function seleccionarMultimedia(e, d, i, a, h, c, g, f, b) {
    if (!h) {
        h = ""
    }
    if (!g) {
        g = ""
    }
    prefijoSeleccionMultimedia = d;
    idCursoSeleccionMultimedia = e;
    idAppSeleccionarMultimedia = f;
    nameAppSeleccionarMultimedia = g;
    showMsgBox("", "/LMS/msgbox.php?op=SelectMultimedia2.showFilePicker&idcurso=" + e + ((h) ? "&mediatype=" + h : "") + ((idclase) ? "&idclase=" + idclase : "") + ((g) ? "&activitytype=" + g : "") + ((f) ? "&activityID=" + f : "") + ((prefijoSeleccionMultimedia) ? "&prefijoSeleccionMultimedia=" + prefijoSeleccionMultimedia : "") + ((b) ? "&maxfilesize=" + b : "") + ((i) ? "&callback=" + i : "") + ((a) ? "&callbackBorrar=" + a : "") + ((c) ? "&ref=" + encodeURIComponent(c) : ""), 771);
    return false
}

function getMediaType(a) {
    if (a) {
        if (isOnlineServiceUrlVideo(a)) {
            return "video"
        } else {
            if (a.indexOf("maps.google.com/maps") != -1) {
                return "image"
            }
        }
        var b = getExt(a, true);
        if (b) {
            if (FLASH_MULTIMEDIA_EXT.split(",").contains(b)) {
                return "flash"
            } else {
                if (VIDEO_MULTIMEDIA_EXT.split(",").contains(b)) {
                    return "video"
                } else {
                    if (DOC_MULTIMEDIA_EXT.split(",").contains(b)) {
                        return "doc"
                    } else {
                        if (IMAGE_EXT.split(",").contains(b)) {
                            return "image"
                        } else {
                            if (SOUND_EXT.split(",").contains(b)) {
                                return "sound"
                            } else {
                                if (["ggb"].contains(b)) {
                                    return "geogebra"
                                } else {
                                    if (["htm", "html"].contains(b)) {
                                        return "html"
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return "other"
}

function hasUploadError(e, a) {
    var f = "ERROR";
    var d = false;
    if (a != undefined && $swfu[a] != undefined) {
        d = $swfu[a]
    }
    var b = false;
    if (d) {
        if (e.startsWith(f)) {
            b = true;
            var c = d.getStats();
            c.successful_uploads--;
            d.setStats(c);
            $("#fsUploadProgress").html('<span style="color:red;">' + e.substring(f.length) + "</span>")
        }
    }
    return b
}

function getUploadInfo(c, f) {
    var b = "5";
    var e = "../images/icons/doc.png";
    var a = "archivo";
    var d = getMediaType(c);
    if (f == "listaapps") {
        a = "aplicacion";
        b = "9";
        e = ""
    } else {
        if (f == "listaampliaciones") {
            a = "ampliacion";
            b = "10"
        } else {
            var g = c.substring(c.lastIndexOf(".") + 1).toLowerCase();
            if (g == "zip") {
                d = "zip"
            }
            if (d == "image") {
                b = "8"
            } else {
                if (d == "video") {
                    b = "2";
                    e = "../images/icons/video.png"
                } else {
                    if (d == "sound") {
                        b = "3";
                        e = "../images/icons/sound.png"
                    } else {
                        if (d == "zip") {
                            b = "4";
                            e = "../images/icons/zip.png"
                        } else {
                            if (d == "flash") {
                                b = "1";
                                e = "../images/icons/flash.png"
                            }
                        }
                    }
                }
            }
        }
    }
    return {
        tipoactividad: b,
        strThumb: e,
        tipoFichero: a,
        mediatype: d
    }
}

function finSeleccionarMultimediaDigitalBook(e, a, o, l, i) {
    var g = a || e || "",
        b = _libroDigital.nuevoID(),
        m = true,
        f = blink.getReqParam(location.href, "idclase");
    var d = getUploadInfo(g, i),
        n = d.tipoactividad,
        p = d.strThumb,
        c = d.tipoFichero,
        k = e.name || d.tipoFichero,
        j = d.mediatype;
    var h = j == "image" ? "addfiledigitalbook" : "getfiledigitalbookinfo";
    getAJAX("/LMS/ajax.php?op=addfiledigitalbook&filename=" + encodeURIComponent(g) + "&idclase=" + f, function(v) {
        if (v.startsWith("OK")) {
            var t = "NEWURLS";
            var q = g;
            if (v.indexOf(t) != -1) {
                var u = v.substr(v.indexOf(t) + t.length);
                var s = u.indexOf("|");
                g = u.substr(0, s);
                q = u.substr(s + 1)
            }
            if (checkUrlExisteJSON(q)) {
                _showAlert(text_web.select_multimedia_30);
                m = false;
                return
            }
            if (j == "image") {
                p = (v.indexOf(t) != -1) ? v.substring(2, v.indexOf(t)) : v.substring(2);
                var r = p.split(";");
                p = r[0];
                $("#img_" + b).attr("src", p)
            }
            $("#borrar_" + b).click(function(w) {
                return deleteFileDigitalBook(b, i)
            });
            salvaLinkJSON(n, q)
        } else {
            if (g.startsWith("http") || g.startsWith("www") || g.startsWith("map:")) {
                if (checkUrlExisteJSON(g)) {
                    _showAlert(text_web.select_multimedia_30);
                    m = false;
                    return
                }
                salvaLinkJSON(n, g)
            } else {
                m = false
            }
        }
    }, false, undefined, undefined, true);
    if (m) {
        finSeleccionarMultimediaDigitalBook_create(b, g, k, p, n, c, i)
    }
}

function finSeleccionarMultimediaDigitalBook_create(c, f, i, n, l, d, g) {
    closeMsgBox();
    if (g == undefined) {
        nombre_lista = "listaarchivos"
    } else {
        nombre_lista = g
    }
    $(".infosinelementos_" + nombre_lista).hide();
    var k = "#contador" + nombre_lista;
    $(k).html($(k).text().replace(/\(.*?\)/, "(" + ($("#" + nombre_lista + "posttituloa div.un_ejercicioa:visible").length + $("#" + nombre_lista + "_nuevoselementos div.un_ejercicioa:visible").length + 1) + ")"));
    var e = "";
    var b = "";
    var h = "";
    if (l != _libroDigital.type_app) {
        if (f && f.length) {
            var a = f.substr(f.lastIndexOf("/") + 1);
            h = "<b>" + a + "</b>"
        }
    }
    var j = getHtmlActividad_LibroDigital(c, nombre_lista, l, i, b, f, n, h, d, true);
    $(j).appendTo("div#" + nombre_lista + "_nuevoselementos");
    $('[id="capa_' + c + '"]').hover(function() {
        $(this).addClass("librodigital_menu_actividades_on")
    }, function() {
        $(this).removeClass("librodigital_menu_actividades_on")
    }).click(function() {
        _libroDigital.abrirActividadDigitalDesdeMenu($(this).attr("tipoactividad"), $(this).attr("urlactividad"))
    });
    $(".capaenlaceborrar").click(function(o) {
        o.preventDefault();
        o.stopPropagation()
    });
    $(".capaenlaceeditar").click(function(o) {
        o.preventDefault();
        o.stopPropagation()
    });
    $("#borrar_" + c).click(function(o) {
        return deleteFileDigitalBook(c, g)
    });
    if (editar) {
        $('[id="capa_' + c + '"]').draggable({
            opacity: 0.5,
            helper: "clone",
            stop: function(p, o) {
                _libroDigital.crearActividadLibroDigital("" + l, f, o, 0, p)
            }
        })
    }
    refrescaTooltip($("#capainfofile_" + c + "[tooltip]"));
    var m = document.getElementById("listadorecursos");
    m.scrollTop = m.scrollHeight
}

function finEditaFileDigitalBook(b, f, d, a, i, e, g) {
    closeMsgBox();
    var c = i;
    if (trim(c) == "") {
        c = e
    }
    $("#nombre_" + b).html("<b>" + c + "</b>");
    var h = "";
    if (c != e) {
        h = '<span style="font-size:9px; font-style: italic">' + e + "</span>";
        if (trim(f) != "") {
            h = "<br>" + h
        }
    }
    $("#descapa_" + b).html(f + h);
    var j = "<b>" + c + "</b><br>" + f;
    $("#capainfofile_" + b).attr("tooltip", j);
    refrescaTooltip($("#capainfofile_" + b + "[tooltip]"));
    _libroDigital.actualizarFile(b, f, d, a, i, g)
}

function finEditaActivityDigitalBook(a, d, b, c) {
    closeMsgBox();
    _libroDigital.actualizarActividad(a, d, b, c)
}

function finEditaVinculoDigitalBook(b, e, g, c, a, j) {
    closeMsgBox();
    var i = "7";
    var d = e;
    var h = getMediaType(e);
    var f = getHtmlActividadLink_LibroDigital(b, i, j, g, d, true);
    $("#capa_link_" + b).html(f);
    $("#capa_link_" + b).hover(function() {
        $(this).addClass("librodigital_menu_actividades_on")
    }, function() {
        $(this).removeClass("librodigital_menu_actividades_on")
    }).click(function() {
        _libroDigital.abrirActividadDigitalDesdeMenu($(this).attr("tipoactividad"), $(this).attr("urlactividad"))
    });
    $("#capa_link_" + b).click(function(k) {
        k.preventDefault();
        k.stopPropagation()
    });
    $(".capaenlaceborrar").click(function(k) {
        k.preventDefault();
        k.stopPropagation()
    });
    $(".capaenlaceeditar").click(function(k) {
        k.preventDefault();
        k.stopPropagation()
    });
    $("#capa_link_" + b).draggable({
        opacity: 0.5,
        helper: "clone",
        stop: function(l, k) {
            _libroDigital.crearActividadLibroDigital("" + i, d, k, 0, l)
        }
    });
    refrescaTooltip($("#capa_link_nombre_" + b + "[tooltip]"));
    refrescaTooltip($("#capa_link_desc_" + b + "[tooltip]"));
    _libroDigital.actualizarLink(b, g, e, c, a, j)
}

function finCreaVinculoActividadDigitalBook(b, e, i) {
    closeMsgBox();
    var a = _libroDigital.nuevoID();
    var g = "6";
    var c = b + "-0";
    var d = e;
    $("#contadorlistaactividades").html($("#contadorlistaactividades").text().replace(/\(.*?\)/, "(" + ($("#listaactividadesposttituloa div.un_ejercicioa:visible").length + 1) + ")"));
    var f = getHtmlActividadVinculo_LibroDigital(a, "listaactividades", e, "", c, i, e, true);
    $(f).appendTo("div#listavinculosactividades");
    $("#capa_" + a).hover(function() {
        $(this).addClass("librodigital_menu_actividades_on")
    }, function() {
        $(this).removeClass("librodigital_menu_actividades_on")
    }).click(function() {
        _libroDigital.abrirActividadDigitalDesdeMenu($(this).attr("tipoactividad"), $(this).attr("urlactividad"))
    });
    $("#capa_" + a).click(function(j) {
        j.preventDefault();
        j.stopPropagation()
    });
    $(".capaenlaceborrar").click(function(j) {
        j.preventDefault();
        j.stopPropagation()
    });
    $(".capaenlaceeditar").remove();
    $("#capa_" + a).draggable({
        opacity: 0.5,
        helper: "clone",
        stop: function(k, j) {
            _libroDigital.crearActividadLibroDigital("" + g, c, j, 0)
        }
    });
    refrescaTooltip($("#capa_" + a + "[tooltip]"));
    var h = document.getElementById("listadorecursos");
    h.scrollTop = h.scrollHeight;
    _libroDigital.crearLinkLibroDigital("" + g, c, d, "1")
}

function finCreaVinculoDigitalBook(b, a) {
    closeMsgBox();
    var f = _libroDigital.nuevoID();
    var d = "7";
    var e = b;
    $("#contadorlistaenlaces").html($("#contadorlistaenlaces").text().replace(/\(.*?\)/, "(" + ($("#listaposttituloalink div.un_ejercicioa:visible").length + 1) + ")"));
    var g = getHtmlActividadLink_LibroDigital(f, d, e, a, e, true);
    $(g).appendTo("div#listaposttituloalink");
    $("#capa_link_" + f).hover(function() {
        $(this).addClass("librodigital_menu_actividades_on")
    }, function() {
        $(this).removeClass("librodigital_menu_actividades_on")
    }).click(function() {
        _libroDigital.abrirActividadDigitalDesdeMenu($(this).attr("tipoactividad"), $(this).attr("urlactividad"))
    });
    $("#capa_link_" + f).click(function(h) {
        h.preventDefault();
        h.stopPropagation()
    });
    $(".capaenlaceborrar").click(function(h) {
        h.preventDefault();
        h.stopPropagation()
    });
    $(".capaenlaceeditar").click(function(h) {
        h.preventDefault();
        h.stopPropagation()
    });
    $("#capa_link_" + f).draggable({
        opacity: 0.5,
        helper: "clone",
        stop: function(i, h) {
            _libroDigital.crearActividadLibroDigital("" + d, e, h, 0, i)
        }
    });
    refrescaTooltip($("#capa_link_nombre_" + f + "[tooltip]"));
    refrescaTooltip($("#capa_link_desc_" + f + "[tooltip]"));
    $(".infosinelementos_listalinks").hide();
    var c = document.getElementById("listadorecursos");
    c.scrollTop = c.scrollHeight;
    _libroDigital.crearLinkLibroDigital("" + d, e, a, "1")
}

function finSeleccionarMultimedia(multimedia, ruta, uso_especial) {
    var strUrl_estandar = multimedia;
    if (multimedia) {
        multimedia.name = ruta
    }
    conidapp = true;
    if (multimedia && multimedia.name) {
        if (idAppSeleccionarMultimedia == "" || idAppSeleccionarMultimedia == undefined || nameAppSeleccionarMultimedia == "" || nameAppSeleccionarMultimedia == undefined) {
            if (idCursoSeleccionMultimedia == 0) {
                conidapp = false;
                multimedia = MEDIA_URL + "/tmp/" + multimedia.name
            } else {
                nameAppSeleccionarMultimedia = "course";
                idAppSeleccionarMultimedia = idCursoSeleccionMultimedia
            }
        }
        if (uso_especial == "imagen_tema") {
            nameAppSeleccionarMultimedia = "course";
            var tmpIDTema = idAppSeleccionarMultimedia;
            idAppSeleccionarMultimedia = idCursoSeleccionMultimedia
        }
        if (conidapp) {
            strUrl_estandar = MEDIA_URL + "/resources/" + multimedia.name;
            var multimedia_url = MEDIA_URL;
            if (nameAppSeleccionarMultimedia == "slide") {
                multimedia_url += "/ctx/a/" + window.idclase
            }
            multimedia = multimedia_url + "/r/" + nameAppSeleccionarMultimedia.substr(0, 1) + "/" + idAppSeleccionarMultimedia + "/" + multimedia.name
        }
    } else {
        if (prefijoSeleccionMultimedia == "" && idCursoSeleccionMultimedia > 0) {
            if (nameAppSeleccionarMultimedia == undefined || nameAppSeleccionarMultimedia.length == 0) {
                nameAppSeleccionarMultimedia = "course";
                idAppSeleccionarMultimedia = idCursoSeleccionMultimedia
            }
        }
        if (uso_especial == "imagen_tema") {
            nameAppSeleccionarMultimedia = "course";
            var tmpIDTema = idAppSeleccionarMultimedia;
            idAppSeleccionarMultimedia = idCursoSeleccionMultimedia
        } else {
            if (uso_especial == "perfil") {
                nameAppSeleccionarMultimedia = "userfile";
                idAppSeleccionarMultimedia = blink.user.getID()
            }
        }
        getAJAX("/LMS/ajax.php?op=getfilemultimedia&filename=" + encodeURIComponent(multimedia) + "&app=" + nameAppSeleccionarMultimedia + "&appid=" + idAppSeleccionarMultimedia, function(msg) {
            if (msg.startsWith("OK") && msg.length > 2) {
                var strNewUrl = "NEWURLS";
                if (msg.indexOf(strNewUrl) != -1) {
                    newurls = msg.substr(msg.indexOf(strNewUrl) + strNewUrl.length);
                    var pos_medio = newurls.indexOf("|");
                    multimedia = newurls.substr(0, pos_medio);
                    if (nameAppSeleccionarMultimedia == "slide" && multimedia.startsWith(MEDIA_URL) && !multimedia.startsWith(BLINKDB_URL)) {
                        multimedia = multimedia.slice(0, 12) + "/ctx/a/" + window.idclase + multimedia.slice(12)
                    }
                    strUrl_estandar = newurls.substr(pos_medio + 1)
                }
            } else {}
        }, false, undefined, undefined, true)
    }
    closeMsgBox();
    if (uso_especial == "attachfile") {
        return multimedia
    } else {
        if (uso_especial == "imagen_clase" || uso_especial == "imagen_clase_repositorio") {
            getAJAX("/LMS/ajax.php?op=updateclassimage&idcurso=" + idCursoSeleccionMultimedia + "&idclase=" + idAppSeleccionarMultimedia + "&img=" + encodeURIComponent(strUrl_estandar), function(res) {
                if (res == "OK" || res == "RELOAD") {
                    if (uso_especial == "imagen_clase_repositorio") {
                        $("#img_actividad_" + idAppSeleccionarMultimedia).attr("src", multimedia)
                    } else {
                        window.location.reload(true)
                    }
                }
            }, false)
        } else {
            if (uso_especial == "imagen_tema") {
                getAJAX("/LMS/ajax.php?op=updatesectionimage&idcurso=" + idCursoSeleccionMultimedia + "&idtema=" + tmpIDTema + "&img=" + encodeURIComponent(strUrl_estandar), function(res) {
                    if (res == "OK" || res == "RELOAD") {
                        window.location.reload(true)
                    }
                }, false)
            } else {
                if (uso_especial == "imagen_hijo") {
                    cargarImagen("imagenhijo", multimedia, true)
                } else {
                    if (prefijoSeleccionMultimedia == "" && idCursoSeleccionMultimedia > 0) {
                        cargarImagen("", multimedia, true);
                        getAJAX("/LMS/ajax.php?op=updatecourseimage&idcurso=" + idCursoSeleccionMultimedia + "&img=" + encodeURIComponent(strUrl_estandar), standardAJAXFunc, false)
                    } else {
                        if (prefijoSeleccionMultimedia == "" && idCursoSeleccionMultimedia == 0) {
                            cargarImagen("perfil", multimedia, true)
                        } else {
                            var mediatype = getMediaType(multimedia);
                            $("#" + prefijoSeleccionMultimedia + "_img1v").val(multimedia);
                            var maxHeight = 380;
                            try {
                                eval("var maxHeight = " + prefijoSeleccionMultimedia + "_maxHeight;")
                            } catch (e) {}
                            if (mediatype == "image") {
                                var centrar = false;
                                if (uso_especial == "imagen_pantalla_completa") {
                                    centrar = true
                                }
                                writeImgPlayer(prefijoSeleccionMultimedia, multimedia, "", centrar, $("[name=" + prefijoSeleccionMultimedia + "_img1v_title]").val(), maxHeight);
                                cargarImagen(prefijoSeleccionMultimedia, multimedia, true);
                                $("#slide_miniatura_" + secuencia[activeSlide]).attr("src", multimedia)
                            } else {
                                if (mediatype == "video" || mediatype == "sound") {
                                    var isFlash = mediatype === "flash",
                                        mediaType = mediatype === "sound" ? "audio" : "video",
                                        media = blink.theme[mediaType],
                                        id = prefijoSeleccionMultimedia + "-multimedia",
                                        idPlayer = id + "-player";
                                    if (media && media.player[idPlayer]) {
                                        return media.videojs(idPlayer)
                                    }
                                    writeVideoPlayer(prefijoSeleccionMultimedia, multimedia, mediatype == "flash", maxHeight, false, false, id)
                                } else {
                                    if (mediatype == "flash") {
                                        writeFlashPlayer(prefijoSeleccionMultimedia, multimedia, maxHeight)
                                    } else {
                                        if (mediatype == "geogebra") {
                                            writeGeogebraPlayer(prefijoSeleccionMultimedia, multimedia, maxHeight)
                                        } else {
                                            if (mediatype == "doc") {
                                                writeDocPlayer(prefijoSeleccionMultimedia, multimedia, maxHeight, true);
                                                $("#slide_miniatura_" + secuencia[activeSlide]).attr("src", $("#" + prefijoSeleccionMultimedia + "_img1").attr("src"))
                                            } else {
                                                writeOtherPlayer(prefijoSeleccionMultimedia, multimedia, maxHeight)
                                            }
                                        }
                                    }
                                }
                            }
                            $("#" + prefijoSeleccionMultimedia + "_tipomultimedia").val(mediatype);
                            marcarHaCambiado(getIDSlideFromPrefijo(prefijoSeleccionMultimedia))
                        }
                    }
                    $("body").trigger("image:change")
                }
            }
        }
    }
}

function finSeleccionarImagenFondo(d, e, f, b) {
    var a = d;
    if (idAppSeleccionarMultimedia == "" || idAppSeleccionarMultimedia == undefined || nameAppSeleccionarMultimedia == "" || nameAppSeleccionarMultimedia == undefined) {
        nameAppSeleccionarMultimedia = "slide";
        idAppSeleccionarMultimedia = idtransact
    }
    d.name = e;
    if (d.name) {
        d = MEDIA_URL + "/ctx/a/" + window.idclase + "/r/" + nameAppSeleccionarMultimedia.substr(0, 1) + "/" + idAppSeleccionarMultimedia + "/" + d.name
    } else {
        getAJAX("/LMS/ajax.php?op=getfilemultimedia&filename=" + encodeURIComponent(d) + "&app=" + nameAppSeleccionarMultimedia + "&appid=" + idAppSeleccionarMultimedia, function(i) {
            if (i.startsWith("OK") && i.length > 2) {
                var h = "NEWURLS";
                if (i.indexOf(h) != -1) {
                    newurls = i.substr(i.indexOf(h) + h.length);
                    var g = newurls.indexOf("|");
                    d = newurls.substr(0, g);
                    a = newurls.substr(g + 1)
                }
            } else {}
        }, false, undefined, undefined, true)
    }
    var c = prefijoSeleccionMultimedia;
    $("[name=" + c + "_img_bg]").val(d);
    setBackgroundImage(d, c);
    marcarHaCambiado(getIDSlideFromPrefijo(prefijoSeleccionMultimedia));
    closeMsgBox()
}

function finUploadImagenDBBlink(d, a, c, b) {
    getAJAX("/coursePlayer/getfiles.php?type=uploadblinkdbimage&tags=" + encodeURIComponent(a.join("|")) + "&img=" + escape(d) + "&urlmedia=" + c + "&app_id=" + b, null, false, "preview")
}

function getImageMarkUp(a) {
    return "<img src='" + a + "'>"
}

function finSeleccionarImagenGaleria(p, b, o, k) {
    var m = p;
    if (idAppSeleccionarMultimedia == "" || idAppSeleccionarMultimedia == undefined || nameAppSeleccionarMultimedia == "" || nameAppSeleccionarMultimedia == undefined) {
        nameAppSeleccionarMultimedia = "slide";
        idAppSeleccionarMultimedia = idtransact
    }
    if (b) {
        p = MEDIA_URL + "/r/" + nameAppSeleccionarMultimedia.substr(0, 1) + "/" + idAppSeleccionarMultimedia + "/" + b
    } else {
        var i = "";
        if (nameAppSeleccionarMultimedia == "message_body") {
            nameAppSeleccionarMultimedia = "message";
            idAppSeleccionarMultimedia = 999999999;
            i = "tmp_messagebody"
        }
        var g = "/LMS/ajax.php?op=getfilemultimedia&filename=" + encodeURIComponent(p) + "&app=" + nameAppSeleccionarMultimedia + "&appid=" + idAppSeleccionarMultimedia;
        if (i.length > 0) {
            g += "&use_type=" + i
        }
        getAJAX(g, function(s) {
            if (s.startsWith("OK") && s.length > 2) {
                var r = "NEWURLS";
                if (s.indexOf(r) != -1) {
                    newurls = s.substr(s.indexOf(r) + r.length);
                    var q = newurls.indexOf("|");
                    p = newurls.substr(0, q);
                    m = newurls.substr(q + 1)
                }
            } else {}
        }, false, undefined, undefined, true)
    }
    var n = p.substring(p.lastIndexOf("/") + 1);
    var h = CKEDITOR.instances[editorNameMultimedia];
    var l = getImageGalleryMarkUp(p);
    var c = h.getSelection();
    var a = c.getRanges();
    var d = c.getSelectedElement();
    var j = d.find(".bck-gallery-images").getItem(0);
    var f = h.createRange();
    f.selectNodeContents(j);
    f.moveToPosition(j, CKEDITOR.POSITION_BEFORE_END);
    if (CKEDITOR.env.ie) {
        var e = h.getData();
        h.setData(e + " " + l)
    } else {
        h.insertHtml(l, "html", f)
    }
    marcarHaCambiado(getIDSlideFromPrefijo(prefijoSeleccionMultimedia));
    closeMsgBox()
}

function getImageGalleryMarkUp(b) {
    var a = '<figure class="image"><img class="bck-image" src="' + b + '"><figcaption><div>Edit me...</div></figcaption></figure>&nbsp';
    return a
}

function finSeleccionarSonidoFondo(c, d, e, b) {
    var a = c;
    if (idAppSeleccionarMultimedia == "" || idAppSeleccionarMultimedia == undefined || nameAppSeleccionarMultimedia == "" || nameAppSeleccionarMultimedia == undefined) {
        nameAppSeleccionarMultimedia = "slide";
        idAppSeleccionarMultimedia = idtransact
    }
    c.name = d;
    if (c.name) {
        c = MEDIA_URL + "/r/" + nameAppSeleccionarMultimedia.substr(0, 1) + "/" + idAppSeleccionarMultimedia + "/" + c.name
    } else {
        getAJAX("/LMS/ajax.php?op=getfilemultimedia&filename=" + encodeURIComponent(c) + "&app=" + nameAppSeleccionarMultimedia + "&appid=" + idAppSeleccionarMultimedia, function(h) {
            if (h.startsWith("OK") && h.length > 2) {
                var g = "NEWURLS";
                if (h.indexOf(g) != -1) {
                    newurls = h.substr(h.indexOf(g) + g.length);
                    var f = newurls.indexOf("|");
                    c = newurls.substr(0, f);
                    a = newurls.substr(f + 1)
                }
            } else {}
        }, false, undefined, undefined, true)
    }
    document.f.elements[prefijoSeleccionMultimedia + "_snd1v"].value = c;
    updateLabelFile(c, prefijoSeleccionMultimedia + "_snd1v_info");
    marcarHaCambiado(getIDSlideFromPrefijo(prefijoSeleccionMultimedia));
    closeMsgBox()
}

function finSeleccionarImagenEditor(a, b) {
    blink.theme.finSeleccionarImagenEditor(a, b)
}

function insertarArchivoMultimediaSlides(a, b) {
    blink.theme.insertarArchivoMultimediaSlides(a, b)
}

function finSeleccionarSonido(a, b) {
    blink.theme.finSeleccionarSonido(a, b)
}

function finSeleccionarVideo(b, a) {
    blink.theme.finSeleccionarVideo(b, a)
}

function finSeleccionarVideo2(b, a) {
    blink.theme.finSeleccionarVideo2(b, a)
}

function finSeleccionarArchivo(a, b) {
    blink.theme.finSeleccionarArchivo(a, b)
}

function finSeleccionarSubtitulo(n, c, p, b) {
    var m = n,
        f = {
            isSetIDApp: idAppSeleccionarMultimedia == "" || idAppSeleccionarMultimedia == undefined,
            isSetNameApp: nameAppSeleccionarMultimedia == "" || nameAppSeleccionarMultimedia == undefined
        };
    if (f.isSetIDApp || f.isSetNameApp) {
        nameAppSeleccionarMultimedia = "slide";
        idAppSeleccionarMultimedia = idtransact
    }
    if (c) {
        n = MEDIA_URL + "/r/" + nameAppSeleccionarMultimedia.substr(0, 1) + "/" + idAppSeleccionarMultimedia + "/" + c
    } else {
        getAJAX("/LMS/ajax.php?op=getfilemultimedia&filename=" + encodeURIComponent(n) + "&app=" + nameAppSeleccionarMultimedia + "&appid=" + idAppSeleccionarMultimedia, function(t) {
            if (t.startsWith("OK") && t.length > 2) {
                var r = "NEWURLS";
                if (t.indexOf(r) != -1) {
                    var s = t.substr(t.indexOf(r) + r.length);
                    var q = s.indexOf("|");
                    n = s.substr(0, q);
                    m = s.substr(q + 1)
                }
            } else {}
        }, false, undefined, undefined, true)
    }
    var l = n.substring(n.lastIndexOf("/") + 1);
    var j = CKEDITOR.instances[editorNameMultimedia];
    var o = l.replace(/\W+/g, " ").replace(/_*[0-9]*( srt| vtt)/g, "");
    var d = j.getSelection();
    var a = d.getRanges();
    var e = d.getSelectedElement();
    var k = e.find(".bck-subtitles").getItem(0);
    var i = j.createRange();
    i.selectNodeContents(k);
    i.moveToPosition(k, CKEDITOR.POSITION_BEFORE_END);
    var g = getSrtMarkUp(n, o, k);
    if (CKEDITOR.env.ie) {
        var h = j.getData();
        j.setData(h + " " + g)
    } else {
        j.insertHtml(g, "html", i)
    }
    marcarHaCambiado(getIDSlideFromPrefijo(prefijoSeleccionMultimedia));
    closeMsgBox()
}
getSrtMarkUp = function(b, c, d) {
    var a = d.find(".bck-video-srt").count();
    return '<div id="srt_' + a + '" href="' + b + '" class="bck-video-srt" data-srt-file="' + b + '" data-srt-label="' + c + '" data-srt-kind="captions" data-srt-default="' + !a + '" ><img src="../themes/responsive/images/contenido/recurso-icon-archivo-add.png"/><div class="bck-video-srt-label">&nbsp' + c + "</div>&nbsp</div>"
};

function uploadFile(g, b, a, h, d, f) {
    var e = new FormData();
    if (!(a instanceof Blob)) {
        a = new Blob([a], {
            type: "text/plain"
        })
    }
    e.append("Filedata", a, b);
    e.append("type", "multimedia");
    e.append("app", g || "multimedia");
    if (f) {
        _.each(f, function(j, i) {
            e.append(i, j)
        })
    }
    var c = d || "/coursePlayer/upload_swf.php";
    blink.ajax(c, h, {
        data: e,
        processData: false,
        contentType: false
    }, {})
};;
var pizarraOff = true;
var modoPizarra = false;
var herramientaPizarra = 0;

function toggleModoPizarra() {
    modoPizarra = !modoPizarra;
    conmutarEstadoBoton("boton_modo_pizarra", !modoPizarra);
    var cambiarZoom = !($.browser.msie && parseInt($.browser.version, 10) < 9) && false;
    if (modoPizarra) {
        $(".titulo_pagina_curso, #paginador").hide();
        $(document.body).css("font-size", "125%");
        $(".texto_curso,.circulo_gris,.true_false,.ejercicio,.clasificar_lista,.clasificar_conjuntos,.relacion,.relacionreducida,.ordenar,.slide_main,.boton_rojo,.quedan,.drag").addClass("modo_pizarra");
        $(".libro3, .curso, .contenidos_curso").removeClass("modo_ordenador").addClass("modo_pizarra");
        $(".contenidos_curso").css("background-position", "0 40px");
        $("#menubar").hide()
    } else {
        $("#menubar").show();
        $(".titulo_pagina_curso, #paginador").show();
        $(document.body).css("font-size", "100%");
        $(".texto_curso,.circulo_gris,.true_false,.ejercicio,.clasificar_lista,.clasificar_conjuntos,.relacion,.relacionreducida,.ordenar,.slide_main,.boton_rojo,.quedan,.drag").removeClass("modo_pizarra");
        $(".libro3, .curso, .contenidos_curso").removeClass("modo_pizarra").addClass("modo_ordenador");
        $(".contenidos_curso").css("background-position", "0 0")
    }
    if (modoContinuo) {
        posicionarMenuLateral(false)
    }
    $(".contenidos_curso").each(function() {
        $(this).find("canvas").attr("height", $(this).height())
    });
    if (window.activeSlide) {
        var objSlide = eval("t" + activeSlide + "_slide");
        if (objSlide) {
            objSlide.onShow()
        }
    }
}
var miniaturasInfantil = false;

function mostrarMiniaturasInfantil() {
    conmutarEstadoBoton("boton_miniaturas_infantil", miniaturasInfantil);
    miniaturasInfantil = (miniaturasInfantil) ? false : true;
    if (!$(".miniaturas").is(":visible")) {
        $(".miniaturas").fadeIn()
    } else {
        $(".miniaturas").fadeOut()
    }
    if (miniaturasInfantil) {
        hideLupa();
        if (!pizarraOff) {
            setPizarraOff(false)
        }
        if (modoContinuo) {
            conmutarModoContinuo()
        }
    }
}

function puedeUsarHerramienta(b, a) {
    if (a == 0) {
        return true
    }
    if ($.browser.msie && parseInt($.browser.version, 10) < 9) {
        setPizarraOff(b);
        _showAlert(text_web.javascript_switchpizarra);
        return false
    }
    return true
}

function selectPizarraColor(b, a) {
    blink.theme.selectPizarraColor(b, a)
}

function setPizarraOn(b, a) {
    blink.theme.setPizarraOn(b, a)
}

function setPizarraOff(a) {
    blink.theme.setPizarraOff(a)
}

function switchPizarra(a) {
    if (!a) {
        a = 1
    }
    if ($.browser.msie && parseInt($.browser.version, 10) < 9) {
        setPizarraOff(true);
        _showAlert(text_web.javascript_switchpizarra);
        return
    }(pizarraOff || a != herramientaPizarra) ? setPizarraOn(true, a): setPizarraOff(true);
    return false
}

function estrella(b, a) {
    $("[id^=estrella_" + b + "]").removeClass("on").addClass("off");
    $("[id^=estrella_" + b + "]:lt(" + a + ")").addClass("on")
}

function estrella0(a) {
    $("[id^=estrella_" + a + "]").removeClass("on").addClass("off");
    $("[id^=estrella_" + a + "_t]").html("")
}
var colorSelected = "#000000";

function _setSelectedColor(a) {
    colorSelected = a;
    hidePopupColores()
}
var idbuttonPopupColores = "";
var toolbarFixed = false;

function showPopupColores(a) {
    blink.theme.showPopupColores(a)
}

function hidePopupColores() {
    $(".popup_colores").fadeOut("fast")
}

function positionPopupColores() {
    if ($(".popup_colores:visible").size() == 0) {
        return
    }
    var a = $("#" + idbuttonPopupColores).offset();
    if (a != null) {
        $(".popup_colores").css({
            top: a.top + ((esWeb) ? 20 : 0) - (toolbarFixed ? $(window).scrollTop() : 0),
            left: a.left - $(".popup_colores").width() + ((esWeb) ? 84 : 0)
        }).fadeIn("slow")
    }
    if (esWeb) {
        $(".popup_colores").addClass("up")
    }
}

function setSelectedColorInfantil(a, b) {
    colorSelected = a;
    $('li[id^="color"] div').removeClass("on");
    $("li#color" + b + " div").addClass("on");
    setPizarraOn(false, herramientaPizarra)
}

function generaPanelColores(a) {
    return blink.theme.generaPanelColores(a)
}
var gometSelected;
var zIndexGomet = 200;

function setSelectedGomet(b) {
    var a = $(b),
        c = a.position();
    if (!a.hasClass("gometusado")) {
        a.clone().appendTo(a.parent()).blinkDraggable();
        a.addClass("gometusado").attr("inix", c.left).attr("iniy", c.top)
    }
    a.css("z-index", zIndexGomet);
    zIndexGomet++;
    return false
}

function generaPanelGomets(a) {
    return blink.theme.generaPanelGomets(a)
};;
$(document).ready(function() {
    if (blink.isWinRTApp) {
        window.confirm = function() {
            return true
        }
    }
});
$(document).ready(function() {
    try {
        blink.utils.attachImageEvents();
        if (blink.isWinRTApp) {
            $("#footer").hide()
        }
        var b = 0;
        $("#ul_botonera li").each(function() {
            b += parseInt($(this).css("width")) + 12
        });
        $("#div_botonera").css("width", b);
        $(document).mousemove(function(i) {
            window.mouseXPos = i.pageX;
            window.mouseYPos = i.pageY
        });
        if (typeof(TEXTWEB_DEBUG) != "undefined" && TEXTWEB_DEBUG) {
            for (k in text_web) {
                text_web[k] = "[" + k + "]" + text_web[k]
            }
        }
        if (typeof(modoVisualizacion) != "undefined") {
            setModoVisualizacion(modoVisualizacion)
        }
        if (typeof(access_type_blocked) != "undefined" && access_type_blocked) {
            setModoBlocked()
        }
        if (typeof(ask_credit) != "undefined" && ask_credit) {
            askCredit()
        }
        if (typeof(esPopup) != "undefined" && esPopup) {
            $(".no_popup").remove()
        }
        if (typeof(esPopup) == "undefined" || !esPopup) {
            $(".only_popup").remove()
        }
        if (canUseOfflineUrls() || (window.offline && blink.appVersion < 4)) {
            $(document).on("submit", "form", function() {
                var e = canUseOfflineUrls();
                if (!e) {
                    var i = $(this).attr("method");
                    e = i && i.toLowerCase() == "post"
                }
                if (e) {
                    mostrarAvisoOffline();
                    return false
                }
            })
        }
        if (typeof(loadpagewithajax) != "undefined" && loadpagewithajax) {
            $("a").each(function() {
                var e = $(this).attr("href");
                if (e.startsWith("/") || e.startsWith(".")) {
                    $(this).attr("href", "javascript:redireccionar('" + e + "');")
                }
            })
        }
        $("a.disabled_link").remove();
        prepararCamposTexto();
        desactivarVinculosAccessControl();
        $(".submit_on_return").keypress(function(e) {
            if (e.keyCode == "13") {
                $(this).parents("form").get(0).submit()
            }
        });
        $("#buscador").keypress(function(e) {
            if (e.keyCode == "13") {
                goBusqueda(this.id)
            }
        });
        $("#suscribe").keypress(function(e) {
            if (e.keyCode == "13") {
                onSaveNewsletter()
            }
        });
        //blink.theme.attachFiltersEvents();
        if (blink.browserNotSupported && getCookie("invbrowser") != "1") {
            showMsgBox("", "/LMS/msgbox.php?op=invalidbrowser", msgBoxWidth, null, false);
            setCookie("invbrowser", "1", 1)
        }
        enableFloatingObjects();
        if (blink.isAndroid) {
            blink.initAndroid()
        } else {
            if (blink.isAndroidApp) {
                initAndroidApp()
            } else {
                blink.initPC()
            }
        }
        var c = blink.getReqParam(location.href, "errCode");
        if (c != "") {
            printError(text_web["error_" + c])
        }
    } catch (h) {
        blink.log.error(h);
        _showAlert(h)
    }
    if (blink.getReqParam(location.href, "printServer") == "true" && blink.theme.isAdaptative()) {
        $("body").addClass("print-mode");
        var m = [];
        $(".js-slider-item").each(function() {
            var e = parseInt($(this).attr("id").substr(12, $(this).attr("id").length));
            m[e] = $(this)
        });
        m.unshift(m.pop());
        m.reverse().map(function(e) {
            e.prependTo("#actividad .content")
        });
        $(".spinner").css("display", "none");
        $(document.body).css("overflow", "auto");
        $(".select-wrap").addClass("solucion");
        generarContenidoPrintMode(m.length);
        $("body.print-mode .layout-panel").width("45%");
        var j = [];
        var j = $("body.print-mode .layout-panel.left");
        j.map(function(e, o) {
            var i = $(this).attr("id").substr(1, $(this).attr("id").length - 5);
            if ($("#t" + i + "right").hasClass("hidden")) {
                $("#t" + i + "left").css("width", "100%")
            }
        });
        for (var f = 0; f <= m.length; f++) {
            var l;
            if (window["t" + f + "_preguntas"] !== undefined) {
                l = window["t" + f + "_preguntas"];
                $.map(l, function(o, i) {
                    var e = diferenciarTipoSlide(f);
                    $(e[0]).append($('<li id="t' + f + "v" + i + '"							 class="' + e[1] + '">							<p>								<span class="texto">' + o + "</span>							</p>						</li>"))
                })
            }
            if (window["Datat" + f] !== undefined) {
                var n = window["t" + f + "_slide"];
                n.data = window["Datat" + f];
                n.clues = window["Cluest" + f];
                var a = n.getPuzzleData();
                $("#t" + f + "-puzzle-wrapper").crossword(a, "t" + f, n)
            }
        }
        for (var d = 0; d < m.length - 1; d++) {
            try {
                var g = window["t" + d + "_slide"];
                g.evalNumElements();
                g.firstElementIndex = (g.useExamples) ? 1 : 0;
                g.showSolution()
            } catch (h) {}
        }
    }
});
$(window).resize(function() {
    if ($("#background:visible").size()) {
        resizeMask()
    }
    setTimeout(function() {
        calculateDimTextareas()
    }, 100)
});

function calculateDimTextareas() {
    $(".textarea-answer textarea").each(function(d, e) {
        var f = $(e);
        var b = f.parent().siblings(".preview.js-richeditor");
        f.css("height", "");
        var h = parseInt(f.css("line-height")),
            g = false,
            c = f.get(0).scrollHeight + 2;
        if (f.attr("rows") != undefined) {
            g = parseInt(f.attr("rows")) * h + 2
        }
        var a = g && (g >= c) ? g : c;
        f.css({
            "min-height": g ? g : "",
            height: a
        });
        b.css({
            "min-height": g ? g : ""
        })
    })
}
$(function() {
    $(".temas").tooltip({
        selector: "[data-original-title]",
        container: "body"
    });
    if (!blink.hasTouch) {
        $(".toolbar").tooltip({
            selector: "[data-original-title]",
            placement: "bottom"
        })
    }
});

function diferenciarTipoSlide(b) {
    var a = [];
    if ($("#t" + b + "_lista").length) {
        a = ["#t" + b + "_lista", "js-rank-item"]
    } else {
        if ($("#t" + b + "_lista_conceptos")) {
            a = ["#t" + b + "_lista_conceptos", "classify-item"]
        }
    }
    return a
}

function generarContenidoPrintMode() {};;